// Copyright 2017 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// vector_icons.h.template is used to generate vector_icons.h. Edit the former
// rather than the latter.

#ifndef CHROME_APP_VECTOR_ICONS_VECTOR_ICONS_H_
#define CHROME_APP_VECTOR_ICONS_VECTOR_ICONS_H_

namespace gfx {
struct VectorIcon;
}

#define VECTOR_ICON_TEMPLATE_H(icon_name) \
extern const gfx::VectorIcon icon_name;

VECTOR_ICON_TEMPLATE_H(kAccountAddChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kAccountBoxIcon)
VECTOR_ICON_TEMPLATE_H(kAccountChildCircleIcon)
VECTOR_ICON_TEMPLATE_H(kAccountCircleIcon)
VECTOR_ICON_TEMPLATE_H(kAccountCircleChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kAccountManageChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kAddIcon)
VECTOR_ICON_TEMPLATE_H(kAddChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kAutoTabGroupsIcon)
VECTOR_ICON_TEMPLATE_H(kLocalOfferFlippedRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kWebauthnDialogHeaderIcon)
VECTOR_ICON_TEMPLATE_H(kWebauthnDialogHeaderDarkIcon)
VECTOR_ICON_TEMPLATE_H(kBackArrowTouchIcon)
VECTOR_ICON_TEMPLATE_H(kBackspaceIcon)
VECTOR_ICON_TEMPLATE_H(kBatterySaverRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kBookmarkAllTabsChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kBookmarkbarOverflowRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kBookmarksListsMenuIcon)
VECTOR_ICON_TEMPLATE_H(kBookmarksManagerIcon)
VECTOR_ICON_TEMPLATE_H(kBookmarksSidePanelIcon)
VECTOR_ICON_TEMPLATE_H(kBookmarksSidePanelRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kBrowserLogoIcon)
VECTOR_ICON_TEMPLATE_H(kBrowserToolsIcon)
VECTOR_ICON_TEMPLATE_H(kBrowserToolsChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kBrowserToolsErrorIcon)
VECTOR_ICON_TEMPLATE_H(kBrowserToolsTouchIcon)
VECTOR_ICON_TEMPLATE_H(kBrowserToolsUpdateIcon)
VECTOR_ICON_TEMPLATE_H(kBrowserToolsUpdateChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kCastChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kChevronRightIcon)
VECTOR_ICON_TEMPLATE_H(kChevronRightChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kChromiumMinimizeIcon)
VECTOR_ICON_TEMPLATE_H(kClickToCallIllustrationIcon)
VECTOR_ICON_TEMPLATE_H(kClickToCallIllustrationDarkIcon)
VECTOR_ICON_TEMPLATE_H(kCloseChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kCloseGroupRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kCloseTabChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kCompareIcon)
VECTOR_ICON_TEMPLATE_H(kComputerWithCircleBackgroundIcon)
VECTOR_ICON_TEMPLATE_H(kCopyIcon)
VECTOR_ICON_TEMPLATE_H(kCopyMenuIcon)
VECTOR_ICON_TEMPLATE_H(kCrashedTabIcon)
VECTOR_ICON_TEMPLATE_H(kCreateNewTabGroupIcon)
VECTOR_ICON_TEMPLATE_H(kCreditCardIcon)
VECTOR_ICON_TEMPLATE_H(kCreditCardChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kCutMenuIcon)
VECTOR_ICON_TEMPLATE_H(kDefaultTouchFaviconIcon)
VECTOR_ICON_TEMPLATE_H(kDefaultTouchFaviconMaskIcon)
VECTOR_ICON_TEMPLATE_H(kDesktopWindowsChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kDeveloperToolsIcon)
VECTOR_ICON_TEMPLATE_H(kDevicesIcon)
VECTOR_ICON_TEMPLATE_H(kDevicesChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kDownloadInProgressChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kDownloadInProgressTouchIcon)
VECTOR_ICON_TEMPLATE_H(kDownloadMenuIcon)
VECTOR_ICON_TEMPLATE_H(kDownloadToolbarButtonIcon)
VECTOR_ICON_TEMPLATE_H(kDownloadToolbarButtonChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kDownloadToolbarButtonTouchIcon)
VECTOR_ICON_TEMPLATE_H(kDownloadWarningIcon)
VECTOR_ICON_TEMPLATE_H(kDragHandleIcon)
VECTOR_ICON_TEMPLATE_H(kDriveShortcutChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kEditChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kExitMenuIcon)
VECTOR_ICON_TEMPLATE_H(kExtensionCrashedIcon)
VECTOR_ICON_TEMPLATE_H(kFileDownloadShelfIcon)
VECTOR_ICON_TEMPLATE_H(kFileSaveIcon)
VECTOR_ICON_TEMPLATE_H(kFileSaveChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kFileSaveOffChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kFingerprintIcon)
VECTOR_ICON_TEMPLATE_H(kForwardArrowTouchIcon)
VECTOR_ICON_TEMPLATE_H(kFullscreenIcon)
VECTOR_ICON_TEMPLATE_H(kFullscreenRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kGenericStopIcon)
VECTOR_ICON_TEMPLATE_H(kGlobeIcon)
VECTOR_ICON_TEMPLATE_H(kGuardianIcon)
VECTOR_ICON_TEMPLATE_H(kGuestMenuArtIcon)
VECTOR_ICON_TEMPLATE_H(kHardwareComputerIcon)
VECTOR_ICON_TEMPLATE_H(kHardwareComputerSmallIcon)
VECTOR_ICON_TEMPLATE_H(kHardwareSmartphoneIcon)
VECTOR_ICON_TEMPLATE_H(kHelpMenuIcon)
VECTOR_ICON_TEMPLATE_H(kHistoryIcon)
VECTOR_ICON_TEMPLATE_H(kIncognitoIcon)
VECTOR_ICON_TEMPLATE_H(kIncognitoMenuArtIcon)
VECTOR_ICON_TEMPLATE_H(kIncognitoProfileIcon)
VECTOR_ICON_TEMPLATE_H(kIncognitoRefreshMenuIcon)
VECTOR_ICON_TEMPLATE_H(kInfoIcon)
VECTOR_ICON_TEMPLATE_H(kInputIcon)
VECTOR_ICON_TEMPLATE_H(kInstallDesktopChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kJourneysIcon)
VECTOR_ICON_TEMPLATE_H(kKeepIcon)
VECTOR_ICON_TEMPLATE_H(kKeepFilledIcon)
VECTOR_ICON_TEMPLATE_H(kKeepOffIcon)
VECTOR_ICON_TEMPLATE_H(kKeyIcon)
VECTOR_ICON_TEMPLATE_H(kKeyboardArrowDownIcon)
VECTOR_ICON_TEMPLATE_H(kKeyboardArrowDownChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kKeyboardArrowRightIcon)
VECTOR_ICON_TEMPLATE_H(kKeyboardArrowUpIcon)
VECTOR_ICON_TEMPLATE_H(kKeyboardArrowUpChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kLaptopIcon)
VECTOR_ICON_TEMPLATE_H(kLeadingScrollIcon)
VECTOR_ICON_TEMPLATE_H(kLeftPanelCloseIcon)
VECTOR_ICON_TEMPLATE_H(kLinkChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kLogoutIcon)
VECTOR_ICON_TEMPLATE_H(kMediaControlsArrowDropDownIcon)
VECTOR_ICON_TEMPLATE_H(kMediaControlsArrowDropUpIcon)
VECTOR_ICON_TEMPLATE_H(kMediaToolbarButtonChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kMediaToolbarButtonTouchIcon)
VECTOR_ICON_TEMPLATE_H(kMenuBookChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kMixedContentIcon)
VECTOR_ICON_TEMPLATE_H(kMoreToolsMenuIcon)
VECTOR_ICON_TEMPLATE_H(kMoveGroupToNewWindowRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kMyLocationIcon)
VECTOR_ICON_TEMPLATE_H(kNameWindowIcon)
VECTOR_ICON_TEMPLATE_H(kNavigateHomeIcon)
VECTOR_ICON_TEMPLATE_H(kNavigateHomeChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kNavigateHomeTouchIcon)
VECTOR_ICON_TEMPLATE_H(kNavigateStopIcon)
VECTOR_ICON_TEMPLATE_H(kNavigateStopChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kNavigateStopTouchIcon)
VECTOR_ICON_TEMPLATE_H(kNewTabInGroupRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kNewTabRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kNewWindowIcon)
VECTOR_ICON_TEMPLATE_H(kNotesIcon)
VECTOR_ICON_TEMPLATE_H(kOpenInBrowserIcon)
VECTOR_ICON_TEMPLATE_H(kOpenInNewIcon)
VECTOR_ICON_TEMPLATE_H(kOpenInNewChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kOpenInNewOffChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kOverflowButtonIcon)
VECTOR_ICON_TEMPLATE_H(kOverflowButtonTouchIcon)
VECTOR_ICON_TEMPLATE_H(kPaintbrushIcon)
VECTOR_ICON_TEMPLATE_H(kPasswordFieldIcon)
VECTOR_ICON_TEMPLATE_H(kPasteMenuIcon)
VECTOR_ICON_TEMPLATE_H(kSaveCardAndVcnSuccessConfirmationIcon)
VECTOR_ICON_TEMPLATE_H(kSaveCardAndVcnSuccessConfirmationDarkIcon)
VECTOR_ICON_TEMPLATE_H(kPeopleGroupIcon)
VECTOR_ICON_TEMPLATE_H(kPerformanceIcon)
VECTOR_ICON_TEMPLATE_H(kPerformanceSpeedometerIcon)
VECTOR_ICON_TEMPLATE_H(kPersonIcon)
VECTOR_ICON_TEMPLATE_H(kPersonFilledPaddedLargeIcon)
VECTOR_ICON_TEMPLATE_H(kPersonFilledPaddedSmallIcon)
VECTOR_ICON_TEMPLATE_H(kPictureInPictureAltIcon)
VECTOR_ICON_TEMPLATE_H(kPrintMenuIcon)
VECTOR_ICON_TEMPLATE_H(kPrivacyTipIcon)
VECTOR_ICON_TEMPLATE_H(kQrCodeChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kQrcodeGeneratorIcon)
VECTOR_ICON_TEMPLATE_H(kReadLaterAddIcon)
VECTOR_ICON_TEMPLATE_H(kReadingListIcon)
VECTOR_ICON_TEMPLATE_H(kReleaseAlertIcon)
VECTOR_ICON_TEMPLATE_H(kReloadTouchIcon)
VECTOR_ICON_TEMPLATE_H(kRemoveIcon)
VECTOR_ICON_TEMPLATE_H(kReportIcon)
VECTOR_ICON_TEMPLATE_H(kRequestMobileSiteCheckedIcon)
VECTOR_ICON_TEMPLATE_H(kRequestMobileSiteUncheckedIcon)
VECTOR_ICON_TEMPLATE_H(kResizeHandleIcon)
VECTOR_ICON_TEMPLATE_H(kRightPanelCloseIcon)
VECTOR_ICON_TEMPLATE_H(kSadTabIcon)
VECTOR_ICON_TEMPLATE_H(kSafetyCheckIcon)
VECTOR_ICON_TEMPLATE_H(kSaveGroupRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kSavePageIcon)
VECTOR_ICON_TEMPLATE_H(kSavedTabGroupBarEverythingIcon)
VECTOR_ICON_TEMPLATE_H(kScienceIcon)
VECTOR_ICON_TEMPLATE_H(kSearchMenuIcon)
VECTOR_ICON_TEMPLATE_H(kSecurityIcon)
VECTOR_ICON_TEMPLATE_H(kSettingsMenuIcon)
VECTOR_ICON_TEMPLATE_H(kSharingHubScreenshotIcon)
VECTOR_ICON_TEMPLATE_H(kSidePanelIcon)
VECTOR_ICON_TEMPLATE_H(kSignOutIcon)
VECTOR_ICON_TEMPLATE_H(kSmartphoneIcon)
VECTOR_ICON_TEMPLATE_H(kSmartphoneRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kSpeakerIcon)
VECTOR_ICON_TEMPLATE_H(kSpeakerGroupIcon)
VECTOR_ICON_TEMPLATE_H(kSubmitFeedbackIcon)
VECTOR_ICON_TEMPLATE_H(kSupervisorAccountCircleIcon)
VECTOR_ICON_TEMPLATE_H(kSyncChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kSyncCircleIcon)
VECTOR_ICON_TEMPLATE_H(kSyncDisabledChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kSyncErrorCircleIcon)
VECTOR_ICON_TEMPLATE_H(kSyncPausedCircleIcon)
VECTOR_ICON_TEMPLATE_H(kSyncRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kTabIcon)
VECTOR_ICON_TEMPLATE_H(kTabAudioIcon)
VECTOR_ICON_TEMPLATE_H(kTabCloseInactiveIcon)
VECTOR_ICON_TEMPLATE_H(kTabCloseNormalIcon)
VECTOR_ICON_TEMPLATE_H(kTabGroupIcon)
VECTOR_ICON_TEMPLATE_H(kTabGroupSharingIcon)
VECTOR_ICON_TEMPLATE_H(kTabGroupsSyncIcon)
VECTOR_ICON_TEMPLATE_H(kTabUsbConnectedIcon)
VECTOR_ICON_TEMPLATE_H(kTabletIcon)
VECTOR_ICON_TEMPLATE_H(kTaskManagerIcon)
VECTOR_ICON_TEMPLATE_H(kTextAnalysisIcon)
VECTOR_ICON_TEMPLATE_H(kToolbarChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kTrailingScrollIcon)
VECTOR_ICON_TEMPLATE_H(kTranslateIcon)
VECTOR_ICON_TEMPLATE_H(kTrashCanIcon)
VECTOR_ICON_TEMPLATE_H(kTrashCanRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kTvIcon)
VECTOR_ICON_TEMPLATE_H(kUngroupRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kUserAccountAvatarIcon)
VECTOR_ICON_TEMPLATE_H(kUserAccountAvatarRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kWebIcon)
VECTOR_ICON_TEMPLATE_H(kCameraIcon)
VECTOR_ICON_TEMPLATE_H(kIcloudKeychainIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyAoaIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyAoaDarkIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyErrorIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyErrorBluetoothIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyErrorBluetoothDarkIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyErrorDarkIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyFingerprintIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyFingerprintDarkIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyPhoneIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyPhoneDarkIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyUsbIcon)
VECTOR_ICON_TEMPLATE_H(kPasskeyUsbDarkIcon)
VECTOR_ICON_TEMPLATE_H(kUsbSecurityKeyIcon)
VECTOR_ICON_TEMPLATE_H(kWebauthnErrorIcon)
VECTOR_ICON_TEMPLATE_H(kWebauthnErrorDarkIcon)
VECTOR_ICON_TEMPLATE_H(kWebidArrowIcon)
VECTOR_ICON_TEMPLATE_H(kWebidGlobeIcon)
VECTOR_ICON_TEMPLATE_H(kZoomInIcon)
VECTOR_ICON_TEMPLATE_H(kZoomMinusIcon)
VECTOR_ICON_TEMPLATE_H(kZoomMinusChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kZoomMinusMenuRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kZoomPlusChromeRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kZoomPlusMenuRefreshIcon)
VECTOR_ICON_TEMPLATE_H(kSecurePaymentConfirmationFingerprintIcon)
VECTOR_ICON_TEMPLATE_H(kSecurePaymentConfirmationFingerprintDarkIcon)
VECTOR_ICON_TEMPLATE_H(kNearbyShareIcon)

#undef VECTOR_ICON_TEMPLATE_H

#endif  // CHROME_APP_VECTOR_ICONS_VECTOR_ICONS_H_
