/* Generated by wayland-scanner 1.24.0 */

/*
 * Copyright 2019 Sebastian Wick
 * Copyright 2019 Erwin Burema
 * Copyright 2020 AMD
 * Copyright 2020 Collabora, Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

#ifndef __has_attribute
# define __has_attribute(x) 0  /* Compatibility with non-clang compilers. */
#endif

#if (__has_attribute(visibility) || defined(__GNUC__) && __GNUC__ >= 4)
#define WL_PRIVATE __attribute__ ((visibility("hidden")))
#else
#define WL_PRIVATE
#endif

extern const struct wl_interface wl_output_interface;
extern const struct wl_interface wl_surface_interface;
extern const struct wl_interface zcr_color_management_output_v1_interface;
extern const struct wl_interface zcr_color_management_surface_v1_interface;
extern const struct wl_interface zcr_color_space_creator_v1_interface;
extern const struct wl_interface zcr_color_space_v1_interface;

static const struct wl_interface *chrome_color_management_types[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&zcr_color_space_creator_v1_interface,
	NULL,
	&zcr_color_space_creator_v1_interface,
	NULL,
	NULL,
	NULL,
	&zcr_color_space_creator_v1_interface,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&zcr_color_management_output_v1_interface,
	&wl_output_interface,
	&zcr_color_management_surface_v1_interface,
	&wl_surface_interface,
	&zcr_color_space_creator_v1_interface,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&zcr_color_space_creator_v1_interface,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&zcr_color_space_v1_interface,
	&zcr_color_space_v1_interface,
	NULL,
	&wl_output_interface,
	&zcr_color_space_v1_interface,
};

static const struct wl_message zcr_color_manager_v1_requests[] = {
	{ "create_color_space_from_icc", "nh", chrome_color_management_types + 11 },
	{ "create_color_space_from_names", "nuuu", chrome_color_management_types + 13 },
	{ "create_color_space_from_params", "nuuuuuuuuu", chrome_color_management_types + 17 },
	{ "get_color_management_output", "no", chrome_color_management_types + 27 },
	{ "get_color_management_surface", "no", chrome_color_management_types + 29 },
	{ "destroy", "", chrome_color_management_types + 0 },
	{ "create_color_space_from_complete_names", "3nuuuuu", chrome_color_management_types + 31 },
	{ "create_color_space_from_complete_params", "3nuuuuuuuuuuu", chrome_color_management_types + 37 },
};

WL_PRIVATE const struct wl_interface zcr_color_manager_v1_interface = {
	"zcr_color_manager_v1", 6,
	8, zcr_color_manager_v1_requests,
	0, NULL,
};

static const struct wl_message zcr_color_management_output_v1_requests[] = {
	{ "get_color_space", "n", chrome_color_management_types + 49 },
	{ "destroy", "", chrome_color_management_types + 0 },
};

static const struct wl_message zcr_color_management_output_v1_events[] = {
	{ "color_space_changed", "", chrome_color_management_types + 0 },
	{ "extended_dynamic_range", "u", chrome_color_management_types + 0 },
};

WL_PRIVATE const struct wl_interface zcr_color_management_output_v1_interface = {
	"zcr_color_management_output_v1", 4,
	2, zcr_color_management_output_v1_requests,
	2, zcr_color_management_output_v1_events,
};

static const struct wl_message zcr_color_management_surface_v1_requests[] = {
	{ "set_alpha_mode", "u", chrome_color_management_types + 0 },
	{ "set_extended_dynamic_range", "u", chrome_color_management_types + 0 },
	{ "set_color_space", "ou", chrome_color_management_types + 50 },
	{ "set_default_color_space", "", chrome_color_management_types + 0 },
	{ "destroy", "", chrome_color_management_types + 0 },
};

static const struct wl_message zcr_color_management_surface_v1_events[] = {
	{ "preferred_color_space", "o", chrome_color_management_types + 52 },
};

WL_PRIVATE const struct wl_interface zcr_color_management_surface_v1_interface = {
	"zcr_color_management_surface_v1", 4,
	5, zcr_color_management_surface_v1_requests,
	1, zcr_color_management_surface_v1_events,
};

static const struct wl_message zcr_color_space_creator_v1_events[] = {
	{ "created", "n", chrome_color_management_types + 53 },
	{ "error", "u", chrome_color_management_types + 0 },
};

WL_PRIVATE const struct wl_interface zcr_color_space_creator_v1_interface = {
	"zcr_color_space_creator_v1", 4,
	0, NULL,
	2, zcr_color_space_creator_v1_events,
};

static const struct wl_message zcr_color_space_v1_requests[] = {
	{ "get_information", "", chrome_color_management_types + 0 },
	{ "destroy", "", chrome_color_management_types + 0 },
};

static const struct wl_message zcr_color_space_v1_events[] = {
	{ "icc_file", "hu", chrome_color_management_types + 0 },
	{ "names", "uuu", chrome_color_management_types + 0 },
	{ "params", "uuuuuuuuu", chrome_color_management_types + 0 },
	{ "done", "", chrome_color_management_types + 0 },
	{ "complete_names", "3uuuuu", chrome_color_management_types + 0 },
	{ "complete_params", "3uuuuuuuuuuu", chrome_color_management_types + 0 },
};

WL_PRIVATE const struct wl_interface zcr_color_space_v1_interface = {
	"zcr_color_space_v1", 4,
	2, zcr_color_space_v1_requests,
	6, zcr_color_space_v1_events,
};

