/* Generated by wayland-scanner 1.24.0 */

#ifndef CHROME_COLOR_MANAGEMENT_SERVER_PROTOCOL_H
#define CHROME_COLOR_MANAGEMENT_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_chrome_color_management The chrome_color_management protocol
 * color management protocol
 *
 * @section page_desc_chrome_color_management Description
 *
 * This protocol specifies a way for a client to set the color space and
 * HDR metadata of a surface and to get information about the color spaces
 * and HDR capabilities of outputs.
 *
 * This protocol is based on a proposed upstream protocol, which we will migrate
 * to once it is approved. It may diverge from the proposed upstream protocol
 * over the course of our development.
 *
 * @section page_ifaces_chrome_color_management Interfaces
 * - @subpage page_iface_zcr_color_manager_v1 - color manager singleton
 * - @subpage page_iface_zcr_color_management_output_v1 - output color properties
 * - @subpage page_iface_zcr_color_management_surface_v1 - color management extension to a surface
 * - @subpage page_iface_zcr_color_space_creator_v1 - color space creator
 * - @subpage page_iface_zcr_color_space_v1 - color space
 * @section page_copyright_chrome_color_management Copyright
 * <pre>
 *
 * Copyright 2019 Sebastian Wick
 * Copyright 2019 Erwin Burema
 * Copyright 2020 AMD
 * Copyright 2020 Collabora, Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct wl_output;
struct wl_surface;
struct zcr_color_management_output_v1;
struct zcr_color_management_surface_v1;
struct zcr_color_manager_v1;
struct zcr_color_space_creator_v1;
struct zcr_color_space_v1;

#ifndef ZCR_COLOR_MANAGER_V1_INTERFACE
#define ZCR_COLOR_MANAGER_V1_INTERFACE
/**
 * @page page_iface_zcr_color_manager_v1 zcr_color_manager_v1
 * @section page_iface_zcr_color_manager_v1_desc Description
 *
 * A global interface used for getting color management surface and color
 * management output objects as well as creating color space objects from
 * ICC profiles, parameters, or enumerated names.
 * @section page_iface_zcr_color_manager_v1_api API
 * See @ref iface_zcr_color_manager_v1.
 */
/**
 * @defgroup iface_zcr_color_manager_v1 The zcr_color_manager_v1 interface
 *
 * A global interface used for getting color management surface and color
 * management output objects as well as creating color space objects from
 * ICC profiles, parameters, or enumerated names.
 */
extern const struct wl_interface zcr_color_manager_v1_interface;
#endif
#ifndef ZCR_COLOR_MANAGEMENT_OUTPUT_V1_INTERFACE
#define ZCR_COLOR_MANAGEMENT_OUTPUT_V1_INTERFACE
/**
 * @page page_iface_zcr_color_management_output_v1 zcr_color_management_output_v1
 * @section page_iface_zcr_color_management_output_v1_desc Description
 *
 * A zcr_color_management_output_v1 describes the color properties of an
 * output.
 *
 * When zcr_color_management_output_v1 object is created, it will send
 * its initial events followed by a wl_output.done event. When creating
 * wl_output and its extension objects, use a final wl_display.sync to
 * guarantee that all output events have been received across all
 * extensions.
 *
 * If the wl_output associated with the zcr_color_management_output_v1 is
 * destroyed, the zcr_color_management_output_v1 object becomes inert.
 * @section page_iface_zcr_color_management_output_v1_api API
 * See @ref iface_zcr_color_management_output_v1.
 */
/**
 * @defgroup iface_zcr_color_management_output_v1 The zcr_color_management_output_v1 interface
 *
 * A zcr_color_management_output_v1 describes the color properties of an
 * output.
 *
 * When zcr_color_management_output_v1 object is created, it will send
 * its initial events followed by a wl_output.done event. When creating
 * wl_output and its extension objects, use a final wl_display.sync to
 * guarantee that all output events have been received across all
 * extensions.
 *
 * If the wl_output associated with the zcr_color_management_output_v1 is
 * destroyed, the zcr_color_management_output_v1 object becomes inert.
 */
extern const struct wl_interface zcr_color_management_output_v1_interface;
#endif
#ifndef ZCR_COLOR_MANAGEMENT_SURFACE_V1_INTERFACE
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_INTERFACE
/**
 * @page page_iface_zcr_color_management_surface_v1 zcr_color_management_surface_v1
 * @section page_iface_zcr_color_management_surface_v1_desc Description
 *
 * A zcr_color_management_surface_v1 allows the client to set the color
 * space and HDR properties of a surface.
 *
 * If the wl_surface associated with the zcr_color_management_surface_v1 is
 * destroyed, the zcr_color_management_surface_v1 object becomes inert.
 * @section page_iface_zcr_color_management_surface_v1_api API
 * See @ref iface_zcr_color_management_surface_v1.
 */
/**
 * @defgroup iface_zcr_color_management_surface_v1 The zcr_color_management_surface_v1 interface
 *
 * A zcr_color_management_surface_v1 allows the client to set the color
 * space and HDR properties of a surface.
 *
 * If the wl_surface associated with the zcr_color_management_surface_v1 is
 * destroyed, the zcr_color_management_surface_v1 object becomes inert.
 */
extern const struct wl_interface zcr_color_management_surface_v1_interface;
#endif
#ifndef ZCR_COLOR_SPACE_CREATOR_V1_INTERFACE
#define ZCR_COLOR_SPACE_CREATOR_V1_INTERFACE
/**
 * @page page_iface_zcr_color_space_creator_v1 zcr_color_space_creator_v1
 * @section page_iface_zcr_color_space_creator_v1_desc Description
 *
 * A zcr_color_space_creator_v1 object returns a created color space
 * or the error which occured during creation.
 *
 * Once a zcr_color_space_creator_v1 object has delivered a 'created'
 * or 'error' event it is automatically destroyed.
 * @section page_iface_zcr_color_space_creator_v1_api API
 * See @ref iface_zcr_color_space_creator_v1.
 */
/**
 * @defgroup iface_zcr_color_space_creator_v1 The zcr_color_space_creator_v1 interface
 *
 * A zcr_color_space_creator_v1 object returns a created color space
 * or the error which occured during creation.
 *
 * Once a zcr_color_space_creator_v1 object has delivered a 'created'
 * or 'error' event it is automatically destroyed.
 */
extern const struct wl_interface zcr_color_space_creator_v1_interface;
#endif
#ifndef ZCR_COLOR_SPACE_V1_INTERFACE
#define ZCR_COLOR_SPACE_V1_INTERFACE
/**
 * @page page_iface_zcr_color_space_v1 zcr_color_space_v1
 * @section page_iface_zcr_color_space_v1_desc Description
 *
 * Refers to a color space which can be attached to a surface
 * (zcr_color_management_surface_v1.set_color_space). It may provide
 * information like the ICC profile and the well-known names to allow
 * clients to know the color space and do color transformations of their
 * own.
 *
 * Once created and regardless of how it was created, a zcr_color_space_v1
 * object always refers to one fixed color space.
 *
 * The client can create a zcr_color_space_v1 object with
 * zcr_color_manager_v1 requests or from an output by calling
 * zcr_color_management_output_v1.get_color_space.
 *
 * Other extensions may define more zcr_color_space_v1 factory interfaces.
 * Those interfaces must explicitly specify the interface version for the
 * object created, otherwise versioning zcr_color_space_v1 correctly
 * becomes impossible. Using a 'new_id' argument without 'interface'
 * attribute defined in XML forces code generators to add two explicit
 * arguments: interface and version. Version is the explicit version
 * number needed, and interface should be required to be
 * "zcr_color_space_v1". The compositor supported zcr_color_space_v1
 * versions are defined by the advertised zcr_color_manager_v1 in
 * wl_registry.
 * @section page_iface_zcr_color_space_v1_api API
 * See @ref iface_zcr_color_space_v1.
 */
/**
 * @defgroup iface_zcr_color_space_v1 The zcr_color_space_v1 interface
 *
 * Refers to a color space which can be attached to a surface
 * (zcr_color_management_surface_v1.set_color_space). It may provide
 * information like the ICC profile and the well-known names to allow
 * clients to know the color space and do color transformations of their
 * own.
 *
 * Once created and regardless of how it was created, a zcr_color_space_v1
 * object always refers to one fixed color space.
 *
 * The client can create a zcr_color_space_v1 object with
 * zcr_color_manager_v1 requests or from an output by calling
 * zcr_color_management_output_v1.get_color_space.
 *
 * Other extensions may define more zcr_color_space_v1 factory interfaces.
 * Those interfaces must explicitly specify the interface version for the
 * object created, otherwise versioning zcr_color_space_v1 correctly
 * becomes impossible. Using a 'new_id' argument without 'interface'
 * attribute defined in XML forces code generators to add two explicit
 * arguments: interface and version. Version is the explicit version
 * number needed, and interface should be required to be
 * "zcr_color_space_v1". The compositor supported zcr_color_space_v1
 * versions are defined by the advertised zcr_color_manager_v1 in
 * wl_registry.
 */
extern const struct wl_interface zcr_color_space_v1_interface;
#endif

#ifndef ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ENUM
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ENUM
/**
 * @ingroup iface_zcr_color_manager_v1
 * well-known EOTF names
 *
 * Names that describe a well-known EOTF.
 *
 * A compositor must support all of these based on the protocol interface
 * version.
 */
enum zcr_color_manager_v1_eotf_names {
	/**
	 * unknown EOTF
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_UNKNOWN = 0,
	/**
	 * Linear transfer function
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LINEAR = 1,
	/**
	 * sRGB transfer function
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SRGB = 2,
	/**
	 * BT.2087 transfer function
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2087 = 3,
	/**
	 * AdobeRGB transfer function
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ADOBERGB = 4,
	/**
	 * Perceptual quantizer / SMPTEST2084
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_PQ = 5,
	/**
	 * hybrid log gamma
	 * @since 2
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_HLG = 6,
	/**
	 * gamma for rec709 encoded videos
	 * @since 2
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT709 = 7,
	/**
	 * sRGB transfer function with headroom for HDR
	 * @since 2
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_EXTENDEDSRGB10 = 8,
	/**
	 * SMPTE240M transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTE170M = 9,
	/**
	 * SMPTE240M transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTE240M = 10,
	/**
	 * SMPTEST428_1 transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTEST428_1 = 11,
	/**
	 * LOG transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LOG = 12,
	/**
	 * LOG Sqrt transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LOG_SQRT = 13,
	/**
	 * IEC61966_2_4 transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_IEC61966_2_4 = 14,
	/**
	 * BT1361_ECG transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT1361_ECG = 15,
	/**
	 * BT2020_10 transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2020_10 = 16,
	/**
	 * BT2020_12 transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2020_12 = 17,
	/**
	 * SCRGB Linear transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SCRGB_LINEAR_80_NITS = 18,
	/**
	 * GAMMA18 transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_GAMMA18 = 19,
	/**
	 * GAMMA28 transfer function
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_GAMMA28 = 20,
	/**
	 * sRGB transfer function
	 * @since 6
	 */
	ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SRGB_HDR = 21,
};
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_HLG_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT709_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_EXTENDEDSRGB10_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTE170M_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTE240M_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTEST428_1_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LOG_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LOG_SQRT_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_IEC61966_2_4_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT1361_ECG_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2020_10_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2020_12_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SCRGB_LINEAR_80_NITS_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_GAMMA18_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_GAMMA28_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SRGB_HDR_SINCE_VERSION 6
#endif /* ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ENUM */

#ifndef ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ENUM_IS_VALID
#define ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_manager_v1
 * Validate a zcr_color_manager_v1 eotf_names value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_manager_v1_eotf_names
 */
static inline bool
zcr_color_manager_v1_eotf_names_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_UNKNOWN:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LINEAR:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SRGB:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2087:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ADOBERGB:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_PQ:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_HLG:
		return version >= 2;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT709:
		return version >= 2;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_EXTENDEDSRGB10:
		return version >= 2;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTE170M:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTE240M:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SMPTEST428_1:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LOG:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_LOG_SQRT:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_IEC61966_2_4:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT1361_ECG:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2020_10:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_BT2020_12:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SCRGB_LINEAR_80_NITS:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_GAMMA18:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_GAMMA28:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_EOTF_NAMES_SRGB_HDR:
		return version >= 6;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGER_V1_EOTF_NAMES_ENUM_IS_VALID */

#ifndef ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ENUM
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ENUM
/**
 * @ingroup iface_zcr_color_manager_v1
 * well-known chromaticity names
 *
 * Names that describe well-known chromaticities.
 *
 * A compositor must support all of these based on the protocol interface
 * version.
 */
enum zcr_color_manager_v1_chromaticity_names {
	/**
	 * unknown chromaticity
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_UNKNOWN = 0,
	/**
	 * ITU-R BT.601 http://www.itu.int/rec/R-REC-BT.601/en
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT601_525_LINE = 1,
	/**
	 * ITU-R BT.601 http://www.itu.int/rec/R-REC-BT.601/en
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT601_625_LINE = 2,
	/**
	 * SMPTE 170M-1999 https://www.itu.int/rec/R-REC-BT.1700/en
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTE170M = 3,
	/**
	 * ITU-R BT.709 https://www.itu.int/rec/R-REC-BT.709/en
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT709 = 4,
	/**
	 * ITU-R BT.2020 http://www.itu.int/rec/R-REC-BT.2020/en
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT2020 = 5,
	/**
	 * IEC/4WD 61966-2-1: sRGB https://webstore.iec.ch/publication/6169
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SRGB = 6,
	/**
	 * Display P3 https://developer.apple.com/reference/coregraphics/cgcolorspace/1408916-displayp3
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_DISPLAYP3 = 7,
	/**
	 * Adobe RGB https://www.adobe.com/digitalimag/pdfs/AdobeRGB1998.pdf
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ADOBERGB = 8,
	/**
	 * 
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_WIDE_GAMUT_COLOR_SPIN = 9,
	/**
	 * 
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT470M = 10,
	/**
	 * 
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTE240M = 11,
	/**
	 * 
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_XYZ_D50 = 12,
	/**
	 * 
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTEST428_1 = 13,
	/**
	 * 
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTEST431_2 = 14,
	/**
	 * 
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_FILM = 15,
};
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_WIDE_GAMUT_COLOR_SPIN_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT470M_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTE240M_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_XYZ_D50_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTEST428_1_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTEST431_2_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_FILM_SINCE_VERSION 5
#endif /* ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ENUM */

#ifndef ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ENUM_IS_VALID
#define ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_manager_v1
 * Validate a zcr_color_manager_v1 chromaticity_names value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_manager_v1_chromaticity_names
 */
static inline bool
zcr_color_manager_v1_chromaticity_names_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_UNKNOWN:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT601_525_LINE:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT601_625_LINE:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTE170M:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT709:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT2020:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SRGB:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_DISPLAYP3:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ADOBERGB:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_WIDE_GAMUT_COLOR_SPIN:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_BT470M:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTE240M:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_XYZ_D50:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTEST428_1:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_SMPTEST431_2:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_FILM:
		return version >= 5;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGER_V1_CHROMATICITY_NAMES_ENUM_IS_VALID */

#ifndef ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_ENUM
#define ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_ENUM
/**
 * @ingroup iface_zcr_color_manager_v1
 * well-known whitepoint names
 *
 * Names that describe well-known whitepoints.
 *
 * A compositor must support all of these based on the protocol interface
 * version.
 */
enum zcr_color_manager_v1_whitepoint_names {
	/**
	 * unknown whitepoint
	 */
	ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_UNKNOWN = 0,
	/**
	 * DCI whitepoint
	 */
	ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_DCI = 1,
	/**
	 * D50 whitepoint
	 */
	ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_D50 = 2,
	/**
	 * D65 whitepoint
	 */
	ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_D65 = 3,
};
#endif /* ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_ENUM */

#ifndef ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_ENUM_IS_VALID
#define ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_manager_v1
 * Validate a zcr_color_manager_v1 whitepoint_names value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_manager_v1_whitepoint_names
 */
static inline bool
zcr_color_manager_v1_whitepoint_names_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_UNKNOWN:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_DCI:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_D50:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_D65:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGER_V1_WHITEPOINT_NAMES_ENUM_IS_VALID */

#ifndef ZCR_COLOR_MANAGER_V1_ERROR_ENUM
#define ZCR_COLOR_MANAGER_V1_ERROR_ENUM
enum zcr_color_manager_v1_error {
	/**
	 * given ICC fd has bad properties
	 */
	ZCR_COLOR_MANAGER_V1_ERROR_ICC_FD = 0,
	/**
	 * bad value given as a well-known name
	 */
	ZCR_COLOR_MANAGER_V1_ERROR_BAD_ENUM = 1,
	/**
	 * bad parameter value
	 */
	ZCR_COLOR_MANAGER_V1_ERROR_BAD_PARAM = 2,
};
#endif /* ZCR_COLOR_MANAGER_V1_ERROR_ENUM */

#ifndef ZCR_COLOR_MANAGER_V1_ERROR_ENUM_IS_VALID
#define ZCR_COLOR_MANAGER_V1_ERROR_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_manager_v1
 * Validate a zcr_color_manager_v1 error value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_manager_v1_error
 */
static inline bool
zcr_color_manager_v1_error_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGER_V1_ERROR_ICC_FD:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_ERROR_BAD_ENUM:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_ERROR_BAD_PARAM:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGER_V1_ERROR_ENUM_IS_VALID */

#ifndef ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_ENUM
#define ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_ENUM
/**
 * @ingroup iface_zcr_color_manager_v1
 * For specifying color matrices
 *
 * Names that describe typical ColorSpace Matrix IDs
 *
 */
enum zcr_color_manager_v1_matrix_names {
	/**
	 * Unknown range
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_UNKNOWN = 0,
	/**
	 * RGB matrix
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_RGB = 1,
	/**
	 * BT709 matrix
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT709 = 2,
	/**
	 * BT2020_NCL matrix
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT2020_NCL = 3,
	/**
	 * BT2020_CL matrix
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT2020_CL = 4,
	/**
	 * FCC matrix
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_FCC = 5,
	/**
	 * SMPTE170M matrix
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_SMPTE170M = 6,
	/**
	 * SMPTE240M matrix
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_SMPTE240M = 7,
	/**
	 * YDZDX matrix
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_YDZDX = 8,
	/**
	 * BT470BG matrix
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT470BG = 9,
	/**
	 * GBR matrix
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_GBR = 10,
	/**
	 * YCOCG matrix
	 * @since 5
	 */
	ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_YCOCG = 11,
};
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_YDZDX_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT470BG_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_GBR_SINCE_VERSION 5
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_YCOCG_SINCE_VERSION 5
#endif /* ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_ENUM */

#ifndef ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_ENUM_IS_VALID
#define ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_manager_v1
 * Validate a zcr_color_manager_v1 matrix_names value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_manager_v1_matrix_names
 */
static inline bool
zcr_color_manager_v1_matrix_names_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_UNKNOWN:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_RGB:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT709:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT2020_NCL:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT2020_CL:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_FCC:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_SMPTE170M:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_SMPTE240M:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_YDZDX:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_BT470BG:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_GBR:
		return version >= 5;
	case ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_YCOCG:
		return version >= 5;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGER_V1_MATRIX_NAMES_ENUM_IS_VALID */

#ifndef ZCR_COLOR_MANAGER_V1_RANGE_NAMES_ENUM
#define ZCR_COLOR_MANAGER_V1_RANGE_NAMES_ENUM
/**
 * @ingroup iface_zcr_color_manager_v1
 * For specifying RGB ranges
 *
 * Names that describe typical RGB value ranges.
 *
 */
enum zcr_color_manager_v1_range_names {
	/**
	 * Unknown range
	 */
	ZCR_COLOR_MANAGER_V1_RANGE_NAMES_UNKNOWN = 0,
	/**
	 * Limited RGB color range (values from 16-235 for 8-bit)
	 */
	ZCR_COLOR_MANAGER_V1_RANGE_NAMES_LIMITED = 1,
	/**
	 * Full RGB color range (values from 0 to 255 for 8-bit)
	 */
	ZCR_COLOR_MANAGER_V1_RANGE_NAMES_FULL = 2,
	/**
	 * Range is defined by EOTF/MatrixID
	 */
	ZCR_COLOR_MANAGER_V1_RANGE_NAMES_DERIVED = 3,
};
#endif /* ZCR_COLOR_MANAGER_V1_RANGE_NAMES_ENUM */

#ifndef ZCR_COLOR_MANAGER_V1_RANGE_NAMES_ENUM_IS_VALID
#define ZCR_COLOR_MANAGER_V1_RANGE_NAMES_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_manager_v1
 * Validate a zcr_color_manager_v1 range_names value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_manager_v1_range_names
 */
static inline bool
zcr_color_manager_v1_range_names_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGER_V1_RANGE_NAMES_UNKNOWN:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_RANGE_NAMES_LIMITED:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_RANGE_NAMES_FULL:
		return version >= 1;
	case ZCR_COLOR_MANAGER_V1_RANGE_NAMES_DERIVED:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGER_V1_RANGE_NAMES_ENUM_IS_VALID */

/**
 * @ingroup iface_zcr_color_manager_v1
 * @struct zcr_color_manager_v1_interface
 */
struct zcr_color_manager_v1_interface {
	/**
	 * create a color space object from ICC profiles
	 *
	 * Create a color space object from an ICC profile. This request
	 * returns a zcr_color_space_creator_v1 object which either returns
	 * an error or the successfully created zcr_color_space_v1 object.
	 *
	 * The description of the color space to create is sent in the form
	 * of an ICC profile as a file descriptor in the argument icc.
	 *
	 * The fd must be seekable and the maximum size of the ICC profile
	 * is 4 MB. Violating these requirements will raise an icc_fd
	 * protocol error. A compositor must not modify the contents of the
	 * file, and the fd may be sealed for writes and size changes.
	 *
	 * The file contents must represent a valid ICC profile. The ICC
	 * profile version must be 2 or 4, it must be a 3 channel profile
	 * and the class must be 'input', 'output', 'abstract' or
	 * 'display'. Violating these requirements will not result in a
	 * protocol error but raise the zcr_color_space_creator_v1.error
	 * event.
	 *
	 * See the zcr_color_space_v1 and zcr_color_space_creator_v1
	 * interface for more details about the created object.
	 *
	 * See the specification from International Color Consortium for
	 * more details about ICC profiles, also known as ISO 15076-1:2010.
	 */
	void (*create_color_space_from_icc)(struct wl_client *client,
					    struct wl_resource *resource,
					    uint32_t id,
					    int32_t icc);
	/**
	 * create a color space object from well-known names
	 *
	 * [Deprecated] Create a color space object from well-known
	 * names. This request returns a zcr_color_space_creator_v1 object
	 * which either returns an error or the successfully created
	 * zcr_color_space_v1 object.
	 *
	 * EOTF, chromaticity and whitepoint must not be unknown.
	 * Otherwise, or if a given value is not listed in the enumeration,
	 * the protocol error bad_enum is raised.
	 *
	 * See the zcr_color_space_v1 and zcr_color_space_creator_v1
	 * interface for more details about the created object. Use
	 * create_color_space_from_complete_names instead.
	 * @param eotf EOTF
	 * @param chromaticity chromaticity
	 * @param whitepoint whitepoint
	 */
	void (*create_color_space_from_names)(struct wl_client *client,
					      struct wl_resource *resource,
					      uint32_t id,
					      uint32_t eotf,
					      uint32_t chromaticity,
					      uint32_t whitepoint);
	/**
	 * create a color space object from parameters
	 *
	 * [Deprecated] Create a color space object from parameters. This
	 * request returns a zcr_color_space_creator_v1 object which either
	 * returns an error or the successfully created zcr_color_space_v1
	 * object.
	 *
	 * EOTF must not be unknown. Otherwise, or if a given EOTF is not
	 * listed in the enumeration, the protocol error bad_enum is
	 * raised.
	 *
	 * The white point must be inside the triangle created by the red,
	 * green and blue primaries. Otherwise the bad_param protocol error
	 * is raised.
	 *
	 * All the chromaticity values are multiplied by 10000 to produce
	 * the integers carried by the protocol.
	 *
	 * See the zcr_color_space_v1 and zcr_color_space_creator_v1
	 * interface for more details about the created object. Use
	 * create_color_space_from_complete_params instead.
	 * @param eotf EOTF
	 * @param primary_r_x red primary X * 10000
	 * @param primary_r_y red primary Y * 10000
	 * @param primary_g_x green primary X * 10000
	 * @param primary_g_y green primary Y * 10000
	 * @param primary_b_x blue primary X * 10000
	 * @param primary_b_y blue primary Y * 10000
	 * @param white_point_x white point X * 10000
	 * @param white_point_y white point Y * 10000
	 */
	void (*create_color_space_from_params)(struct wl_client *client,
					       struct wl_resource *resource,
					       uint32_t id,
					       uint32_t eotf,
					       uint32_t primary_r_x,
					       uint32_t primary_r_y,
					       uint32_t primary_g_x,
					       uint32_t primary_g_y,
					       uint32_t primary_b_x,
					       uint32_t primary_b_y,
					       uint32_t white_point_x,
					       uint32_t white_point_y);
	/**
	 * create a color management interface for a wl_output
	 *
	 * This creates a new zcr_color_management_output_v1 object for
	 * the given wl_output.
	 *
	 * See the zcr_color_management_output_v1 interface for more
	 * details.
	 */
	void (*get_color_management_output)(struct wl_client *client,
					    struct wl_resource *resource,
					    uint32_t id,
					    struct wl_resource *output);
	/**
	 * create a color management interface for a wl_surface
	 *
	 * This creates a new color zcr_color_management_surface_v1
	 * object for the given wl_surface.
	 *
	 * See the zcr_color_management_surface_v1 interface for more
	 * details.
	 */
	void (*get_color_management_surface)(struct wl_client *client,
					     struct wl_resource *resource,
					     uint32_t id,
					     struct wl_resource *surface);
	/**
	 * destroy the color manager
	 *
	 * Destroy the zcr_color_manager_v1 object. This does not affect
	 * any other objects in any way.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * create a color space object from well-known names
	 *
	 * Create a color space object from well-known names. This
	 * request returns a zcr_color_space_creator_v1 object which either
	 * returns an error or the successfully created zcr_color_space_v1
	 * object.
	 *
	 * EOTF, chromaticity and whitepoint must not be unknown.
	 * Otherwise, or if a given value is not listed in the enumeration,
	 * the protocol error bad_enum is raised.
	 *
	 * This request additionally includes matrix and range information.
	 *
	 * See the zcr_color_space_v1 and zcr_color_space_creator_v1
	 * interface for more details about the created object.
	 * @param eotf EOTF
	 * @param chromaticity chromaticity
	 * @param whitepoint whitepoint
	 * @param matrix color matrix
	 * @param range color range
	 * @since 3
	 */
	void (*create_color_space_from_complete_names)(struct wl_client *client,
						       struct wl_resource *resource,
						       uint32_t id,
						       uint32_t eotf,
						       uint32_t chromaticity,
						       uint32_t whitepoint,
						       uint32_t matrix,
						       uint32_t range);
	/**
	 * create a color space object from parameters
	 *
	 * Create a color space object from parameters. This request
	 * returns a zcr_color_space_creator_v1 object which either returns
	 * an error or the successfully created zcr_color_space_v1 object.
	 *
	 * EOTF must not be unknown. Otherwise, or if a given EOTF is not
	 * listed in the enumeration, the protocol error bad_enum is
	 * raised.
	 *
	 * The white point must be inside the triangle created by the red,
	 * green and blue primaries. Otherwise the bad_param protocol error
	 * is raised.
	 *
	 * All the chromaticity values are multiplied by 10000 to produce
	 * the integers carried by the protocol.
	 *
	 * This request additionally includes matrix and range information.
	 *
	 * See the zcr_color_space_v1 and zcr_color_space_creator_v1
	 * interface for more details about the created object.
	 * @param eotf EOTF
	 * @param matrix Color matrix
	 * @param range Color range
	 * @param primary_r_x red primary X * 10000
	 * @param primary_r_y red primary Y * 10000
	 * @param primary_g_x green primary X * 10000
	 * @param primary_g_y green primary Y * 10000
	 * @param primary_b_x blue primary X * 10000
	 * @param primary_b_y blue primary Y * 10000
	 * @param white_point_x white point X * 10000
	 * @param white_point_y white point Y * 10000
	 * @since 3
	 */
	void (*create_color_space_from_complete_params)(struct wl_client *client,
							struct wl_resource *resource,
							uint32_t id,
							uint32_t eotf,
							uint32_t matrix,
							uint32_t range,
							uint32_t primary_r_x,
							uint32_t primary_r_y,
							uint32_t primary_g_x,
							uint32_t primary_g_y,
							uint32_t primary_b_x,
							uint32_t primary_b_y,
							uint32_t white_point_x,
							uint32_t white_point_y);
};


/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CREATE_COLOR_SPACE_FROM_ICC_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CREATE_COLOR_SPACE_FROM_NAMES_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CREATE_COLOR_SPACE_FROM_PARAMS_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_GET_COLOR_MANAGEMENT_OUTPUT_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_GET_COLOR_MANAGEMENT_SURFACE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CREATE_COLOR_SPACE_FROM_COMPLETE_NAMES_SINCE_VERSION 3
/**
 * @ingroup iface_zcr_color_manager_v1
 */
#define ZCR_COLOR_MANAGER_V1_CREATE_COLOR_SPACE_FROM_COMPLETE_PARAMS_SINCE_VERSION 3

/**
 * @ingroup iface_zcr_color_management_output_v1
 * @struct zcr_color_management_output_v1_interface
 */
struct zcr_color_management_output_v1_interface {
	/**
	 * get the color space of the output
	 *
	 * This creates a new zcr_color_space_v1 object for the current
	 * color space of the output. There always is exactly one color
	 * space active for an output so the client should destroy the
	 * color space created by earlier invocations of this request. This
	 * request is usually sent as a reaction to the color_space_changed
	 * event or when creating a zcr_color_management_output_v1 object.
	 *
	 * The created zcr_color_space_v1 object preserves the color space
	 * of the output from the time the object was created.
	 *
	 * The resulting color space object allows get_information request.
	 *
	 * See the zcr_color_space_v1 interface for more details.
	 */
	void (*get_color_space)(struct wl_client *client,
				struct wl_resource *resource,
				uint32_t id);
	/**
	 * destroy the color management output
	 *
	 * Destroy the color zcr_color_management_output_v1 object. This
	 * does not affect any remaining protocol objects.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZCR_COLOR_MANAGEMENT_OUTPUT_V1_COLOR_SPACE_CHANGED 0
#define ZCR_COLOR_MANAGEMENT_OUTPUT_V1_EXTENDED_DYNAMIC_RANGE 1

/**
 * @ingroup iface_zcr_color_management_output_v1
 */
#define ZCR_COLOR_MANAGEMENT_OUTPUT_V1_COLOR_SPACE_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_management_output_v1
 */
#define ZCR_COLOR_MANAGEMENT_OUTPUT_V1_EXTENDED_DYNAMIC_RANGE_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_color_management_output_v1
 */
#define ZCR_COLOR_MANAGEMENT_OUTPUT_V1_GET_COLOR_SPACE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_management_output_v1
 */
#define ZCR_COLOR_MANAGEMENT_OUTPUT_V1_DESTROY_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_color_management_output_v1
 * Sends an color_space_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zcr_color_management_output_v1_send_color_space_changed(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZCR_COLOR_MANAGEMENT_OUTPUT_V1_COLOR_SPACE_CHANGED);
}

/**
 * @ingroup iface_zcr_color_management_output_v1
 * Sends an extended_dynamic_range event to the client owning the resource.
 * @param resource_ The client's resource
 * @param value EDR value * 1000
 */
static inline void
zcr_color_management_output_v1_send_extended_dynamic_range(struct wl_resource *resource_, uint32_t value)
{
	wl_resource_post_event(resource_, ZCR_COLOR_MANAGEMENT_OUTPUT_V1_EXTENDED_DYNAMIC_RANGE, value);
}

#ifndef ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ENUM
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ENUM
/**
 * @ingroup iface_zcr_color_management_surface_v1
 * render intent
 *
 *
 * Rendering intent allow the client to hint at how to perform color space
 * transformations.
 *
 * See the ICC specification for more details about rendering intent.
 */
enum zcr_color_management_surface_v1_render_intent {
	/**
	 * perceptual
	 */
	ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_PERCEPTUAL = 0,
	/**
	 * media-relative colorimetric
	 */
	ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_RELATIVE = 1,
	/**
	 * saturation
	 */
	ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_SATURATION = 2,
	/**
	 * ICC-absolute colorimetric
	 */
	ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ABSOLUTE = 3,
	/**
	 * media-relative colorimetric + black point compensation
	 */
	ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_RELATIVE_BPC = 4,
};
#endif /* ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ENUM */

#ifndef ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ENUM_IS_VALID
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_management_surface_v1
 * Validate a zcr_color_management_surface_v1 render_intent value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_management_surface_v1_render_intent
 */
static inline bool
zcr_color_management_surface_v1_render_intent_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_PERCEPTUAL:
		return version >= 1;
	case ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_RELATIVE:
		return version >= 1;
	case ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_SATURATION:
		return version >= 1;
	case ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ABSOLUTE:
		return version >= 1;
	case ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_RELATIVE_BPC:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGEMENT_SURFACE_V1_RENDER_INTENT_ENUM_IS_VALID */

#ifndef ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_ENUM
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_ENUM
/**
 * @ingroup iface_zcr_color_management_surface_v1
 * alpha mode
 *
 * Specifies whether alpha is pre-multiplied into color channels or not.
 * If pre-multiplied, the linear alpha value is already multiplied with the
 * (non-linear) color channel code values in the color channels.
 */
enum zcr_color_management_surface_v1_alpha_mode {
	/**
	 * alpha is independent from color channels
	 */
	ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_STRAIGHT = 0,
	/**
	 * alpha is pre-multiplied into color channels
	 */
	ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_PREMULTIPLIED = 1,
};
#endif /* ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_ENUM */

#ifndef ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_ENUM_IS_VALID
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_management_surface_v1
 * Validate a zcr_color_management_surface_v1 alpha_mode value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_management_surface_v1_alpha_mode
 */
static inline bool
zcr_color_management_surface_v1_alpha_mode_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_STRAIGHT:
		return version >= 1;
	case ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_PREMULTIPLIED:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_MANAGEMENT_SURFACE_V1_ALPHA_MODE_ENUM_IS_VALID */

/**
 * @ingroup iface_zcr_color_management_surface_v1
 * @struct zcr_color_management_surface_v1_interface
 */
struct zcr_color_management_surface_v1_interface {
	/**
	 * set the surface alpha mode
	 *
	 * Assuming an alpha channel exists, it is always linear. The
	 * alpha mode determines whether the color channels include alpha
	 * pre-multiplied or not. Using straight alpha might have
	 * performance benefits.
	 *
	 * Alpha mode is double buffered, and will be applied at the time
	 * wl_surface.commit of the corresponding wl_surface is called.
	 *
	 * By default, a surface is assumed to have pre-multiplied alpha.
	 * @param alpha_mode alpha mode
	 */
	void (*set_alpha_mode)(struct wl_client *client,
			       struct wl_resource *resource,
			       uint32_t alpha_mode);
	/**
	 * set the content extended dynamic range
	 *
	 * Set the extended dynamic range (EDR) value for the underlying
	 * surface. The EDR value is double buffered, and will be applied
	 * at the time wl_surface.commit of the corresponding wl_surface is
	 * called.
	 *
	 * The EDR value describes how much dynamic range is encoded
	 * relative to the SDR maximum white. EDR value is proportional to
	 * luminance, using the luminance of black as the zero level. A
	 * value of 1.0 means that the SDR maximum white is the highest
	 * possible luminance of the surface. A value of 3.0 means that the
	 * SDR maximum white is one third of the highest possible luminance
	 * of the surface.
	 *
	 * The color space attached to the surface can make the code values
	 * in the buffer non-linear in regards to the luminance. The code
	 * value to produce a third of the luminance of the biggest code
	 * value therefore might not be one third of the biggest code
	 * value.
	 *
	 * For the definition of the SDR maximum white on an output, see
	 * zcr_color_management_output_v1.extended_dynamic_range. Content
	 * producers are free to choose their SDR maximum white level. How
	 * it shall be displayed depends on the monitor capabilities and
	 * the output EDR value.
	 *
	 * By default the EDR value is 1.0. The compositor will tone map
	 * the image to match the EDR of each output the surface is shown
	 * on. The aim for the EDR-EDR mapping is to produce a relative
	 * luminance mapping that looks equally good regardless of the
	 * viewing conditions and the monitor capabilities, assuming the
	 * output EDR value was tuned to the output capabilities and the
	 * viewing environment. There might be performance and image
	 * quality benefits from providing content readily tone mapped to
	 * the EDR value of the output the surface is shown on.
	 *
	 * The EDR value is multiplied by 1000 to produce the integer value
	 * carried by the protocol.
	 * @param value EDR value * 1000
	 */
	void (*set_extended_dynamic_range)(struct wl_client *client,
					   struct wl_resource *resource,
					   uint32_t value);
	/**
	 * set the surface color space
	 *
	 * Set the color space of the underlying surface. The color space
	 * and render intent are double buffered, and will be applied at
	 * the time wl_surface.commit of the corresponding wl_surface is
	 * called.
	 *
	 * The render intent gives the compositor a hint what to optimize
	 * for in color space transformations.
	 *
	 * By default, a surface is assumed to have the sRGB color space
	 * and an arbitrary render intent.
	 *
	 * If the color space of the surface matches the color space of an
	 * output it is shown on the performance and color accuracy might
	 * improve. To find those color spaces the client can listen to the
	 * preferred_color_space or the wl_surface.enter/leave events. This
	 * improvement may require using the color space object created by
	 * zcr_color_management_output_v1.get_color_space.
	 * @param render_intent render intent
	 */
	void (*set_color_space)(struct wl_client *client,
				struct wl_resource *resource,
				struct wl_resource *color_space,
				uint32_t render_intent);
	/**
	 * set the surface color space to default
	 *
	 * This request sets the surface color space to the defaults, see
	 * set_color_space. The setting will be applied at the time
	 * wl_surface.commit of the corresponding wl_surface is called.
	 */
	void (*set_default_color_space)(struct wl_client *client,
					struct wl_resource *resource);
	/**
	 * destroy the color management interface for a surface
	 *
	 * Destroy the zcr_color_management_surface_v1 object.
	 *
	 * When the last zcr_color_management_surface_v1 object for a
	 * wl_surface is destroyed, the destruction will pend unsetting the
	 * wl_surface's color space, render intent and alpha mode similar
	 * to set_color_space will pend a set.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_PREFERRED_COLOR_SPACE 0

/**
 * @ingroup iface_zcr_color_management_surface_v1
 */
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_PREFERRED_COLOR_SPACE_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_color_management_surface_v1
 */
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_SET_ALPHA_MODE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_management_surface_v1
 */
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_SET_EXTENDED_DYNAMIC_RANGE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_management_surface_v1
 */
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_SET_COLOR_SPACE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_management_surface_v1
 */
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_SET_DEFAULT_COLOR_SPACE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_management_surface_v1
 */
#define ZCR_COLOR_MANAGEMENT_SURFACE_V1_DESTROY_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_color_management_surface_v1
 * Sends an preferred_color_space event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zcr_color_management_surface_v1_send_preferred_color_space(struct wl_resource *resource_, struct wl_resource *output)
{
	wl_resource_post_event(resource_, ZCR_COLOR_MANAGEMENT_SURFACE_V1_PREFERRED_COLOR_SPACE, output);
}

#ifndef ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_ENUM
#define ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_ENUM
/**
 * @ingroup iface_zcr_color_space_creator_v1
 * color space creation error
 *
 * Bitmask of errors which occured while trying to create a color space
 */
enum zcr_color_space_creator_v1_creation_error {
	/**
	 * malformed ICC profile
	 */
	ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_MALFORMED_ICC = 0x1,
	/**
	 * ICC profile does not meet requirements
	 */
	ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_BAD_ICC = 0x2,
	/**
	 * bad primaries
	 */
	ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_BAD_PRIMARIES = 0x4,
	/**
	 * bad whitepoint
	 */
	ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_BAD_WHITEPOINT = 0x8,
};
#endif /* ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_ENUM */

#ifndef ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_ENUM_IS_VALID
#define ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_space_creator_v1
 * Validate a zcr_color_space_creator_v1 creation_error value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_space_creator_v1_creation_error
 */
static inline bool
zcr_color_space_creator_v1_creation_error_is_valid(uint32_t value, uint32_t version) {
	uint32_t valid = 0;
	if (version >= 1)
		valid |= ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_MALFORMED_ICC;
	if (version >= 1)
		valid |= ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_BAD_ICC;
	if (version >= 1)
		valid |= ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_BAD_PRIMARIES;
	if (version >= 1)
		valid |= ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_BAD_WHITEPOINT;
	return (value & ~valid) == 0;
}
#endif /* ZCR_COLOR_SPACE_CREATOR_V1_CREATION_ERROR_ENUM_IS_VALID */

#define ZCR_COLOR_SPACE_CREATOR_V1_CREATED 0
#define ZCR_COLOR_SPACE_CREATOR_V1_ERROR 1

/**
 * @ingroup iface_zcr_color_space_creator_v1
 */
#define ZCR_COLOR_SPACE_CREATOR_V1_CREATED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_space_creator_v1
 */
#define ZCR_COLOR_SPACE_CREATOR_V1_ERROR_SINCE_VERSION 1


/**
 * @ingroup iface_zcr_color_space_creator_v1
 * Sends an created event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zcr_color_space_creator_v1_send_created(struct wl_resource *resource_, struct wl_resource *id)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_CREATOR_V1_CREATED, id);
}

/**
 * @ingroup iface_zcr_color_space_creator_v1
 * Sends an error event to the client owning the resource.
 * @param resource_ The client's resource
 * @param error error bitmask
 */
static inline void
zcr_color_space_creator_v1_send_error(struct wl_resource *resource_, uint32_t error)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_CREATOR_V1_ERROR, error);
}

#ifndef ZCR_COLOR_SPACE_V1_ERROR_ENUM
#define ZCR_COLOR_SPACE_V1_ERROR_ENUM
enum zcr_color_space_v1_error {
	/**
	 * get_information disallowed
	 */
	ZCR_COLOR_SPACE_V1_ERROR_NO_INFORMATION = 0,
};
#endif /* ZCR_COLOR_SPACE_V1_ERROR_ENUM */

#ifndef ZCR_COLOR_SPACE_V1_ERROR_ENUM_IS_VALID
#define ZCR_COLOR_SPACE_V1_ERROR_ENUM_IS_VALID
/**
 * @ingroup iface_zcr_color_space_v1
 * Validate a zcr_color_space_v1 error value.
 *
 * @return true on success, false on error.
 * @ref zcr_color_space_v1_error
 */
static inline bool
zcr_color_space_v1_error_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case ZCR_COLOR_SPACE_V1_ERROR_NO_INFORMATION:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* ZCR_COLOR_SPACE_V1_ERROR_ENUM_IS_VALID */

/**
 * @ingroup iface_zcr_color_space_v1
 * @struct zcr_color_space_v1_interface
 */
struct zcr_color_space_v1_interface {
	/**
	 * get information about the color space
	 *
	 * As a reply to this request, the compositor will send all
	 * available information events describing this color space object
	 * and finally the 'done' event. Other extensions may define more
	 * events to be sent before 'done'.
	 *
	 * This request is allowed only on zcr_color_space_v1 objects where
	 * the message that created the object specifies that
	 * get_information is allowed. Otherwise protocol error
	 * no_information is raised.
	 *
	 * Every get_information request on the same object will always
	 * return the exact same data.
	 *
	 * See zcr_color_management_output_v1.get_color_space and
	 * zcr_color_space_creator_v1.created.
	 */
	void (*get_information)(struct wl_client *client,
				struct wl_resource *resource);
	/**
	 * destroy the color space
	 *
	 * Destroy the zcr_color_space_v1 object.
	 *
	 * Destroying the zcr_color_space_v1 which is active on a surface
	 * or an output does not change the color space of those objects.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZCR_COLOR_SPACE_V1_ICC_FILE 0
#define ZCR_COLOR_SPACE_V1_NAMES 1
#define ZCR_COLOR_SPACE_V1_PARAMS 2
#define ZCR_COLOR_SPACE_V1_DONE 3
#define ZCR_COLOR_SPACE_V1_COMPLETE_NAMES 4
#define ZCR_COLOR_SPACE_V1_COMPLETE_PARAMS 5

/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_ICC_FILE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_NAMES_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_PARAMS_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_DONE_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_COMPLETE_NAMES_SINCE_VERSION 3
/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_COMPLETE_PARAMS_SINCE_VERSION 3

/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_GET_INFORMATION_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_color_space_v1
 */
#define ZCR_COLOR_SPACE_V1_DESTROY_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_color_space_v1
 * Sends an icc_file event to the client owning the resource.
 * @param resource_ The client's resource
 * @param icc ICC profile file descriptor
 * @param icc_size ICC profile size, in bytes
 */
static inline void
zcr_color_space_v1_send_icc_file(struct wl_resource *resource_, int32_t icc, uint32_t icc_size)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_V1_ICC_FILE, icc, icc_size);
}

/**
 * @ingroup iface_zcr_color_space_v1
 * Sends an names event to the client owning the resource.
 * @param resource_ The client's resource
 * @param eotf EOTF
 * @param chromaticity chromaticity
 * @param whitepoint whitepoint
 */
static inline void
zcr_color_space_v1_send_names(struct wl_resource *resource_, uint32_t eotf, uint32_t chromaticity, uint32_t whitepoint)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_V1_NAMES, eotf, chromaticity, whitepoint);
}

/**
 * @ingroup iface_zcr_color_space_v1
 * Sends an params event to the client owning the resource.
 * @param resource_ The client's resource
 * @param eotf EOTF
 * @param primary_r_x red primary X * 10000
 * @param primary_r_y red primary Y * 10000
 * @param primary_g_x green primary X * 10000
 * @param primary_g_y green primary Y * 10000
 * @param primary_b_x blue primary X * 10000
 * @param primary_b_y blue primary Y * 10000
 * @param white_point_x white point X * 10000
 * @param white_point_y white point Y * 10000
 */
static inline void
zcr_color_space_v1_send_params(struct wl_resource *resource_, uint32_t eotf, uint32_t primary_r_x, uint32_t primary_r_y, uint32_t primary_g_x, uint32_t primary_g_y, uint32_t primary_b_x, uint32_t primary_b_y, uint32_t white_point_x, uint32_t white_point_y)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_V1_PARAMS, eotf, primary_r_x, primary_r_y, primary_g_x, primary_g_y, primary_b_x, primary_b_y, white_point_x, white_point_y);
}

/**
 * @ingroup iface_zcr_color_space_v1
 * Sends an done event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zcr_color_space_v1_send_done(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_V1_DONE);
}

/**
 * @ingroup iface_zcr_color_space_v1
 * Sends an complete_names event to the client owning the resource.
 * @param resource_ The client's resource
 * @param eotf EOTF
 * @param chromaticity chromaticity
 * @param whitepoint whitepoint
 * @param matrix Color matrix
 * @param range Color range
 */
static inline void
zcr_color_space_v1_send_complete_names(struct wl_resource *resource_, uint32_t eotf, uint32_t chromaticity, uint32_t whitepoint, uint32_t matrix, uint32_t range)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_V1_COMPLETE_NAMES, eotf, chromaticity, whitepoint, matrix, range);
}

/**
 * @ingroup iface_zcr_color_space_v1
 * Sends an complete_params event to the client owning the resource.
 * @param resource_ The client's resource
 * @param eotf EOTF
 * @param matrix Color matrix
 * @param range Color range
 * @param primary_r_x red primary X * 10000
 * @param primary_r_y red primary Y * 10000
 * @param primary_g_x green primary X * 10000
 * @param primary_g_y green primary Y * 10000
 * @param primary_b_x blue primary X * 10000
 * @param primary_b_y blue primary Y * 10000
 * @param white_point_x white point X * 10000
 * @param white_point_y white point Y * 10000
 */
static inline void
zcr_color_space_v1_send_complete_params(struct wl_resource *resource_, uint32_t eotf, uint32_t matrix, uint32_t range, uint32_t primary_r_x, uint32_t primary_r_y, uint32_t primary_g_x, uint32_t primary_g_y, uint32_t primary_b_x, uint32_t primary_b_y, uint32_t white_point_x, uint32_t white_point_y)
{
	wl_resource_post_event(resource_, ZCR_COLOR_SPACE_V1_COMPLETE_PARAMS, eotf, matrix, range, primary_r_x, primary_r_y, primary_g_x, primary_g_y, primary_b_x, primary_b_y, white_point_x, white_point_y);
}

#ifdef  __cplusplus
}
#endif

#endif
