// This file is generated by TypeBuilder_h.template.

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef content_protocol_BluetoothEmulation_h
#define content_protocol_BluetoothEmulation_h

#include "content/common/content_export.h"
#include "content/browser/devtools/protocol/protocol.h"
// For each imported domain we generate a ValueConversions struct instead of a full domain definition
// and include Domain::API version from there.

namespace content {
namespace protocol {
namespace BluetoothEmulation {
using CentralState = String;
class ManufacturerData;
class ScanRecord;
class ScanEntry;

// ------------- Forward and enum declarations.

namespace CentralStateEnum {
CONTENT_EXPORT extern const char Absent[];
CONTENT_EXPORT extern const char PoweredOff[];
CONTENT_EXPORT extern const char PoweredOn[];
} // namespace CentralStateEnum

// ------------- Type and builder declarations.

class CONTENT_EXPORT ManufacturerData : public ::crdtp::ProtocolObject<ManufacturerData> {
public:
    ~ManufacturerData() override { }

    int GetKey() { return m_key; }
    void SetKey(int value) { m_key = value; }

    Binary GetData() { return m_data; }
    void SetData(const Binary& value) { m_data = value; }

    template<int STATE>
    class ManufacturerDataBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            KeySet = 1 << 1,
            DataSet = 1 << 2,
            AllFieldsSet = (KeySet | DataSet | 0)};


        ManufacturerDataBuilder<STATE | KeySet>& SetKey(int value)
        {
            static_assert(!(STATE & KeySet), "property key should not be set yet");
            m_result->SetKey(value);
            return castState<KeySet>();
        }

        ManufacturerDataBuilder<STATE | DataSet>& SetData(const Binary& value)
        {
            static_assert(!(STATE & DataSet), "property data should not be set yet");
            m_result->SetData(value);
            return castState<DataSet>();
        }

        std::unique_ptr<ManufacturerData> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ManufacturerData;
        ManufacturerDataBuilder() : m_result(new ManufacturerData()) { }

        template<int STEP> ManufacturerDataBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ManufacturerDataBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::BluetoothEmulation::ManufacturerData> m_result;
    };

    static ManufacturerDataBuilder<0> Create()
    {
        return ManufacturerDataBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ManufacturerData()
    {
          m_key = 0;
    }

    int m_key;
    Binary m_data;
};


class CONTENT_EXPORT ScanRecord : public ::crdtp::ProtocolObject<ScanRecord> {
public:
    ~ScanRecord() override { }

    bool HasName() { return !!m_name; }
    String GetName(const String& defaultValue) const {
       return m_name.value_or(defaultValue);
    }
    const std::optional<String>& GetName() const {
       return m_name;
    }
    void SetName(const String& value) { m_name = value; }

    bool HasUuids() { return !!m_uuids; }
    protocol::Array<String>* GetUuids(protocol::Array<String>* defaultValue) {
       return m_uuids ? m_uuids.get() : defaultValue;
    }
    const std::unique_ptr<protocol::Array<String>>& GetUuids() const {
       return m_uuids;
    }
    void SetUuids(std::unique_ptr<protocol::Array<String>> value) { m_uuids = std::move(value); }

    bool HasAppearance() { return !!m_appearance; }
    int GetAppearance(int defaultValue) const {
       return m_appearance.value_or(defaultValue);
    }
    const std::optional<int>& GetAppearance() const {
       return m_appearance;
    }
    void SetAppearance(int value) { m_appearance = value; }

    bool HasTxPower() { return !!m_txPower; }
    int GetTxPower(int defaultValue) const {
       return m_txPower.value_or(defaultValue);
    }
    const std::optional<int>& GetTxPower() const {
       return m_txPower;
    }
    void SetTxPower(int value) { m_txPower = value; }

    bool HasManufacturerData() { return !!m_manufacturerData; }
    protocol::Array<protocol::BluetoothEmulation::ManufacturerData>* GetManufacturerData(protocol::Array<protocol::BluetoothEmulation::ManufacturerData>* defaultValue) {
       return m_manufacturerData ? m_manufacturerData.get() : defaultValue;
    }
    const std::unique_ptr<protocol::Array<protocol::BluetoothEmulation::ManufacturerData>>& GetManufacturerData() const {
       return m_manufacturerData;
    }
    void SetManufacturerData(std::unique_ptr<protocol::Array<protocol::BluetoothEmulation::ManufacturerData>> value) { m_manufacturerData = std::move(value); }

    template<int STATE>
    class ScanRecordBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            AllFieldsSet = (0)};


        ScanRecordBuilder<STATE>& SetName(const String& value)
        {
            m_result->SetName(value);
            return *this;
        }

        ScanRecordBuilder<STATE>& SetUuids(std::unique_ptr<protocol::Array<String>> value)
        {
            m_result->SetUuids(std::move(value));
            return *this;
        }

        ScanRecordBuilder<STATE>& SetAppearance(int value)
        {
            m_result->SetAppearance(value);
            return *this;
        }

        ScanRecordBuilder<STATE>& SetTxPower(int value)
        {
            m_result->SetTxPower(value);
            return *this;
        }

        ScanRecordBuilder<STATE>& SetManufacturerData(std::unique_ptr<protocol::Array<protocol::BluetoothEmulation::ManufacturerData>> value)
        {
            m_result->SetManufacturerData(std::move(value));
            return *this;
        }

        std::unique_ptr<ScanRecord> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ScanRecord;
        ScanRecordBuilder() : m_result(new ScanRecord()) { }

        template<int STEP> ScanRecordBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ScanRecordBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::BluetoothEmulation::ScanRecord> m_result;
    };

    static ScanRecordBuilder<0> Create()
    {
        return ScanRecordBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ScanRecord()
    {
    }

    std::optional<String> m_name;
    std::unique_ptr<protocol::Array<String>> m_uuids;
    std::optional<int> m_appearance;
    std::optional<int> m_txPower;
    std::unique_ptr<protocol::Array<protocol::BluetoothEmulation::ManufacturerData>> m_manufacturerData;
};


class CONTENT_EXPORT ScanEntry : public ::crdtp::ProtocolObject<ScanEntry> {
public:
    ~ScanEntry() override { }

    String GetDeviceAddress() { return m_deviceAddress; }
    void SetDeviceAddress(const String& value) { m_deviceAddress = value; }

    int GetRssi() { return m_rssi; }
    void SetRssi(int value) { m_rssi = value; }

    protocol::BluetoothEmulation::ScanRecord* GetScanRecord() { return m_scanRecord.get(); }
    void SetScanRecord(std::unique_ptr<protocol::BluetoothEmulation::ScanRecord> value) { m_scanRecord = std::move(value); }

    template<int STATE>
    class ScanEntryBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            DeviceAddressSet = 1 << 1,
            RssiSet = 1 << 2,
            ScanRecordSet = 1 << 3,
            AllFieldsSet = (DeviceAddressSet | RssiSet | ScanRecordSet | 0)};


        ScanEntryBuilder<STATE | DeviceAddressSet>& SetDeviceAddress(const String& value)
        {
            static_assert(!(STATE & DeviceAddressSet), "property deviceAddress should not be set yet");
            m_result->SetDeviceAddress(value);
            return castState<DeviceAddressSet>();
        }

        ScanEntryBuilder<STATE | RssiSet>& SetRssi(int value)
        {
            static_assert(!(STATE & RssiSet), "property rssi should not be set yet");
            m_result->SetRssi(value);
            return castState<RssiSet>();
        }

        ScanEntryBuilder<STATE | ScanRecordSet>& SetScanRecord(std::unique_ptr<protocol::BluetoothEmulation::ScanRecord> value)
        {
            static_assert(!(STATE & ScanRecordSet), "property scanRecord should not be set yet");
            m_result->SetScanRecord(std::move(value));
            return castState<ScanRecordSet>();
        }

        std::unique_ptr<ScanEntry> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ScanEntry;
        ScanEntryBuilder() : m_result(new ScanEntry()) { }

        template<int STEP> ScanEntryBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ScanEntryBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::BluetoothEmulation::ScanEntry> m_result;
    };

    static ScanEntryBuilder<0> Create()
    {
        return ScanEntryBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ScanEntry()
    {
          m_rssi = 0;
    }

    String m_deviceAddress;
    int m_rssi;
    std::unique_ptr<protocol::BluetoothEmulation::ScanRecord> m_scanRecord;
};


// ------------- Backend interface.

class CONTENT_EXPORT Backend {
public:
    virtual ~Backend() { }

    virtual DispatchResponse Enable(const String& in_state) = 0;
    virtual DispatchResponse Disable() = 0;
    class CONTENT_EXPORT SimulatePreconnectedPeripheralCallback {
    public:
        virtual void sendSuccess() = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~SimulatePreconnectedPeripheralCallback() { }
    };
    virtual void SimulatePreconnectedPeripheral(const String& in_address, const String& in_name, std::unique_ptr<protocol::Array<protocol::BluetoothEmulation::ManufacturerData>> in_manufacturerData, std::unique_ptr<protocol::Array<String>> in_knownServiceUuids, std::unique_ptr<SimulatePreconnectedPeripheralCallback> callback) = 0;
    class CONTENT_EXPORT SimulateAdvertisementCallback {
    public:
        virtual void sendSuccess() = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~SimulateAdvertisementCallback() { }
    };
    virtual void SimulateAdvertisement(std::unique_ptr<protocol::BluetoothEmulation::ScanEntry> in_entry, std::unique_ptr<SimulateAdvertisementCallback> callback) = 0;

};

// ------------- Frontend interface.

class CONTENT_EXPORT Frontend {
public:
  explicit Frontend(FrontendChannel* frontend_channel) : frontend_channel_(frontend_channel) {}

  void flush();
  void sendRawNotification(std::unique_ptr<Serializable>);
 private:
  FrontendChannel* frontend_channel_;
};

// ------------- Dispatcher.

class CONTENT_EXPORT Dispatcher {
public:
    static void wire(UberDispatcher*, Backend*);

private:
    Dispatcher() { }
};

// ------------- Metainfo.

class CONTENT_EXPORT Metainfo {
public:
    using BackendClass = Backend;
    using FrontendClass = Frontend;
    using DispatcherClass = Dispatcher;
    static const char domainName[];
    static const char commandPrefix[];
    static const char version[];
};

} // namespace BluetoothEmulation
} // namespace content
} // namespace protocol

#endif // !defined(content_protocol_BluetoothEmulation_h)
