// content/browser/private_aggregation/private_aggregation_internals.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_PRIVATE_AGGREGATION_PRIVATE_AGGREGATION_INTERNALS_MOJOM_TEST_UTILS_H_
#define CONTENT_BROWSER_PRIVATE_AGGREGATION_PRIVATE_AGGREGATION_INTERNALS_MOJOM_TEST_UTILS_H_

#include "content/browser/private_aggregation/private_aggregation_internals.mojom.h"
#include "content/common/content_export.h"


namespace private_aggregation_internals::mojom {


class CONTENT_EXPORT ObserverInterceptorForTesting : public Observer {
  virtual Observer* GetForwardingInterface() = 0;
  void OnRequestStorageModified() override;
  void OnReportHandled(WebUIAggregatableReportPtr report) override;
};
class CONTENT_EXPORT ObserverAsyncWaiter {
 public:
  explicit ObserverAsyncWaiter(Observer* proxy);

  ObserverAsyncWaiter(const ObserverAsyncWaiter&) = delete;
  ObserverAsyncWaiter& operator=(const ObserverAsyncWaiter&) = delete;

  ~ObserverAsyncWaiter();

 private:
  Observer* const proxy_;
};


class CONTENT_EXPORT HandlerInterceptorForTesting : public Handler {
  virtual Handler* GetForwardingInterface() = 0;
  void GetReports(GetReportsCallback callback) override;
  void SendReports(const std::vector<::content::AggregatableReportRequestStorageId>& ids, SendReportsCallback callback) override;
  void ClearStorage(ClearStorageCallback callback) override;
};
class CONTENT_EXPORT HandlerAsyncWaiter {
 public:
  explicit HandlerAsyncWaiter(Handler* proxy);

  HandlerAsyncWaiter(const HandlerAsyncWaiter&) = delete;
  HandlerAsyncWaiter& operator=(const HandlerAsyncWaiter&) = delete;

  ~HandlerAsyncWaiter();
  void GetReports(
      std::vector<WebUIAggregatableReportPtr>* out_reports);
  std::vector<WebUIAggregatableReportPtr> GetReports();
  void SendReports(
      const std::vector<::content::AggregatableReportRequestStorageId>& ids);
  
  void ClearStorage(
      );
  

 private:
  Handler* const proxy_;
};


class CONTENT_EXPORT FactoryInterceptorForTesting : public Factory {
  virtual Factory* GetForwardingInterface() = 0;
  void Create(::mojo::PendingRemote<Observer> observer, ::mojo::PendingReceiver<Handler> handler) override;
};
class CONTENT_EXPORT FactoryAsyncWaiter {
 public:
  explicit FactoryAsyncWaiter(Factory* proxy);

  FactoryAsyncWaiter(const FactoryAsyncWaiter&) = delete;
  FactoryAsyncWaiter& operator=(const FactoryAsyncWaiter&) = delete;

  ~FactoryAsyncWaiter();

 private:
  Factory* const proxy_;
};




}  // private_aggregation_internals::mojom

#endif  // CONTENT_BROWSER_PRIVATE_AGGREGATION_PRIVATE_AGGREGATION_INTERNALS_MOJOM_TEST_UTILS_H_