// content/browser/tracing/trace_report/trace_report.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_TRACING_TRACE_REPORT_TRACE_REPORT_MOJOM_TEST_UTILS_H_
#define CONTENT_BROWSER_TRACING_TRACE_REPORT_TRACE_REPORT_MOJOM_TEST_UTILS_H_

#include "content/browser/tracing/trace_report/trace_report.mojom.h"


namespace trace_report::mojom {


class  TraceReportHandlerFactoryInterceptorForTesting : public TraceReportHandlerFactory {
  virtual TraceReportHandlerFactory* GetForwardingInterface() = 0;
  void CreatePageHandler(::mojo::PendingRemote<Page> page, ::mojo::PendingReceiver<PageHandler> handler) override;
};
class  TraceReportHandlerFactoryAsyncWaiter {
 public:
  explicit TraceReportHandlerFactoryAsyncWaiter(TraceReportHandlerFactory* proxy);

  TraceReportHandlerFactoryAsyncWaiter(const TraceReportHandlerFactoryAsyncWaiter&) = delete;
  TraceReportHandlerFactoryAsyncWaiter& operator=(const TraceReportHandlerFactoryAsyncWaiter&) = delete;

  ~TraceReportHandlerFactoryAsyncWaiter();

 private:
  TraceReportHandlerFactory* const proxy_;
};


class  PageHandlerInterceptorForTesting : public PageHandler {
  virtual PageHandler* GetForwardingInterface() = 0;
  void GetAllTraceReports(GetAllTraceReportsCallback callback) override;
  void DeleteSingleTrace(const ::base::Token& uuid, DeleteSingleTraceCallback callback) override;
  void DeleteAllTraces(DeleteAllTracesCallback callback) override;
  void UserUploadSingleTrace(const ::base::Token& uuid, UserUploadSingleTraceCallback callback) override;
  void DownloadTrace(const ::base::Token& uuid, DownloadTraceCallback callback) override;
  void GetAllPresetScenarios(GetAllPresetScenariosCallback callback) override;
  void GetAllFieldScenarios(GetAllFieldScenariosCallback callback) override;
  void GetEnabledScenarios(GetEnabledScenariosCallback callback) override;
  void SetEnabledScenarios(const std::vector<std::string>& new_config, SetEnabledScenariosCallback callback) override;
  void GetPrivacyFilterEnabled(GetPrivacyFilterEnabledCallback callback) override;
  void SetPrivacyFilterEnabled(bool enable) override;
};
class  PageHandlerAsyncWaiter {
 public:
  explicit PageHandlerAsyncWaiter(PageHandler* proxy);

  PageHandlerAsyncWaiter(const PageHandlerAsyncWaiter&) = delete;
  PageHandlerAsyncWaiter& operator=(const PageHandlerAsyncWaiter&) = delete;

  ~PageHandlerAsyncWaiter();
  void GetAllTraceReports(
      std::vector<ClientTraceReportPtr>* out_reports);
  std::vector<ClientTraceReportPtr> GetAllTraceReports();
  void DeleteSingleTrace(
      const ::base::Token& uuid, bool* out_success);
  bool DeleteSingleTrace(const ::base::Token& uuid);
  void DeleteAllTraces(
      bool* out_success);
  bool DeleteAllTraces();
  void UserUploadSingleTrace(
      const ::base::Token& uuid, bool* out_success);
  bool UserUploadSingleTrace(const ::base::Token& uuid);
  void DownloadTrace(
      const ::base::Token& uuid, std::optional<::mojo_base::BigBuffer>* out_trace);
  std::optional<::mojo_base::BigBuffer> DownloadTrace(const ::base::Token& uuid);
  void GetAllPresetScenarios(
      std::vector<ScenarioPtr>* out_config);
  std::vector<ScenarioPtr> GetAllPresetScenarios();
  void GetAllFieldScenarios(
      std::vector<ScenarioPtr>* out_config);
  std::vector<ScenarioPtr> GetAllFieldScenarios();
  void GetEnabledScenarios(
      std::vector<std::string>* out_config);
  std::vector<std::string> GetEnabledScenarios();
  void SetEnabledScenarios(
      const std::vector<std::string>& new_config, bool* out_success);
  bool SetEnabledScenarios(const std::vector<std::string>& new_config);
  void GetPrivacyFilterEnabled(
      bool* out_enabled);
  bool GetPrivacyFilterEnabled();

 private:
  PageHandler* const proxy_;
};


class  PageInterceptorForTesting : public Page {
  virtual Page* GetForwardingInterface() = 0;
};
class  PageAsyncWaiter {
 public:
  explicit PageAsyncWaiter(Page* proxy);

  PageAsyncWaiter(const PageAsyncWaiter&) = delete;
  PageAsyncWaiter& operator=(const PageAsyncWaiter&) = delete;

  ~PageAsyncWaiter();

 private:
  Page* const proxy_;
};




}  // trace_report::mojom

#endif  // CONTENT_BROWSER_TRACING_TRACE_REPORT_TRACE_REPORT_MOJOM_TEST_UTILS_H_