// electron/shell/common/api/api.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef ELECTRON_SHELL_COMMON_API_API_MOJOM_H_
#define ELECTRON_SHELL_COMMON_API_API_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "electron/shell/common/api/api.mojom-features.h"  // IWYU pragma: export
#include "electron/shell/common/api/api.mojom-shared.h"  // IWYU pragma: export
#include "electron/shell/common/api/api.mojom-forward.h"  // IWYU pragma: export
#include "mojo/public/mojom/base/string16.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include "third_party/blink/public/mojom/messaging/cloneable_message.mojom.h"
#include "third_party/blink/public/mojom/messaging/transferable_message.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace electron::mojom {

class ElectronRendererProxy;

template <typename ImplRefTraits>
class ElectronRendererStub;

class ElectronRendererRequestValidator;
class ElectronRendererResponseValidator;


class ElectronRenderer
    : public ElectronRendererInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ElectronRendererInterfaceBase;
  using Proxy_ = ElectronRendererProxy;

  template <typename ImplRefTraits>
  using Stub_ = ElectronRendererStub<ImplRefTraits>;

  using RequestValidator_ = ElectronRendererRequestValidator;
  using ResponseValidator_ = ElectronRendererResponseValidator;
  enum MethodMinVersions : uint32_t {
    kMessageMinVersion = 0,
    kReceivePostMessageMinVersion = 0,
    kTakeHeapSnapshotMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Message_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ReceivePostMessage_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct TakeHeapSnapshot_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ElectronRenderer() = default;

  
  virtual void Message(bool internal, const std::string& channel, ::blink::CloneableMessage arguments) = 0;

  
  virtual void ReceivePostMessage(const std::string& channel, ::blink::TransferableMessage message) = 0;


  using TakeHeapSnapshotCallback = base::OnceCallback<void(bool)>;
  
  virtual void TakeHeapSnapshot(::mojo::ScopedHandle file, TakeHeapSnapshotCallback callback) = 0;
};

class ElectronAutofillAgentProxy;

template <typename ImplRefTraits>
class ElectronAutofillAgentStub;

class ElectronAutofillAgentRequestValidator;


class ElectronAutofillAgent
    : public ElectronAutofillAgentInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ElectronAutofillAgentInterfaceBase;
  using Proxy_ = ElectronAutofillAgentProxy;

  template <typename ImplRefTraits>
  using Stub_ = ElectronAutofillAgentStub<ImplRefTraits>;

  using RequestValidator_ = ElectronAutofillAgentRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAcceptDataListSuggestionMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct AcceptDataListSuggestion_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ElectronAutofillAgent() = default;

  
  virtual void AcceptDataListSuggestion(const ::std::u16string& value) = 0;
};

class ElectronAutofillDriverProxy;

template <typename ImplRefTraits>
class ElectronAutofillDriverStub;

class ElectronAutofillDriverRequestValidator;


class ElectronAutofillDriver
    : public ElectronAutofillDriverInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ElectronAutofillDriverInterfaceBase;
  using Proxy_ = ElectronAutofillDriverProxy;

  template <typename ImplRefTraits>
  using Stub_ = ElectronAutofillDriverStub<ImplRefTraits>;

  using RequestValidator_ = ElectronAutofillDriverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kShowAutofillPopupMinVersion = 0,
    kHideAutofillPopupMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ShowAutofillPopup_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct HideAutofillPopup_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ElectronAutofillDriver() = default;

  
  virtual void ShowAutofillPopup(const ::gfx::RectF& bounds, const std::vector<::std::u16string>& values, const std::vector<::std::u16string>& labels) = 0;

  
  virtual void HideAutofillPopup() = 0;
};

class ElectronApiIPCProxy;

template <typename ImplRefTraits>
class ElectronApiIPCStub;

class ElectronApiIPCRequestValidator;
class ElectronApiIPCResponseValidator;


class ElectronApiIPC
    : public ElectronApiIPCInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    893845755
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ElectronApiIPCInterfaceBase;
  using Proxy_ = ElectronApiIPCProxy;

  template <typename ImplRefTraits>
  using Stub_ = ElectronApiIPCStub<ImplRefTraits>;

  using RequestValidator_ = ElectronApiIPCRequestValidator;
  using ResponseValidator_ = ElectronApiIPCResponseValidator;
  enum MethodMinVersions : uint32_t {
    kMessageMinVersion = 0,
    kInvokeMinVersion = 0,
    kReceivePostMessageMinVersion = 0,
    kMessageSyncMinVersion = 0,
    kMessageHostMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Message_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Invoke_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ReceivePostMessage_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct MessageSync_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct MessageHost_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ElectronApiIPC() = default;

  
  virtual void Message(bool internal, const std::string& channel, ::blink::CloneableMessage arguments) = 0;


  using InvokeCallback = base::OnceCallback<void(::blink::CloneableMessage)>;
  
  virtual void Invoke(bool internal, const std::string& channel, ::blink::CloneableMessage arguments, InvokeCallback callback) = 0;

  
  virtual void ReceivePostMessage(const std::string& channel, ::blink::TransferableMessage message) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool MessageSync(bool internal, const std::string& channel, ::blink::CloneableMessage arguments, ::blink::CloneableMessage* out_result);

  using MessageSyncCallback = base::OnceCallback<void(::blink::CloneableMessage)>;
  
  virtual void MessageSync(bool internal, const std::string& channel, ::blink::CloneableMessage arguments, MessageSyncCallback callback) = 0;

  
  virtual void MessageHost(const std::string& channel, ::blink::CloneableMessage arguments) = 0;
};



class  ElectronRendererProxy
    : public ElectronRenderer {
 public:
  using InterfaceType = ElectronRenderer;

  explicit ElectronRendererProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Message(bool internal, const std::string& channel, ::blink::CloneableMessage arguments) final;
  
  void ReceivePostMessage(const std::string& channel, ::blink::TransferableMessage message) final;
  
  void TakeHeapSnapshot(::mojo::ScopedHandle file, TakeHeapSnapshotCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  ElectronAutofillAgentProxy
    : public ElectronAutofillAgent {
 public:
  using InterfaceType = ElectronAutofillAgent;

  explicit ElectronAutofillAgentProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AcceptDataListSuggestion(const ::std::u16string& value) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  ElectronAutofillDriverProxy
    : public ElectronAutofillDriver {
 public:
  using InterfaceType = ElectronAutofillDriver;

  explicit ElectronAutofillDriverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ShowAutofillPopup(const ::gfx::RectF& bounds, const std::vector<::std::u16string>& values, const std::vector<::std::u16string>& labels) final;
  
  void HideAutofillPopup() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  ElectronApiIPCProxy
    : public ElectronApiIPC {
 public:
  using InterfaceType = ElectronApiIPC;

  explicit ElectronApiIPCProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Message(bool internal, const std::string& channel, ::blink::CloneableMessage arguments) final;
  
  void Invoke(bool internal, const std::string& channel, ::blink::CloneableMessage arguments, InvokeCallback callback) final;
  
  void ReceivePostMessage(const std::string& channel, ::blink::TransferableMessage message) final;
  
  bool MessageSync(bool internal, const std::string& channel, ::blink::CloneableMessage arguments, ::blink::CloneableMessage* out_result) final;
  
  void MessageSync(bool internal, const std::string& channel, ::blink::CloneableMessage arguments, MessageSyncCallback callback) final;
  
  void MessageHost(const std::string& channel, ::blink::CloneableMessage arguments) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ElectronRendererStubDispatch {
 public:
  static bool Accept(ElectronRenderer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ElectronRenderer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ElectronRenderer>>
class ElectronRendererStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ElectronRendererStub() = default;
  ~ElectronRendererStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronRendererStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronRendererStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ElectronAutofillAgentStubDispatch {
 public:
  static bool Accept(ElectronAutofillAgent* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ElectronAutofillAgent* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ElectronAutofillAgent>>
class ElectronAutofillAgentStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ElectronAutofillAgentStub() = default;
  ~ElectronAutofillAgentStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronAutofillAgentStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronAutofillAgentStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ElectronAutofillDriverStubDispatch {
 public:
  static bool Accept(ElectronAutofillDriver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ElectronAutofillDriver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ElectronAutofillDriver>>
class ElectronAutofillDriverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ElectronAutofillDriverStub() = default;
  ~ElectronAutofillDriverStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronAutofillDriverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronAutofillDriverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ElectronApiIPCStubDispatch {
 public:
  static bool Accept(ElectronApiIPC* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ElectronApiIPC* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ElectronApiIPC>>
class ElectronApiIPCStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ElectronApiIPCStub() = default;
  ~ElectronApiIPCStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronApiIPCStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronApiIPCStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ElectronRendererRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ElectronAutofillAgentRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ElectronAutofillDriverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ElectronApiIPCRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ElectronRendererResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ElectronApiIPCResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // electron::mojom

namespace mojo {

}  // namespace mojo

#endif  // ELECTRON_SHELL_COMMON_API_API_MOJOM_H_