// electron/shell/services/node/public/mojom/node_service.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef ELECTRON_SHELL_SERVICES_NODE_PUBLIC_MOJOM_NODE_SERVICE_MOJOM_SHARED_H_
#define ELECTRON_SHELL_SERVICES_NODE_PUBLIC_MOJOM_NODE_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "electron/shell/services/node/public/mojom/node_service.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file_path.mojom-shared.h"
#include "sandbox/policy/mojom/sandbox.mojom-shared.h"
#include "services/network/public/mojom/host_resolver.mojom-shared.h"
#include "services/network/public/mojom/url_loader_factory.mojom-shared.h"
#include "third_party/blink/public/mojom/messaging/message_port_descriptor.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace node::mojom {
class NodeServiceParamsDataView;



}  // node::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::node::mojom::NodeServiceParamsDataView> {
  using Data = ::node::mojom::internal::NodeServiceParams_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace node::mojom {
// Interface base classes. They are used for type safety check.
class NodeServiceClientInterfaceBase {};

using NodeServiceClientPtrDataView =
    mojo::InterfacePtrDataView<NodeServiceClientInterfaceBase>;
using NodeServiceClientRequestDataView =
    mojo::InterfaceRequestDataView<NodeServiceClientInterfaceBase>;
using NodeServiceClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NodeServiceClientInterfaceBase>;
using NodeServiceClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NodeServiceClientInterfaceBase>;
class NodeServiceInterfaceBase {};

using NodeServicePtrDataView =
    mojo::InterfacePtrDataView<NodeServiceInterfaceBase>;
using NodeServiceRequestDataView =
    mojo::InterfaceRequestDataView<NodeServiceInterfaceBase>;
using NodeServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NodeServiceInterfaceBase>;
using NodeServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NodeServiceInterfaceBase>;


class NodeServiceParamsDataView {
 public:
  NodeServiceParamsDataView() = default;

  NodeServiceParamsDataView(
      internal::NodeServiceParams_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetScriptDataView(
      ::mojo_base::mojom::FilePathDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadScript(UserType* output) {
    
    auto* pointer = data_->script.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FilePathDataView>(
        pointer, output, message_);
  }
  inline void GetArgsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadArgs(UserType* output) {
    
    auto* pointer = data_->args.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, message_);
  }
  inline void GetExecArgsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadExecArgs(UserType* output) {
    
    auto* pointer = data_->exec_args.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, message_);
  }
  inline void GetPortDataView(
      ::blink::mojom::MessagePortDescriptorDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadPort(UserType* output) {
    
    auto* pointer = data_->port.Get();
    return mojo::internal::Deserialize<::blink::mojom::MessagePortDescriptorDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  UserType TakeUrlLoaderFactory() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>(
            &data_->url_loader_factory, &result, message_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeHostResolver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::network::mojom::HostResolverInterfaceBase>>(
            &data_->host_resolver, &result, message_);
    DCHECK(ret);
    return result;
  }
  bool use_network_observer_from_url_loader_factory() const {
    return data_->use_network_observer_from_url_loader_factory;
  }
 private:
  internal::NodeServiceParams_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // node::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::node::mojom::NodeServiceParamsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::node::mojom::NodeServiceParamsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::node::mojom::internal::NodeServiceParams_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::script(input)) in_script = Traits::script(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->script)::BaseType> script_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::FilePathDataView>(
        in_script, script_fragment);
    fragment->script.Set(
        script_fragment.is_null() ? nullptr : script_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->script.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null script in NodeServiceParams struct");
    decltype(Traits::args(input)) in_args = Traits::args(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->args)::BaseType>
        args_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& args_validate_params =
        mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_args, args_fragment, &args_validate_params);
    fragment->args.Set(
        args_fragment.is_null() ? nullptr : args_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->args.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null args in NodeServiceParams struct");
    decltype(Traits::exec_args(input)) in_exec_args = Traits::exec_args(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->exec_args)::BaseType>
        exec_args_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& exec_args_validate_params =
        mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_exec_args, exec_args_fragment, &exec_args_validate_params);
    fragment->exec_args.Set(
        exec_args_fragment.is_null() ? nullptr : exec_args_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->exec_args.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null exec_args in NodeServiceParams struct");
    decltype(Traits::port(input)) in_port = Traits::port(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->port)::BaseType> port_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::MessagePortDescriptorDataView>(
        in_port, port_fragment);
    fragment->port.Set(
        port_fragment.is_null() ? nullptr : port_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->port.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null port in NodeServiceParams struct");
    decltype(Traits::url_loader_factory(input)) in_url_loader_factory = Traits::url_loader_factory(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>(
        in_url_loader_factory, &fragment->url_loader_factory, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->url_loader_factory),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid url_loader_factory in NodeServiceParams struct");
    decltype(Traits::host_resolver(input)) in_host_resolver = Traits::host_resolver(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::network::mojom::HostResolverInterfaceBase>>(
        in_host_resolver, &fragment->host_resolver, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->host_resolver),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid host_resolver in NodeServiceParams struct");
    fragment->use_network_observer_from_url_loader_factory = Traits::use_network_observer_from_url_loader_factory(input);
  }

  static bool Deserialize(::node::mojom::internal::NodeServiceParams_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::node::mojom::NodeServiceParamsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace node::mojom {

inline void NodeServiceParamsDataView::GetScriptDataView(
    ::mojo_base::mojom::FilePathDataView* output) {
  auto pointer = data_->script.Get();
  *output = ::mojo_base::mojom::FilePathDataView(pointer, message_);
}
inline void NodeServiceParamsDataView::GetArgsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->args.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, message_);
}
inline void NodeServiceParamsDataView::GetExecArgsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->exec_args.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, message_);
}
inline void NodeServiceParamsDataView::GetPortDataView(
    ::blink::mojom::MessagePortDescriptorDataView* output) {
  auto pointer = data_->port.Get();
  *output = ::blink::mojom::MessagePortDescriptorDataView(pointer, message_);
}



}  // node::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // ELECTRON_SHELL_SERVICES_NODE_PUBLIC_MOJOM_NODE_SERVICE_MOJOM_SHARED_H_