// media/mojo/mojom/speech_recognition_recognition_context.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_RECOGNITION_CONTEXT_MOJOM_SHARED_H_
#define MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_RECOGNITION_CONTEXT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "media/mojo/mojom/speech_recognition_recognition_context.mojom-shared-internal.h"







namespace media::mojom {
class SpeechRecognitionPhraseDataView;

class SpeechRecognitionRecognitionContextDataView;



}  // media::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::media::mojom::SpeechRecognitionPhraseDataView> {
  using Data = ::media::mojom::internal::SpeechRecognitionPhrase_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media::mojom::SpeechRecognitionRecognitionContextDataView> {
  using Data = ::media::mojom::internal::SpeechRecognitionRecognitionContext_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace media::mojom {


class SpeechRecognitionPhraseDataView {
 public:
  SpeechRecognitionPhraseDataView() = default;

  SpeechRecognitionPhraseDataView(
      internal::SpeechRecognitionPhrase_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetPhraseDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadPhrase(UserType* output) {
    
    auto* pointer = data_->phrase.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  float boost() const {
    return data_->boost;
  }
 private:
  internal::SpeechRecognitionPhrase_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class SpeechRecognitionRecognitionContextDataView {
 public:
  SpeechRecognitionRecognitionContextDataView() = default;

  SpeechRecognitionRecognitionContextDataView(
      internal::SpeechRecognitionRecognitionContext_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetPhrasesDataView(
      mojo::ArrayDataView<SpeechRecognitionPhraseDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadPhrases(UserType* output) {
    
    auto* pointer = data_->phrases.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::media::mojom::SpeechRecognitionPhraseDataView>>(
        pointer, output, message_);
  }
 private:
  internal::SpeechRecognitionRecognitionContext_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // media::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media::mojom::SpeechRecognitionPhraseDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media::mojom::SpeechRecognitionPhraseDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::media::mojom::internal::SpeechRecognitionPhrase_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::phrase(input)) in_phrase = Traits::phrase(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->phrase)::BaseType> phrase_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_phrase, phrase_fragment);
    fragment->phrase.Set(
        phrase_fragment.is_null() ? nullptr : phrase_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->phrase.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null phrase in SpeechRecognitionPhrase struct");
    fragment->boost = Traits::boost(input);
  }

  static bool Deserialize(::media::mojom::internal::SpeechRecognitionPhrase_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media::mojom::SpeechRecognitionPhraseDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media::mojom::SpeechRecognitionRecognitionContextDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media::mojom::SpeechRecognitionRecognitionContextDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::media::mojom::internal::SpeechRecognitionRecognitionContext_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::phrases(input)) in_phrases = Traits::phrases(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->phrases)::BaseType>
        phrases_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& phrases_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<::media::mojom::SpeechRecognitionPhraseDataView>>(
        in_phrases, phrases_fragment, &phrases_validate_params);
    fragment->phrases.Set(
        phrases_fragment.is_null() ? nullptr : phrases_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->phrases.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null phrases in SpeechRecognitionRecognitionContext struct");
  }

  static bool Deserialize(::media::mojom::internal::SpeechRecognitionRecognitionContext_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media::mojom::SpeechRecognitionRecognitionContextDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace media::mojom {

inline void SpeechRecognitionPhraseDataView::GetPhraseDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->phrase.Get();
  *output = mojo::StringDataView(pointer, message_);
}


inline void SpeechRecognitionRecognitionContextDataView::GetPhrasesDataView(
    mojo::ArrayDataView<SpeechRecognitionPhraseDataView>* output) {
  auto pointer = data_->phrases.Get();
  *output = mojo::ArrayDataView<SpeechRecognitionPhraseDataView>(pointer, message_);
}



}  // media::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_RECOGNITION_CONTEXT_MOJOM_SHARED_H_