// services/network/public/mojom/network_isolation_key.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/network/public/mojom/network_isolation_key.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/network/public/mojom/network_isolation_key.mojom-params-data.h"
#include "services/network/public/mojom/network_isolation_key.mojom-shared-message-ids.h"

#include "services/network/public/mojom/network_isolation_key.mojom-import-headers.h"
#include "services/network/public/mojom/network_isolation_key.mojom-test-utils.h"


namespace network::mojom {
EmptyNetworkIsolationKey::EmptyNetworkIsolationKey() {}

EmptyNetworkIsolationKey::~EmptyNetworkIsolationKey() = default;
size_t EmptyNetworkIsolationKey::Hash(size_t seed) const {
  return seed;
}

void EmptyNetworkIsolationKey::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
}

bool EmptyNetworkIsolationKey::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
NonEmptyNetworkIsolationKey::NonEmptyNetworkIsolationKey()
    : top_frame_site(),
      frame_site(),
      nonce() {}

NonEmptyNetworkIsolationKey::NonEmptyNetworkIsolationKey(
    const ::net::SchemefulSite& top_frame_site_in,
    const ::net::SchemefulSite& frame_site_in,
    const std::optional<::base::UnguessableToken>& nonce_in)
    : top_frame_site(std::move(top_frame_site_in)),
      frame_site(std::move(frame_site_in)),
      nonce(std::move(nonce_in)) {}

NonEmptyNetworkIsolationKey::~NonEmptyNetworkIsolationKey() = default;

void NonEmptyNetworkIsolationKey::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "top_frame_site"), this->top_frame_site,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::net::SchemefulSite&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "frame_site"), this->frame_site,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::net::SchemefulSite&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "nonce"), this->nonce,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::optional<::base::UnguessableToken>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool NonEmptyNetworkIsolationKey::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
NetworkIsolationKey::NetworkIsolationKey() : tag_(Tag::kEmpty) {
  data_.empty = new EmptyNetworkIsolationKeyPtr;
}

NetworkIsolationKey::~NetworkIsolationKey() {
  DestroyActive();
}


void NetworkIsolationKey::set_empty(
    EmptyNetworkIsolationKeyPtr empty) {
  if (tag_ == Tag::kEmpty) {
    *(data_.empty) = std::move(empty);
  } else {
    DestroyActive();
    tag_ = Tag::kEmpty;
    data_.empty = new EmptyNetworkIsolationKeyPtr(
        std::move(empty));
  }
}
void NetworkIsolationKey::set_non_empty(
    NonEmptyNetworkIsolationKeyPtr non_empty) {
  if (tag_ == Tag::kNonEmpty) {
    *(data_.non_empty) = std::move(non_empty);
  } else {
    DestroyActive();
    tag_ = Tag::kNonEmpty;
    data_.non_empty = new NonEmptyNetworkIsolationKeyPtr(
        std::move(non_empty));
  }
}

void NetworkIsolationKey::DestroyActive() {
  switch (tag_) {

    case Tag::kEmpty:

      delete data_.empty;
      break;
    case Tag::kNonEmpty:

      delete data_.non_empty;
      break;
  }
}

bool NetworkIsolationKey::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}


}  // network::mojom


namespace mojo {


// static
bool StructTraits<::network::mojom::EmptyNetworkIsolationKey::DataView, ::network::mojom::EmptyNetworkIsolationKeyPtr>::Read(
    ::network::mojom::EmptyNetworkIsolationKey::DataView input,
    ::network::mojom::EmptyNetworkIsolationKeyPtr* output) {
  bool success = true;
  ::network::mojom::EmptyNetworkIsolationKeyPtr result(::network::mojom::EmptyNetworkIsolationKey::New());
  
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::network::mojom::NonEmptyNetworkIsolationKey::DataView, ::network::mojom::NonEmptyNetworkIsolationKeyPtr>::Read(
    ::network::mojom::NonEmptyNetworkIsolationKey::DataView input,
    ::network::mojom::NonEmptyNetworkIsolationKeyPtr* output) {
  bool success = true;
  ::network::mojom::NonEmptyNetworkIsolationKeyPtr result(::network::mojom::NonEmptyNetworkIsolationKey::New());
  
      if (success && !input.ReadTopFrameSite(&result->top_frame_site))
        success = false;
      if (success && !input.ReadFrameSite(&result->frame_site))
        success = false;
      if (success && !input.ReadNonce(&result->nonce))
        success = false;
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::network::mojom::NetworkIsolationKey::DataView, ::network::mojom::NetworkIsolationKeyPtr>::Read(
    ::network::mojom::NetworkIsolationKey::DataView input,
    ::network::mojom::NetworkIsolationKeyPtr* output) {
  using UnionType = ::network::mojom::NetworkIsolationKey;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kEmpty: {
      ::network::mojom::EmptyNetworkIsolationKeyPtr result_empty;
      if (!input.ReadEmpty(&result_empty))
        return false;

      *output = UnionType::NewEmpty(
          std::move(result_empty));
      break;
    }
    case Tag::kNonEmpty: {
      ::network::mojom::NonEmptyNetworkIsolationKeyPtr result_non_empty;
      if (!input.ReadNonEmpty(&result_non_empty))
        return false;

      *output = UnionType::NewNonEmpty(
          std::move(result_non_empty));
      break;
    }
    default:

      return false;
  }
  return true;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace network::mojom {




}  // network::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif