// services/network/public/mojom/structured_headers.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/network/public/mojom/structured_headers.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/network/public/mojom/structured_headers.mojom-params-data.h"
#include "services/network/public/mojom/structured_headers.mojom-shared-message-ids.h"

#include "services/network/public/mojom/structured_headers.mojom-import-headers.h"
#include "services/network/public/mojom/structured_headers.mojom-test-utils.h"


namespace network::mojom {
StructuredHeadersParameter::StructuredHeadersParameter()
    : key(),
      item() {}

StructuredHeadersParameter::StructuredHeadersParameter(
    const std::string& key_in,
    ::net::structured_headers::Item item_in)
    : key(std::move(key_in)),
      item(std::move(item_in)) {}

StructuredHeadersParameter::~StructuredHeadersParameter() = default;

void StructuredHeadersParameter::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "key"), this->key,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "item"), this->item,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::net::structured_headers::Item>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool StructuredHeadersParameter::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
StructuredHeadersParameterizedItem::StructuredHeadersParameterizedItem()
    : item(),
      parameters() {}

StructuredHeadersParameterizedItem::StructuredHeadersParameterizedItem(
    ::net::structured_headers::Item item_in,
    std::vector<std::pair<std::string, ::net::structured_headers::Item>> parameters_in)
    : item(std::move(item_in)),
      parameters(std::move(parameters_in)) {}

StructuredHeadersParameterizedItem::~StructuredHeadersParameterizedItem() = default;

void StructuredHeadersParameterizedItem::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "item"), this->item,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::net::structured_headers::Item>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "parameters"), this->parameters,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<std::pair<std::string, ::net::structured_headers::Item>>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool StructuredHeadersParameterizedItem::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
StructuredHeadersParameterizedMember::StructuredHeadersParameterizedMember()
    : member(),
      member_is_inner_list(),
      parameters() {}

StructuredHeadersParameterizedMember::StructuredHeadersParameterizedMember(
    std::vector<::net::structured_headers::ParameterizedItem> member_in,
    bool member_is_inner_list_in,
    std::vector<std::pair<std::string, ::net::structured_headers::Item>> parameters_in)
    : member(std::move(member_in)),
      member_is_inner_list(std::move(member_is_inner_list_in)),
      parameters(std::move(parameters_in)) {}

StructuredHeadersParameterizedMember::~StructuredHeadersParameterizedMember() = default;

void StructuredHeadersParameterizedMember::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "member"), this->member,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<::net::structured_headers::ParameterizedItem>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "member_is_inner_list"), this->member_is_inner_list,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "parameters"), this->parameters,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<std::pair<std::string, ::net::structured_headers::Item>>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool StructuredHeadersParameterizedMember::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
StructuredHeadersDictionaryMember::StructuredHeadersDictionaryMember()
    : key(),
      value() {}

StructuredHeadersDictionaryMember::StructuredHeadersDictionaryMember(
    const std::string& key_in,
    ::net::structured_headers::ParameterizedMember value_in)
    : key(std::move(key_in)),
      value(std::move(value_in)) {}

StructuredHeadersDictionaryMember::~StructuredHeadersDictionaryMember() = default;

void StructuredHeadersDictionaryMember::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "key"), this->key,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "value"), this->value,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::net::structured_headers::ParameterizedMember>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool StructuredHeadersDictionaryMember::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
StructuredHeadersDictionary::StructuredHeadersDictionary()
    : members() {}

StructuredHeadersDictionary::StructuredHeadersDictionary(
    std::vector<::net::structured_headers::DictionaryMember> members_in)
    : members(std::move(members_in)) {}

StructuredHeadersDictionary::~StructuredHeadersDictionary() = default;

void StructuredHeadersDictionary::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "members"), this->members,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<::net::structured_headers::DictionaryMember>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool StructuredHeadersDictionary::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
StructuredHeadersItem::StructuredHeadersItem() : tag_(Tag::kNullValue) {
  data_.null_value = uint8_t();
}

StructuredHeadersItem::~StructuredHeadersItem() {
  DestroyActive();
}


void StructuredHeadersItem::set_null_value(
    uint8_t null_value) {
  if (tag_ != Tag::kNullValue) {
    DestroyActive();
    tag_ = Tag::kNullValue;
  }
  data_.null_value = null_value;
}
void StructuredHeadersItem::set_integer_value(
    int64_t integer_value) {
  if (tag_ != Tag::kIntegerValue) {
    DestroyActive();
    tag_ = Tag::kIntegerValue;
  }
  data_.integer_value = integer_value;
}
void StructuredHeadersItem::set_decimal_value(
    double decimal_value) {
  if (tag_ != Tag::kDecimalValue) {
    DestroyActive();
    tag_ = Tag::kDecimalValue;
  }
  data_.decimal_value = decimal_value;
}
void StructuredHeadersItem::set_string_value(
    const std::string& string_value) {
  if (tag_ == Tag::kStringValue) {
    *(data_.string_value) = std::move(string_value);
  } else {
    DestroyActive();
    tag_ = Tag::kStringValue;
    data_.string_value = new std::string(
        std::move(string_value));
  }
}
void StructuredHeadersItem::set_token_value(
    const std::string& token_value) {
  if (tag_ == Tag::kTokenValue) {
    *(data_.token_value) = std::move(token_value);
  } else {
    DestroyActive();
    tag_ = Tag::kTokenValue;
    data_.token_value = new std::string(
        std::move(token_value));
  }
}
void StructuredHeadersItem::set_byte_sequence_value(
    const std::string& byte_sequence_value) {
  if (tag_ == Tag::kByteSequenceValue) {
    *(data_.byte_sequence_value) = std::move(byte_sequence_value);
  } else {
    DestroyActive();
    tag_ = Tag::kByteSequenceValue;
    data_.byte_sequence_value = new std::string(
        std::move(byte_sequence_value));
  }
}
void StructuredHeadersItem::set_boolean_value(
    bool boolean_value) {
  if (tag_ != Tag::kBooleanValue) {
    DestroyActive();
    tag_ = Tag::kBooleanValue;
  }
  data_.boolean_value = boolean_value;
}

void StructuredHeadersItem::DestroyActive() {
  switch (tag_) {

    case Tag::kNullValue:

      break;
    case Tag::kIntegerValue:

      break;
    case Tag::kDecimalValue:

      break;
    case Tag::kStringValue:

      delete data_.string_value;
      break;
    case Tag::kTokenValue:

      delete data_.token_value;
      break;
    case Tag::kByteSequenceValue:

      delete data_.byte_sequence_value;
      break;
    case Tag::kBooleanValue:

      break;
  }
}

bool StructuredHeadersItem::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}


}  // network::mojom


namespace mojo {


// static
bool StructTraits<::network::mojom::StructuredHeadersParameter::DataView, ::network::mojom::StructuredHeadersParameterPtr>::Read(
    ::network::mojom::StructuredHeadersParameter::DataView input,
    ::network::mojom::StructuredHeadersParameterPtr* output) {
  bool success = true;
  ::network::mojom::StructuredHeadersParameterPtr result(::network::mojom::StructuredHeadersParameter::New());
  
      if (success && !input.ReadKey(&result->key))
        success = false;
      if (success && !input.ReadItem(&result->item))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::network::mojom::StructuredHeadersParameterizedItem::DataView, ::network::mojom::StructuredHeadersParameterizedItemPtr>::Read(
    ::network::mojom::StructuredHeadersParameterizedItem::DataView input,
    ::network::mojom::StructuredHeadersParameterizedItemPtr* output) {
  bool success = true;
  ::network::mojom::StructuredHeadersParameterizedItemPtr result(::network::mojom::StructuredHeadersParameterizedItem::New());
  
      if (success && !input.ReadItem(&result->item))
        success = false;
      if (success && !input.ReadParameters(&result->parameters))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::network::mojom::StructuredHeadersParameterizedMember::DataView, ::network::mojom::StructuredHeadersParameterizedMemberPtr>::Read(
    ::network::mojom::StructuredHeadersParameterizedMember::DataView input,
    ::network::mojom::StructuredHeadersParameterizedMemberPtr* output) {
  bool success = true;
  ::network::mojom::StructuredHeadersParameterizedMemberPtr result(::network::mojom::StructuredHeadersParameterizedMember::New());
  
      if (success && !input.ReadMember(&result->member))
        success = false;
      if (success)
        result->member_is_inner_list = input.member_is_inner_list();
      if (success && !input.ReadParameters(&result->parameters))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::network::mojom::StructuredHeadersDictionaryMember::DataView, ::network::mojom::StructuredHeadersDictionaryMemberPtr>::Read(
    ::network::mojom::StructuredHeadersDictionaryMember::DataView input,
    ::network::mojom::StructuredHeadersDictionaryMemberPtr* output) {
  bool success = true;
  ::network::mojom::StructuredHeadersDictionaryMemberPtr result(::network::mojom::StructuredHeadersDictionaryMember::New());
  
      if (success && !input.ReadKey(&result->key))
        success = false;
      if (success && !input.ReadValue(&result->value))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::network::mojom::StructuredHeadersDictionary::DataView, ::network::mojom::StructuredHeadersDictionaryPtr>::Read(
    ::network::mojom::StructuredHeadersDictionary::DataView input,
    ::network::mojom::StructuredHeadersDictionaryPtr* output) {
  bool success = true;
  ::network::mojom::StructuredHeadersDictionaryPtr result(::network::mojom::StructuredHeadersDictionary::New());
  
      if (success && !input.ReadMembers(&result->members))
        success = false;
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::network::mojom::StructuredHeadersItem::DataView, ::network::mojom::StructuredHeadersItemPtr>::Read(
    ::network::mojom::StructuredHeadersItem::DataView input,
    ::network::mojom::StructuredHeadersItemPtr* output) {
  using UnionType = ::network::mojom::StructuredHeadersItem;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kNullValue: {
      *output = UnionType::NewNullValue(input.null_value());
      break;
    }
    case Tag::kIntegerValue: {
      *output = UnionType::NewIntegerValue(input.integer_value());
      break;
    }
    case Tag::kDecimalValue: {
      *output = UnionType::NewDecimalValue(input.decimal_value());
      break;
    }
    case Tag::kStringValue: {
      std::string result_string_value;
      if (!input.ReadStringValue(&result_string_value))
        return false;

      *output = UnionType::NewStringValue(
          std::move(result_string_value));
      break;
    }
    case Tag::kTokenValue: {
      std::string result_token_value;
      if (!input.ReadTokenValue(&result_token_value))
        return false;

      *output = UnionType::NewTokenValue(
          std::move(result_token_value));
      break;
    }
    case Tag::kByteSequenceValue: {
      std::string result_byte_sequence_value;
      if (!input.ReadByteSequenceValue(&result_byte_sequence_value))
        return false;

      *output = UnionType::NewByteSequenceValue(
          std::move(result_byte_sequence_value));
      break;
    }
    case Tag::kBooleanValue: {
      *output = UnionType::NewBooleanValue(input.boolean_value());
      break;
    }
    default:

      return false;
  }
  return true;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace network::mojom {




}  // network::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif