// services/on_device_model/public/mojom/on_device_model.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_MOJOM_H_
#define SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/on_device_model/public/mojom/on_device_model.mojom-features.h"  // IWYU pragma: export
#include "services/on_device_model/public/mojom/on_device_model.mojom-shared.h"  // IWYU pragma: export
#include "services/on_device_model/public/mojom/on_device_model.mojom-forward.h"  // IWYU pragma: export
#include "mojo/public/mojom/base/file.mojom.h"
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "skia/public/mojom/bitmap.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "services/on_device_model/ml/chrome_ml_types_traits.h"
#include "services/on_device_model/public/cpp/adaptation_assets_mojom_traits.h"
#include "services/on_device_model/public/cpp/model_assets_mojom_traits.h"




namespace on_device_model::mojom {

class StreamingResponderProxy;

template <typename ImplRefTraits>
class StreamingResponderStub;

class StreamingResponderRequestValidator;


class StreamingResponder
    : public StreamingResponderInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = StreamingResponderInterfaceBase;
  using Proxy_ = StreamingResponderProxy;

  template <typename ImplRefTraits>
  using Stub_ = StreamingResponderStub<ImplRefTraits>;

  using RequestValidator_ = StreamingResponderRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnResponseMinVersion = 0,
    kOnCompleteMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnResponse_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnComplete_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~StreamingResponder() = default;

  
  virtual void OnResponse(ResponseChunkPtr chunk) = 0;

  
  virtual void OnComplete(ResponseSummaryPtr summary) = 0;
};

class ContextClientProxy;

template <typename ImplRefTraits>
class ContextClientStub;

class ContextClientRequestValidator;


class ContextClient
    : public ContextClientInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ContextClientInterfaceBase;
  using Proxy_ = ContextClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = ContextClientStub<ImplRefTraits>;

  using RequestValidator_ = ContextClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnCompleteMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnComplete_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ContextClient() = default;

  
  virtual void OnComplete(uint32_t tokens_processed) = 0;
};

class SessionProxy;

template <typename ImplRefTraits>
class SessionStub;

class SessionRequestValidator;
class SessionResponseValidator;


class Session
    : public SessionInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = SessionInterfaceBase;
  using Proxy_ = SessionProxy;

  template <typename ImplRefTraits>
  using Stub_ = SessionStub<ImplRefTraits>;

  using RequestValidator_ = SessionRequestValidator;
  using ResponseValidator_ = SessionResponseValidator;
  enum MethodMinVersions : uint32_t {
    kAddContextMinVersion = 0,
    kExecuteMinVersion = 0,
    kGetSizeInTokensMinVersion = 0,
    kScoreMinVersion = 0,
    kCloneMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct AddContext_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Execute_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetSizeInTokens_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Score_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Clone_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~Session() = default;

  
  virtual void AddContext(InputOptionsPtr input, ::mojo::PendingRemote<ContextClient> client) = 0;

  
  virtual void Execute(InputOptionsPtr input, ::mojo::PendingRemote<StreamingResponder> response) = 0;


  using GetSizeInTokensCallback = base::OnceCallback<void(uint32_t)>;
  
  virtual void GetSizeInTokens(InputPtr input, GetSizeInTokensCallback callback) = 0;


  using ScoreCallback = base::OnceCallback<void(float)>;
  
  virtual void Score(const std::string& text, ScoreCallback callback) = 0;

  
  virtual void Clone(::mojo::PendingReceiver<Session> session) = 0;
};

class OnDeviceModelProxy;

template <typename ImplRefTraits>
class OnDeviceModelStub;

class OnDeviceModelRequestValidator;
class OnDeviceModelResponseValidator;


class OnDeviceModel
    : public OnDeviceModelInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = OnDeviceModelInterfaceBase;
  using Proxy_ = OnDeviceModelProxy;

  template <typename ImplRefTraits>
  using Stub_ = OnDeviceModelStub<ImplRefTraits>;

  using RequestValidator_ = OnDeviceModelRequestValidator;
  using ResponseValidator_ = OnDeviceModelResponseValidator;
  enum MethodMinVersions : uint32_t {
    kStartSessionMinVersion = 0,
    kClassifyTextSafetyMinVersion = 0,
    kDetectLanguageMinVersion = 0,
    kLoadAdaptationMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct StartSession_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ClassifyTextSafety_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DetectLanguage_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct LoadAdaptation_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~OnDeviceModel() = default;

  
  virtual void StartSession(::mojo::PendingReceiver<Session> session) = 0;


  using ClassifyTextSafetyCallback = base::OnceCallback<void(SafetyInfoPtr)>;
  
  virtual void ClassifyTextSafety(const std::string& text, ClassifyTextSafetyCallback callback) = 0;


  using DetectLanguageCallback = base::OnceCallback<void(LanguageDetectionResultPtr)>;
  
  virtual void DetectLanguage(const std::string& text, DetectLanguageCallback callback) = 0;


  using LoadAdaptationCallback = base::OnceCallback<void(LoadModelResult)>;
  
  virtual void LoadAdaptation(LoadAdaptationParamsPtr params, ::mojo::PendingReceiver<OnDeviceModel> model, LoadAdaptationCallback callback) = 0;
};

class TextSafetyModelProxy;

template <typename ImplRefTraits>
class TextSafetyModelStub;

class TextSafetyModelRequestValidator;
class TextSafetyModelResponseValidator;


class TextSafetyModel
    : public TextSafetyModelInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = TextSafetyModelInterfaceBase;
  using Proxy_ = TextSafetyModelProxy;

  template <typename ImplRefTraits>
  using Stub_ = TextSafetyModelStub<ImplRefTraits>;

  using RequestValidator_ = TextSafetyModelRequestValidator;
  using ResponseValidator_ = TextSafetyModelResponseValidator;
  enum MethodMinVersions : uint32_t {
    kClassifyTextSafetyMinVersion = 0,
    kDetectLanguageMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ClassifyTextSafety_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DetectLanguage_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~TextSafetyModel() = default;


  using ClassifyTextSafetyCallback = base::OnceCallback<void(SafetyInfoPtr)>;
  
  virtual void ClassifyTextSafety(const std::string& text, ClassifyTextSafetyCallback callback) = 0;


  using DetectLanguageCallback = base::OnceCallback<void(LanguageDetectionResultPtr)>;
  
  virtual void DetectLanguage(const std::string& text, DetectLanguageCallback callback) = 0;
};



class  StreamingResponderProxy
    : public StreamingResponder {
 public:
  using InterfaceType = StreamingResponder;

  explicit StreamingResponderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnResponse(ResponseChunkPtr chunk) final;
  
  void OnComplete(ResponseSummaryPtr summary) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  ContextClientProxy
    : public ContextClient {
 public:
  using InterfaceType = ContextClient;

  explicit ContextClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnComplete(uint32_t tokens_processed) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SessionProxy
    : public Session {
 public:
  using InterfaceType = Session;

  explicit SessionProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddContext(InputOptionsPtr input, ::mojo::PendingRemote<ContextClient> client) final;
  
  void Execute(InputOptionsPtr input, ::mojo::PendingRemote<StreamingResponder> response) final;
  
  void GetSizeInTokens(InputPtr input, GetSizeInTokensCallback callback) final;
  
  void Score(const std::string& text, ScoreCallback callback) final;
  
  void Clone(::mojo::PendingReceiver<Session> session) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  OnDeviceModelProxy
    : public OnDeviceModel {
 public:
  using InterfaceType = OnDeviceModel;

  explicit OnDeviceModelProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void StartSession(::mojo::PendingReceiver<Session> session) final;
  
  void ClassifyTextSafety(const std::string& text, ClassifyTextSafetyCallback callback) final;
  
  void DetectLanguage(const std::string& text, DetectLanguageCallback callback) final;
  
  void LoadAdaptation(LoadAdaptationParamsPtr params, ::mojo::PendingReceiver<OnDeviceModel> model, LoadAdaptationCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  TextSafetyModelProxy
    : public TextSafetyModel {
 public:
  using InterfaceType = TextSafetyModel;

  explicit TextSafetyModelProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ClassifyTextSafety(const std::string& text, ClassifyTextSafetyCallback callback) final;
  
  void DetectLanguage(const std::string& text, DetectLanguageCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  StreamingResponderStubDispatch {
 public:
  static bool Accept(StreamingResponder* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      StreamingResponder* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<StreamingResponder>>
class StreamingResponderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  StreamingResponderStub() = default;
  ~StreamingResponderStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return StreamingResponderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return StreamingResponderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ContextClientStubDispatch {
 public:
  static bool Accept(ContextClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ContextClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ContextClient>>
class ContextClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ContextClientStub() = default;
  ~ContextClientStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContextClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContextClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SessionStubDispatch {
 public:
  static bool Accept(Session* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      Session* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Session>>
class SessionStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SessionStub() = default;
  ~SessionStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SessionStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SessionStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  OnDeviceModelStubDispatch {
 public:
  static bool Accept(OnDeviceModel* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OnDeviceModel* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OnDeviceModel>>
class OnDeviceModelStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OnDeviceModelStub() = default;
  ~OnDeviceModelStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  TextSafetyModelStubDispatch {
 public:
  static bool Accept(TextSafetyModel* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TextSafetyModel* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TextSafetyModel>>
class TextSafetyModelStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TextSafetyModelStub() = default;
  ~TextSafetyModelStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TextSafetyModelStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TextSafetyModelStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  StreamingResponderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ContextClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SessionRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  OnDeviceModelRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  TextSafetyModelRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SessionResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  OnDeviceModelResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  TextSafetyModelResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class  LanguageDetectionResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LanguageDetectionResult, T>::value>;
  using DataView = LanguageDetectionResultDataView;
  using Data_ = internal::LanguageDetectionResult_Data;

  template <typename... Args>
  static LanguageDetectionResultPtr New(Args&&... args) {
    return LanguageDetectionResultPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LanguageDetectionResultPtr From(const U& u) {
    return mojo::TypeConverter<LanguageDetectionResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LanguageDetectionResult>::Convert(*this);
  }


  LanguageDetectionResult();

  LanguageDetectionResult(
      const std::string& code,
      float reliability);


  ~LanguageDetectionResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LanguageDetectionResultPtr>
  LanguageDetectionResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LanguageDetectionResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, LanguageDetectionResult::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, LanguageDetectionResult::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        LanguageDetectionResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LanguageDetectionResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LanguageDetectionResult_UnserializedMessageContext<
            UserType, LanguageDetectionResult::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<LanguageDetectionResult::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return LanguageDetectionResult::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LanguageDetectionResult_UnserializedMessageContext<
            UserType, LanguageDetectionResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LanguageDetectionResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string code;
  
  float reliability;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LanguageDetectionResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LanguageDetectionResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LanguageDetectionResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LanguageDetectionResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}











class  InputPiece {
 public:
  using DataView = InputPieceDataView;
  using Data_ = internal::InputPiece_Data;
  using Tag = Data_::InputPiece_Tag;

  template <typename... Args>
  static InputPiecePtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |token|.
  static InputPiecePtr
  NewToken(
      ::ml::Token value) {
    auto result = InputPiecePtr(std::in_place);
    result->set_token(std::move(value));
    return result;
  }
  // Construct an instance holding |text|.
  static InputPiecePtr
  NewText(
      const std::string& value) {
    auto result = InputPiecePtr(std::in_place);
    result->set_text(std::move(value));
    return result;
  }
  // Construct an instance holding |bitmap|.
  static InputPiecePtr
  NewBitmap(
      const ::SkBitmap& value) {
    auto result = InputPiecePtr(std::in_place);
    result->set_bitmap(std::move(value));
    return result;
  }
  // Construct an instance holding |unknown_type|.
  static InputPiecePtr
  NewUnknownType(
      bool value) {
    auto result = InputPiecePtr(std::in_place);
    result->set_unknown_type(std::move(value));
    return result;
  }

  template <typename U>
  static InputPiecePtr From(const U& u) {
    return mojo::TypeConverter<InputPiecePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, InputPiece>::Convert(*this);
  }

  InputPiece();
  ~InputPiece();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  InputPiece(const InputPiece& other) = delete;
  InputPiece& operator=(const InputPiece& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = InputPiecePtr>
  InputPiecePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, InputPiece>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, InputPiece>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_token() const { return tag_ == Tag::kToken; }

  
  ::ml::Token get_token() const {
    CHECK(tag_ == Tag::kToken);
    return data_.token;
  }

  
  void set_token(
      ::ml::Token token);
  
  bool is_text() const { return tag_ == Tag::kText; }

  
  std::string& get_text() const {
    CHECK(tag_ == Tag::kText);
    return *(data_.text);
  }

  
  void set_text(
      const std::string& text);
  
  bool is_bitmap() const { return tag_ == Tag::kBitmap; }

  
  ::SkBitmap& get_bitmap() const {
    CHECK(tag_ == Tag::kBitmap);
    return *(data_.bitmap);
  }

  
  void set_bitmap(
      const ::SkBitmap& bitmap);
  
  bool is_unknown_type() const { return tag_ == Tag::kUnknownType; }

  
  bool get_unknown_type() const {
    CHECK(tag_ == Tag::kUnknownType);
    return data_.unknown_type;
  }

  
  void set_unknown_type(
      bool unknown_type);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        InputPiece::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<InputPiece::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ::ml::Token token;
    std::string* text;
    ::SkBitmap* bitmap;
    bool unknown_type;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  AdaptationAssets {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AdaptationAssets, T>::value>;
  using DataView = AdaptationAssetsDataView;
  using Data_ = internal::AdaptationAssets_Data;

  template <typename... Args>
  static AdaptationAssetsPtr New(Args&&... args) {
    return AdaptationAssetsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AdaptationAssetsPtr From(const U& u) {
    return mojo::TypeConverter<AdaptationAssetsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AdaptationAssets>::Convert(*this);
  }


  AdaptationAssets();

  AdaptationAssets(
      ::base::File weights,
      const std::optional<::base::FilePath>& weights_path);

AdaptationAssets(const AdaptationAssets&) = delete;
AdaptationAssets& operator=(const AdaptationAssets&) = delete;

  ~AdaptationAssets();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AdaptationAssetsPtr>
  AdaptationAssetsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AdaptationAssets::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AdaptationAssets::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AdaptationAssets::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AdaptationAssets::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AdaptationAssets_UnserializedMessageContext<
            UserType, AdaptationAssets::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AdaptationAssets::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AdaptationAssets::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AdaptationAssets_UnserializedMessageContext<
            UserType, AdaptationAssets::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AdaptationAssets::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::base::File weights;
  
  std::optional<::base::FilePath> weights_path;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AdaptationAssets::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AdaptationAssets::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AdaptationAssets::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AdaptationAssets::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  SafetyInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SafetyInfo, T>::value>;
  using DataView = SafetyInfoDataView;
  using Data_ = internal::SafetyInfo_Data;

  template <typename... Args>
  static SafetyInfoPtr New(Args&&... args) {
    return SafetyInfoPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SafetyInfoPtr From(const U& u) {
    return mojo::TypeConverter<SafetyInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SafetyInfo>::Convert(*this);
  }


  SafetyInfo();

  SafetyInfo(
      std::vector<float> class_scores,
      LanguageDetectionResultPtr language);

SafetyInfo(const SafetyInfo&) = delete;
SafetyInfo& operator=(const SafetyInfo&) = delete;

  ~SafetyInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SafetyInfoPtr>
  SafetyInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SafetyInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SafetyInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, SafetyInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SafetyInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SafetyInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SafetyInfo_UnserializedMessageContext<
            UserType, SafetyInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SafetyInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return SafetyInfo::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SafetyInfo_UnserializedMessageContext<
            UserType, SafetyInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SafetyInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<float> class_scores;
  
  LanguageDetectionResultPtr language;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SafetyInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SafetyInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SafetyInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SafetyInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ResponseChunk {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ResponseChunk, T>::value>;
  using DataView = ResponseChunkDataView;
  using Data_ = internal::ResponseChunk_Data;

  template <typename... Args>
  static ResponseChunkPtr New(Args&&... args) {
    return ResponseChunkPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ResponseChunkPtr From(const U& u) {
    return mojo::TypeConverter<ResponseChunkPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ResponseChunk>::Convert(*this);
  }


  ResponseChunk();

  ResponseChunk(
      const std::string& text,
      SafetyInfoPtr safety_info);

ResponseChunk(const ResponseChunk&) = delete;
ResponseChunk& operator=(const ResponseChunk&) = delete;

  ~ResponseChunk();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ResponseChunkPtr>
  ResponseChunkPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ResponseChunk::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ResponseChunk::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ResponseChunk::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ResponseChunk::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ResponseChunk::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ResponseChunk_UnserializedMessageContext<
            UserType, ResponseChunk::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ResponseChunk::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return ResponseChunk::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ResponseChunk_UnserializedMessageContext<
            UserType, ResponseChunk::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ResponseChunk::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string text;
  
  SafetyInfoPtr safety_info;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ResponseChunk::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ResponseChunk::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ResponseChunk::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ResponseChunk::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ResponseSummary {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ResponseSummary, T>::value>;
  using DataView = ResponseSummaryDataView;
  using Data_ = internal::ResponseSummary_Data;

  template <typename... Args>
  static ResponseSummaryPtr New(Args&&... args) {
    return ResponseSummaryPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ResponseSummaryPtr From(const U& u) {
    return mojo::TypeConverter<ResponseSummaryPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ResponseSummary>::Convert(*this);
  }


  ResponseSummary();

  ResponseSummary(
      SafetyInfoPtr safety_info,
      uint32_t input_token_count,
      uint32_t output_token_count);

ResponseSummary(const ResponseSummary&) = delete;
ResponseSummary& operator=(const ResponseSummary&) = delete;

  ~ResponseSummary();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ResponseSummaryPtr>
  ResponseSummaryPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ResponseSummary::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ResponseSummary::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ResponseSummary::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ResponseSummary::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ResponseSummary::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ResponseSummary_UnserializedMessageContext<
            UserType, ResponseSummary::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ResponseSummary::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return ResponseSummary::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ResponseSummary_UnserializedMessageContext<
            UserType, ResponseSummary::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ResponseSummary::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  SafetyInfoPtr safety_info;
  
  uint32_t input_token_count;
  
  uint32_t output_token_count;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ResponseSummary::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ResponseSummary::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ResponseSummary::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ResponseSummary::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  LoadAdaptationParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LoadAdaptationParams, T>::value>;
  using DataView = LoadAdaptationParamsDataView;
  using Data_ = internal::LoadAdaptationParams_Data;

  template <typename... Args>
  static LoadAdaptationParamsPtr New(Args&&... args) {
    return LoadAdaptationParamsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LoadAdaptationParamsPtr From(const U& u) {
    return mojo::TypeConverter<LoadAdaptationParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LoadAdaptationParams>::Convert(*this);
  }


  LoadAdaptationParams();

  LoadAdaptationParams(
      ::on_device_model::AdaptationAssets assets,
      uint32_t max_tokens);

  LoadAdaptationParams(
      ::on_device_model::AdaptationAssets assets,
      uint32_t max_tokens,
      bool enable_image_input);

LoadAdaptationParams(const LoadAdaptationParams&) = delete;
LoadAdaptationParams& operator=(const LoadAdaptationParams&) = delete;

  ~LoadAdaptationParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LoadAdaptationParamsPtr>
  LoadAdaptationParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LoadAdaptationParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, LoadAdaptationParams::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, LoadAdaptationParams::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LoadAdaptationParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LoadAdaptationParams_UnserializedMessageContext<
            UserType, LoadAdaptationParams::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<LoadAdaptationParams::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return LoadAdaptationParams::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LoadAdaptationParams_UnserializedMessageContext<
            UserType, LoadAdaptationParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LoadAdaptationParams::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::on_device_model::AdaptationAssets assets;
  
  uint32_t max_tokens;
  
  bool enable_image_input;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LoadAdaptationParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LoadAdaptationParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LoadAdaptationParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LoadAdaptationParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Input {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Input, T>::value>;
  using DataView = InputDataView;
  using Data_ = internal::Input_Data;

  template <typename... Args>
  static InputPtr New(Args&&... args) {
    return InputPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static InputPtr From(const U& u) {
    return mojo::TypeConverter<InputPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Input>::Convert(*this);
  }


  Input();

  explicit Input(
      std::vector<::ml::InputPiece> pieces);


  ~Input();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = InputPtr>
  InputPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Input::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Input::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Input::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Input::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Input_UnserializedMessageContext<
            UserType, Input::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Input::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return Input::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Input_UnserializedMessageContext<
            UserType, Input::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Input::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<::ml::InputPiece> pieces;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Input::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Input::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Input::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Input::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  InputOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<InputOptions, T>::value>;
  using DataView = InputOptionsDataView;
  using Data_ = internal::InputOptions_Data;

  template <typename... Args>
  static InputOptionsPtr New(Args&&... args) {
    return InputOptionsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static InputOptionsPtr From(const U& u) {
    return mojo::TypeConverter<InputOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, InputOptions>::Convert(*this);
  }


  InputOptions();

  InputOptions(
      InputPtr input,
      uint32_t max_tokens,
      uint32_t token_offset,
      bool ignore_context,
      uint32_t max_output_tokens,
      std::optional<uint32_t> top_k,
      std::optional<float> temperature);

InputOptions(const InputOptions&) = delete;
InputOptions& operator=(const InputOptions&) = delete;

  ~InputOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = InputOptionsPtr>
  InputOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, InputOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, InputOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, InputOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        InputOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::InputOptions_UnserializedMessageContext<
            UserType, InputOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<InputOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return InputOptions::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::InputOptions_UnserializedMessageContext<
            UserType, InputOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<InputOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  InputPtr input;
  
  uint32_t max_tokens;
  
  uint32_t token_offset;
  
  bool ignore_context;
  
  uint32_t max_output_tokens;
  
  std::optional<uint32_t> top_k;
  
  std::optional<float> temperature;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, InputOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, InputOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, InputOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, InputOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
InputPiecePtr InputPiece::Clone() const {
  switch (tag_) {
    case Tag::kToken:
      return NewToken(
          mojo::Clone(data_.token));
    case Tag::kText:
      return NewText(
          mojo::Clone(*data_.text));
    case Tag::kBitmap:
      return NewBitmap(
          mojo::Clone(*data_.bitmap));
    case Tag::kUnknownType:
      return NewUnknownType(
          mojo::Clone(data_.unknown_type));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, InputPiece>::value>::type*>
bool InputPiece::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kToken:
      return mojo::Equals(data_.token, other.data_.token);
    case Tag::kText:
      return mojo::Equals(*(data_.text), *(other.data_.text));
    case Tag::kBitmap:
      return mojo::Equals(*(data_.bitmap), *(other.data_.bitmap));
    case Tag::kUnknownType:
      return mojo::Equals(data_.unknown_type, other.data_.unknown_type);
  }

  return false;
}
template <typename StructPtrType>
AdaptationAssetsPtr AdaptationAssets::Clone() const {
  return New(
      mojo::Clone(weights),
      mojo::Clone(weights_path)
  );
}

template <typename T, AdaptationAssets::EnableIfSame<T>*>
bool AdaptationAssets::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->weights, other_struct.weights))
    return false;
  if (!mojo::Equals(this->weights_path, other_struct.weights_path))
    return false;
  return true;
}

template <typename T, AdaptationAssets::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.weights < rhs.weights)
    return true;
  if (rhs.weights < lhs.weights)
    return false;
  if (lhs.weights_path < rhs.weights_path)
    return true;
  if (rhs.weights_path < lhs.weights_path)
    return false;
  return false;
}
template <typename StructPtrType>
LanguageDetectionResultPtr LanguageDetectionResult::Clone() const {
  return New(
      mojo::Clone(code),
      mojo::Clone(reliability)
  );
}

template <typename T, LanguageDetectionResult::EnableIfSame<T>*>
bool LanguageDetectionResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->code, other_struct.code))
    return false;
  if (!mojo::Equals(this->reliability, other_struct.reliability))
    return false;
  return true;
}

template <typename T, LanguageDetectionResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.code < rhs.code)
    return true;
  if (rhs.code < lhs.code)
    return false;
  if (lhs.reliability < rhs.reliability)
    return true;
  if (rhs.reliability < lhs.reliability)
    return false;
  return false;
}
template <typename StructPtrType>
SafetyInfoPtr SafetyInfo::Clone() const {
  return New(
      mojo::Clone(class_scores),
      mojo::Clone(language)
  );
}

template <typename T, SafetyInfo::EnableIfSame<T>*>
bool SafetyInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->class_scores, other_struct.class_scores))
    return false;
  if (!mojo::Equals(this->language, other_struct.language))
    return false;
  return true;
}

template <typename T, SafetyInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.class_scores < rhs.class_scores)
    return true;
  if (rhs.class_scores < lhs.class_scores)
    return false;
  if (lhs.language < rhs.language)
    return true;
  if (rhs.language < lhs.language)
    return false;
  return false;
}
template <typename StructPtrType>
ResponseChunkPtr ResponseChunk::Clone() const {
  return New(
      mojo::Clone(text),
      mojo::Clone(safety_info)
  );
}

template <typename T, ResponseChunk::EnableIfSame<T>*>
bool ResponseChunk::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->text, other_struct.text))
    return false;
  if (!mojo::Equals(this->safety_info, other_struct.safety_info))
    return false;
  return true;
}

template <typename T, ResponseChunk::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.text < rhs.text)
    return true;
  if (rhs.text < lhs.text)
    return false;
  if (lhs.safety_info < rhs.safety_info)
    return true;
  if (rhs.safety_info < lhs.safety_info)
    return false;
  return false;
}
template <typename StructPtrType>
ResponseSummaryPtr ResponseSummary::Clone() const {
  return New(
      mojo::Clone(safety_info),
      mojo::Clone(input_token_count),
      mojo::Clone(output_token_count)
  );
}

template <typename T, ResponseSummary::EnableIfSame<T>*>
bool ResponseSummary::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->safety_info, other_struct.safety_info))
    return false;
  if (!mojo::Equals(this->input_token_count, other_struct.input_token_count))
    return false;
  if (!mojo::Equals(this->output_token_count, other_struct.output_token_count))
    return false;
  return true;
}

template <typename T, ResponseSummary::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.safety_info < rhs.safety_info)
    return true;
  if (rhs.safety_info < lhs.safety_info)
    return false;
  if (lhs.input_token_count < rhs.input_token_count)
    return true;
  if (rhs.input_token_count < lhs.input_token_count)
    return false;
  if (lhs.output_token_count < rhs.output_token_count)
    return true;
  if (rhs.output_token_count < lhs.output_token_count)
    return false;
  return false;
}
template <typename StructPtrType>
LoadAdaptationParamsPtr LoadAdaptationParams::Clone() const {
  return New(
      mojo::Clone(assets),
      mojo::Clone(max_tokens),
      mojo::Clone(enable_image_input)
  );
}

template <typename T, LoadAdaptationParams::EnableIfSame<T>*>
bool LoadAdaptationParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->assets, other_struct.assets))
    return false;
  if (!mojo::Equals(this->max_tokens, other_struct.max_tokens))
    return false;
  if (!mojo::Equals(this->enable_image_input, other_struct.enable_image_input))
    return false;
  return true;
}

template <typename T, LoadAdaptationParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.assets < rhs.assets)
    return true;
  if (rhs.assets < lhs.assets)
    return false;
  if (lhs.max_tokens < rhs.max_tokens)
    return true;
  if (rhs.max_tokens < lhs.max_tokens)
    return false;
  if (lhs.enable_image_input < rhs.enable_image_input)
    return true;
  if (rhs.enable_image_input < lhs.enable_image_input)
    return false;
  return false;
}
template <typename StructPtrType>
InputPtr Input::Clone() const {
  return New(
      mojo::Clone(pieces)
  );
}

template <typename T, Input::EnableIfSame<T>*>
bool Input::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->pieces, other_struct.pieces))
    return false;
  return true;
}

template <typename T, Input::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.pieces < rhs.pieces)
    return true;
  if (rhs.pieces < lhs.pieces)
    return false;
  return false;
}
template <typename StructPtrType>
InputOptionsPtr InputOptions::Clone() const {
  return New(
      mojo::Clone(input),
      mojo::Clone(max_tokens),
      mojo::Clone(token_offset),
      mojo::Clone(ignore_context),
      mojo::Clone(max_output_tokens),
      mojo::Clone(top_k),
      mojo::Clone(temperature)
  );
}

template <typename T, InputOptions::EnableIfSame<T>*>
bool InputOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input, other_struct.input))
    return false;
  if (!mojo::Equals(this->max_tokens, other_struct.max_tokens))
    return false;
  if (!mojo::Equals(this->token_offset, other_struct.token_offset))
    return false;
  if (!mojo::Equals(this->ignore_context, other_struct.ignore_context))
    return false;
  if (!mojo::Equals(this->max_output_tokens, other_struct.max_output_tokens))
    return false;
  if (!mojo::Equals(this->top_k, other_struct.top_k))
    return false;
  if (!mojo::Equals(this->temperature, other_struct.temperature))
    return false;
  return true;
}

template <typename T, InputOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input < rhs.input)
    return true;
  if (rhs.input < lhs.input)
    return false;
  if (lhs.max_tokens < rhs.max_tokens)
    return true;
  if (rhs.max_tokens < lhs.max_tokens)
    return false;
  if (lhs.token_offset < rhs.token_offset)
    return true;
  if (rhs.token_offset < lhs.token_offset)
    return false;
  if (lhs.ignore_context < rhs.ignore_context)
    return true;
  if (rhs.ignore_context < lhs.ignore_context)
    return false;
  if (lhs.max_output_tokens < rhs.max_output_tokens)
    return true;
  if (rhs.max_output_tokens < lhs.max_output_tokens)
    return false;
  if (lhs.top_k < rhs.top_k)
    return true;
  if (rhs.top_k < lhs.top_k)
    return false;
  if (lhs.temperature < rhs.temperature)
    return true;
  if (rhs.temperature < lhs.temperature)
    return false;
  return false;
}


}  // on_device_model::mojom

namespace mojo {


template <>
struct  StructTraits<::on_device_model::mojom::AdaptationAssets::DataView,
                                         ::on_device_model::mojom::AdaptationAssetsPtr> {
  static bool IsNull(const ::on_device_model::mojom::AdaptationAssetsPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::AdaptationAssetsPtr* output) { output->reset(); }

  static  decltype(::on_device_model::mojom::AdaptationAssets::weights)& weights(
       ::on_device_model::mojom::AdaptationAssetsPtr& input) {
    return input->weights;
  }

  static const decltype(::on_device_model::mojom::AdaptationAssets::weights_path)& weights_path(
      const ::on_device_model::mojom::AdaptationAssetsPtr& input) {
    return input->weights_path;
  }

  static bool Read(::on_device_model::mojom::AdaptationAssets::DataView input, ::on_device_model::mojom::AdaptationAssetsPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::LanguageDetectionResult::DataView,
                                         ::on_device_model::mojom::LanguageDetectionResultPtr> {
  static bool IsNull(const ::on_device_model::mojom::LanguageDetectionResultPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::LanguageDetectionResultPtr* output) { output->reset(); }

  static const decltype(::on_device_model::mojom::LanguageDetectionResult::code)& code(
      const ::on_device_model::mojom::LanguageDetectionResultPtr& input) {
    return input->code;
  }

  static decltype(::on_device_model::mojom::LanguageDetectionResult::reliability) reliability(
      const ::on_device_model::mojom::LanguageDetectionResultPtr& input) {
    return input->reliability;
  }

  static bool Read(::on_device_model::mojom::LanguageDetectionResult::DataView input, ::on_device_model::mojom::LanguageDetectionResultPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::SafetyInfo::DataView,
                                         ::on_device_model::mojom::SafetyInfoPtr> {
  static bool IsNull(const ::on_device_model::mojom::SafetyInfoPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::SafetyInfoPtr* output) { output->reset(); }

  static const decltype(::on_device_model::mojom::SafetyInfo::class_scores)& class_scores(
      const ::on_device_model::mojom::SafetyInfoPtr& input) {
    return input->class_scores;
  }

  static const decltype(::on_device_model::mojom::SafetyInfo::language)& language(
      const ::on_device_model::mojom::SafetyInfoPtr& input) {
    return input->language;
  }

  static bool Read(::on_device_model::mojom::SafetyInfo::DataView input, ::on_device_model::mojom::SafetyInfoPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::ResponseChunk::DataView,
                                         ::on_device_model::mojom::ResponseChunkPtr> {
  static bool IsNull(const ::on_device_model::mojom::ResponseChunkPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::ResponseChunkPtr* output) { output->reset(); }

  static const decltype(::on_device_model::mojom::ResponseChunk::text)& text(
      const ::on_device_model::mojom::ResponseChunkPtr& input) {
    return input->text;
  }

  static const decltype(::on_device_model::mojom::ResponseChunk::safety_info)& safety_info(
      const ::on_device_model::mojom::ResponseChunkPtr& input) {
    return input->safety_info;
  }

  static bool Read(::on_device_model::mojom::ResponseChunk::DataView input, ::on_device_model::mojom::ResponseChunkPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::ResponseSummary::DataView,
                                         ::on_device_model::mojom::ResponseSummaryPtr> {
  static bool IsNull(const ::on_device_model::mojom::ResponseSummaryPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::ResponseSummaryPtr* output) { output->reset(); }

  static const decltype(::on_device_model::mojom::ResponseSummary::safety_info)& safety_info(
      const ::on_device_model::mojom::ResponseSummaryPtr& input) {
    return input->safety_info;
  }

  static decltype(::on_device_model::mojom::ResponseSummary::input_token_count) input_token_count(
      const ::on_device_model::mojom::ResponseSummaryPtr& input) {
    return input->input_token_count;
  }

  static decltype(::on_device_model::mojom::ResponseSummary::output_token_count) output_token_count(
      const ::on_device_model::mojom::ResponseSummaryPtr& input) {
    return input->output_token_count;
  }

  static bool Read(::on_device_model::mojom::ResponseSummary::DataView input, ::on_device_model::mojom::ResponseSummaryPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::LoadAdaptationParams::DataView,
                                         ::on_device_model::mojom::LoadAdaptationParamsPtr> {
  static bool IsNull(const ::on_device_model::mojom::LoadAdaptationParamsPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::LoadAdaptationParamsPtr* output) { output->reset(); }

  static  decltype(::on_device_model::mojom::LoadAdaptationParams::assets)& assets(
       ::on_device_model::mojom::LoadAdaptationParamsPtr& input) {
    return input->assets;
  }

  static decltype(::on_device_model::mojom::LoadAdaptationParams::max_tokens) max_tokens(
      const ::on_device_model::mojom::LoadAdaptationParamsPtr& input) {
    return input->max_tokens;
  }

  static decltype(::on_device_model::mojom::LoadAdaptationParams::enable_image_input) enable_image_input(
      const ::on_device_model::mojom::LoadAdaptationParamsPtr& input) {
    return input->enable_image_input;
  }

  static bool Read(::on_device_model::mojom::LoadAdaptationParams::DataView input, ::on_device_model::mojom::LoadAdaptationParamsPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::Input::DataView,
                                         ::on_device_model::mojom::InputPtr> {
  static bool IsNull(const ::on_device_model::mojom::InputPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::InputPtr* output) { output->reset(); }

  static  decltype(::on_device_model::mojom::Input::pieces)& pieces(
       ::on_device_model::mojom::InputPtr& input) {
    return input->pieces;
  }

  static bool Read(::on_device_model::mojom::Input::DataView input, ::on_device_model::mojom::InputPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::InputOptions::DataView,
                                         ::on_device_model::mojom::InputOptionsPtr> {
  static bool IsNull(const ::on_device_model::mojom::InputOptionsPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::InputOptionsPtr* output) { output->reset(); }

  static  decltype(::on_device_model::mojom::InputOptions::input)& input(
       ::on_device_model::mojom::InputOptionsPtr& input) {
    return input->input;
  }

  static decltype(::on_device_model::mojom::InputOptions::max_tokens) max_tokens(
      const ::on_device_model::mojom::InputOptionsPtr& input) {
    return input->max_tokens;
  }

  static decltype(::on_device_model::mojom::InputOptions::token_offset) token_offset(
      const ::on_device_model::mojom::InputOptionsPtr& input) {
    return input->token_offset;
  }

  static decltype(::on_device_model::mojom::InputOptions::ignore_context) ignore_context(
      const ::on_device_model::mojom::InputOptionsPtr& input) {
    return input->ignore_context;
  }

  static decltype(::on_device_model::mojom::InputOptions::max_output_tokens) max_output_tokens(
      const ::on_device_model::mojom::InputOptionsPtr& input) {
    return input->max_output_tokens;
  }

  static decltype(::on_device_model::mojom::InputOptions::top_k) top_k(
      const ::on_device_model::mojom::InputOptionsPtr& input) {
    return input->top_k;
  }

  static decltype(::on_device_model::mojom::InputOptions::temperature) temperature(
      const ::on_device_model::mojom::InputOptionsPtr& input) {
    return input->temperature;
  }

  static bool Read(::on_device_model::mojom::InputOptions::DataView input, ::on_device_model::mojom::InputOptionsPtr* output);
};


template <>
struct  UnionTraits<::on_device_model::mojom::InputPiece::DataView,
                                        ::on_device_model::mojom::InputPiecePtr> {
  static bool IsNull(const ::on_device_model::mojom::InputPiecePtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::InputPiecePtr* output) { output->reset(); }

  static ::on_device_model::mojom::InputPiece::Tag GetTag(const ::on_device_model::mojom::InputPiecePtr& input) {
    return input->which();
  }

  static  ::ml::Token token(const ::on_device_model::mojom::InputPiecePtr& input) {
    return input->get_token();
  }

  static const std::string& text(const ::on_device_model::mojom::InputPiecePtr& input) {
    return input->get_text();
  }

  static  ::SkBitmap& bitmap( ::on_device_model::mojom::InputPiecePtr& input) {
    return input->get_bitmap();
  }

  static  bool unknown_type(const ::on_device_model::mojom::InputPiecePtr& input) {
    return input->get_unknown_type();
  }

  static bool Read(::on_device_model::mojom::InputPiece::DataView input, ::on_device_model::mojom::InputPiecePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_MOJOM_H_