// services/shape_detection/public/mojom/facedetection.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/shape_detection/public/mojom/facedetection.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>
#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/shape_detection/public/mojom/facedetection.mojom-params-data.h"
namespace shape_detection {
namespace mojom {

NOINLINE static const char* LandmarkTypeToStringHelper(LandmarkType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case LandmarkType::MOUTH:
      return "MOUTH";
    case LandmarkType::EYE:
      return "EYE";
    case LandmarkType::NOSE:
      return "NOSE";
    default:
      return nullptr;
  }
}

std::string LandmarkTypeToString(LandmarkType value) {
  const char *str = LandmarkTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown LandmarkType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, LandmarkType value) {
  return os << LandmarkTypeToString(value);
}

namespace internal {


// static
bool Landmark_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Landmark_Data* object =
      static_cast<const Landmark_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->locations, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& locations_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->locations, validation_context,
                                         &locations_validate_params)) {
    return false;
  }


  if (!::shape_detection::mojom::internal::LandmarkType_Data
        ::Validate(object->type, validation_context))
    return false;

  return true;
}

Landmark_Data::Landmark_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FaceDetectionResult_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FaceDetectionResult_Data* object =
      static_cast<const FaceDetectionResult_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->bounding_box, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->bounding_box, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->landmarks, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& landmarks_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->landmarks, validation_context,
                                         &landmarks_validate_params)) {
    return false;
  }

  return true;
}

FaceDetectionResult_Data::FaceDetectionResult_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FaceDetectorOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FaceDetectorOptions_Data* object =
      static_cast<const FaceDetectorOptions_Data*>(data);

  return true;
}

FaceDetectorOptions_Data::FaceDetectorOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FaceDetection_Detect_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FaceDetection_Detect_Params_Data* object =
      static_cast<const FaceDetection_Detect_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->bitmap_data, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->bitmap_data, validation_context))
    return false;

  return true;
}

FaceDetection_Detect_Params_Data::FaceDetection_Detect_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FaceDetection_Detect_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FaceDetection_Detect_ResponseParams_Data* object =
      static_cast<const FaceDetection_Detect_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->results, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& results_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->results, validation_context,
                                         &results_validate_params)) {
    return false;
  }

  return true;
}

FaceDetection_Detect_ResponseParams_Data::FaceDetection_Detect_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace shape_detection

namespace perfetto {

// static
void TraceFormatTraits<::shape_detection::mojom::LandmarkType>::WriteIntoTrace(
   perfetto::TracedValue context, ::shape_detection::mojom::LandmarkType value) {
  return std::move(context).WriteString(::shape_detection::mojom::LandmarkTypeToString(value));
}

} // namespace perfetto