// services/webnn/public/mojom/webnn_context.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/webnn/public/mojom/webnn_context.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/webnn/public/mojom/webnn_context.mojom-params-data.h"
#include "services/webnn/public/mojom/webnn_context.mojom-shared-message-ids.h"

#include "services/webnn/public/mojom/webnn_context.mojom-import-headers.h"
#include "services/webnn/public/mojom/webnn_context.mojom-test-utils.h"


namespace webnn::mojom {
CreateTensorSuccess::CreateTensorSuccess()
    : tensor_remote(),
      tensor_handle() {}

CreateTensorSuccess::CreateTensorSuccess(
    ::mojo::PendingAssociatedRemote<::webnn::mojom::WebNNTensor> tensor_remote_in,
    const ::blink::WebNNTensorToken& tensor_handle_in)
    : tensor_remote(std::move(tensor_remote_in)),
      tensor_handle(std::move(tensor_handle_in)) {}

CreateTensorSuccess::~CreateTensorSuccess() = default;

void CreateTensorSuccess::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "tensor_remote"), this->tensor_remote,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::mojo::PendingAssociatedRemote<::webnn::mojom::WebNNTensor>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "tensor_handle"), this->tensor_handle,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::blink::WebNNTensorToken&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool CreateTensorSuccess::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
CreateTensorResult::CreateTensorResult() : tag_(Tag::kSuccess) {
  data_.success = new CreateTensorSuccessPtr;
}

CreateTensorResult::~CreateTensorResult() {
  DestroyActive();
}


void CreateTensorResult::set_success(
    CreateTensorSuccessPtr success) {
  if (tag_ == Tag::kSuccess) {
    *(data_.success) = std::move(success);
  } else {
    DestroyActive();
    tag_ = Tag::kSuccess;
    data_.success = new CreateTensorSuccessPtr(
        std::move(success));
  }
}
void CreateTensorResult::set_error(
    ::webnn::mojom::ErrorPtr error) {
  if (tag_ == Tag::kError) {
    *(data_.error) = std::move(error);
  } else {
    DestroyActive();
    tag_ = Tag::kError;
    data_.error = new ::webnn::mojom::ErrorPtr(
        std::move(error));
  }
}

void CreateTensorResult::DestroyActive() {
  switch (tag_) {

    case Tag::kSuccess:

      delete data_.success;
      break;
    case Tag::kError:

      delete data_.error;
      break;
  }
}

bool CreateTensorResult::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
const char WebNNContext::Name_[] = "webnn.mojom.WebNNContext";

WebNNContext::IPCStableHashFunction WebNNContext::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (static_cast<messages::WebNNContext>(message.name())) {
    case messages::WebNNContext::kCreateGraphBuilder: {
      return &WebNNContext::CreateGraphBuilder_Sym::IPCStableHash;
    }
    case messages::WebNNContext::kCreateTensor: {
      return &WebNNContext::CreateTensor_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* WebNNContext::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (static_cast<messages::WebNNContext>(message.name())) {
      case messages::WebNNContext::kCreateGraphBuilder:
            return "Receive webnn::mojom::WebNNContext::CreateGraphBuilder";
      case messages::WebNNContext::kCreateTensor:
            return "Receive webnn::mojom::WebNNContext::CreateTensor";
    }
  } else {
    switch (static_cast<messages::WebNNContext>(message.name())) {
      case messages::WebNNContext::kCreateGraphBuilder:
            return "Receive reply webnn::mojom::WebNNContext::CreateGraphBuilder";
      case messages::WebNNContext::kCreateTensor:
            return "Receive reply webnn::mojom::WebNNContext::CreateTensor";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t WebNNContext::CreateGraphBuilder_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNContext::CreateGraphBuilder");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t WebNNContext::CreateTensor_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNContext::CreateTensor");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

// static
bool WebNNContext::RuntimeFeature_IsEnabled_(bool expected) {
  bool enabled = base::FeatureList::IsEnabled(::webnn::mojom::features::kWebMachineLearningNeuralNetwork);
#if DCHECK_IS_ON()
  if (expected) {
    DCHECK(enabled) << "RuntimeFeature ::webnn::mojom::features::kWebMachineLearningNeuralNetwork for WebNNContext is not enabled";
  }
#endif
  return enabled;
}

class WebNNContext_CreateTensor_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  WebNNContext_CreateTensor_ForwardToCallback(
      WebNNContext::CreateTensorCallback callback
      ) : callback_(std::move(callback)) {
  }

  WebNNContext_CreateTensor_ForwardToCallback(const WebNNContext_CreateTensor_ForwardToCallback&) = delete;
  WebNNContext_CreateTensor_ForwardToCallback& operator=(const WebNNContext_CreateTensor_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  WebNNContext::CreateTensorCallback callback_;
};

WebNNContextProxy::WebNNContextProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WebNNContextProxy::CreateGraphBuilder(
    ::mojo::PendingAssociatedReceiver<::webnn::mojom::WebNNGraphBuilder> in_receiver) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send webnn::mojom::WebNNContext::CreateGraphBuilder", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("receiver"), in_receiver,
                        "<value of type ::mojo::PendingAssociatedReceiver<::webnn::mojom::WebNNGraphBuilder>>");
   });
#endif

  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;

  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::WebNNContext::kCreateGraphBuilder), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNContext_CreateGraphBuilder_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<::webnn::mojom::WebNNGraphBuilderAssociatedRequestDataView>(
      in_receiver, &params->receiver, &params.message());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->receiver),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid receiver in WebNNContext.CreateGraphBuilder request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNContext::Name_);
  message.set_method_name("CreateGraphBuilder");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

void WebNNContextProxy::CreateTensor(
    ::webnn::mojom::TensorInfoPtr in_tensor_info, CreateTensorCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send webnn::mojom::WebNNContext::CreateTensor", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("tensor_info"), in_tensor_info,
                        "<value of type ::webnn::mojom::TensorInfoPtr>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;

  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::WebNNContext::kCreateTensor), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNContext_CreateTensor_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->tensor_info)::BaseType> tensor_info_fragment(
          params.message());
  mojo::internal::Serialize<::webnn::mojom::TensorInfoDataView>(
      in_tensor_info, tensor_info_fragment);
  params->tensor_info.Set(
      tensor_info_fragment.is_null() ? nullptr : tensor_info_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tensor_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tensor_info in WebNNContext.CreateTensor request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNContext::Name_);
  message.set_method_name("CreateTensor");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new WebNNContext_CreateTensor_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class WebNNContext_CreateTensor_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static WebNNContext::CreateTensorCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<WebNNContext_CreateTensor_ProxyToResponder> proxy(
        new WebNNContext_CreateTensor_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&WebNNContext_CreateTensor_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~WebNNContext_CreateTensor_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  WebNNContext_CreateTensor_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "WebNNContext::CreateTensorCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      CreateTensorResultPtr in_result);
};

bool WebNNContext_CreateTensor_ForwardToCallback::Accept(
    mojo::Message* message) {
  DCHECK(message->is_serialized());
  internal::WebNNContext_CreateTensor_ResponseParams_Data* params =
      reinterpret_cast<
          internal::WebNNContext_CreateTensor_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for WebNNContext.1
  bool success = true;
  CreateTensorResultPtr p_result{};
  WebNNContext_CreateTensor_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        WebNNContext::Name_, 1, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void WebNNContext_CreateTensor_ProxyToResponder::Run(
    CreateTensorResultPtr in_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply webnn::mojom::WebNNContext::CreateTensor", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type CreateTensorResultPtr>");
   });
#endif

  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::WebNNContext::kCreateTensor), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNContext_CreateTensor_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<decltype(params->result)>
      result_fragment(params.message());
  result_fragment.Claim(&params->result);
  mojo::internal::Serialize<::webnn::mojom::CreateTensorResultDataView>(
      in_result, result_fragment, true);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->result.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null result in ");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNContext::Name_);
  message.set_method_name("CreateTensor");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool WebNNContextStubDispatch::Accept(
    WebNNContext* impl,
    mojo::Message* message) {
  switch (static_cast<messages::WebNNContext>(message->header()->name)) {
    case messages::WebNNContext::kCreateGraphBuilder: {
      DCHECK(message->is_serialized());
      internal::WebNNContext_CreateGraphBuilder_Params_Data* params =
          reinterpret_cast<internal::WebNNContext_CreateGraphBuilder_Params_Data*>(
              message->mutable_payload());
      
      
      // Validation for WebNNContext.0
      bool success = true;
      ::mojo::PendingAssociatedReceiver<::webnn::mojom::WebNNGraphBuilder> p_receiver{};
      WebNNContext_CreateGraphBuilder_ParamsDataView input_data_view(params, message);
      
      if (success) {
        p_receiver =
            input_data_view.TakeReceiver<decltype(p_receiver)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNContext::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateGraphBuilder(        
        std::move(p_receiver));
      return true;
    }
    case messages::WebNNContext::kCreateTensor: {
      break;
    }
  }
  return false;
}

// static
bool WebNNContextStubDispatch::AcceptWithResponder(
    WebNNContext* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (static_cast<messages::WebNNContext>(message->header()->name)) {
    case messages::WebNNContext::kCreateGraphBuilder: {
      break;
    }
    case messages::WebNNContext::kCreateTensor: {
      internal::WebNNContext_CreateTensor_Params_Data* params =
          reinterpret_cast<
              internal::WebNNContext_CreateTensor_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for WebNNContext.1
      bool success = true;
      ::webnn::mojom::TensorInfoPtr p_tensor_info{};
      WebNNContext_CreateTensor_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadTensorInfo(&p_tensor_info))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNContext::Name_, 1, false);
        return false;
      }
      WebNNContext::CreateTensorCallback callback =
          WebNNContext_CreateTensor_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateTensor(        
        std::move(p_tensor_info), std::move(callback));
      return true;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWebNNContextValidationInfo[] = {
    {base::to_underlying(messages::WebNNContext::kCreateGraphBuilder),
     { &internal::WebNNContext_CreateGraphBuilder_Params_Data::Validate,
      nullptr /* no response */}},
    {base::to_underlying(messages::WebNNContext::kCreateTensor),
     { &internal::WebNNContext_CreateTensor_Params_Data::Validate,
      &internal::WebNNContext_CreateTensor_ResponseParams_Data::Validate}},
};

bool WebNNContextRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNContext::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWebNNContextValidationInfo);
}

bool WebNNContextResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNContext::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kWebNNContextValidationInfo);

}


}  // webnn::mojom


namespace mojo {


// static
bool StructTraits<::webnn::mojom::CreateTensorSuccess::DataView, ::webnn::mojom::CreateTensorSuccessPtr>::Read(
    ::webnn::mojom::CreateTensorSuccess::DataView input,
    ::webnn::mojom::CreateTensorSuccessPtr* output) {
  bool success = true;
  ::webnn::mojom::CreateTensorSuccessPtr result(::webnn::mojom::CreateTensorSuccess::New());
  
      if (success) {
        result->tensor_remote =
            input.TakeTensorRemote<decltype(result->tensor_remote)>();
      }
      if (success && !input.ReadTensorHandle(&result->tensor_handle))
        success = false;
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::webnn::mojom::CreateTensorResult::DataView, ::webnn::mojom::CreateTensorResultPtr>::Read(
    ::webnn::mojom::CreateTensorResult::DataView input,
    ::webnn::mojom::CreateTensorResultPtr* output) {
  using UnionType = ::webnn::mojom::CreateTensorResult;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kSuccess: {
      ::webnn::mojom::CreateTensorSuccessPtr result_success;
      if (!input.ReadSuccess(&result_success))
        return false;

      *output = UnionType::NewSuccess(
          std::move(result_success));
      break;
    }
    case Tag::kError: {
      ::webnn::mojom::ErrorPtr result_error;
      if (!input.ReadError(&result_error))
        return false;

      *output = UnionType::NewError(
          std::move(result_error));
      break;
    }
    default:

      return false;
  }
  return true;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace webnn::mojom {


void WebNNContextInterceptorForTesting::CreateGraphBuilder(::mojo::PendingAssociatedReceiver<::webnn::mojom::WebNNGraphBuilder> receiver) {
  GetForwardingInterface()->CreateGraphBuilder(
    std::move(receiver)
    );
}
void WebNNContextInterceptorForTesting::CreateTensor(::webnn::mojom::TensorInfoPtr tensor_info, CreateTensorCallback callback) {
  GetForwardingInterface()->CreateTensor(
    std::move(tensor_info)
    , std::move(callback));
}
WebNNContextAsyncWaiter::WebNNContextAsyncWaiter(
    WebNNContext* proxy) : proxy_(proxy) {}

WebNNContextAsyncWaiter::~WebNNContextAsyncWaiter() = default;

void WebNNContextAsyncWaiter::CreateTensor(
    ::webnn::mojom::TensorInfoPtr tensor_info, CreateTensorResultPtr* out_result) {
  base::RunLoop loop;
  proxy_->CreateTensor(
      std::move(tensor_info),
      base::BindOnce(
          [](base::RunLoop* loop,
             CreateTensorResultPtr* out_result
,
             CreateTensorResultPtr result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}

CreateTensorResultPtr WebNNContextAsyncWaiter::CreateTensor(
    ::webnn::mojom::TensorInfoPtr tensor_info) {
  CreateTensorResultPtr async_wait_result;
  CreateTensor(std::move(tensor_info),&async_wait_result);
  return async_wait_result;
}






}  // webnn::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif