// services/webnn/public/mojom/webnn_context_provider.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_CONTEXT_PROVIDER_MOJOM_SHARED_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_CONTEXT_PROVIDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_context_provider.mojom-shared-internal.h"
#include "services/webnn/public/mojom/features.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_context.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_context_properties.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_error.mojom-shared.h"
#include "third_party/blink/public/mojom/tokens/tokens.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace webnn::mojom {
class CreateContextOptionsDataView;

class CreateContextSuccessDataView;

class CreateContextResultDataView;


}  // webnn::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::webnn::mojom::CreateContextOptionsDataView> {
  using Data = ::webnn::mojom::internal::CreateContextOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::CreateContextSuccessDataView> {
  using Data = ::webnn::mojom::internal::CreateContextSuccess_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::CreateContextResultDataView> {
  using Data = ::webnn::mojom::internal::CreateContextResult_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace webnn::mojom {


enum class CreateContextOptions_Device : int32_t {
  
  kCpu = 0,
  
  kGpu = 1,
  
  kNpu = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(WEBNN_MOJOM_SHARED) std::ostream& operator<<(std::ostream& os, CreateContextOptions_Device value);
inline bool IsKnownEnumValue(CreateContextOptions_Device value) {
  return internal::CreateContextOptions_Device_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class CreateContextOptions_PowerPreference : int32_t {
  
  kDefault = 0,
  
  kHighPerformance = 1,
  
  kLowPower = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(WEBNN_MOJOM_SHARED) std::ostream& operator<<(std::ostream& os, CreateContextOptions_PowerPreference value);
inline bool IsKnownEnumValue(CreateContextOptions_PowerPreference value) {
  return internal::CreateContextOptions_PowerPreference_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class WebNNContextProviderInterfaceBase {};

using WebNNContextProviderPtrDataView =
    mojo::InterfacePtrDataView<WebNNContextProviderInterfaceBase>;
using WebNNContextProviderRequestDataView =
    mojo::InterfaceRequestDataView<WebNNContextProviderInterfaceBase>;
using WebNNContextProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebNNContextProviderInterfaceBase>;
using WebNNContextProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebNNContextProviderInterfaceBase>;


class CreateContextOptionsDataView {
 public:
  CreateContextOptionsDataView() = default;

  CreateContextOptionsDataView(
      internal::CreateContextOptions_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadDevice(UserType* output) const {
    auto data_value = data_->device;
    return mojo::internal::Deserialize<::webnn::mojom::CreateContextOptions_Device>(
        data_value, output);
  }
  CreateContextOptions_Device device() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::CreateContextOptions_Device>(data_->device));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadPowerPreference(UserType* output) const {
    auto data_value = data_->power_preference;
    return mojo::internal::Deserialize<::webnn::mojom::CreateContextOptions_PowerPreference>(
        data_value, output);
  }
  CreateContextOptions_PowerPreference power_preference() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::CreateContextOptions_PowerPreference>(data_->power_preference));
  }
 private:
  internal::CreateContextOptions_Data* data_ = nullptr;
};


class CreateContextSuccessDataView {
 public:
  CreateContextSuccessDataView() = default;

  CreateContextSuccessDataView(
      internal::CreateContextSuccess_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeContextRemote() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::webnn::mojom::WebNNContextInterfaceBase>>(
            &data_->context_remote, &result, message_);
    DCHECK(ret);
    return result;
  }
  inline void GetContextPropertiesDataView(
      ::webnn::mojom::ContextPropertiesDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadContextProperties(UserType* output) {
    
    auto* pointer = data_->context_properties.Get();
    return mojo::internal::Deserialize<::webnn::mojom::ContextPropertiesDataView>(
        pointer, output, message_);
  }
  inline void GetContextHandleDataView(
      ::blink::mojom::WebNNContextTokenDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadContextHandle(UserType* output) {
    
    auto* pointer = data_->context_handle.Get();
    return mojo::internal::Deserialize<::blink::mojom::WebNNContextTokenDataView>(
        pointer, output, message_);
  }
 private:
  internal::CreateContextSuccess_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class CreateContextResultDataView {
 public:
  using Tag = internal::CreateContextResult_Data::CreateContextResult_Tag;

  CreateContextResultDataView() = default;

  CreateContextResultDataView(
      internal::CreateContextResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_success() const { return data_->tag == Tag::kSuccess; }
  inline void GetSuccessDataView(
      CreateContextSuccessDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadSuccess(UserType* output) const {
    
    CHECK(is_success());
    return mojo::internal::Deserialize<::webnn::mojom::CreateContextSuccessDataView>(
        data_->data.f_success.Get(), output, message_);
  }
  bool is_error() const { return data_->tag == Tag::kError; }
  inline void GetErrorDataView(
      ::webnn::mojom::ErrorDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadError(UserType* output) const {
    
    CHECK(is_error());
    return mojo::internal::Deserialize<::webnn::mojom::ErrorDataView>(
        data_->data.f_error.Get(), output, message_);
  }

 private:
  internal::CreateContextResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // webnn::mojom

namespace std {

template <>
struct hash<::webnn::mojom::CreateContextOptions_Device>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::CreateContextOptions_Device> {};

template <>
struct hash<::webnn::mojom::CreateContextOptions_PowerPreference>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::CreateContextOptions_PowerPreference> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateContextOptions_Device, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::CreateContextOptions_Device, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::CreateContextOptions_Device>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateContextOptions_PowerPreference, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::CreateContextOptions_PowerPreference, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::CreateContextOptions_PowerPreference>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateContextOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::CreateContextOptionsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::CreateContextOptions_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::webnn::mojom::CreateContextOptions_Device>(
        Traits::device(input), &fragment->device);
    mojo::internal::Serialize<::webnn::mojom::CreateContextOptions_PowerPreference>(
        Traits::power_preference(input), &fragment->power_preference);
  }

  static bool Deserialize(::webnn::mojom::internal::CreateContextOptions_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::CreateContextOptionsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateContextSuccessDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::CreateContextSuccessDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::CreateContextSuccess_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::context_remote(input)) in_context_remote = Traits::context_remote(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::webnn::mojom::WebNNContextInterfaceBase>>(
        in_context_remote, &fragment->context_remote, &fragment.message());
    decltype(Traits::context_properties(input)) in_context_properties = Traits::context_properties(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->context_properties)::BaseType> context_properties_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::ContextPropertiesDataView>(
        in_context_properties, context_properties_fragment);
    fragment->context_properties.Set(
        context_properties_fragment.is_null() ? nullptr : context_properties_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->context_properties.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null context_properties in CreateContextSuccess struct");
    decltype(Traits::context_handle(input)) in_context_handle = Traits::context_handle(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->context_handle)::BaseType> context_handle_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::WebNNContextTokenDataView>(
        in_context_handle, context_handle_fragment);
    fragment->context_handle.Set(
        context_handle_fragment.is_null() ? nullptr : context_handle_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->context_handle.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null context_handle in CreateContextSuccess struct");
  }

  static bool Deserialize(::webnn::mojom::internal::CreateContextSuccess_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::CreateContextSuccessDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateContextResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::webnn::mojom::CreateContextResultDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::webnn::mojom::internal::CreateContextResult_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::webnn::mojom::CreateContextResultDataView::Tag::kSuccess: {
        decltype(Traits::success(input))
            in_success = Traits::success(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_success)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::webnn::mojom::CreateContextSuccessDataView>(
            in_success, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null success in CreateContextResult union");
        fragment->data.f_success.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::webnn::mojom::CreateContextResultDataView::Tag::kError: {
        decltype(Traits::error(input))
            in_error = Traits::error(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_error)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::webnn::mojom::ErrorDataView>(
            in_error, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null error in CreateContextResult union");
        fragment->data.f_error.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
    }
  }

  static bool Deserialize(::webnn::mojom::internal::CreateContextResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::CreateContextResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace webnn::mojom {



inline void CreateContextSuccessDataView::GetContextPropertiesDataView(
    ::webnn::mojom::ContextPropertiesDataView* output) {
  auto pointer = data_->context_properties.Get();
  *output = ::webnn::mojom::ContextPropertiesDataView(pointer, message_);
}
inline void CreateContextSuccessDataView::GetContextHandleDataView(
    ::blink::mojom::WebNNContextTokenDataView* output) {
  auto pointer = data_->context_handle.Get();
  *output = ::blink::mojom::WebNNContextTokenDataView(pointer, message_);
}


inline void CreateContextResultDataView::GetSuccessDataView(
    CreateContextSuccessDataView* output) const {
  CHECK(is_success());
  *output = CreateContextSuccessDataView(data_->data.f_success.Get(), message_);
}
inline void CreateContextResultDataView::GetErrorDataView(
    ::webnn::mojom::ErrorDataView* output) const {
  CHECK(is_error());
  *output = ::webnn::mojom::ErrorDataView(data_->data.f_error.Get(), message_);
}


}  // webnn::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(WEBNN_MOJOM_SHARED) TraceFormatTraits<::webnn::mojom::CreateContextOptions_Device> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::CreateContextOptions_Device value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(WEBNN_MOJOM_SHARED) TraceFormatTraits<::webnn::mojom::CreateContextOptions_PowerPreference> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::CreateContextOptions_PowerPreference value);
};

} // namespace perfetto

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_CONTEXT_PROVIDER_MOJOM_SHARED_H_