// services/webnn/public/mojom/webnn_graph_builder.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_BUILDER_MOJOM_SHARED_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_BUILDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_graph_builder.mojom-shared-internal.h"
#include "mojo/public/mojom/base/big_buffer.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_context_properties.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_error.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-shared.h"
#include "third_party/blink/public/mojom/tokens/tokens.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace webnn::mojom {
class CreateGraphResultDataView;


}  // webnn::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::webnn::mojom::CreateGraphResultDataView> {
  using Data = ::webnn::mojom::internal::CreateGraphResult_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace webnn::mojom {
// Interface base classes. They are used for type safety check.
class WebNNGraphBuilderInterfaceBase {};

using WebNNGraphBuilderPtrDataView =
    mojo::InterfacePtrDataView<WebNNGraphBuilderInterfaceBase>;
using WebNNGraphBuilderRequestDataView =
    mojo::InterfaceRequestDataView<WebNNGraphBuilderInterfaceBase>;
using WebNNGraphBuilderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebNNGraphBuilderInterfaceBase>;
using WebNNGraphBuilderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebNNGraphBuilderInterfaceBase>;


class CreateGraphResultDataView {
 public:
  using Tag = internal::CreateGraphResult_Data::CreateGraphResult_Tag;

  CreateGraphResultDataView() = default;

  CreateGraphResultDataView(
      internal::CreateGraphResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_graph_remote() const { return data_->tag == Tag::kGraphRemote; }
  template <typename UserType>
  UserType TakeGraphRemote() {
    CHECK(is_graph_remote());
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::webnn::mojom::WebNNGraphAssociatedPtrInfoDataView>(
            &data_->data.f_graph_remote, &result, message_);
    CHECK(ret);
    return result;
  }
  bool is_error() const { return data_->tag == Tag::kError; }
  inline void GetErrorDataView(
      ::webnn::mojom::ErrorDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadError(UserType* output) const {
    
    CHECK(is_error());
    return mojo::internal::Deserialize<::webnn::mojom::ErrorDataView>(
        data_->data.f_error.Get(), output, message_);
  }

 private:
  internal::CreateGraphResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // webnn::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateGraphResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::webnn::mojom::CreateGraphResultDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::webnn::mojom::internal::CreateGraphResult_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::webnn::mojom::CreateGraphResultDataView::Tag::kGraphRemote: {
        decltype(Traits::graph_remote(input))
            in_graph_remote = Traits::graph_remote(input);
        mojo::internal::Serialize<::webnn::mojom::WebNNGraphAssociatedPtrInfoDataView>(
            in_graph_remote, &fragment->data.f_graph_remote, &fragment.message());
        break;
      }
      case ::webnn::mojom::CreateGraphResultDataView::Tag::kError: {
        decltype(Traits::error(input))
            in_error = Traits::error(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_error)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::webnn::mojom::ErrorDataView>(
            in_error, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null error in CreateGraphResult union");
        fragment->data.f_error.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
    }
  }

  static bool Deserialize(::webnn::mojom::internal::CreateGraphResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::CreateGraphResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace webnn::mojom {

inline void CreateGraphResultDataView::GetErrorDataView(
    ::webnn::mojom::ErrorDataView* output) const {
  CHECK(is_error());
  *output = ::webnn::mojom::ErrorDataView(data_->data.f_error.Get(), message_);
}


}  // webnn::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_BUILDER_MOJOM_SHARED_H_