// third_party/blink/public/mojom/ai/ai_rewriter.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_REWRITER_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_REWRITER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/ai/ai_rewriter.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/ai/model_streaming_responder.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class AIRewriterCreateOptionsDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::AIRewriterCreateOptionsDataView> {
  using Data = ::blink::mojom::internal::AIRewriterCreateOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class AIRewriterTone : int32_t {
  
  kAsIs = 0,
  
  kMoreFormal = 1,
  
  kMoreCasual = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AIRewriterTone value);
inline bool IsKnownEnumValue(AIRewriterTone value) {
  return internal::AIRewriterTone_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class AIRewriterFormat : int32_t {
  
  kAsIs = 0,
  
  kPlainText = 1,
  
  kMarkdown = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AIRewriterFormat value);
inline bool IsKnownEnumValue(AIRewriterFormat value) {
  return internal::AIRewriterFormat_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class AIRewriterLength : int32_t {
  
  kAsIs = 0,
  
  kShorter = 1,
  
  kLonger = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AIRewriterLength value);
inline bool IsKnownEnumValue(AIRewriterLength value) {
  return internal::AIRewriterLength_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class AIRewriterInterfaceBase {};

using AIRewriterPtrDataView =
    mojo::InterfacePtrDataView<AIRewriterInterfaceBase>;
using AIRewriterRequestDataView =
    mojo::InterfaceRequestDataView<AIRewriterInterfaceBase>;
using AIRewriterAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AIRewriterInterfaceBase>;
using AIRewriterAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AIRewriterInterfaceBase>;


class AIRewriterCreateOptionsDataView {
 public:
  AIRewriterCreateOptionsDataView() = default;

  AIRewriterCreateOptionsDataView(
      internal::AIRewriterCreateOptions_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetSharedContextDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSharedContext(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `shared_context` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadSharedContext` instead "
    "of `ReadSharedContext if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->shared_context.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadTone(UserType* output) const {
    auto data_value = data_->tone;
    return mojo::internal::Deserialize<::blink::mojom::AIRewriterTone>(
        data_value, output);
  }
  AIRewriterTone tone() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AIRewriterTone>(data_->tone));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadFormat(UserType* output) const {
    auto data_value = data_->format;
    return mojo::internal::Deserialize<::blink::mojom::AIRewriterFormat>(
        data_value, output);
  }
  AIRewriterFormat format() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AIRewriterFormat>(data_->format));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadLength(UserType* output) const {
    auto data_value = data_->length;
    return mojo::internal::Deserialize<::blink::mojom::AIRewriterLength>(
        data_value, output);
  }
  AIRewriterLength length() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AIRewriterLength>(data_->length));
  }
  inline void GetExpectedInputLanguagesDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadExpectedInputLanguages(UserType* output) {
    
    auto* pointer = data_->expected_input_languages.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, message_);
  }
  inline void GetExpectedContextLanguagesDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadExpectedContextLanguages(UserType* output) {
    
    auto* pointer = data_->expected_context_languages.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, message_);
  }
  inline void GetOutputLanguageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadOutputLanguage(UserType* output) {
    
    auto* pointer = data_->output_language.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
 private:
  internal::AIRewriterCreateOptions_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::AIRewriterTone>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AIRewriterTone> {};

template <>
struct hash<::blink::mojom::AIRewriterFormat>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AIRewriterFormat> {};

template <>
struct hash<::blink::mojom::AIRewriterLength>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AIRewriterLength> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AIRewriterTone, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AIRewriterTone, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AIRewriterTone>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AIRewriterFormat, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AIRewriterFormat, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AIRewriterFormat>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AIRewriterLength, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AIRewriterLength, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AIRewriterLength>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AIRewriterCreateOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::AIRewriterCreateOptionsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::AIRewriterCreateOptions_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::shared_context(input)) in_shared_context = Traits::shared_context(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->shared_context)::BaseType> shared_context_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_shared_context, shared_context_fragment);
    fragment->shared_context.Set(
        shared_context_fragment.is_null() ? nullptr : shared_context_fragment.data());
    mojo::internal::Serialize<::blink::mojom::AIRewriterTone>(
        Traits::tone(input), &fragment->tone);
    mojo::internal::Serialize<::blink::mojom::AIRewriterFormat>(
        Traits::format(input), &fragment->format);
    mojo::internal::Serialize<::blink::mojom::AIRewriterLength>(
        Traits::length(input), &fragment->length);
    decltype(Traits::expected_input_languages(input)) in_expected_input_languages = Traits::expected_input_languages(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->expected_input_languages)::BaseType>
        expected_input_languages_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& expected_input_languages_validate_params =
        mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_expected_input_languages, expected_input_languages_fragment, &expected_input_languages_validate_params);
    fragment->expected_input_languages.Set(
        expected_input_languages_fragment.is_null() ? nullptr : expected_input_languages_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->expected_input_languages.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null expected_input_languages in AIRewriterCreateOptions struct");
    decltype(Traits::expected_context_languages(input)) in_expected_context_languages = Traits::expected_context_languages(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->expected_context_languages)::BaseType>
        expected_context_languages_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& expected_context_languages_validate_params =
        mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_expected_context_languages, expected_context_languages_fragment, &expected_context_languages_validate_params);
    fragment->expected_context_languages.Set(
        expected_context_languages_fragment.is_null() ? nullptr : expected_context_languages_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->expected_context_languages.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null expected_context_languages in AIRewriterCreateOptions struct");
    decltype(Traits::output_language(input)) in_output_language = Traits::output_language(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->output_language)::BaseType> output_language_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_output_language, output_language_fragment);
    fragment->output_language.Set(
        output_language_fragment.is_null() ? nullptr : output_language_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->output_language.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null output_language in AIRewriterCreateOptions struct");
  }

  static bool Deserialize(::blink::mojom::internal::AIRewriterCreateOptions_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::AIRewriterCreateOptionsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void AIRewriterCreateOptionsDataView::GetSharedContextDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->shared_context.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AIRewriterCreateOptionsDataView::GetExpectedInputLanguagesDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->expected_input_languages.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, message_);
}
inline void AIRewriterCreateOptionsDataView::GetExpectedContextLanguagesDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->expected_context_languages.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, message_);
}
inline void AIRewriterCreateOptionsDataView::GetOutputLanguageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->output_language.Get();
  *output = mojo::StringDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AIRewriterTone> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::AIRewriterTone value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AIRewriterFormat> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::AIRewriterFormat value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AIRewriterLength> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::AIRewriterLength value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_REWRITER_MOJOM_SHARED_H_