// third_party/blink/public/mojom/ai/ai_summarizer.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_SUMMARIZER_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_SUMMARIZER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/ai/ai_summarizer.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/ai/ai_summarizer.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/ai/ai_summarizer.mojom-blink-forward.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/ai/model_streaming_responder.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"
#if !BLINK_MOJO_IMPL && !INSIDE_BLINK
#error "File must only be imported inside blink"
#endif




namespace blink::mojom::blink {

class AISummarizerProxy;

template <typename ImplRefTraits>
class AISummarizerStub;

class AISummarizerRequestValidator;


class PLATFORM_EXPORT AISummarizer
    : public AISummarizerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AISummarizerInterfaceBase;
  using Proxy_ = AISummarizerProxy;

  template <typename ImplRefTraits>
  using Stub_ = AISummarizerStub<ImplRefTraits>;

  using RequestValidator_ = AISummarizerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSummarizeMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Summarize_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AISummarizer() = default;

  
  virtual void Summarize(const WTF::String& input, const WTF::String& context, ::mojo::PendingRemote<::blink::mojom::blink::ModelStreamingResponder> pending_responder) = 0;
};



class PLATFORM_EXPORT AISummarizerProxy
    : public AISummarizer {
 public:
  using InterfaceType = AISummarizer;

  explicit AISummarizerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Summarize(const WTF::String& input, const WTF::String& context, ::mojo::PendingRemote<::blink::mojom::blink::ModelStreamingResponder> pending_responder) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT AISummarizerStubDispatch {
 public:
  static bool Accept(AISummarizer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AISummarizer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AISummarizer>>
class AISummarizerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AISummarizerStub() = default;
  ~AISummarizerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AISummarizerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AISummarizerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT AISummarizerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class PLATFORM_EXPORT AISummarizerCreateOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AISummarizerCreateOptions, T>::value>;
  using DataView = AISummarizerCreateOptionsDataView;
  using Data_ = internal::AISummarizerCreateOptions_Data;

  template <typename... Args>
  static AISummarizerCreateOptionsPtr New(Args&&... args) {
    return AISummarizerCreateOptionsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AISummarizerCreateOptionsPtr From(const U& u) {
    return mojo::TypeConverter<AISummarizerCreateOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AISummarizerCreateOptions>::Convert(*this);
  }


  AISummarizerCreateOptions();

  AISummarizerCreateOptions(
      const WTF::String& shared_context,
      AISummarizerType type,
      AISummarizerFormat format,
      AISummarizerLength length);


  ~AISummarizerCreateOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AISummarizerCreateOptionsPtr>
  AISummarizerCreateOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AISummarizerCreateOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AISummarizerCreateOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AISummarizerCreateOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AISummarizerCreateOptions::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AISummarizerCreateOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AISummarizerCreateOptions_UnserializedMessageContext<
            UserType, AISummarizerCreateOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AISummarizerCreateOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AISummarizerCreateOptions::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AISummarizerCreateOptions_UnserializedMessageContext<
            UserType, AISummarizerCreateOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AISummarizerCreateOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String shared_context;
  
  AISummarizerType type;
  
  AISummarizerFormat format;
  
  AISummarizerLength length;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AISummarizerCreateOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AISummarizerCreateOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AISummarizerCreateOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AISummarizerCreateOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
AISummarizerCreateOptionsPtr AISummarizerCreateOptions::Clone() const {
  return New(
      mojo::Clone(shared_context),
      mojo::Clone(type),
      mojo::Clone(format),
      mojo::Clone(length)
  );
}

template <typename T, AISummarizerCreateOptions::EnableIfSame<T>*>
bool AISummarizerCreateOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->shared_context, other_struct.shared_context))
    return false;
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->format, other_struct.format))
    return false;
  if (!mojo::Equals(this->length, other_struct.length))
    return false;
  return true;
}

template <typename T, AISummarizerCreateOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.shared_context < rhs.shared_context)
    return true;
  if (rhs.shared_context < lhs.shared_context)
    return false;
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.format < rhs.format)
    return true;
  if (rhs.format < lhs.format)
    return false;
  if (lhs.length < rhs.length)
    return true;
  if (rhs.length < lhs.length)
    return false;
  return false;
}


}  // blink::mojom::blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::AISummarizerCreateOptions::DataView,
                                         ::blink::mojom::blink::AISummarizerCreateOptionsPtr> {
  static bool IsNull(const ::blink::mojom::blink::AISummarizerCreateOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::AISummarizerCreateOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::AISummarizerCreateOptions::shared_context)& shared_context(
      const ::blink::mojom::blink::AISummarizerCreateOptionsPtr& input) {
    return input->shared_context;
  }

  static decltype(::blink::mojom::blink::AISummarizerCreateOptions::type) type(
      const ::blink::mojom::blink::AISummarizerCreateOptionsPtr& input) {
    return input->type;
  }

  static decltype(::blink::mojom::blink::AISummarizerCreateOptions::format) format(
      const ::blink::mojom::blink::AISummarizerCreateOptionsPtr& input) {
    return input->format;
  }

  static decltype(::blink::mojom::blink::AISummarizerCreateOptions::length) length(
      const ::blink::mojom::blink::AISummarizerCreateOptionsPtr& input) {
    return input->length;
  }

  static bool Read(::blink::mojom::blink::AISummarizerCreateOptions::DataView input, ::blink::mojom::blink::AISummarizerCreateOptionsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_SUMMARIZER_MOJOM_BLINK_H_