// third_party/blink/public/mojom/ai/ai_summarizer.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_SUMMARIZER_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_SUMMARIZER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/ai/ai_summarizer.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/ai/model_streaming_responder.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class AISummarizerCreateOptionsDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::AISummarizerCreateOptionsDataView> {
  using Data = ::blink::mojom::internal::AISummarizerCreateOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class AISummarizerType : int32_t {
  
  kTLDR = 0,
  
  kKeyPoints = 1,
  
  kTeaser = 2,
  
  kHeadline = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AISummarizerType value);
inline bool IsKnownEnumValue(AISummarizerType value) {
  return internal::AISummarizerType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class AISummarizerFormat : int32_t {
  
  kPlainText = 0,
  
  kMarkDown = 1,
  kMinValue = 0,
  kMaxValue = 1,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AISummarizerFormat value);
inline bool IsKnownEnumValue(AISummarizerFormat value) {
  return internal::AISummarizerFormat_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class AISummarizerLength : int32_t {
  
  kShort = 0,
  
  kMedium = 1,
  
  kLong = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AISummarizerLength value);
inline bool IsKnownEnumValue(AISummarizerLength value) {
  return internal::AISummarizerLength_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class AISummarizerInterfaceBase {};

using AISummarizerPtrDataView =
    mojo::InterfacePtrDataView<AISummarizerInterfaceBase>;
using AISummarizerRequestDataView =
    mojo::InterfaceRequestDataView<AISummarizerInterfaceBase>;
using AISummarizerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AISummarizerInterfaceBase>;
using AISummarizerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AISummarizerInterfaceBase>;


class AISummarizerCreateOptionsDataView {
 public:
  AISummarizerCreateOptionsDataView() = default;

  AISummarizerCreateOptionsDataView(
      internal::AISummarizerCreateOptions_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetSharedContextDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSharedContext(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `shared_context` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadSharedContext` instead "
    "of `ReadSharedContext if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->shared_context.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::blink::mojom::AISummarizerType>(
        data_value, output);
  }
  AISummarizerType type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AISummarizerType>(data_->type));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadFormat(UserType* output) const {
    auto data_value = data_->format;
    return mojo::internal::Deserialize<::blink::mojom::AISummarizerFormat>(
        data_value, output);
  }
  AISummarizerFormat format() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AISummarizerFormat>(data_->format));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadLength(UserType* output) const {
    auto data_value = data_->length;
    return mojo::internal::Deserialize<::blink::mojom::AISummarizerLength>(
        data_value, output);
  }
  AISummarizerLength length() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AISummarizerLength>(data_->length));
  }
 private:
  internal::AISummarizerCreateOptions_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::AISummarizerType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AISummarizerType> {};

template <>
struct hash<::blink::mojom::AISummarizerFormat>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AISummarizerFormat> {};

template <>
struct hash<::blink::mojom::AISummarizerLength>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AISummarizerLength> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AISummarizerType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AISummarizerType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AISummarizerType>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AISummarizerFormat, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AISummarizerFormat, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AISummarizerFormat>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AISummarizerLength, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AISummarizerLength, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AISummarizerLength>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AISummarizerCreateOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::AISummarizerCreateOptionsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::AISummarizerCreateOptions_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::shared_context(input)) in_shared_context = Traits::shared_context(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->shared_context)::BaseType> shared_context_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_shared_context, shared_context_fragment);
    fragment->shared_context.Set(
        shared_context_fragment.is_null() ? nullptr : shared_context_fragment.data());
    mojo::internal::Serialize<::blink::mojom::AISummarizerType>(
        Traits::type(input), &fragment->type);
    mojo::internal::Serialize<::blink::mojom::AISummarizerFormat>(
        Traits::format(input), &fragment->format);
    mojo::internal::Serialize<::blink::mojom::AISummarizerLength>(
        Traits::length(input), &fragment->length);
  }

  static bool Deserialize(::blink::mojom::internal::AISummarizerCreateOptions_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::AISummarizerCreateOptionsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void AISummarizerCreateOptionsDataView::GetSharedContextDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->shared_context.Get();
  *output = mojo::StringDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AISummarizerType> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::AISummarizerType value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AISummarizerFormat> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::AISummarizerFormat value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AISummarizerLength> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::AISummarizerLength value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_SUMMARIZER_MOJOM_SHARED_H_