// third_party/blink/public/mojom/content_extraction/ai_page_content.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_CONTENT_EXTRACTION_AI_PAGE_CONTENT_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_CONTENT_EXTRACTION_AI_PAGE_CONTENT_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/content_extraction/ai_page_content.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/content_extraction/ai_page_content.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/content_extraction/ai_page_content.mojom-forward.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/forms/form_control_type.mojom-forward.h"
#include "third_party/blink/public/mojom/tokens/tokens.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class AIPageContentAgentProxy;

template <typename ImplRefTraits>
class AIPageContentAgentStub;

class AIPageContentAgentRequestValidator;
class AIPageContentAgentResponseValidator;


class BLINK_COMMON_EXPORT AIPageContentAgent
    : public AIPageContentAgentInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AIPageContentAgentInterfaceBase;
  using Proxy_ = AIPageContentAgentProxy;

  template <typename ImplRefTraits>
  using Stub_ = AIPageContentAgentStub<ImplRefTraits>;

  using RequestValidator_ = AIPageContentAgentRequestValidator;
  using ResponseValidator_ = AIPageContentAgentResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetAIPageContentMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct GetAIPageContent_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AIPageContentAgent() = default;


  using GetAIPageContentCallback = base::OnceCallback<void(AIPageContentPtr)>;
  
  virtual void GetAIPageContent(AIPageContentOptionsPtr request, GetAIPageContentCallback callback) = 0;
};



class BLINK_COMMON_EXPORT AIPageContentAgentProxy
    : public AIPageContentAgent {
 public:
  using InterfaceType = AIPageContentAgent;

  explicit AIPageContentAgentProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetAIPageContent(AIPageContentOptionsPtr request, GetAIPageContentCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT AIPageContentAgentStubDispatch {
 public:
  static bool Accept(AIPageContentAgent* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AIPageContentAgent* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AIPageContentAgent>>
class AIPageContentAgentStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AIPageContentAgentStub() = default;
  ~AIPageContentAgentStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AIPageContentAgentStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AIPageContentAgentStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AIPageContentAgentRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT AIPageContentAgentResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class BLINK_COMMON_EXPORT AIPageContentTextStyle {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentTextStyle, T>::value>;
  using DataView = AIPageContentTextStyleDataView;
  using Data_ = internal::AIPageContentTextStyle_Data;

  template <typename... Args>
  static AIPageContentTextStylePtr New(Args&&... args) {
    return AIPageContentTextStylePtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentTextStylePtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentTextStylePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentTextStyle>::Convert(*this);
  }


  AIPageContentTextStyle();

  AIPageContentTextStyle(
      AIPageContentTextSize text_size,
      bool has_emphasis,
      uint32_t color);


  ~AIPageContentTextStyle();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentTextStylePtr>
  AIPageContentTextStylePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentTextStyle::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentTextStyle::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentTextStyle::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentTextStyle::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentTextStyle::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentTextStyle_UnserializedMessageContext<
            UserType, AIPageContentTextStyle::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentTextStyle::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentTextStyle::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentTextStyle_UnserializedMessageContext<
            UserType, AIPageContentTextStyle::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentTextStyle::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  AIPageContentTextSize text_size;
  
  bool has_emphasis;
  
  uint32_t color;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentTextStyle::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentTextStyle::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentTextStyle::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentTextStyle::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}









class BLINK_COMMON_EXPORT AIPageContentTableData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentTableData, T>::value>;
  using DataView = AIPageContentTableDataDataView;
  using Data_ = internal::AIPageContentTableData_Data;

  template <typename... Args>
  static AIPageContentTableDataPtr New(Args&&... args) {
    return AIPageContentTableDataPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentTableDataPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentTableDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentTableData>::Convert(*this);
  }


  AIPageContentTableData();

  explicit AIPageContentTableData(
      const std::optional<std::string>& table_name);


  ~AIPageContentTableData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentTableDataPtr>
  AIPageContentTableDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentTableData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentTableData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentTableData::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentTableData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentTableData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentTableData_UnserializedMessageContext<
            UserType, AIPageContentTableData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentTableData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentTableData::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentTableData_UnserializedMessageContext<
            UserType, AIPageContentTableData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentTableData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<std::string> table_name;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentTableData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentTableData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentTableData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentTableData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentTableRowData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentTableRowData, T>::value>;
  using DataView = AIPageContentTableRowDataDataView;
  using Data_ = internal::AIPageContentTableRowData_Data;

  template <typename... Args>
  static AIPageContentTableRowDataPtr New(Args&&... args) {
    return AIPageContentTableRowDataPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentTableRowDataPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentTableRowDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentTableRowData>::Convert(*this);
  }


  AIPageContentTableRowData();

  explicit AIPageContentTableRowData(
      AIPageContentTableRowType row_type);


  ~AIPageContentTableRowData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentTableRowDataPtr>
  AIPageContentTableRowDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentTableRowData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentTableRowData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentTableRowData::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentTableRowData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentTableRowData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentTableRowData_UnserializedMessageContext<
            UserType, AIPageContentTableRowData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentTableRowData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentTableRowData::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentTableRowData_UnserializedMessageContext<
            UserType, AIPageContentTableRowData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentTableRowData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  AIPageContentTableRowType row_type;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentTableRowData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentTableRowData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentTableRowData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentTableRowData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentFormData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentFormData, T>::value>;
  using DataView = AIPageContentFormDataDataView;
  using Data_ = internal::AIPageContentFormData_Data;

  template <typename... Args>
  static AIPageContentFormDataPtr New(Args&&... args) {
    return AIPageContentFormDataPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentFormDataPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentFormDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentFormData>::Convert(*this);
  }


  AIPageContentFormData();

  explicit AIPageContentFormData(
      const std::optional<std::string>& form_name);


  ~AIPageContentFormData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentFormDataPtr>
  AIPageContentFormDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentFormData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentFormData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentFormData::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentFormData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentFormData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentFormData_UnserializedMessageContext<
            UserType, AIPageContentFormData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentFormData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentFormData::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentFormData_UnserializedMessageContext<
            UserType, AIPageContentFormData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentFormData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<std::string> form_name;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentFormData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentFormData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentFormData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentFormData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentSelectOption {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentSelectOption, T>::value>;
  using DataView = AIPageContentSelectOptionDataView;
  using Data_ = internal::AIPageContentSelectOption_Data;

  template <typename... Args>
  static AIPageContentSelectOptionPtr New(Args&&... args) {
    return AIPageContentSelectOptionPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentSelectOptionPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentSelectOptionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentSelectOption>::Convert(*this);
  }


  AIPageContentSelectOption();

  AIPageContentSelectOption(
      const std::optional<std::string>& value,
      const std::optional<std::string>& text,
      bool is_selected);


  ~AIPageContentSelectOption();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentSelectOptionPtr>
  AIPageContentSelectOptionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentSelectOption::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentSelectOption::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentSelectOption::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentSelectOption::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentSelectOption::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentSelectOption_UnserializedMessageContext<
            UserType, AIPageContentSelectOption::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentSelectOption::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentSelectOption::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentSelectOption_UnserializedMessageContext<
            UserType, AIPageContentSelectOption::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentSelectOption::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<std::string> value;
  
  std::optional<std::string> text;
  
  bool is_selected;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentSelectOption::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentSelectOption::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentSelectOption::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentSelectOption::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}









class BLINK_COMMON_EXPORT AIPageContentOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentOptions, T>::value>;
  using DataView = AIPageContentOptionsDataView;
  using Data_ = internal::AIPageContentOptions_Data;

  template <typename... Args>
  static AIPageContentOptionsPtr New(Args&&... args) {
    return AIPageContentOptionsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentOptionsPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentOptions>::Convert(*this);
  }


  AIPageContentOptions();

  AIPageContentOptions(
      bool include_geometry,
      bool on_critical_path,
      bool include_hidden_searchable_content);


  ~AIPageContentOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentOptionsPtr>
  AIPageContentOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentOptions_UnserializedMessageContext<
            UserType, AIPageContentOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentOptions::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentOptions_UnserializedMessageContext<
            UserType, AIPageContentOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool include_geometry;
  
  bool on_critical_path;
  
  bool include_hidden_searchable_content;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class BLINK_COMMON_EXPORT AIPageContentGeometry {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentGeometry, T>::value>;
  using DataView = AIPageContentGeometryDataView;
  using Data_ = internal::AIPageContentGeometry_Data;

  template <typename... Args>
  static AIPageContentGeometryPtr New(Args&&... args) {
    return AIPageContentGeometryPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentGeometryPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentGeometryPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentGeometry>::Convert(*this);
  }


  AIPageContentGeometry();

  AIPageContentGeometry(
      const ::gfx::Rect& outer_bounding_box,
      const ::gfx::Rect& visible_bounding_box,
      bool is_fixed_or_sticky_position,
      bool scrolls_overflow_x,
      bool scrolls_overflow_y);


  ~AIPageContentGeometry();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentGeometryPtr>
  AIPageContentGeometryPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentGeometry::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentGeometry::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentGeometry::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentGeometry::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentGeometry::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentGeometry_UnserializedMessageContext<
            UserType, AIPageContentGeometry::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentGeometry::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentGeometry::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentGeometry_UnserializedMessageContext<
            UserType, AIPageContentGeometry::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentGeometry::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::gfx::Rect outer_bounding_box;
  
  ::gfx::Rect visible_bounding_box;
  
  bool is_fixed_or_sticky_position;
  
  bool scrolls_overflow_x;
  
  bool scrolls_overflow_y;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentGeometry::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentGeometry::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentGeometry::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentGeometry::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT AIPageContentTextInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentTextInfo, T>::value>;
  using DataView = AIPageContentTextInfoDataView;
  using Data_ = internal::AIPageContentTextInfo_Data;

  template <typename... Args>
  static AIPageContentTextInfoPtr New(Args&&... args) {
    return AIPageContentTextInfoPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentTextInfoPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentTextInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentTextInfo>::Convert(*this);
  }


  AIPageContentTextInfo();

  AIPageContentTextInfo(
      const std::string& text_content,
      AIPageContentTextStylePtr text_style);

AIPageContentTextInfo(const AIPageContentTextInfo&) = delete;
AIPageContentTextInfo& operator=(const AIPageContentTextInfo&) = delete;

  ~AIPageContentTextInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentTextInfoPtr>
  AIPageContentTextInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentTextInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentTextInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentTextInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentTextInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentTextInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentTextInfo_UnserializedMessageContext<
            UserType, AIPageContentTextInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentTextInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentTextInfo::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentTextInfo_UnserializedMessageContext<
            UserType, AIPageContentTextInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentTextInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string text_content;
  
  AIPageContentTextStylePtr text_style;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentTextInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentTextInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentTextInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentTextInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentAnchorData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentAnchorData, T>::value>;
  using DataView = AIPageContentAnchorDataDataView;
  using Data_ = internal::AIPageContentAnchorData_Data;

  template <typename... Args>
  static AIPageContentAnchorDataPtr New(Args&&... args) {
    return AIPageContentAnchorDataPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentAnchorDataPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentAnchorDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentAnchorData>::Convert(*this);
  }


  AIPageContentAnchorData();

  AIPageContentAnchorData(
      const ::GURL& url,
      std::vector<AIPageContentAnchorRel> rel);


  ~AIPageContentAnchorData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentAnchorDataPtr>
  AIPageContentAnchorDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentAnchorData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentAnchorData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentAnchorData::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentAnchorData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentAnchorData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentAnchorData_UnserializedMessageContext<
            UserType, AIPageContentAnchorData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentAnchorData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentAnchorData::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentAnchorData_UnserializedMessageContext<
            UserType, AIPageContentAnchorData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentAnchorData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::GURL url;
  
  std::vector<AIPageContentAnchorRel> rel;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentAnchorData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentAnchorData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentAnchorData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentAnchorData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentImageInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentImageInfo, T>::value>;
  using DataView = AIPageContentImageInfoDataView;
  using Data_ = internal::AIPageContentImageInfo_Data;

  template <typename... Args>
  static AIPageContentImageInfoPtr New(Args&&... args) {
    return AIPageContentImageInfoPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentImageInfoPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentImageInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentImageInfo>::Convert(*this);
  }


  AIPageContentImageInfo();

  AIPageContentImageInfo(
      const std::optional<std::string>& image_caption,
      const std::optional<::url::Origin>& source_origin);


  ~AIPageContentImageInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentImageInfoPtr>
  AIPageContentImageInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentImageInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentImageInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentImageInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentImageInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentImageInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentImageInfo_UnserializedMessageContext<
            UserType, AIPageContentImageInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentImageInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentImageInfo::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentImageInfo_UnserializedMessageContext<
            UserType, AIPageContentImageInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentImageInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<std::string> image_caption;
  
  std::optional<::url::Origin> source_origin;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentImageInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentImageInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentImageInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentImageInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentIframeData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentIframeData, T>::value>;
  using DataView = AIPageContentIframeDataDataView;
  using Data_ = internal::AIPageContentIframeData_Data;

  template <typename... Args>
  static AIPageContentIframeDataPtr New(Args&&... args) {
    return AIPageContentIframeDataPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentIframeDataPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentIframeDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentIframeData>::Convert(*this);
  }


  AIPageContentIframeData();

  AIPageContentIframeData(
      const ::blink::FrameToken& frame_token,
      bool likely_ad_frame);


  ~AIPageContentIframeData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentIframeDataPtr>
  AIPageContentIframeDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentIframeData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentIframeData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentIframeData::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentIframeData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentIframeData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentIframeData_UnserializedMessageContext<
            UserType, AIPageContentIframeData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentIframeData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentIframeData::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentIframeData_UnserializedMessageContext<
            UserType, AIPageContentIframeData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentIframeData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::blink::FrameToken frame_token;
  
  bool likely_ad_frame;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentIframeData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentIframeData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentIframeData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentIframeData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}









class BLINK_COMMON_EXPORT AIPageContentFormControlData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentFormControlData, T>::value>;
  using DataView = AIPageContentFormControlDataDataView;
  using Data_ = internal::AIPageContentFormControlData_Data;

  template <typename... Args>
  static AIPageContentFormControlDataPtr New(Args&&... args) {
    return AIPageContentFormControlDataPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentFormControlDataPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentFormControlDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentFormControlData>::Convert(*this);
  }


  AIPageContentFormControlData();

  AIPageContentFormControlData(
      ::blink::mojom::FormControlType form_control_type,
      const std::optional<std::string>& field_name,
      const std::optional<std::string>& field_value,
      std::vector<AIPageContentSelectOptionPtr> select_options,
      const std::optional<std::string>& placeholder,
      bool is_checked,
      bool is_required);

AIPageContentFormControlData(const AIPageContentFormControlData&) = delete;
AIPageContentFormControlData& operator=(const AIPageContentFormControlData&) = delete;

  ~AIPageContentFormControlData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentFormControlDataPtr>
  AIPageContentFormControlDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentFormControlData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentFormControlData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentFormControlData::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentFormControlData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentFormControlData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentFormControlData_UnserializedMessageContext<
            UserType, AIPageContentFormControlData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentFormControlData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentFormControlData::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentFormControlData_UnserializedMessageContext<
            UserType, AIPageContentFormControlData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentFormControlData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::blink::mojom::FormControlType form_control_type;
  
  std::optional<std::string> field_name;
  
  std::optional<std::string> field_value;
  
  std::vector<AIPageContentSelectOptionPtr> select_options;
  
  std::optional<std::string> placeholder;
  
  bool is_checked;
  
  bool is_required;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentFormControlData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentFormControlData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentFormControlData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentFormControlData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentAttributes {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentAttributes, T>::value>;
  using DataView = AIPageContentAttributesDataView;
  using Data_ = internal::AIPageContentAttributes_Data;

  template <typename... Args>
  static AIPageContentAttributesPtr New(Args&&... args) {
    return AIPageContentAttributesPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentAttributesPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentAttributesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentAttributes>::Convert(*this);
  }


  AIPageContentAttributes();

  AIPageContentAttributes(
      std::vector<int32_t> dom_node_ids,
      std::optional<int32_t> common_ancestor_dom_node_id,
      AIPageContentAttributeType attribute_type,
      AIPageContentGeometryPtr geometry,
      AIPageContentTextInfoPtr text_info,
      AIPageContentImageInfoPtr image_info,
      AIPageContentAnchorDataPtr anchor_data,
      AIPageContentFormDataPtr form_data,
      AIPageContentFormControlDataPtr form_control_data,
      AIPageContentTableDataPtr table_data,
      AIPageContentIframeDataPtr iframe_data,
      AIPageContentTableRowDataPtr table_row_data,
      std::vector<AIPageContentAnnotatedRole> annotated_roles);

AIPageContentAttributes(const AIPageContentAttributes&) = delete;
AIPageContentAttributes& operator=(const AIPageContentAttributes&) = delete;

  ~AIPageContentAttributes();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentAttributesPtr>
  AIPageContentAttributesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentAttributes::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentAttributes::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentAttributes::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentAttributes::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentAttributes::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentAttributes_UnserializedMessageContext<
            UserType, AIPageContentAttributes::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentAttributes::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentAttributes::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentAttributes_UnserializedMessageContext<
            UserType, AIPageContentAttributes::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentAttributes::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<int32_t> dom_node_ids;
  
  std::optional<int32_t> common_ancestor_dom_node_id;
  
  AIPageContentAttributeType attribute_type;
  
  AIPageContentGeometryPtr geometry;
  
  AIPageContentTextInfoPtr text_info;
  
  AIPageContentImageInfoPtr image_info;
  
  AIPageContentAnchorDataPtr anchor_data;
  
  AIPageContentFormDataPtr form_data;
  
  AIPageContentFormControlDataPtr form_control_data;
  
  AIPageContentTableDataPtr table_data;
  
  AIPageContentIframeDataPtr iframe_data;
  
  AIPageContentTableRowDataPtr table_row_data;
  
  std::vector<AIPageContentAnnotatedRole> annotated_roles;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentAttributes::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentAttributes::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentAttributes::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentAttributes::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContentNode {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContentNode, T>::value>;
  using DataView = AIPageContentNodeDataView;
  using Data_ = internal::AIPageContentNode_Data;

  template <typename... Args>
  static AIPageContentNodePtr New(Args&&... args) {
    return AIPageContentNodePtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentNodePtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentNodePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContentNode>::Convert(*this);
  }


  AIPageContentNode();

  AIPageContentNode(
      std::vector<AIPageContentNodePtr> children_nodes,
      AIPageContentAttributesPtr content_attributes);

AIPageContentNode(const AIPageContentNode&) = delete;
AIPageContentNode& operator=(const AIPageContentNode&) = delete;

  ~AIPageContentNode();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentNodePtr>
  AIPageContentNodePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContentNode::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContentNode::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContentNode::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContentNode::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContentNode::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContentNode_UnserializedMessageContext<
            UserType, AIPageContentNode::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContentNode::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContentNode::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContentNode_UnserializedMessageContext<
            UserType, AIPageContentNode::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContentNode::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<AIPageContentNodePtr> children_nodes;
  
  AIPageContentAttributesPtr content_attributes;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContentNode::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContentNode::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContentNode::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContentNode::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AIPageContent {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIPageContent, T>::value>;
  using DataView = AIPageContentDataView;
  using Data_ = internal::AIPageContent_Data;

  template <typename... Args>
  static AIPageContentPtr New(Args&&... args) {
    return AIPageContentPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIPageContentPtr From(const U& u) {
    return mojo::TypeConverter<AIPageContentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIPageContent>::Convert(*this);
  }


  AIPageContent();

  explicit AIPageContent(
      AIPageContentNodePtr root_node);

AIPageContent(const AIPageContent&) = delete;
AIPageContent& operator=(const AIPageContent&) = delete;

  ~AIPageContent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIPageContentPtr>
  AIPageContentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIPageContent::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIPageContent::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIPageContent::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIPageContent::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIPageContent::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIPageContent_UnserializedMessageContext<
            UserType, AIPageContent::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIPageContent::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIPageContent::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIPageContent_UnserializedMessageContext<
            UserType, AIPageContent::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIPageContent::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  AIPageContentNodePtr root_node;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIPageContent::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIPageContent::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIPageContent::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIPageContent::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}


template <typename StructPtrType>
AIPageContentGeometryPtr AIPageContentGeometry::Clone() const {
  return New(
      mojo::Clone(outer_bounding_box),
      mojo::Clone(visible_bounding_box),
      mojo::Clone(is_fixed_or_sticky_position),
      mojo::Clone(scrolls_overflow_x),
      mojo::Clone(scrolls_overflow_y)
  );
}

template <typename T, AIPageContentGeometry::EnableIfSame<T>*>
bool AIPageContentGeometry::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->outer_bounding_box, other_struct.outer_bounding_box))
    return false;
  if (!mojo::Equals(this->visible_bounding_box, other_struct.visible_bounding_box))
    return false;
  if (!mojo::Equals(this->is_fixed_or_sticky_position, other_struct.is_fixed_or_sticky_position))
    return false;
  if (!mojo::Equals(this->scrolls_overflow_x, other_struct.scrolls_overflow_x))
    return false;
  if (!mojo::Equals(this->scrolls_overflow_y, other_struct.scrolls_overflow_y))
    return false;
  return true;
}

template <typename T, AIPageContentGeometry::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.outer_bounding_box < rhs.outer_bounding_box)
    return true;
  if (rhs.outer_bounding_box < lhs.outer_bounding_box)
    return false;
  if (lhs.visible_bounding_box < rhs.visible_bounding_box)
    return true;
  if (rhs.visible_bounding_box < lhs.visible_bounding_box)
    return false;
  if (lhs.is_fixed_or_sticky_position < rhs.is_fixed_or_sticky_position)
    return true;
  if (rhs.is_fixed_or_sticky_position < lhs.is_fixed_or_sticky_position)
    return false;
  if (lhs.scrolls_overflow_x < rhs.scrolls_overflow_x)
    return true;
  if (rhs.scrolls_overflow_x < lhs.scrolls_overflow_x)
    return false;
  if (lhs.scrolls_overflow_y < rhs.scrolls_overflow_y)
    return true;
  if (rhs.scrolls_overflow_y < lhs.scrolls_overflow_y)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentTextStylePtr AIPageContentTextStyle::Clone() const {
  return New(
      mojo::Clone(text_size),
      mojo::Clone(has_emphasis),
      mojo::Clone(color)
  );
}

template <typename T, AIPageContentTextStyle::EnableIfSame<T>*>
bool AIPageContentTextStyle::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->text_size, other_struct.text_size))
    return false;
  if (!mojo::Equals(this->has_emphasis, other_struct.has_emphasis))
    return false;
  if (!mojo::Equals(this->color, other_struct.color))
    return false;
  return true;
}

template <typename T, AIPageContentTextStyle::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.text_size < rhs.text_size)
    return true;
  if (rhs.text_size < lhs.text_size)
    return false;
  if (lhs.has_emphasis < rhs.has_emphasis)
    return true;
  if (rhs.has_emphasis < lhs.has_emphasis)
    return false;
  if (lhs.color < rhs.color)
    return true;
  if (rhs.color < lhs.color)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentTextInfoPtr AIPageContentTextInfo::Clone() const {
  return New(
      mojo::Clone(text_content),
      mojo::Clone(text_style)
  );
}

template <typename T, AIPageContentTextInfo::EnableIfSame<T>*>
bool AIPageContentTextInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->text_content, other_struct.text_content))
    return false;
  if (!mojo::Equals(this->text_style, other_struct.text_style))
    return false;
  return true;
}

template <typename T, AIPageContentTextInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.text_content < rhs.text_content)
    return true;
  if (rhs.text_content < lhs.text_content)
    return false;
  if (lhs.text_style < rhs.text_style)
    return true;
  if (rhs.text_style < lhs.text_style)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentAnchorDataPtr AIPageContentAnchorData::Clone() const {
  return New(
      mojo::Clone(url),
      mojo::Clone(rel)
  );
}

template <typename T, AIPageContentAnchorData::EnableIfSame<T>*>
bool AIPageContentAnchorData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  if (!mojo::Equals(this->rel, other_struct.rel))
    return false;
  return true;
}

template <typename T, AIPageContentAnchorData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  if (lhs.rel < rhs.rel)
    return true;
  if (rhs.rel < lhs.rel)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentImageInfoPtr AIPageContentImageInfo::Clone() const {
  return New(
      mojo::Clone(image_caption),
      mojo::Clone(source_origin)
  );
}

template <typename T, AIPageContentImageInfo::EnableIfSame<T>*>
bool AIPageContentImageInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->image_caption, other_struct.image_caption))
    return false;
  if (!mojo::Equals(this->source_origin, other_struct.source_origin))
    return false;
  return true;
}

template <typename T, AIPageContentImageInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.image_caption < rhs.image_caption)
    return true;
  if (rhs.image_caption < lhs.image_caption)
    return false;
  if (lhs.source_origin < rhs.source_origin)
    return true;
  if (rhs.source_origin < lhs.source_origin)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentIframeDataPtr AIPageContentIframeData::Clone() const {
  return New(
      mojo::Clone(frame_token),
      mojo::Clone(likely_ad_frame)
  );
}

template <typename T, AIPageContentIframeData::EnableIfSame<T>*>
bool AIPageContentIframeData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->frame_token, other_struct.frame_token))
    return false;
  if (!mojo::Equals(this->likely_ad_frame, other_struct.likely_ad_frame))
    return false;
  return true;
}

template <typename T, AIPageContentIframeData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.frame_token < rhs.frame_token)
    return true;
  if (rhs.frame_token < lhs.frame_token)
    return false;
  if (lhs.likely_ad_frame < rhs.likely_ad_frame)
    return true;
  if (rhs.likely_ad_frame < lhs.likely_ad_frame)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentTableDataPtr AIPageContentTableData::Clone() const {
  return New(
      mojo::Clone(table_name)
  );
}

template <typename T, AIPageContentTableData::EnableIfSame<T>*>
bool AIPageContentTableData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->table_name, other_struct.table_name))
    return false;
  return true;
}

template <typename T, AIPageContentTableData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.table_name < rhs.table_name)
    return true;
  if (rhs.table_name < lhs.table_name)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentTableRowDataPtr AIPageContentTableRowData::Clone() const {
  return New(
      mojo::Clone(row_type)
  );
}

template <typename T, AIPageContentTableRowData::EnableIfSame<T>*>
bool AIPageContentTableRowData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->row_type, other_struct.row_type))
    return false;
  return true;
}

template <typename T, AIPageContentTableRowData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.row_type < rhs.row_type)
    return true;
  if (rhs.row_type < lhs.row_type)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentFormDataPtr AIPageContentFormData::Clone() const {
  return New(
      mojo::Clone(form_name)
  );
}

template <typename T, AIPageContentFormData::EnableIfSame<T>*>
bool AIPageContentFormData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->form_name, other_struct.form_name))
    return false;
  return true;
}

template <typename T, AIPageContentFormData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.form_name < rhs.form_name)
    return true;
  if (rhs.form_name < lhs.form_name)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentSelectOptionPtr AIPageContentSelectOption::Clone() const {
  return New(
      mojo::Clone(value),
      mojo::Clone(text),
      mojo::Clone(is_selected)
  );
}

template <typename T, AIPageContentSelectOption::EnableIfSame<T>*>
bool AIPageContentSelectOption::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  if (!mojo::Equals(this->text, other_struct.text))
    return false;
  if (!mojo::Equals(this->is_selected, other_struct.is_selected))
    return false;
  return true;
}

template <typename T, AIPageContentSelectOption::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  if (lhs.text < rhs.text)
    return true;
  if (rhs.text < lhs.text)
    return false;
  if (lhs.is_selected < rhs.is_selected)
    return true;
  if (rhs.is_selected < lhs.is_selected)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentFormControlDataPtr AIPageContentFormControlData::Clone() const {
  return New(
      mojo::Clone(form_control_type),
      mojo::Clone(field_name),
      mojo::Clone(field_value),
      mojo::Clone(select_options),
      mojo::Clone(placeholder),
      mojo::Clone(is_checked),
      mojo::Clone(is_required)
  );
}

template <typename T, AIPageContentFormControlData::EnableIfSame<T>*>
bool AIPageContentFormControlData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->form_control_type, other_struct.form_control_type))
    return false;
  if (!mojo::Equals(this->field_name, other_struct.field_name))
    return false;
  if (!mojo::Equals(this->field_value, other_struct.field_value))
    return false;
  if (!mojo::Equals(this->select_options, other_struct.select_options))
    return false;
  if (!mojo::Equals(this->placeholder, other_struct.placeholder))
    return false;
  if (!mojo::Equals(this->is_checked, other_struct.is_checked))
    return false;
  if (!mojo::Equals(this->is_required, other_struct.is_required))
    return false;
  return true;
}

template <typename T, AIPageContentFormControlData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.form_control_type < rhs.form_control_type)
    return true;
  if (rhs.form_control_type < lhs.form_control_type)
    return false;
  if (lhs.field_name < rhs.field_name)
    return true;
  if (rhs.field_name < lhs.field_name)
    return false;
  if (lhs.field_value < rhs.field_value)
    return true;
  if (rhs.field_value < lhs.field_value)
    return false;
  if (lhs.select_options < rhs.select_options)
    return true;
  if (rhs.select_options < lhs.select_options)
    return false;
  if (lhs.placeholder < rhs.placeholder)
    return true;
  if (rhs.placeholder < lhs.placeholder)
    return false;
  if (lhs.is_checked < rhs.is_checked)
    return true;
  if (rhs.is_checked < lhs.is_checked)
    return false;
  if (lhs.is_required < rhs.is_required)
    return true;
  if (rhs.is_required < lhs.is_required)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentAttributesPtr AIPageContentAttributes::Clone() const {
  return New(
      mojo::Clone(dom_node_ids),
      mojo::Clone(common_ancestor_dom_node_id),
      mojo::Clone(attribute_type),
      mojo::Clone(geometry),
      mojo::Clone(text_info),
      mojo::Clone(image_info),
      mojo::Clone(anchor_data),
      mojo::Clone(form_data),
      mojo::Clone(form_control_data),
      mojo::Clone(table_data),
      mojo::Clone(iframe_data),
      mojo::Clone(table_row_data),
      mojo::Clone(annotated_roles)
  );
}

template <typename T, AIPageContentAttributes::EnableIfSame<T>*>
bool AIPageContentAttributes::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->dom_node_ids, other_struct.dom_node_ids))
    return false;
  if (!mojo::Equals(this->common_ancestor_dom_node_id, other_struct.common_ancestor_dom_node_id))
    return false;
  if (!mojo::Equals(this->attribute_type, other_struct.attribute_type))
    return false;
  if (!mojo::Equals(this->geometry, other_struct.geometry))
    return false;
  if (!mojo::Equals(this->text_info, other_struct.text_info))
    return false;
  if (!mojo::Equals(this->image_info, other_struct.image_info))
    return false;
  if (!mojo::Equals(this->anchor_data, other_struct.anchor_data))
    return false;
  if (!mojo::Equals(this->form_data, other_struct.form_data))
    return false;
  if (!mojo::Equals(this->form_control_data, other_struct.form_control_data))
    return false;
  if (!mojo::Equals(this->table_data, other_struct.table_data))
    return false;
  if (!mojo::Equals(this->iframe_data, other_struct.iframe_data))
    return false;
  if (!mojo::Equals(this->table_row_data, other_struct.table_row_data))
    return false;
  if (!mojo::Equals(this->annotated_roles, other_struct.annotated_roles))
    return false;
  return true;
}

template <typename T, AIPageContentAttributes::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.dom_node_ids < rhs.dom_node_ids)
    return true;
  if (rhs.dom_node_ids < lhs.dom_node_ids)
    return false;
  if (lhs.common_ancestor_dom_node_id < rhs.common_ancestor_dom_node_id)
    return true;
  if (rhs.common_ancestor_dom_node_id < lhs.common_ancestor_dom_node_id)
    return false;
  if (lhs.attribute_type < rhs.attribute_type)
    return true;
  if (rhs.attribute_type < lhs.attribute_type)
    return false;
  if (lhs.geometry < rhs.geometry)
    return true;
  if (rhs.geometry < lhs.geometry)
    return false;
  if (lhs.text_info < rhs.text_info)
    return true;
  if (rhs.text_info < lhs.text_info)
    return false;
  if (lhs.image_info < rhs.image_info)
    return true;
  if (rhs.image_info < lhs.image_info)
    return false;
  if (lhs.anchor_data < rhs.anchor_data)
    return true;
  if (rhs.anchor_data < lhs.anchor_data)
    return false;
  if (lhs.form_data < rhs.form_data)
    return true;
  if (rhs.form_data < lhs.form_data)
    return false;
  if (lhs.form_control_data < rhs.form_control_data)
    return true;
  if (rhs.form_control_data < lhs.form_control_data)
    return false;
  if (lhs.table_data < rhs.table_data)
    return true;
  if (rhs.table_data < lhs.table_data)
    return false;
  if (lhs.iframe_data < rhs.iframe_data)
    return true;
  if (rhs.iframe_data < lhs.iframe_data)
    return false;
  if (lhs.table_row_data < rhs.table_row_data)
    return true;
  if (rhs.table_row_data < lhs.table_row_data)
    return false;
  if (lhs.annotated_roles < rhs.annotated_roles)
    return true;
  if (rhs.annotated_roles < lhs.annotated_roles)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentNodePtr AIPageContentNode::Clone() const {
  return New(
      mojo::Clone(children_nodes),
      mojo::Clone(content_attributes)
  );
}

template <typename T, AIPageContentNode::EnableIfSame<T>*>
bool AIPageContentNode::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->children_nodes, other_struct.children_nodes))
    return false;
  if (!mojo::Equals(this->content_attributes, other_struct.content_attributes))
    return false;
  return true;
}

template <typename T, AIPageContentNode::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.children_nodes < rhs.children_nodes)
    return true;
  if (rhs.children_nodes < lhs.children_nodes)
    return false;
  if (lhs.content_attributes < rhs.content_attributes)
    return true;
  if (rhs.content_attributes < lhs.content_attributes)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentPtr AIPageContent::Clone() const {
  return New(
      mojo::Clone(root_node)
  );
}

template <typename T, AIPageContent::EnableIfSame<T>*>
bool AIPageContent::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->root_node, other_struct.root_node))
    return false;
  return true;
}

template <typename T, AIPageContent::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.root_node < rhs.root_node)
    return true;
  if (rhs.root_node < lhs.root_node)
    return false;
  return false;
}
template <typename StructPtrType>
AIPageContentOptionsPtr AIPageContentOptions::Clone() const {
  return New(
      mojo::Clone(include_geometry),
      mojo::Clone(on_critical_path),
      mojo::Clone(include_hidden_searchable_content)
  );
}

template <typename T, AIPageContentOptions::EnableIfSame<T>*>
bool AIPageContentOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->include_geometry, other_struct.include_geometry))
    return false;
  if (!mojo::Equals(this->on_critical_path, other_struct.on_critical_path))
    return false;
  if (!mojo::Equals(this->include_hidden_searchable_content, other_struct.include_hidden_searchable_content))
    return false;
  return true;
}

template <typename T, AIPageContentOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.include_geometry < rhs.include_geometry)
    return true;
  if (rhs.include_geometry < lhs.include_geometry)
    return false;
  if (lhs.on_critical_path < rhs.on_critical_path)
    return true;
  if (rhs.on_critical_path < lhs.on_critical_path)
    return false;
  if (lhs.include_hidden_searchable_content < rhs.include_hidden_searchable_content)
    return true;
  if (rhs.include_hidden_searchable_content < lhs.include_hidden_searchable_content)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentGeometry::DataView,
                                         ::blink::mojom::AIPageContentGeometryPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentGeometryPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentGeometryPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentGeometry::outer_bounding_box)& outer_bounding_box(
      const ::blink::mojom::AIPageContentGeometryPtr& input) {
    return input->outer_bounding_box;
  }

  static const decltype(::blink::mojom::AIPageContentGeometry::visible_bounding_box)& visible_bounding_box(
      const ::blink::mojom::AIPageContentGeometryPtr& input) {
    return input->visible_bounding_box;
  }

  static decltype(::blink::mojom::AIPageContentGeometry::is_fixed_or_sticky_position) is_fixed_or_sticky_position(
      const ::blink::mojom::AIPageContentGeometryPtr& input) {
    return input->is_fixed_or_sticky_position;
  }

  static decltype(::blink::mojom::AIPageContentGeometry::scrolls_overflow_x) scrolls_overflow_x(
      const ::blink::mojom::AIPageContentGeometryPtr& input) {
    return input->scrolls_overflow_x;
  }

  static decltype(::blink::mojom::AIPageContentGeometry::scrolls_overflow_y) scrolls_overflow_y(
      const ::blink::mojom::AIPageContentGeometryPtr& input) {
    return input->scrolls_overflow_y;
  }

  static bool Read(::blink::mojom::AIPageContentGeometry::DataView input, ::blink::mojom::AIPageContentGeometryPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentTextStyle::DataView,
                                         ::blink::mojom::AIPageContentTextStylePtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentTextStylePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentTextStylePtr* output) { output->reset(); }

  static decltype(::blink::mojom::AIPageContentTextStyle::text_size) text_size(
      const ::blink::mojom::AIPageContentTextStylePtr& input) {
    return input->text_size;
  }

  static decltype(::blink::mojom::AIPageContentTextStyle::has_emphasis) has_emphasis(
      const ::blink::mojom::AIPageContentTextStylePtr& input) {
    return input->has_emphasis;
  }

  static decltype(::blink::mojom::AIPageContentTextStyle::color) color(
      const ::blink::mojom::AIPageContentTextStylePtr& input) {
    return input->color;
  }

  static bool Read(::blink::mojom::AIPageContentTextStyle::DataView input, ::blink::mojom::AIPageContentTextStylePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentTextInfo::DataView,
                                         ::blink::mojom::AIPageContentTextInfoPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentTextInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentTextInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentTextInfo::text_content)& text_content(
      const ::blink::mojom::AIPageContentTextInfoPtr& input) {
    return input->text_content;
  }

  static const decltype(::blink::mojom::AIPageContentTextInfo::text_style)& text_style(
      const ::blink::mojom::AIPageContentTextInfoPtr& input) {
    return input->text_style;
  }

  static bool Read(::blink::mojom::AIPageContentTextInfo::DataView input, ::blink::mojom::AIPageContentTextInfoPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentAnchorData::DataView,
                                         ::blink::mojom::AIPageContentAnchorDataPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentAnchorDataPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentAnchorDataPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentAnchorData::url)& url(
      const ::blink::mojom::AIPageContentAnchorDataPtr& input) {
    return input->url;
  }

  static const decltype(::blink::mojom::AIPageContentAnchorData::rel)& rel(
      const ::blink::mojom::AIPageContentAnchorDataPtr& input) {
    return input->rel;
  }

  static bool Read(::blink::mojom::AIPageContentAnchorData::DataView input, ::blink::mojom::AIPageContentAnchorDataPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentImageInfo::DataView,
                                         ::blink::mojom::AIPageContentImageInfoPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentImageInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentImageInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentImageInfo::image_caption)& image_caption(
      const ::blink::mojom::AIPageContentImageInfoPtr& input) {
    return input->image_caption;
  }

  static const decltype(::blink::mojom::AIPageContentImageInfo::source_origin)& source_origin(
      const ::blink::mojom::AIPageContentImageInfoPtr& input) {
    return input->source_origin;
  }

  static bool Read(::blink::mojom::AIPageContentImageInfo::DataView input, ::blink::mojom::AIPageContentImageInfoPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentIframeData::DataView,
                                         ::blink::mojom::AIPageContentIframeDataPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentIframeDataPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentIframeDataPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentIframeData::frame_token)& frame_token(
      const ::blink::mojom::AIPageContentIframeDataPtr& input) {
    return input->frame_token;
  }

  static decltype(::blink::mojom::AIPageContentIframeData::likely_ad_frame) likely_ad_frame(
      const ::blink::mojom::AIPageContentIframeDataPtr& input) {
    return input->likely_ad_frame;
  }

  static bool Read(::blink::mojom::AIPageContentIframeData::DataView input, ::blink::mojom::AIPageContentIframeDataPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentTableData::DataView,
                                         ::blink::mojom::AIPageContentTableDataPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentTableDataPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentTableDataPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentTableData::table_name)& table_name(
      const ::blink::mojom::AIPageContentTableDataPtr& input) {
    return input->table_name;
  }

  static bool Read(::blink::mojom::AIPageContentTableData::DataView input, ::blink::mojom::AIPageContentTableDataPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentTableRowData::DataView,
                                         ::blink::mojom::AIPageContentTableRowDataPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentTableRowDataPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentTableRowDataPtr* output) { output->reset(); }

  static decltype(::blink::mojom::AIPageContentTableRowData::row_type) row_type(
      const ::blink::mojom::AIPageContentTableRowDataPtr& input) {
    return input->row_type;
  }

  static bool Read(::blink::mojom::AIPageContentTableRowData::DataView input, ::blink::mojom::AIPageContentTableRowDataPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentFormData::DataView,
                                         ::blink::mojom::AIPageContentFormDataPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentFormDataPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentFormDataPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentFormData::form_name)& form_name(
      const ::blink::mojom::AIPageContentFormDataPtr& input) {
    return input->form_name;
  }

  static bool Read(::blink::mojom::AIPageContentFormData::DataView input, ::blink::mojom::AIPageContentFormDataPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentSelectOption::DataView,
                                         ::blink::mojom::AIPageContentSelectOptionPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentSelectOptionPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentSelectOptionPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentSelectOption::value)& value(
      const ::blink::mojom::AIPageContentSelectOptionPtr& input) {
    return input->value;
  }

  static const decltype(::blink::mojom::AIPageContentSelectOption::text)& text(
      const ::blink::mojom::AIPageContentSelectOptionPtr& input) {
    return input->text;
  }

  static decltype(::blink::mojom::AIPageContentSelectOption::is_selected) is_selected(
      const ::blink::mojom::AIPageContentSelectOptionPtr& input) {
    return input->is_selected;
  }

  static bool Read(::blink::mojom::AIPageContentSelectOption::DataView input, ::blink::mojom::AIPageContentSelectOptionPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentFormControlData::DataView,
                                         ::blink::mojom::AIPageContentFormControlDataPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentFormControlDataPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentFormControlDataPtr* output) { output->reset(); }

  static decltype(::blink::mojom::AIPageContentFormControlData::form_control_type) form_control_type(
      const ::blink::mojom::AIPageContentFormControlDataPtr& input) {
    return input->form_control_type;
  }

  static const decltype(::blink::mojom::AIPageContentFormControlData::field_name)& field_name(
      const ::blink::mojom::AIPageContentFormControlDataPtr& input) {
    return input->field_name;
  }

  static const decltype(::blink::mojom::AIPageContentFormControlData::field_value)& field_value(
      const ::blink::mojom::AIPageContentFormControlDataPtr& input) {
    return input->field_value;
  }

  static const decltype(::blink::mojom::AIPageContentFormControlData::select_options)& select_options(
      const ::blink::mojom::AIPageContentFormControlDataPtr& input) {
    return input->select_options;
  }

  static const decltype(::blink::mojom::AIPageContentFormControlData::placeholder)& placeholder(
      const ::blink::mojom::AIPageContentFormControlDataPtr& input) {
    return input->placeholder;
  }

  static decltype(::blink::mojom::AIPageContentFormControlData::is_checked) is_checked(
      const ::blink::mojom::AIPageContentFormControlDataPtr& input) {
    return input->is_checked;
  }

  static decltype(::blink::mojom::AIPageContentFormControlData::is_required) is_required(
      const ::blink::mojom::AIPageContentFormControlDataPtr& input) {
    return input->is_required;
  }

  static bool Read(::blink::mojom::AIPageContentFormControlData::DataView input, ::blink::mojom::AIPageContentFormControlDataPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentAttributes::DataView,
                                         ::blink::mojom::AIPageContentAttributesPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentAttributesPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentAttributesPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentAttributes::dom_node_ids)& dom_node_ids(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->dom_node_ids;
  }

  static decltype(::blink::mojom::AIPageContentAttributes::common_ancestor_dom_node_id) common_ancestor_dom_node_id(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->common_ancestor_dom_node_id;
  }

  static decltype(::blink::mojom::AIPageContentAttributes::attribute_type) attribute_type(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->attribute_type;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::geometry)& geometry(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->geometry;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::text_info)& text_info(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->text_info;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::image_info)& image_info(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->image_info;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::anchor_data)& anchor_data(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->anchor_data;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::form_data)& form_data(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->form_data;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::form_control_data)& form_control_data(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->form_control_data;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::table_data)& table_data(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->table_data;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::iframe_data)& iframe_data(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->iframe_data;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::table_row_data)& table_row_data(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->table_row_data;
  }

  static const decltype(::blink::mojom::AIPageContentAttributes::annotated_roles)& annotated_roles(
      const ::blink::mojom::AIPageContentAttributesPtr& input) {
    return input->annotated_roles;
  }

  static bool Read(::blink::mojom::AIPageContentAttributes::DataView input, ::blink::mojom::AIPageContentAttributesPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentNode::DataView,
                                         ::blink::mojom::AIPageContentNodePtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentNodePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentNodePtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContentNode::children_nodes)& children_nodes(
      const ::blink::mojom::AIPageContentNodePtr& input) {
    return input->children_nodes;
  }

  static const decltype(::blink::mojom::AIPageContentNode::content_attributes)& content_attributes(
      const ::blink::mojom::AIPageContentNodePtr& input) {
    return input->content_attributes;
  }

  static bool Read(::blink::mojom::AIPageContentNode::DataView input, ::blink::mojom::AIPageContentNodePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContent::DataView,
                                         ::blink::mojom::AIPageContentPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIPageContent::root_node)& root_node(
      const ::blink::mojom::AIPageContentPtr& input) {
    return input->root_node;
  }

  static bool Read(::blink::mojom::AIPageContent::DataView input, ::blink::mojom::AIPageContentPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIPageContentOptions::DataView,
                                         ::blink::mojom::AIPageContentOptionsPtr> {
  static bool IsNull(const ::blink::mojom::AIPageContentOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIPageContentOptionsPtr* output) { output->reset(); }

  static decltype(::blink::mojom::AIPageContentOptions::include_geometry) include_geometry(
      const ::blink::mojom::AIPageContentOptionsPtr& input) {
    return input->include_geometry;
  }

  static decltype(::blink::mojom::AIPageContentOptions::on_critical_path) on_critical_path(
      const ::blink::mojom::AIPageContentOptionsPtr& input) {
    return input->on_critical_path;
  }

  static decltype(::blink::mojom::AIPageContentOptions::include_hidden_searchable_content) include_hidden_searchable_content(
      const ::blink::mojom::AIPageContentOptionsPtr& input) {
    return input->include_hidden_searchable_content;
  }

  static bool Read(::blink::mojom::AIPageContentOptions::DataView input, ::blink::mojom::AIPageContentOptionsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_CONTENT_EXTRACTION_AI_PAGE_CONTENT_MOJOM_H_