// third_party/blink/public/mojom/cookie_manager/cookie_manager_automation.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_COOKIE_MANAGER_COOKIE_MANAGER_AUTOMATION_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_COOKIE_MANAGER_COOKIE_MANAGER_AUTOMATION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/cookie_manager/cookie_manager_automation.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/cookie_manager/cookie_manager_automation.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/cookie_manager/cookie_manager_automation.mojom-forward.h"  // IWYU pragma: export
#include "services/network/public/mojom/cookie_manager.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::test::mojom {

class CookieManagerAutomationProxy;

template <typename ImplRefTraits>
class CookieManagerAutomationStub;

class CookieManagerAutomationRequestValidator;
class CookieManagerAutomationResponseValidator;


class BLINK_COMMON_EXPORT CookieManagerAutomation
    : public CookieManagerAutomationInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = CookieManagerAutomationInterfaceBase;
  using Proxy_ = CookieManagerAutomationProxy;

  template <typename ImplRefTraits>
  using Stub_ = CookieManagerAutomationStub<ImplRefTraits>;

  using RequestValidator_ = CookieManagerAutomationRequestValidator;
  using ResponseValidator_ = CookieManagerAutomationResponseValidator;
  enum MethodMinVersions : uint32_t {
    kDeleteAllCookiesMinVersion = 0,
    kGetAllCookiesMinVersion = 0,
    kGetNamedCookieMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct DeleteAllCookies_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetAllCookies_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetNamedCookie_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~CookieManagerAutomation() = default;


  using DeleteAllCookiesCallback = base::OnceCallback<void()>;
  
  virtual void DeleteAllCookies(DeleteAllCookiesCallback callback) = 0;


  using GetAllCookiesCallback = base::OnceCallback<void(const std::vector<::net::CookieWithAccessResult>&)>;
  
  virtual void GetAllCookies(GetAllCookiesCallback callback) = 0;


  using GetNamedCookieCallback = base::OnceCallback<void(const std::optional<::net::CookieWithAccessResult>&)>;
  
  virtual void GetNamedCookie(const std::string& name, GetNamedCookieCallback callback) = 0;
};



class BLINK_COMMON_EXPORT CookieManagerAutomationProxy
    : public CookieManagerAutomation {
 public:
  using InterfaceType = CookieManagerAutomation;

  explicit CookieManagerAutomationProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void DeleteAllCookies(DeleteAllCookiesCallback callback) final;
  
  void GetAllCookies(GetAllCookiesCallback callback) final;
  
  void GetNamedCookie(const std::string& name, GetNamedCookieCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT CookieManagerAutomationStubDispatch {
 public:
  static bool Accept(CookieManagerAutomation* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      CookieManagerAutomation* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<CookieManagerAutomation>>
class CookieManagerAutomationStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  CookieManagerAutomationStub() = default;
  ~CookieManagerAutomationStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CookieManagerAutomationStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CookieManagerAutomationStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT CookieManagerAutomationRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT CookieManagerAutomationResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::test::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_COOKIE_MANAGER_COOKIE_MANAGER_AUTOMATION_MOJOM_H_