// third_party/blink/public/mojom/dom_storage/storage_area.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DOM_STORAGE_STORAGE_AREA_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DOM_STORAGE_STORAGE_AREA_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/dom_storage/storage_area.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink::mojom::blink {


class PLATFORM_EXPORT StorageAreaObserverInterceptorForTesting : public StorageAreaObserver {
  virtual StorageAreaObserver* GetForwardingInterface() = 0;
  void KeyChanged(const WTF::Vector<uint8_t>& key, const WTF::Vector<uint8_t>& new_value, const std::optional<WTF::Vector<uint8_t>>& old_value, const WTF::String& source) override;
  void KeyChangeFailed(const WTF::Vector<uint8_t>& key, const WTF::String& source) override;
  void KeyDeleted(const WTF::Vector<uint8_t>& key, const std::optional<WTF::Vector<uint8_t>>& old_value, const WTF::String& source) override;
  void AllDeleted(bool was_nonempty, const WTF::String& source) override;
  void ShouldSendOldValueOnMutations(bool value) override;
};
class PLATFORM_EXPORT StorageAreaObserverAsyncWaiter {
 public:
  explicit StorageAreaObserverAsyncWaiter(StorageAreaObserver* proxy);

  StorageAreaObserverAsyncWaiter(const StorageAreaObserverAsyncWaiter&) = delete;
  StorageAreaObserverAsyncWaiter& operator=(const StorageAreaObserverAsyncWaiter&) = delete;

  ~StorageAreaObserverAsyncWaiter();

 private:
  StorageAreaObserver* const proxy_;
};


class PLATFORM_EXPORT StorageAreaInterceptorForTesting : public StorageArea {
  virtual StorageArea* GetForwardingInterface() = 0;
  void AddObserver(::mojo::PendingRemote<StorageAreaObserver> observer) override;
  void Put(const WTF::Vector<uint8_t>& key, const WTF::Vector<uint8_t>& value, const std::optional<WTF::Vector<uint8_t>>& client_old_value, const WTF::String& source, PutCallback callback) override;
  void Delete(const WTF::Vector<uint8_t>& key, const std::optional<WTF::Vector<uint8_t>>& client_old_value, const WTF::String& source, DeleteCallback callback) override;
  void DeleteAll(const WTF::String& source, ::mojo::PendingRemote<StorageAreaObserver> new_observer, DeleteAllCallback callback) override;
  void Get(const WTF::Vector<uint8_t>& key, GetCallback callback) override;
  void GetAll(::mojo::PendingRemote<StorageAreaObserver> new_observer, GetAllCallback callback) override;
  void Checkpoint() override;
};
class PLATFORM_EXPORT StorageAreaAsyncWaiter {
 public:
  explicit StorageAreaAsyncWaiter(StorageArea* proxy);

  StorageAreaAsyncWaiter(const StorageAreaAsyncWaiter&) = delete;
  StorageAreaAsyncWaiter& operator=(const StorageAreaAsyncWaiter&) = delete;

  ~StorageAreaAsyncWaiter();
  void Put(
      const WTF::Vector<uint8_t>& key, const WTF::Vector<uint8_t>& value, const std::optional<WTF::Vector<uint8_t>>& client_old_value, const WTF::String& source, bool* out_success);
  bool Put(const WTF::Vector<uint8_t>& key, const WTF::Vector<uint8_t>& value, const std::optional<WTF::Vector<uint8_t>>& client_old_value, const WTF::String& source);
  void Delete(
      const WTF::Vector<uint8_t>& key, const std::optional<WTF::Vector<uint8_t>>& client_old_value, const WTF::String& source, bool* out_success);
  bool Delete(const WTF::Vector<uint8_t>& key, const std::optional<WTF::Vector<uint8_t>>& client_old_value, const WTF::String& source);
  void DeleteAll(
      const WTF::String& source, ::mojo::PendingRemote<StorageAreaObserver> new_observer, bool* out_success);
  bool DeleteAll(const WTF::String& source, ::mojo::PendingRemote<StorageAreaObserver> new_observer);
  void Get(
      const WTF::Vector<uint8_t>& key, bool* out_success, WTF::Vector<uint8_t>* out_value);
  
  void GetAll(
      ::mojo::PendingRemote<StorageAreaObserver> new_observer, WTF::Vector<KeyValuePtr>* out_data);
  WTF::Vector<KeyValuePtr> GetAll(::mojo::PendingRemote<StorageAreaObserver> new_observer);

 private:
  StorageArea* const proxy_;
};




}  // blink::mojom::blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DOM_STORAGE_STORAGE_AREA_MOJOM_BLINK_TEST_UTILS_H_