// third_party/blink/public/mojom/frame/view_transition_state.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/frame/view_transition_state.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>
#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/frame/view_transition_state.mojom-params-data.h"
namespace blink {
namespace mojom {

NOINLINE static const char* ViewTransitionPropertyIdToStringHelper(ViewTransitionPropertyId value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ViewTransitionPropertyId::kBackdropFilter:
      return "kBackdropFilter";
    case ViewTransitionPropertyId::kColorScheme:
      return "kColorScheme";
    case ViewTransitionPropertyId::kMixBlendMode:
      return "kMixBlendMode";
    case ViewTransitionPropertyId::kTextOrientation:
      return "kTextOrientation";
    case ViewTransitionPropertyId::kWritingMode:
      return "kWritingMode";
    case ViewTransitionPropertyId::kOpacity:
      return "kOpacity";
    case ViewTransitionPropertyId::kClipPath:
      return "kClipPath";
    case ViewTransitionPropertyId::kFilter:
      return "kFilter";
    case ViewTransitionPropertyId::kMask:
      return "kMask";
    case ViewTransitionPropertyId::kBorderTop:
      return "kBorderTop";
    case ViewTransitionPropertyId::kBorderRight:
      return "kBorderRight";
    case ViewTransitionPropertyId::kBorderBottom:
      return "kBorderBottom";
    case ViewTransitionPropertyId::kBorderLeft:
      return "kBorderLeft";
    case ViewTransitionPropertyId::kBackground:
      return "kBackground";
    case ViewTransitionPropertyId::kBorderRadius:
      return "kBorderRadius";
    case ViewTransitionPropertyId::kBoxShadow:
      return "kBoxShadow";
    case ViewTransitionPropertyId::kBoxSizing:
      return "kBoxSizing";
    case ViewTransitionPropertyId::kOutline:
      return "kOutline";
    case ViewTransitionPropertyId::kBorderImage:
      return "kBorderImage";
    case ViewTransitionPropertyId::kPadding:
      return "kPadding";
    case ViewTransitionPropertyId::kOverflow:
      return "kOverflow";
    case ViewTransitionPropertyId::kOverflowClipMargin:
      return "kOverflowClipMargin";
    case ViewTransitionPropertyId::kContain:
      return "kContain";
    default:
      return nullptr;
  }
}

std::string ViewTransitionPropertyIdToString(ViewTransitionPropertyId value) {
  const char *str = ViewTransitionPropertyIdToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ViewTransitionPropertyId value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ViewTransitionPropertyId value) {
  return os << ViewTransitionPropertyIdToString(value);
}

NOINLINE static const char* ViewTransitionElementBoxSizingToStringHelper(ViewTransitionElementBoxSizing value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ViewTransitionElementBoxSizing::kBorderBox:
      return "kBorderBox";
    case ViewTransitionElementBoxSizing::kContentBox:
      return "kContentBox";
    default:
      return nullptr;
  }
}

std::string ViewTransitionElementBoxSizingToString(ViewTransitionElementBoxSizing value) {
  const char *str = ViewTransitionElementBoxSizingToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ViewTransitionElementBoxSizing value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ViewTransitionElementBoxSizing value) {
  return os << ViewTransitionElementBoxSizingToString(value);
}

namespace internal {


// static
bool ViewTransitionElementLayeredBoxProperties_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ViewTransitionElementLayeredBoxProperties_Data* object =
      static_cast<const ViewTransitionElementLayeredBoxProperties_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->content_box, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->content_box, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->padding_box, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->padding_box, validation_context))
    return false;


  if (!::blink::mojom::internal::ViewTransitionElementBoxSizing_Data
        ::Validate(object->box_sizing, validation_context))
    return false;

  return true;
}

ViewTransitionElementLayeredBoxProperties_Data::ViewTransitionElementLayeredBoxProperties_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ViewTransitionElement_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 96, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ViewTransitionElement_Data* object =
      static_cast<const ViewTransitionElement_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->tag_name, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& tag_name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->tag_name, validation_context,
                                         &tag_name_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->border_box_rect_in_enclosing_layer_css_space, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->border_box_rect_in_enclosing_layer_css_space, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->viewport_matrix, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->viewport_matrix, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->overflow_rect_in_layout_space, 4, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->overflow_rect_in_layout_space, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->captured_rect_in_layout_space, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->snapshot_id, 6, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->snapshot_id, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->captured_css_properties, 8, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& captured_css_properties_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayOfEnumsValidator<0, false, ::blink::mojom::internal::ViewTransitionPropertyId_Data::Validate>(), *&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>()>();
  if (!mojo::internal::ValidateContainer(object->captured_css_properties, validation_context,
                                         &captured_css_properties_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->class_list, 9, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& class_list_validate_params =
      mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->class_list, validation_context,
                                         &class_list_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->containing_group_name, 10, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& containing_group_name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->containing_group_name, validation_context,
                                         &containing_group_name_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->layered_box_properties, validation_context))
    return false;

  return true;
}

ViewTransitionElement_Data::ViewTransitionElement_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ViewTransitionState_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ViewTransitionState_Data* object =
      static_cast<const ViewTransitionState_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->elements, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& elements_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->elements, validation_context,
                                         &elements_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->transition_token, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->transition_token, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->snapshot_root_size_at_capture, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->snapshot_root_size_at_capture, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->subframe_snapshot_id, 6, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->subframe_snapshot_id, validation_context))
    return false;

  return true;
}

ViewTransitionState_Data::ViewTransitionState_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::ViewTransitionPropertyId>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::ViewTransitionPropertyId value) {
  return std::move(context).WriteString(::blink::mojom::ViewTransitionPropertyIdToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::ViewTransitionElementBoxSizing>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::ViewTransitionElementBoxSizing value) {
  return std::move(context).WriteString(::blink::mojom::ViewTransitionElementBoxSizingToString(value));
}

} // namespace perfetto