// third_party/blink/public/mojom/keyboard_lock/keyboard_lock.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/keyboard_lock/keyboard_lock.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class GetKeyboardLayoutMapResultDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::GetKeyboardLayoutMapResultDataView> {
  using Data = ::blink::mojom::internal::GetKeyboardLayoutMapResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class KeyboardLockRequestResult : int32_t {
  
  kSuccess = 0,
  
  kFrameDetachedError = 1,
  
  kNoValidKeyCodesError = 2,
  
  kChildFrameError = 3,
  
  kRequestFailedError = 4,
  kMinValue = 0,
  kMaxValue = 4,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, KeyboardLockRequestResult value);
inline bool IsKnownEnumValue(KeyboardLockRequestResult value) {
  return internal::KeyboardLockRequestResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class GetKeyboardLayoutMapStatus : int32_t {
  
  kSuccess = 0,
  
  kFail = 1,
  
  kDenied = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, GetKeyboardLayoutMapStatus value);
inline bool IsKnownEnumValue(GetKeyboardLayoutMapStatus value) {
  return internal::GetKeyboardLayoutMapStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class KeyboardLockServiceInterfaceBase {};

using KeyboardLockServicePtrDataView =
    mojo::InterfacePtrDataView<KeyboardLockServiceInterfaceBase>;
using KeyboardLockServiceRequestDataView =
    mojo::InterfaceRequestDataView<KeyboardLockServiceInterfaceBase>;
using KeyboardLockServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<KeyboardLockServiceInterfaceBase>;
using KeyboardLockServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<KeyboardLockServiceInterfaceBase>;


class GetKeyboardLayoutMapResultDataView {
 public:
  GetKeyboardLayoutMapResultDataView() = default;

  GetKeyboardLayoutMapResultDataView(
      internal::GetKeyboardLayoutMapResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::GetKeyboardLayoutMapStatus>(
        data_value, output);
  }
  GetKeyboardLayoutMapStatus status() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::GetKeyboardLayoutMapStatus>(data_->status));
  }
  inline void GetLayoutMapDataView(
      mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLayoutMap(UserType* output) {
    
    auto* pointer = data_->layout_map.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>>(
        pointer, output, message_);
  }
 private:
  internal::GetKeyboardLayoutMapResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::KeyboardLockRequestResult>
    : public mojo::internal::EnumHashImpl<::blink::mojom::KeyboardLockRequestResult> {};

template <>
struct hash<::blink::mojom::GetKeyboardLayoutMapStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::GetKeyboardLayoutMapStatus> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::KeyboardLockRequestResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::KeyboardLockRequestResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::KeyboardLockRequestResult>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::GetKeyboardLayoutMapStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::GetKeyboardLayoutMapStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::GetKeyboardLayoutMapStatus>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::GetKeyboardLayoutMapResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::GetKeyboardLayoutMapResultDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::GetKeyboardLayoutMapResult_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::blink::mojom::GetKeyboardLayoutMapStatus>(
        Traits::status(input), &fragment->status);
    decltype(Traits::layout_map(input)) in_layout_map = Traits::layout_map(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->layout_map)::BaseType>
        layout_map_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& layout_map_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>(), *&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>()>();
    mojo::internal::Serialize<mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>>(
        in_layout_map, layout_map_fragment, &layout_map_validate_params);
    fragment->layout_map.Set(
        layout_map_fragment.is_null() ? nullptr : layout_map_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->layout_map.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null layout_map in GetKeyboardLayoutMapResult struct");
  }

  static bool Deserialize(::blink::mojom::internal::GetKeyboardLayoutMapResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::GetKeyboardLayoutMapResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void GetKeyboardLayoutMapResultDataView::GetLayoutMapDataView(
    mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>* output) {
  auto pointer = data_->layout_map.Get();
  *output = mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::KeyboardLockRequestResult> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::KeyboardLockRequestResult value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::GetKeyboardLayoutMapStatus> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::GetKeyboardLayoutMapStatus value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_H_