// third_party/blink/public/mojom/leak_detector/leak_detector.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LEAK_DETECTOR_LEAK_DETECTOR_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LEAK_DETECTOR_LEAK_DETECTOR_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/leak_detector/leak_detector.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class LeakDetectionResultDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::LeakDetectionResultDataView> {
  using Data = ::blink::mojom::internal::LeakDetectionResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {
// Interface base classes. They are used for type safety check.
class LeakDetectorInterfaceBase {};

using LeakDetectorPtrDataView =
    mojo::InterfacePtrDataView<LeakDetectorInterfaceBase>;
using LeakDetectorRequestDataView =
    mojo::InterfaceRequestDataView<LeakDetectorInterfaceBase>;
using LeakDetectorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<LeakDetectorInterfaceBase>;
using LeakDetectorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<LeakDetectorInterfaceBase>;


class LeakDetectionResultDataView {
 public:
  LeakDetectionResultDataView() = default;

  LeakDetectionResultDataView(
      internal::LeakDetectionResult_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t number_of_live_audio_nodes() const {
    return data_->number_of_live_audio_nodes;
  }
  uint32_t number_of_live_documents() const {
    return data_->number_of_live_documents;
  }
  uint32_t number_of_live_nodes() const {
    return data_->number_of_live_nodes;
  }
  uint32_t number_of_live_layout_objects() const {
    return data_->number_of_live_layout_objects;
  }
  uint32_t number_of_live_resources() const {
    return data_->number_of_live_resources;
  }
  uint32_t number_of_live_context_lifecycle_state_observers() const {
    return data_->number_of_live_context_lifecycle_state_observers;
  }
  uint32_t number_of_live_frames() const {
    return data_->number_of_live_frames;
  }
  uint32_t number_of_live_v8_per_context_data() const {
    return data_->number_of_live_v8_per_context_data;
  }
  uint32_t number_of_worker_global_scopes() const {
    return data_->number_of_worker_global_scopes;
  }
  uint32_t number_of_live_ua_css_resources() const {
    return data_->number_of_live_ua_css_resources;
  }
  uint32_t number_of_live_resource_fetchers() const {
    return data_->number_of_live_resource_fetchers;
  }
 private:
  internal::LeakDetectionResult_Data* data_ = nullptr;
};


}  // blink::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::LeakDetectionResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::LeakDetectionResultDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::LeakDetectionResult_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->number_of_live_audio_nodes = Traits::number_of_live_audio_nodes(input);
    fragment->number_of_live_documents = Traits::number_of_live_documents(input);
    fragment->number_of_live_nodes = Traits::number_of_live_nodes(input);
    fragment->number_of_live_layout_objects = Traits::number_of_live_layout_objects(input);
    fragment->number_of_live_resources = Traits::number_of_live_resources(input);
    fragment->number_of_live_context_lifecycle_state_observers = Traits::number_of_live_context_lifecycle_state_observers(input);
    fragment->number_of_live_frames = Traits::number_of_live_frames(input);
    fragment->number_of_live_v8_per_context_data = Traits::number_of_live_v8_per_context_data(input);
    fragment->number_of_worker_global_scopes = Traits::number_of_worker_global_scopes(input);
    fragment->number_of_live_ua_css_resources = Traits::number_of_live_ua_css_resources(input);
    fragment->number_of_live_resource_fetchers = Traits::number_of_live_resource_fetchers(input);
  }

  static bool Deserialize(::blink::mojom::internal::LeakDetectionResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::LeakDetectionResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {




}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LEAK_DETECTOR_LEAK_DETECTOR_MOJOM_SHARED_H_