// third_party/blink/public/mojom/loader/content_security_notifier.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_CONTENT_SECURITY_NOTIFIER_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_CONTENT_SECURITY_NOTIFIER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/loader/content_security_notifier.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/loader/content_security_notifier.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/loader/content_security_notifier.mojom-blink-forward.h"  // IWYU pragma: export
#include "url/mojom/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"
#if !BLINK_MOJO_IMPL && !INSIDE_BLINK
#error "File must only be imported inside blink"
#endif




namespace blink::mojom::blink {

class ContentSecurityNotifierProxy;

template <typename ImplRefTraits>
class ContentSecurityNotifierStub;

class ContentSecurityNotifierRequestValidator;


class PLATFORM_EXPORT ContentSecurityNotifier
    : public ContentSecurityNotifierInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ContentSecurityNotifierInterfaceBase;
  using Proxy_ = ContentSecurityNotifierProxy;

  template <typename ImplRefTraits>
  using Stub_ = ContentSecurityNotifierStub<ImplRefTraits>;

  using RequestValidator_ = ContentSecurityNotifierRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kNotifyContentWithCertificateErrorsRanMinVersion = 0,
    kNotifyContentWithCertificateErrorsDisplayedMinVersion = 0,
    kNotifyInsecureContentRanMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct NotifyContentWithCertificateErrorsRan_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct NotifyContentWithCertificateErrorsDisplayed_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct NotifyInsecureContentRan_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ContentSecurityNotifier() = default;

  
  virtual void NotifyContentWithCertificateErrorsRan() = 0;

  
  virtual void NotifyContentWithCertificateErrorsDisplayed() = 0;

  
  virtual void NotifyInsecureContentRan(const ::blink::KURL& origin, const ::blink::KURL& insecure_url) = 0;
};



class PLATFORM_EXPORT ContentSecurityNotifierProxy
    : public ContentSecurityNotifier {
 public:
  using InterfaceType = ContentSecurityNotifier;

  explicit ContentSecurityNotifierProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void NotifyContentWithCertificateErrorsRan() final;
  
  void NotifyContentWithCertificateErrorsDisplayed() final;
  
  void NotifyInsecureContentRan(const ::blink::KURL& origin, const ::blink::KURL& insecure_url) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT ContentSecurityNotifierStubDispatch {
 public:
  static bool Accept(ContentSecurityNotifier* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ContentSecurityNotifier* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ContentSecurityNotifier>>
class ContentSecurityNotifierStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ContentSecurityNotifierStub() = default;
  ~ContentSecurityNotifierStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContentSecurityNotifierStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContentSecurityNotifierStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT ContentSecurityNotifierRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom::blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_CONTENT_SECURITY_NOTIFIER_MOJOM_BLINK_H_