// third_party/blink/public/mojom/loader/javascript_framework_detection.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/loader/javascript_framework_detection.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>
#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/loader/javascript_framework_detection.mojom-params-data.h"
namespace blink {
namespace mojom {

NOINLINE static const char* JavaScriptFrameworkToStringHelper(JavaScriptFramework value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case JavaScriptFramework::kNuxt:
      return "kNuxt";
    case JavaScriptFramework::kVuePress:
      return "kVuePress";
    case JavaScriptFramework::kSapper:
      return "kSapper";
    case JavaScriptFramework::kGatsby:
      return "kGatsby";
    case JavaScriptFramework::kNext:
      return "kNext";
    case JavaScriptFramework::kAngular:
      return "kAngular";
    case JavaScriptFramework::kVue:
      return "kVue";
    case JavaScriptFramework::kSvelte:
      return "kSvelte";
    case JavaScriptFramework::kPreact:
      return "kPreact";
    case JavaScriptFramework::kReact:
      return "kReact";
    case JavaScriptFramework::kDrupal:
      return "kDrupal";
    case JavaScriptFramework::kJoomla:
      return "kJoomla";
    case JavaScriptFramework::kShopify:
      return "kShopify";
    case JavaScriptFramework::kSquarespace:
      return "kSquarespace";
    case JavaScriptFramework::kWix:
      return "kWix";
    case JavaScriptFramework::kWordPress:
      return "kWordPress";
    default:
      return nullptr;
  }
}

std::string JavaScriptFrameworkToString(JavaScriptFramework value) {
  const char *str = JavaScriptFrameworkToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown JavaScriptFramework value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, JavaScriptFramework value) {
  return os << JavaScriptFrameworkToString(value);
}

namespace internal {


// static
bool JavaScriptFrameworkDetectionResult_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const JavaScriptFrameworkDetectionResult_Data* object =
      static_cast<const JavaScriptFrameworkDetectionResult_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->detected_versions, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& detected_versions_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayOfEnumsValidator<0, false, ::blink::mojom::internal::JavaScriptFramework_Data::Validate>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->detected_versions, validation_context,
                                         &detected_versions_validate_params)) {
    return false;
  }

  return true;
}

JavaScriptFrameworkDetectionResult_Data::JavaScriptFrameworkDetectionResult_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::JavaScriptFramework>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::JavaScriptFramework value) {
  return std::move(context).WriteString(::blink::mojom::JavaScriptFrameworkToString(value));
}

} // namespace perfetto