// third_party/blink/public/mojom/loader/url_loader_factory_bundle.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_URL_LOADER_FACTORY_BUNDLE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_URL_LOADER_FACTORY_BUNDLE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/loader/url_loader_factory_bundle.mojom-shared-internal.h"
#include "services/network/public/mojom/url_loader_factory.mojom-shared.h"
#include "url/mojom/origin.mojom-shared.h"
#include "third_party/blink/public/mojom/loader/local_resource_loader_config.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class URLLoaderFactoryBundleDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::URLLoaderFactoryBundleDataView> {
  using Data = ::blink::mojom::internal::URLLoaderFactoryBundle_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


class URLLoaderFactoryBundleDataView {
 public:
  URLLoaderFactoryBundleDataView() = default;

  URLLoaderFactoryBundleDataView(
      internal::URLLoaderFactoryBundle_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeDefaultFactory() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>(
            &data_->default_factory, &result, message_);
    DCHECK(ret);
    return result;
  }
  inline void GetSchemeSpecificFactoriesDataView(
      mojo::MapDataView<mojo::StringDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSchemeSpecificFactories(UserType* output) {
    
    auto* pointer = data_->scheme_specific_factories.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<mojo::StringDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>>(
        pointer, output, message_);
  }
  inline void GetIsolatedWorldFactoriesDataView(
      mojo::MapDataView<::url::mojom::OriginDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadIsolatedWorldFactories(UserType* output) {
    
    auto* pointer = data_->isolated_world_factories.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<::url::mojom::OriginDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>>(
        pointer, output, message_);
  }
  bool bypass_redirect_checks() const {
    return data_->bypass_redirect_checks;
  }
  inline void GetLocalResourceLoaderConfigDataView(
      ::blink::mojom::LocalResourceLoaderConfigDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLocalResourceLoaderConfig(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::blink::mojom::LocalResourceLoaderConfigDataView, UserType>(),
    "Attempting to read the optional `local_resource_loader_config` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadLocalResourceLoaderConfig` instead "
    "of `ReadLocalResourceLoaderConfig if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->local_resource_loader_config.Get();
    return mojo::internal::Deserialize<::blink::mojom::LocalResourceLoaderConfigDataView>(
        pointer, output, message_);
  }
 private:
  internal::URLLoaderFactoryBundle_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::URLLoaderFactoryBundleDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::URLLoaderFactoryBundleDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::URLLoaderFactoryBundle_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::default_factory(input)) in_default_factory = Traits::default_factory(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>(
        in_default_factory, &fragment->default_factory, &fragment.message());
    decltype(Traits::scheme_specific_factories(input)) in_scheme_specific_factories = Traits::scheme_specific_factories(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->scheme_specific_factories)::BaseType>
        scheme_specific_factories_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& scheme_specific_factories_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::MapDataView<mojo::StringDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>>(
        in_scheme_specific_factories, scheme_specific_factories_fragment, &scheme_specific_factories_validate_params);
    fragment->scheme_specific_factories.Set(
        scheme_specific_factories_fragment.is_null() ? nullptr : scheme_specific_factories_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->scheme_specific_factories.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null scheme_specific_factories in URLLoaderFactoryBundle struct");
    decltype(Traits::isolated_world_factories(input)) in_isolated_world_factories = Traits::isolated_world_factories(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->isolated_world_factories)::BaseType>
        isolated_world_factories_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& isolated_world_factories_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::MapDataView<::url::mojom::OriginDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>>(
        in_isolated_world_factories, isolated_world_factories_fragment, &isolated_world_factories_validate_params);
    fragment->isolated_world_factories.Set(
        isolated_world_factories_fragment.is_null() ? nullptr : isolated_world_factories_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->isolated_world_factories.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null isolated_world_factories in URLLoaderFactoryBundle struct");
    fragment->bypass_redirect_checks = Traits::bypass_redirect_checks(input);
    decltype(Traits::local_resource_loader_config(input)) in_local_resource_loader_config = Traits::local_resource_loader_config(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->local_resource_loader_config)::BaseType> local_resource_loader_config_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::LocalResourceLoaderConfigDataView>(
        in_local_resource_loader_config, local_resource_loader_config_fragment);
    fragment->local_resource_loader_config.Set(
        local_resource_loader_config_fragment.is_null() ? nullptr : local_resource_loader_config_fragment.data());
  }

  static bool Deserialize(::blink::mojom::internal::URLLoaderFactoryBundle_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::URLLoaderFactoryBundleDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void URLLoaderFactoryBundleDataView::GetSchemeSpecificFactoriesDataView(
    mojo::MapDataView<mojo::StringDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>* output) {
  auto pointer = data_->scheme_specific_factories.Get();
  *output = mojo::MapDataView<mojo::StringDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>(pointer, message_);
}
inline void URLLoaderFactoryBundleDataView::GetIsolatedWorldFactoriesDataView(
    mojo::MapDataView<::url::mojom::OriginDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>* output) {
  auto pointer = data_->isolated_world_factories.Get();
  *output = mojo::MapDataView<::url::mojom::OriginDataView, mojo::InterfacePtrDataView<::network::mojom::URLLoaderFactoryInterfaceBase>>(pointer, message_);
}
inline void URLLoaderFactoryBundleDataView::GetLocalResourceLoaderConfigDataView(
    ::blink::mojom::LocalResourceLoaderConfigDataView* output) {
  auto pointer = data_->local_resource_loader_config.Get();
  *output = ::blink::mojom::LocalResourceLoaderConfigDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_URL_LOADER_FACTORY_BUNDLE_MOJOM_SHARED_H_