// third_party/blink/public/mojom/on_device_translation/translation_manager.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_ON_DEVICE_TRANSLATION_TRANSLATION_MANAGER_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_ON_DEVICE_TRANSLATION_TRANSLATION_MANAGER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/on_device_translation/translation_manager.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/on_device_translation/translator.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class TranslatorLanguageCodeDataView;

class TranslatorCreateOptionsDataView;

class TranslatorAvailabilityInfoDataView;

class CreateTranslatorResultDataView;


}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::TranslatorLanguageCodeDataView> {
  using Data = ::blink::mojom::internal::TranslatorLanguageCode_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::TranslatorCreateOptionsDataView> {
  using Data = ::blink::mojom::internal::TranslatorCreateOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::TranslatorAvailabilityInfoDataView> {
  using Data = ::blink::mojom::internal::TranslatorAvailabilityInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::CreateTranslatorResultDataView> {
  using Data = ::blink::mojom::internal::CreateTranslatorResult_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class CanCreateTranslatorResult : int32_t {
  
  kReadily = 0,
  
  kAfterDownloadLibraryNotReady = 1,
  
  kAfterDownloadLanguagePackNotReady = 2,
  
  kAfterDownloadLibraryAndLanguagePackNotReady = 3,
  
  kNoNotSupportedLanguage = 4,
  
  kNoAcceptLanguagesCheckFailed = 5,
  
  kNoExceedsLanguagePackCountLimitation = 6,
  
  kNoServiceCrashed = 7,
  
  kNoDisallowedByPolicy = 8,
  
  kNoExceedsServiceCountLimitation = 9,
  kMinValue = 0,
  kMaxValue = 9,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, CanCreateTranslatorResult value);
inline bool IsKnownEnumValue(CanCreateTranslatorResult value) {
  return internal::CanCreateTranslatorResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class CreateTranslatorError : int32_t {
  
  kInvalidBinary = 1,
  
  kInvalidFunctionPointer = 2,
  
  kFailedToInitialize = 3,
  
  kFailedToCreateTranslator = 4,
  
  kAcceptLanguagesCheckFailed = 5,
  
  kExceedsLanguagePackCountLimitation = 6,
  
  kServiceCrashed = 7,
  
  kDisallowedByPolicy = 8,
  
  kExceedsServiceCountLimitation = 9,
  
  kExceedsPendingTaskCountLimitation = 10,
  
  kInvalidVersion = 11,
  kMinValue = 1,
  kMaxValue = 11,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, CreateTranslatorError value);
inline bool IsKnownEnumValue(CreateTranslatorError value) {
  return internal::CreateTranslatorError_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class TranslationAvailability : int32_t {
  
  kNo = 0,
  
  kReadily = 1,
  
  kAfterDownload = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, TranslationAvailability value);
inline bool IsKnownEnumValue(TranslationAvailability value) {
  return internal::TranslationAvailability_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class TranslationManagerCreateTranslatorClientInterfaceBase {};

using TranslationManagerCreateTranslatorClientPtrDataView =
    mojo::InterfacePtrDataView<TranslationManagerCreateTranslatorClientInterfaceBase>;
using TranslationManagerCreateTranslatorClientRequestDataView =
    mojo::InterfaceRequestDataView<TranslationManagerCreateTranslatorClientInterfaceBase>;
using TranslationManagerCreateTranslatorClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<TranslationManagerCreateTranslatorClientInterfaceBase>;
using TranslationManagerCreateTranslatorClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<TranslationManagerCreateTranslatorClientInterfaceBase>;
class TranslationManagerInterfaceBase {};

using TranslationManagerPtrDataView =
    mojo::InterfacePtrDataView<TranslationManagerInterfaceBase>;
using TranslationManagerRequestDataView =
    mojo::InterfaceRequestDataView<TranslationManagerInterfaceBase>;
using TranslationManagerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<TranslationManagerInterfaceBase>;
using TranslationManagerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<TranslationManagerInterfaceBase>;


class TranslatorLanguageCodeDataView {
 public:
  TranslatorLanguageCodeDataView() = default;

  TranslatorLanguageCodeDataView(
      internal::TranslatorLanguageCode_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetCodeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadCode(UserType* output) {
    
    auto* pointer = data_->code.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
 private:
  internal::TranslatorLanguageCode_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class TranslatorCreateOptionsDataView {
 public:
  TranslatorCreateOptionsDataView() = default;

  TranslatorCreateOptionsDataView(
      internal::TranslatorCreateOptions_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetSourceLangDataView(
      TranslatorLanguageCodeDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSourceLang(UserType* output) {
    
    auto* pointer = data_->source_lang.Get();
    return mojo::internal::Deserialize<::blink::mojom::TranslatorLanguageCodeDataView>(
        pointer, output, message_);
  }
  inline void GetTargetLangDataView(
      TranslatorLanguageCodeDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadTargetLang(UserType* output) {
    
    auto* pointer = data_->target_lang.Get();
    return mojo::internal::Deserialize<::blink::mojom::TranslatorLanguageCodeDataView>(
        pointer, output, message_);
  }
 private:
  internal::TranslatorCreateOptions_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class TranslatorAvailabilityInfoDataView {
 public:
  TranslatorAvailabilityInfoDataView() = default;

  TranslatorAvailabilityInfoDataView(
      internal::TranslatorAvailabilityInfo_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetLanguageCategoriesDataView(
      mojo::ArrayDataView<mojo::ArrayDataView<TranslatorLanguageCodeDataView>>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLanguageCategories(UserType* output) {
    
    auto* pointer = data_->language_categories.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::ArrayDataView<::blink::mojom::TranslatorLanguageCodeDataView>>>(
        pointer, output, message_);
  }
  inline void GetLanguageAvailabilityMatrixDataView(
      mojo::ArrayDataView<mojo::ArrayDataView<TranslationAvailability>>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLanguageAvailabilityMatrix(UserType* output) {
    
    auto* pointer = data_->language_availability_matrix.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::ArrayDataView<::blink::mojom::TranslationAvailability>>>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadAvailability(UserType* output) const {
    auto data_value = data_->availability;
    return mojo::internal::Deserialize<::blink::mojom::TranslationAvailability>(
        data_value, output);
  }
  TranslationAvailability availability() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::TranslationAvailability>(data_->availability));
  }
 private:
  internal::TranslatorAvailabilityInfo_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class CreateTranslatorResultDataView {
 public:
  using Tag = internal::CreateTranslatorResult_Data::CreateTranslatorResult_Tag;

  CreateTranslatorResultDataView() = default;

  CreateTranslatorResultDataView(
      internal::CreateTranslatorResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_translator() const { return data_->tag == Tag::kTranslator; }
  template <typename UserType>
  UserType TakeTranslator() {
    CHECK(is_translator());
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::blink::mojom::TranslatorInterfaceBase>>(
            &data_->data.f_translator, &result, message_);
    CHECK(ret);
    return result;
  }
  bool is_error() const { return data_->tag == Tag::kError; }
  template <typename UserType>
  [[nodiscard]] bool ReadError(UserType* output) const {
    CHECK(is_error());
    return mojo::internal::Deserialize<::blink::mojom::CreateTranslatorError>(
        data_->data.f_error, output);
  }
  CreateTranslatorError error() const {
    CHECK(is_error());
    // TODO(dcheng): This seems incorrect, as it bypasses enum traits.
    return ::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::CreateTranslatorError>(data_->data.f_error));
  }

 private:
  internal::CreateTranslatorResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::CanCreateTranslatorResult>
    : public mojo::internal::EnumHashImpl<::blink::mojom::CanCreateTranslatorResult> {};

template <>
struct hash<::blink::mojom::CreateTranslatorError>
    : public mojo::internal::EnumHashImpl<::blink::mojom::CreateTranslatorError> {};

template <>
struct hash<::blink::mojom::TranslationAvailability>
    : public mojo::internal::EnumHashImpl<::blink::mojom::TranslationAvailability> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::CanCreateTranslatorResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::CanCreateTranslatorResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::CanCreateTranslatorResult>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::CreateTranslatorError, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::CreateTranslatorError, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::CreateTranslatorError>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::TranslationAvailability, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::TranslationAvailability, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::TranslationAvailability>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::TranslatorLanguageCodeDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::TranslatorLanguageCodeDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::TranslatorLanguageCode_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::code(input)) in_code = Traits::code(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->code)::BaseType> code_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_code, code_fragment);
    fragment->code.Set(
        code_fragment.is_null() ? nullptr : code_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->code.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null code in TranslatorLanguageCode struct");
  }

  static bool Deserialize(::blink::mojom::internal::TranslatorLanguageCode_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::TranslatorLanguageCodeDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::TranslatorCreateOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::TranslatorCreateOptionsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::TranslatorCreateOptions_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::source_lang(input)) in_source_lang = Traits::source_lang(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->source_lang)::BaseType> source_lang_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::TranslatorLanguageCodeDataView>(
        in_source_lang, source_lang_fragment);
    fragment->source_lang.Set(
        source_lang_fragment.is_null() ? nullptr : source_lang_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->source_lang.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null source_lang in TranslatorCreateOptions struct");
    decltype(Traits::target_lang(input)) in_target_lang = Traits::target_lang(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->target_lang)::BaseType> target_lang_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::TranslatorLanguageCodeDataView>(
        in_target_lang, target_lang_fragment);
    fragment->target_lang.Set(
        target_lang_fragment.is_null() ? nullptr : target_lang_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->target_lang.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null target_lang in TranslatorCreateOptions struct");
  }

  static bool Deserialize(::blink::mojom::internal::TranslatorCreateOptions_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::TranslatorCreateOptionsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::TranslatorAvailabilityInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::TranslatorAvailabilityInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::TranslatorAvailabilityInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::language_categories(input)) in_language_categories = Traits::language_categories(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->language_categories)::BaseType>
        language_categories_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& language_categories_validate_params =
        mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::ArrayDataView<::blink::mojom::TranslatorLanguageCodeDataView>>>(
        in_language_categories, language_categories_fragment, &language_categories_validate_params);
    fragment->language_categories.Set(
        language_categories_fragment.is_null() ? nullptr : language_categories_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->language_categories.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null language_categories in TranslatorAvailabilityInfo struct");
    decltype(Traits::language_availability_matrix(input)) in_language_availability_matrix = Traits::language_availability_matrix(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->language_availability_matrix)::BaseType>
        language_availability_matrix_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& language_availability_matrix_validate_params =
        mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayOfEnumsValidator<0, false, ::blink::mojom::internal::TranslationAvailability_Data::Validate>()>();
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::ArrayDataView<::blink::mojom::TranslationAvailability>>>(
        in_language_availability_matrix, language_availability_matrix_fragment, &language_availability_matrix_validate_params);
    fragment->language_availability_matrix.Set(
        language_availability_matrix_fragment.is_null() ? nullptr : language_availability_matrix_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->language_availability_matrix.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null language_availability_matrix in TranslatorAvailabilityInfo struct");
    mojo::internal::Serialize<::blink::mojom::TranslationAvailability>(
        Traits::availability(input), &fragment->availability);
  }

  static bool Deserialize(::blink::mojom::internal::TranslatorAvailabilityInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::TranslatorAvailabilityInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::CreateTranslatorResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::blink::mojom::CreateTranslatorResultDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::blink::mojom::internal::CreateTranslatorResult_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::blink::mojom::CreateTranslatorResultDataView::Tag::kTranslator: {
        decltype(Traits::translator(input))
            in_translator = Traits::translator(input);
        mojo::internal::Serialize<mojo::InterfacePtrDataView<::blink::mojom::TranslatorInterfaceBase>>(
            in_translator, &fragment->data.f_translator, &fragment.message());
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            !mojo::internal::IsHandleOrInterfaceValid(fragment->data.f_translator),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
            "invalid translator in CreateTranslatorResult union");
        break;
      }
      case ::blink::mojom::CreateTranslatorResultDataView::Tag::kError: {
        decltype(Traits::error(input))
            in_error = Traits::error(input);
        mojo::internal::Serialize<::blink::mojom::CreateTranslatorError>(
            in_error, &fragment->data.f_error);
        break;
      }
    }
  }

  static bool Deserialize(::blink::mojom::internal::CreateTranslatorResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::CreateTranslatorResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void TranslatorLanguageCodeDataView::GetCodeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->code.Get();
  *output = mojo::StringDataView(pointer, message_);
}


inline void TranslatorCreateOptionsDataView::GetSourceLangDataView(
    TranslatorLanguageCodeDataView* output) {
  auto pointer = data_->source_lang.Get();
  *output = TranslatorLanguageCodeDataView(pointer, message_);
}
inline void TranslatorCreateOptionsDataView::GetTargetLangDataView(
    TranslatorLanguageCodeDataView* output) {
  auto pointer = data_->target_lang.Get();
  *output = TranslatorLanguageCodeDataView(pointer, message_);
}


inline void TranslatorAvailabilityInfoDataView::GetLanguageCategoriesDataView(
    mojo::ArrayDataView<mojo::ArrayDataView<TranslatorLanguageCodeDataView>>* output) {
  auto pointer = data_->language_categories.Get();
  *output = mojo::ArrayDataView<mojo::ArrayDataView<TranslatorLanguageCodeDataView>>(pointer, message_);
}
inline void TranslatorAvailabilityInfoDataView::GetLanguageAvailabilityMatrixDataView(
    mojo::ArrayDataView<mojo::ArrayDataView<TranslationAvailability>>* output) {
  auto pointer = data_->language_availability_matrix.Get();
  *output = mojo::ArrayDataView<mojo::ArrayDataView<TranslationAvailability>>(pointer, message_);
}




}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::CanCreateTranslatorResult> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::CanCreateTranslatorResult value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::CreateTranslatorError> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::CreateTranslatorError value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::TranslationAvailability> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::TranslationAvailability value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_ON_DEVICE_TRANSLATION_TRANSLATION_MANAGER_MOJOM_SHARED_H_