// third_party/blink/public/mojom/page/browsing_context_group_info.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAGE_BROWSING_CONTEXT_GROUP_INFO_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAGE_BROWSING_CONTEXT_GROUP_INFO_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/page/browsing_context_group_info.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/page/browsing_context_group_info.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/page/browsing_context_group_info.mojom-forward.h"  // IWYU pragma: export
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include <string>
#include <vector>




#include "third_party/blink/public/common/page/browsing_context_group_info.h"
#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {








class BLINK_COMMON_EXPORT BrowsingContextGroupInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BrowsingContextGroupInfo, T>::value>;
  using DataView = BrowsingContextGroupInfoDataView;
  using Data_ = internal::BrowsingContextGroupInfo_Data;

  template <typename... Args>
  static BrowsingContextGroupInfoPtr New(Args&&... args) {
    return BrowsingContextGroupInfoPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BrowsingContextGroupInfoPtr From(const U& u) {
    return mojo::TypeConverter<BrowsingContextGroupInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BrowsingContextGroupInfo>::Convert(*this);
  }


  BrowsingContextGroupInfo();

  BrowsingContextGroupInfo(
      const ::base::UnguessableToken& browsing_context_group_token,
      const ::base::UnguessableToken& coop_related_group_token);


  ~BrowsingContextGroupInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BrowsingContextGroupInfoPtr>
  BrowsingContextGroupInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BrowsingContextGroupInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BrowsingContextGroupInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BrowsingContextGroupInfo_UnserializedMessageContext<
            UserType, BrowsingContextGroupInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<BrowsingContextGroupInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return BrowsingContextGroupInfo::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BrowsingContextGroupInfo_UnserializedMessageContext<
            UserType, BrowsingContextGroupInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BrowsingContextGroupInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::base::UnguessableToken browsing_context_group_token;
  
  ::base::UnguessableToken coop_related_group_token;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
BrowsingContextGroupInfoPtr BrowsingContextGroupInfo::Clone() const {
  return New(
      mojo::Clone(browsing_context_group_token),
      mojo::Clone(coop_related_group_token)
  );
}

template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>*>
bool BrowsingContextGroupInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->browsing_context_group_token, other_struct.browsing_context_group_token))
    return false;
  if (!mojo::Equals(this->coop_related_group_token, other_struct.coop_related_group_token))
    return false;
  return true;
}

template <typename T, BrowsingContextGroupInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.browsing_context_group_token < rhs.browsing_context_group_token)
    return true;
  if (rhs.browsing_context_group_token < lhs.browsing_context_group_token)
    return false;
  if (lhs.coop_related_group_token < rhs.coop_related_group_token)
    return true;
  if (rhs.coop_related_group_token < lhs.coop_related_group_token)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::BrowsingContextGroupInfo::DataView,
                                         ::blink::mojom::BrowsingContextGroupInfoPtr> {
  static bool IsNull(const ::blink::mojom::BrowsingContextGroupInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::BrowsingContextGroupInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::BrowsingContextGroupInfo::browsing_context_group_token)& browsing_context_group_token(
      const ::blink::mojom::BrowsingContextGroupInfoPtr& input) {
    return input->browsing_context_group_token;
  }

  static const decltype(::blink::mojom::BrowsingContextGroupInfo::coop_related_group_token)& coop_related_group_token(
      const ::blink::mojom::BrowsingContextGroupInfoPtr& input) {
    return input->coop_related_group_token;
  }

  static bool Read(::blink::mojom::BrowsingContextGroupInfo::DataView input, ::blink::mojom::BrowsingContextGroupInfoPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAGE_BROWSING_CONTEXT_GROUP_INFO_MOJOM_H_