// third_party/blink/public/mojom/payments/secure_payment_confirmation_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAYMENTS_SECURE_PAYMENT_CONFIRMATION_SERVICE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAYMENTS_SECURE_PAYMENT_CONFIRMATION_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/payments/secure_payment_confirmation_service.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/payments/secure_payment_confirmation_service.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/payments/secure_payment_confirmation_service.mojom-forward.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/webauthn/authenticator.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace payments::mojom {

class SecurePaymentConfirmationServiceProxy;

template <typename ImplRefTraits>
class SecurePaymentConfirmationServiceStub;

class SecurePaymentConfirmationServiceRequestValidator;
class SecurePaymentConfirmationServiceResponseValidator;


class BLINK_COMMON_EXPORT SecurePaymentConfirmationService
    : public SecurePaymentConfirmationServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = SecurePaymentConfirmationServiceInterfaceBase;
  using Proxy_ = SecurePaymentConfirmationServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = SecurePaymentConfirmationServiceStub<ImplRefTraits>;

  using RequestValidator_ = SecurePaymentConfirmationServiceRequestValidator;
  using ResponseValidator_ = SecurePaymentConfirmationServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kStorePaymentCredentialMinVersion = 0,
    kMakePaymentCredentialMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct StorePaymentCredential_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct MakePaymentCredential_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~SecurePaymentConfirmationService() = default;


  using StorePaymentCredentialCallback = base::OnceCallback<void(PaymentCredentialStorageStatus)>;
  
  virtual void StorePaymentCredential(const std::vector<uint8_t>& credential_id, const std::string& rp_id, const std::vector<uint8_t>& user_id, StorePaymentCredentialCallback callback) = 0;


  using MakePaymentCredentialCallback = base::OnceCallback<void(::blink::mojom::AuthenticatorStatus, ::blink::mojom::MakeCredentialAuthenticatorResponsePtr, ::blink::mojom::WebAuthnDOMExceptionDetailsPtr)>;
  
  virtual void MakePaymentCredential(::blink::mojom::PublicKeyCredentialCreationOptionsPtr options, MakePaymentCredentialCallback callback) = 0;
};



class BLINK_COMMON_EXPORT SecurePaymentConfirmationServiceProxy
    : public SecurePaymentConfirmationService {
 public:
  using InterfaceType = SecurePaymentConfirmationService;

  explicit SecurePaymentConfirmationServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void StorePaymentCredential(const std::vector<uint8_t>& credential_id, const std::string& rp_id, const std::vector<uint8_t>& user_id, StorePaymentCredentialCallback callback) final;
  
  void MakePaymentCredential(::blink::mojom::PublicKeyCredentialCreationOptionsPtr options, MakePaymentCredentialCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT SecurePaymentConfirmationServiceStubDispatch {
 public:
  static bool Accept(SecurePaymentConfirmationService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SecurePaymentConfirmationService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SecurePaymentConfirmationService>>
class SecurePaymentConfirmationServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SecurePaymentConfirmationServiceStub() = default;
  ~SecurePaymentConfirmationServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SecurePaymentConfirmationServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SecurePaymentConfirmationServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT SecurePaymentConfirmationServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT SecurePaymentConfirmationServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // payments::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAYMENTS_SECURE_PAYMENT_CONFIRMATION_SERVICE_MOJOM_H_