// third_party/blink/public/mojom/web_install/web_install.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEB_INSTALL_WEB_INSTALL_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEB_INSTALL_WEB_INSTALL_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/web_install/web_install.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class InstallOptionsDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::InstallOptionsDataView> {
  using Data = ::blink::mojom::internal::InstallOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class WebInstallServiceResult : int32_t {
  
  kSuccess = 0,
  
  kAbortError = 1,
  kMinValue = 0,
  kMaxValue = 1,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, WebInstallServiceResult value);
inline bool IsKnownEnumValue(WebInstallServiceResult value) {
  return internal::WebInstallServiceResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class WebInstallServiceInterfaceBase {};

using WebInstallServicePtrDataView =
    mojo::InterfacePtrDataView<WebInstallServiceInterfaceBase>;
using WebInstallServiceRequestDataView =
    mojo::InterfaceRequestDataView<WebInstallServiceInterfaceBase>;
using WebInstallServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebInstallServiceInterfaceBase>;
using WebInstallServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebInstallServiceInterfaceBase>;


class InstallOptionsDataView {
 public:
  InstallOptionsDataView() = default;

  InstallOptionsDataView(
      internal::InstallOptions_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetManifestIdDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadManifestId(UserType* output) {
    
    auto* pointer = data_->manifest_id.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, message_);
  }
  inline void GetInstallUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadInstallUrl(UserType* output) {
    
    auto* pointer = data_->install_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, message_);
  }
 private:
  internal::InstallOptions_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::WebInstallServiceResult>
    : public mojo::internal::EnumHashImpl<::blink::mojom::WebInstallServiceResult> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::WebInstallServiceResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::WebInstallServiceResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::WebInstallServiceResult>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::InstallOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::InstallOptionsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::InstallOptions_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::manifest_id(input)) in_manifest_id = Traits::manifest_id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->manifest_id)::BaseType> manifest_id_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_manifest_id, manifest_id_fragment);
    fragment->manifest_id.Set(
        manifest_id_fragment.is_null() ? nullptr : manifest_id_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->manifest_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null manifest_id in InstallOptions struct");
    decltype(Traits::install_url(input)) in_install_url = Traits::install_url(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->install_url)::BaseType> install_url_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_install_url, install_url_fragment);
    fragment->install_url.Set(
        install_url_fragment.is_null() ? nullptr : install_url_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->install_url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null install_url in InstallOptions struct");
  }

  static bool Deserialize(::blink::mojom::internal::InstallOptions_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::InstallOptionsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void InstallOptionsDataView::GetManifestIdDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->manifest_id.Get();
  *output = ::url::mojom::UrlDataView(pointer, message_);
}
inline void InstallOptionsDataView::GetInstallUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->install_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::WebInstallServiceResult> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::WebInstallServiceResult value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEB_INSTALL_WEB_INSTALL_MOJOM_SHARED_H_