// third_party/blink/public/mojom/webdatabase/web_database.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBDATABASE_WEB_DATABASE_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBDATABASE_WEB_DATABASE_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/webdatabase/web_database.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink::mojom::blink {


class PLATFORM_EXPORT WebDatabaseInterceptorForTesting : public WebDatabase {
  virtual WebDatabase* GetForwardingInterface() = 0;
  void UpdateSize(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::WTF::String& name, int64_t size) override;
  void CloseImmediately(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::WTF::String& name) override;
};
class PLATFORM_EXPORT WebDatabaseAsyncWaiter {
 public:
  explicit WebDatabaseAsyncWaiter(WebDatabase* proxy);

  WebDatabaseAsyncWaiter(const WebDatabaseAsyncWaiter&) = delete;
  WebDatabaseAsyncWaiter& operator=(const WebDatabaseAsyncWaiter&) = delete;

  ~WebDatabaseAsyncWaiter();

 private:
  WebDatabase* const proxy_;
};


class PLATFORM_EXPORT WebDatabaseHostInterceptorForTesting : public WebDatabaseHost {
  virtual WebDatabaseHost* GetForwardingInterface() = 0;
  void OpenFile(const ::WTF::String& vfs_file_name, int32_t desired_flags, OpenFileCallback callback) override;
  void DeleteFile(const ::WTF::String& vfs_file_name, bool sync_dir, DeleteFileCallback callback) override;
  void GetFileAttributes(const ::WTF::String& vfs_file_name, GetFileAttributesCallback callback) override;
  void GetSpaceAvailable(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, GetSpaceAvailableCallback callback) override;
  void Opened(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::WTF::String& database_name, const ::WTF::String& database_description) override;
  void Modified(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::WTF::String& database_name) override;
  void Closed(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::WTF::String& database_name) override;
  void HandleSqliteError(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::WTF::String& database_name, int32_t error) override;
};
class PLATFORM_EXPORT WebDatabaseHostAsyncWaiter {
 public:
  explicit WebDatabaseHostAsyncWaiter(WebDatabaseHost* proxy);

  WebDatabaseHostAsyncWaiter(const WebDatabaseHostAsyncWaiter&) = delete;
  WebDatabaseHostAsyncWaiter& operator=(const WebDatabaseHostAsyncWaiter&) = delete;

  ~WebDatabaseHostAsyncWaiter();
  void OpenFile(
      const ::WTF::String& vfs_file_name, int32_t desired_flags, ::base::File* out_file);
  ::base::File OpenFile(const ::WTF::String& vfs_file_name, int32_t desired_flags);
  void DeleteFile(
      const ::WTF::String& vfs_file_name, bool sync_dir, int32_t* out_sqlite_error_code);
  int32_t DeleteFile(const ::WTF::String& vfs_file_name, bool sync_dir);
  void GetFileAttributes(
      const ::WTF::String& vfs_file_name, int32_t* out_attributes);
  int32_t GetFileAttributes(const ::WTF::String& vfs_file_name);
  void GetSpaceAvailable(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, int64_t* out_space_available);
  int64_t GetSpaceAvailable(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin);

 private:
  WebDatabaseHost* const proxy_;
};




}  // blink::mojom::blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBDATABASE_WEB_DATABASE_MOJOM_BLINK_TEST_UTILS_H_