// third_party/blink/public/mojom/webdatabase/web_database.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBDATABASE_WEB_DATABASE_MOJOM_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBDATABASE_WEB_DATABASE_MOJOM_TEST_UTILS_H_

#include "third_party/blink/public/mojom/webdatabase/web_database.mojom.h"
#include "third_party/blink/public/common/common_export.h"


namespace blink::mojom {


class BLINK_COMMON_EXPORT WebDatabaseInterceptorForTesting : public WebDatabase {
  virtual WebDatabase* GetForwardingInterface() = 0;
  void UpdateSize(const ::url::Origin& origin, const ::std::u16string& name, int64_t size) override;
  void CloseImmediately(const ::url::Origin& origin, const ::std::u16string& name) override;
};
class BLINK_COMMON_EXPORT WebDatabaseAsyncWaiter {
 public:
  explicit WebDatabaseAsyncWaiter(WebDatabase* proxy);

  WebDatabaseAsyncWaiter(const WebDatabaseAsyncWaiter&) = delete;
  WebDatabaseAsyncWaiter& operator=(const WebDatabaseAsyncWaiter&) = delete;

  ~WebDatabaseAsyncWaiter();

 private:
  WebDatabase* const proxy_;
};


class BLINK_COMMON_EXPORT WebDatabaseHostInterceptorForTesting : public WebDatabaseHost {
  virtual WebDatabaseHost* GetForwardingInterface() = 0;
  void OpenFile(const ::std::u16string& vfs_file_name, int32_t desired_flags, OpenFileCallback callback) override;
  void DeleteFile(const ::std::u16string& vfs_file_name, bool sync_dir, DeleteFileCallback callback) override;
  void GetFileAttributes(const ::std::u16string& vfs_file_name, GetFileAttributesCallback callback) override;
  void GetSpaceAvailable(const ::url::Origin& origin, GetSpaceAvailableCallback callback) override;
  void Opened(const ::url::Origin& origin, const ::std::u16string& database_name, const ::std::u16string& database_description) override;
  void Modified(const ::url::Origin& origin, const ::std::u16string& database_name) override;
  void Closed(const ::url::Origin& origin, const ::std::u16string& database_name) override;
  void HandleSqliteError(const ::url::Origin& origin, const ::std::u16string& database_name, int32_t error) override;
};
class BLINK_COMMON_EXPORT WebDatabaseHostAsyncWaiter {
 public:
  explicit WebDatabaseHostAsyncWaiter(WebDatabaseHost* proxy);

  WebDatabaseHostAsyncWaiter(const WebDatabaseHostAsyncWaiter&) = delete;
  WebDatabaseHostAsyncWaiter& operator=(const WebDatabaseHostAsyncWaiter&) = delete;

  ~WebDatabaseHostAsyncWaiter();
  void OpenFile(
      const ::std::u16string& vfs_file_name, int32_t desired_flags, ::base::File* out_file);
  ::base::File OpenFile(const ::std::u16string& vfs_file_name, int32_t desired_flags);
  void DeleteFile(
      const ::std::u16string& vfs_file_name, bool sync_dir, int32_t* out_sqlite_error_code);
  int32_t DeleteFile(const ::std::u16string& vfs_file_name, bool sync_dir);
  void GetFileAttributes(
      const ::std::u16string& vfs_file_name, int32_t* out_attributes);
  int32_t GetFileAttributes(const ::std::u16string& vfs_file_name);
  void GetSpaceAvailable(
      const ::url::Origin& origin, int64_t* out_space_available);
  int64_t GetSpaceAvailable(const ::url::Origin& origin);

 private:
  WebDatabaseHost* const proxy_;
};




}  // blink::mojom

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBDATABASE_WEB_DATABASE_MOJOM_TEST_UTILS_H_