// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_BASE_PROPERTY_INDEXED_KEYFRAME_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_BASE_PROPERTY_INDEXED_KEYFRAME_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_composite_operation_or_auto.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class TimelineRangeOffset;
class V8UnionCompositeOperationOrAutoOrCompositeOperationOrAutoSequence;
class V8UnionDoubleOrDoubleOrStringOrTimelineRangeOffsetOrNullSequenceOrStringOrTimelineRangeOffsetOrNull;
class V8UnionDoubleOrStringOrTimelineRangeOffset;
class V8UnionStringOrStringSequence;

class CORE_EXPORT BasePropertyIndexedKeyframe : public bindings::DictionaryBase {
  
  public:
static BasePropertyIndexedKeyframe* Create() {
  return MakeGarbageCollected<BasePropertyIndexedKeyframe>();
}
static BasePropertyIndexedKeyframe* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<BasePropertyIndexedKeyframe>(isolate);
}
static BasePropertyIndexedKeyframe* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  BasePropertyIndexedKeyframe();
explicit  BasePropertyIndexedKeyframe(v8::Isolate* isolate);

bool hasComposite() const {
  return true;
}
V8UnionCompositeOperationOrAutoOrCompositeOperationOrAutoSequence* composite() const {
  return member_composite_.Get();
}
void setComposite(V8UnionCompositeOperationOrAutoOrCompositeOperationOrAutoSequence* value) {
  member_composite_ = value;
DCHECK(member_composite_);
}

bool hasEasing() const {
  return true;
}
V8UnionStringOrStringSequence* easing() const {
  return member_easing_.Get();
}
void setEasing(V8UnionStringOrStringSequence* value) {
  member_easing_ = value;
DCHECK(member_easing_);
}

bool hasOffset() const {
  return true;
}
V8UnionDoubleOrDoubleOrStringOrTimelineRangeOffsetOrNullSequenceOrStringOrTimelineRangeOffsetOrNull* offset() const {
  return member_offset_.Get();
}
void setOffset(V8UnionDoubleOrDoubleOrStringOrTimelineRangeOffsetOrNullSequenceOrStringOrTimelineRangeOffsetOrNull* value) {
  member_offset_ = value;
DCHECK(member_offset_);
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 3;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



Member<V8UnionCompositeOperationOrAutoOrCompositeOperationOrAutoSequence> member_composite_;
Member<V8UnionStringOrStringSequence> member_easing_;
Member<V8UnionDoubleOrDoubleOrStringOrTimelineRangeOffsetOrNullSequenceOrStringOrTimelineRangeOffsetOrNull> member_offset_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_BASE_PROPERTY_INDEXED_KEYFRAME_H_
