// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_performance_observer_callback.h"

#include <tuple>

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/callback_invoke_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_performance_observer_callback_options.h"
#include "third_party/blink/renderer/core/timing/performance_observer.h"
#include "third_party/blink/renderer/core/timing/performance_observer_entry_list.h"

namespace blink {





const char* V8PerformanceObserverCallback::NameInHeapSnapshot() const {
  return "V8PerformanceObserverCallback";
}

v8::Maybe<void> V8PerformanceObserverCallback::Invoke(bindings::V8ValueOrScriptWrappableAdapter arg0_receiver, PerformanceObserverEntryList* arg1_entries, PerformanceObserver* arg2_observer, const PerformanceObserverCallbackOptions* arg3_options) {
  const char* const class_like_name = "PerformanceObserverCallback";
const char* const property_name = "invoke";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<void>();
}

if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::Isolate* isolate = GetIsolate();
v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
V8ThrowException::ThrowError(isolate,"The provided callback is no longer runnable.");
return v8::Nothing<void>();
}

bindings::CallbackInvokeHelper<CallbackFunctionBase, bindings::CallbackInvokeHelperMode::kDefault, bindings::CallbackReturnTypeIsPromise::kNo> helper(
    this, class_like_name, property_name);
if (!helper.PrepareForCall(arg0_receiver)) [[unlikely]] {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}
v8::Local<v8::Value> argv_arr[3];
base::span<v8::Local<v8::Value>> argv(argv_arr);
v8::Local<v8::Value> v8_arg1_entries;
ScriptState* script_state = CallbackRelevantScriptState();
v8_arg1_entries = ToV8Traits<PerformanceObserverEntryList>::ToV8(script_state, arg1_entries);
argv[0] = v8_arg1_entries;
v8::Local<v8::Value> v8_arg2_observer;
v8_arg2_observer = ToV8Traits<PerformanceObserver>::ToV8(script_state, arg2_observer);
argv[1] = v8_arg2_observer;
v8::Local<v8::Value> v8_arg3_options;
v8_arg3_options = ToV8Traits<PerformanceObserverCallbackOptions>::ToV8(script_state, arg3_options);
argv[2] = v8_arg3_options;
if (!helper.Call(static_cast<int>(argv.size()), argv.data())) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}

v8::Maybe<void> V8PerformanceObserverCallback::Construct(PerformanceObserverEntryList* arg1_entries, PerformanceObserver* arg2_observer, const PerformanceObserverCallbackOptions* arg3_options) {
  const char* const class_like_name = "PerformanceObserverCallback";
const char* const property_name = "construct";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<void>();
}

if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::Isolate* isolate = GetIsolate();
v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
V8ThrowException::ThrowError(isolate,"The provided callback is no longer runnable.");
return v8::Nothing<void>();
}

bindings::CallbackInvokeHelper<CallbackFunctionBase, bindings::CallbackInvokeHelperMode::kConstructorCall, bindings::CallbackReturnTypeIsPromise::kNo> helper(
    this, class_like_name, property_name);
if (!helper.PrepareForCall(nullptr)) [[unlikely]] {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}
v8::Local<v8::Value> argv_arr[3];
base::span<v8::Local<v8::Value>> argv(argv_arr);
v8::Local<v8::Value> v8_arg1_entries;
ScriptState* script_state = CallbackRelevantScriptState();
v8_arg1_entries = ToV8Traits<PerformanceObserverEntryList>::ToV8(script_state, arg1_entries);
argv[0] = v8_arg1_entries;
v8::Local<v8::Value> v8_arg2_observer;
v8_arg2_observer = ToV8Traits<PerformanceObserver>::ToV8(script_state, arg2_observer);
argv[1] = v8_arg2_observer;
v8::Local<v8::Value> v8_arg3_options;
v8_arg3_options = ToV8Traits<PerformanceObserverCallbackOptions>::ToV8(script_state, arg3_options);
argv[2] = v8_arg3_options;
if (!helper.Call(static_cast<int>(argv.size()), argv.data())) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}

void V8PerformanceObserverCallback::InvokeAndReportException(bindings::V8ValueOrScriptWrappableAdapter arg0_receiver, PerformanceObserverEntryList* arg1_entries, PerformanceObserver* arg2_observer, const PerformanceObserverCallbackOptions* arg3_options) {
  v8::Isolate* isolate = GetIsolate();
v8::TryCatch try_catch(isolate);
try_catch.SetVerbose(true);

std::ignore = Invoke(arg0_receiver, arg1_entries, arg2_observer, arg3_options);
}



}  // namespace blink
