// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_property_definition.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"inherits",
"initialValue",
"name",
"syntax",
};


}  // namespace 

PropertyDefinition* PropertyDefinition::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PropertyDefinition* dictionary = MakeGarbageCollected<PropertyDefinition>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PropertyDefinition";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PropertyDefinition::PropertyDefinition() {
  
}

 PropertyDefinition::PropertyDefinition(v8::Isolate* isolate) {
  
}








String PropertyDefinition::getInitialValueOr(const String& fallback_value) const {
  if (!hasInitialValue()) {
  return fallback_value;
}
return member_initial_value_;
}

String PropertyDefinition::getInitialValueOr(String&& fallback_value) const {
  if (!hasInitialValue()) {
  return std::move(fallback_value);
}
return member_initial_value_;
}

void PropertyDefinition::setInitialValue(const String& value) {
  member_initial_value_ = value;
has_initial_value_ = true;
}

void PropertyDefinition::setInitialValue(String&& value) {
  member_initial_value_ = std::move(value);
has_initial_value_ = true;
}




void PropertyDefinition::setName(const String& value) {
  member_name_ = value;
}

void PropertyDefinition::setName(String&& value) {
  member_name_ = std::move(value);
}




void PropertyDefinition::setSyntax(const String& value) {
  member_syntax_ = value;
}

void PropertyDefinition::setSyntax(String&& value) {
  member_syntax_ = std::move(value);
}




void PropertyDefinition::Trace(Visitor* visitor) const {
  bindings::DictionaryBase::Trace(visitor);
}

void PropertyDefinition::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PropertyDefinition::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasInherits()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_inherits_);
DCHECK(!values[0].IsEmpty());
}
if (hasInitialValue()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_initial_value_);
DCHECK(!values[1].IsEmpty());
}
if (hasName()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_name_);
DCHECK(!values[2].IsEmpty());
}
if (hasSyntax()) {
  values[3] = ToV8Traits<IDLString>::ToV8(script_state, member_syntax_);
DCHECK(!values[3].IsEmpty());
}
}

const void* PropertyDefinition::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PropertyDefinition::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PropertyDefinition::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PropertyDefinition";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("inherits");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_inherits_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("initialValue");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_initial_value_, member_initial_value_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("name");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_name_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("syntax");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_syntax_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PropertyDefinition::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
