// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_SCHEDULER_POST_TASK_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_SCHEDULER_POST_TASK_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_task_priority.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class AbortSignal;
class ExceptionState;

class CORE_EXPORT SchedulerPostTaskOptions : public bindings::InputDictionaryBase {
  
  public:
static SchedulerPostTaskOptions* Create() {
  return MakeGarbageCollected<SchedulerPostTaskOptions>();
}
static SchedulerPostTaskOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<SchedulerPostTaskOptions>(isolate);
}
static SchedulerPostTaskOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  SchedulerPostTaskOptions();
explicit  SchedulerPostTaskOptions(v8::Isolate* isolate);

bool hasDelay() const {
  return true;
}
uint64_t delay() const {
  return member_delay_;
}
void setDelay(uint64_t value) {
  member_delay_ = value;
}

bool hasPriority() const {
  return has_priority_;
}
V8TaskPriority priority() const {
  DCHECK(hasPriority());
return member_priority_;
}
V8TaskPriority getPriorityOr(V8TaskPriority fallback_value) const {
  if (!hasPriority()) {
  return fallback_value;
}
return member_priority_;
}
void setPriority(V8TaskPriority value) {
  member_priority_ = value;
has_priority_ = true;
}
void setPriority(V8TaskPriority::Enum value) {
  member_priority_ = V8TaskPriority(value);
has_priority_ = true;
}

bool hasSignal() const {
  return has_signal_;
}
AbortSignal* signal() const {
  DCHECK(hasSignal());
return member_signal_.Get();
}
AbortSignal* getSignalOr(AbortSignal* fallback_value) const {
  if (!hasSignal()) {
  return fallback_value;
}
return member_signal_.Get();
}
void setSignal(AbortSignal* value) {
  member_signal_ = value;
has_signal_ = true;
DCHECK(member_signal_);
}


// Obsolete accessor functions
void setPriority(const String& value) {
  member_priority_ = V8TaskPriority::Create(value).value();
has_priority_ = true;
}

void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 3;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_priority_ = false;
bool has_signal_ = false;

uint64_t member_delay_{0};
V8TaskPriority member_priority_{static_cast<V8TaskPriority::Enum>(0)};
Member<AbortSignal> member_signal_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_SCHEDULER_POST_TASK_OPTIONS_H_
