// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_BYTESTRINGBYTESTRINGRECORD_BYTESTRINGSEQUENCESEQUENCE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_BYTESTRINGBYTESTRINGRECORD_BYTESTRINGSEQUENCESEQUENCE_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class ScriptState;

class CORE_EXPORT V8UnionByteStringByteStringRecordOrByteStringSequenceSequence final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kByteStringByteStringRecord, kByteStringSequenceSequence
};

static V8UnionByteStringByteStringRecordOrByteStringSequenceSequence* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionByteStringByteStringRecordOrByteStringSequenceSequence(const Vector<std::pair<String, String>>& value);
explicit  V8UnionByteStringByteStringRecordOrByteStringSequenceSequence(Vector<std::pair<String, String>>&& value);
explicit  V8UnionByteStringByteStringRecordOrByteStringSequenceSequence(const Vector<Vector<String>>& value);
explicit  V8UnionByteStringByteStringRecordOrByteStringSequenceSequence(Vector<Vector<String>>&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsByteStringByteStringRecord() const {
  return content_type_ == ContentType::kByteStringByteStringRecord;
}
const Vector<std::pair<String, String>>& GetAsByteStringByteStringRecord() const {
  DCHECK_EQ(content_type_, ContentType::kByteStringByteStringRecord);
return member_byte_string_byte_string_record_;
}
void Set(const Vector<std::pair<String, String>>& value);
void Set(Vector<std::pair<String, String>>&& value);

bool IsByteStringSequenceSequence() const {
  return content_type_ == ContentType::kByteStringSequenceSequence;
}
const Vector<Vector<String>>& GetAsByteStringSequenceSequence() const {
  DCHECK_EQ(content_type_, ContentType::kByteStringSequenceSequence);
return member_byte_string_sequence_sequence_;
}
void Set(const Vector<Vector<String>>& value);
void Set(Vector<Vector<String>>&& value);


void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(record<ByteString, ByteString> or sequence<sequence<ByteString>>)";
}

ContentType content_type_;

Vector<std::pair<String, String>> member_byte_string_byte_string_record_;
Vector<Vector<String>> member_byte_string_sequence_sequence_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_BYTESTRINGBYTESTRINGRECORD_BYTESTRINGSEQUENCESEQUENCE_H_
