// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_CSSVARIABLEREFERENCEVALUE_STRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_CSSVARIABLEREFERENCEVALUE_STRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class CSSStyleVariableReferenceValue;
class ExceptionState;
class ScriptState;

class CORE_EXPORT V8UnionCSSVariableReferenceValueOrString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kCSSVariableReferenceValue, kString
};

static V8UnionCSSVariableReferenceValueOrString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionCSSVariableReferenceValueOrString(CSSStyleVariableReferenceValue* value) : content_type_(ContentType::kCSSVariableReferenceValue), member_css_variable_reference_value_(value) {
  DCHECK(value);
}
explicit  V8UnionCSSVariableReferenceValueOrString(const String& value);
explicit  V8UnionCSSVariableReferenceValueOrString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsCSSVariableReferenceValue() const {
  return content_type_ == ContentType::kCSSVariableReferenceValue;
}
CSSStyleVariableReferenceValue* GetAsCSSVariableReferenceValue() const {
  DCHECK_EQ(content_type_, ContentType::kCSSVariableReferenceValue);
return member_css_variable_reference_value_.Get();
}
void Set(CSSStyleVariableReferenceValue* value) {
  DCHECK(value);
Clear();
member_css_variable_reference_value_ = value;
content_type_ = ContentType::kCSSVariableReferenceValue;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);


v8::Local<v8::Value> ToV8(ScriptState* script_state) const;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(CSSVariableReferenceValue or DOMString)";
}

ContentType content_type_;

Member<CSSStyleVariableReferenceValue> member_css_variable_reference_value_;
String member_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_CSSVARIABLEREFERENCEVALUE_STRING_H_
