// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_ELEMENTCREATIONOPTIONS_STRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_ELEMENTCREATIONOPTIONS_STRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ElementCreationOptions;
class ExceptionState;
class ScriptState;

class CORE_EXPORT V8UnionElementCreationOptionsOrString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kElementCreationOptions, kString
};

static V8UnionElementCreationOptionsOrString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionElementCreationOptionsOrString(ElementCreationOptions* value) : content_type_(ContentType::kElementCreationOptions), member_element_creation_options_(value) {
  DCHECK(value);
}
explicit  V8UnionElementCreationOptionsOrString(const String& value);
explicit  V8UnionElementCreationOptionsOrString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsElementCreationOptions() const {
  return content_type_ == ContentType::kElementCreationOptions;
}
ElementCreationOptions* GetAsElementCreationOptions() const {
  DCHECK_EQ(content_type_, ContentType::kElementCreationOptions);
return member_element_creation_options_.Get();
}
void Set(ElementCreationOptions* value) {
  DCHECK(value);
Clear();
member_element_creation_options_ = value;
content_type_ = ContentType::kElementCreationOptions;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);


void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or ElementCreationOptions)";
}

ContentType content_type_;

Member<ElementCreationOptions> member_element_creation_options_;
String member_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_ELEMENTCREATIONOPTIONS_STRING_H_
