// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_file_formdata_usvstring.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_file.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_form_data.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_file_usvstring.h"
#include "third_party/blink/renderer/core/fileapi/file.h"
#include "third_party/blink/renderer/core/html/forms/form_data.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionFileOrFormDataOrUSVString* V8UnionFileOrFormDataOrUSVString::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (V8File::HasInstance(isolate, v8_value)) {
  auto&& blink_value = V8File::ToWrappableUnsafe(isolate, v8_value.As<v8::Object>());
return MakeGarbageCollected<V8UnionFileOrFormDataOrUSVString>(blink_value);
}
if (V8FormData::HasInstance(isolate, v8_value)) {
  auto&& blink_value = V8FormData::ToWrappableUnsafe(isolate, v8_value.As<v8::Object>());
return MakeGarbageCollected<V8UnionFileOrFormDataOrUSVString>(blink_value);
}
{
  auto&& blink_value = NativeValueTraits<IDLUSVString>::NativeValue(isolate, v8_value, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return MakeGarbageCollected<V8UnionFileOrFormDataOrUSVString>(std::move(blink_value));
}
}

 V8UnionFileOrFormDataOrUSVString::V8UnionFileOrFormDataOrUSVString(const String& value) : content_type_(ContentType::kUSVString), member_usv_string_(value) {
  
}

 V8UnionFileOrFormDataOrUSVString::V8UnionFileOrFormDataOrUSVString(String&& value) : content_type_(ContentType::kUSVString), member_usv_string_(std::move(value)) {
  
}










void V8UnionFileOrFormDataOrUSVString::Set(const String& value) {
  Clear();
member_usv_string_ = value;
content_type_ = ContentType::kUSVString;
}

void V8UnionFileOrFormDataOrUSVString::Set(String&& value) {
  Clear();
member_usv_string_ = std::move(value);
content_type_ = ContentType::kUSVString;
}


V8UnionFileOrUSVString* V8UnionFileOrFormDataOrUSVString::GetAsV8UnionFileOrUSVString() const {
  switch (content_type_) {
  case ContentType::kFile: {
    return MakeGarbageCollected<V8UnionFileOrUSVString>(GetAsFile());
  }
  case ContentType::kUSVString: {
    return MakeGarbageCollected<V8UnionFileOrUSVString>(GetAsUSVString());
  }
  default: {
    NOTREACHED();
  }
}
}

void V8UnionFileOrFormDataOrUSVString::Set(const V8UnionFileOrUSVString* value) {
  switch (value->GetContentType()) {
  case V8UnionFileOrUSVString::ContentType::kFile: {
    Set(value->GetAsFile());
    break;
  }
  case V8UnionFileOrUSVString::ContentType::kUSVString: {
    Set(value->GetAsUSVString());
    break;
  }
}
}




v8::Local<v8::Value> V8UnionFileOrFormDataOrUSVString::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kFile: {
    return ToV8Traits<File>::ToV8(script_state, member_file_.Get());
  }
  case ContentType::kFormData: {
    return ToV8Traits<FormData>::ToV8(script_state, member_form_data_.Get());
  }
  case ContentType::kUSVString: {
    return ToV8Traits<IDLUSVString>::ToV8(script_state, member_usv_string_);
  }
}

NOTREACHED();
}

void V8UnionFileOrFormDataOrUSVString::Trace(Visitor* visitor) const {
  visitor->Trace(member_file_);
visitor->Trace(member_form_data_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionFileOrFormDataOrUSVString::Clear() {
  member_file_.Clear();
member_form_data_.Clear();
member_usv_string_ = String();
}



}  // namespace blink
