// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_int32arrayallowshared_longsequence.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionInt32ArrayAllowSharedOrLongSequence* V8UnionInt32ArrayAllowSharedOrLongSequence::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (v8_value->IsInt32Array()) {
  auto&& blink_value = NativeValueTraits<MaybeShared<DOMInt32Array>>::NativeValue(isolate, v8_value, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return MakeGarbageCollected<V8UnionInt32ArrayAllowSharedOrLongSequence>(blink_value);
}
if (v8_value->IsArray()) {
  auto&& blink_value = NativeValueTraits<IDLSequence<IDLLong>>::NativeValue(isolate, v8_value, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return MakeGarbageCollected<V8UnionInt32ArrayAllowSharedOrLongSequence>(std::move(blink_value));
}
if (v8_value->IsObject()) {
  ScriptIterator script_iterator = ScriptIterator::FromIterable(isolate, v8_value.As<v8::Object>(), exception_state, ScriptIterator::Kind::kSync);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
if (!script_iterator.IsNull()) {
  auto&& blink_value = bindings::CreateIDLSequenceFromIterator<IDLLong>(isolate, std::move(script_iterator), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return MakeGarbageCollected<V8UnionInt32ArrayAllowSharedOrLongSequence>(std::move(blink_value));
}
}
ThrowTypeErrorNotOfType(exception_state, UnionNameInIDL());
return nullptr;
}

 V8UnionInt32ArrayAllowSharedOrLongSequence::V8UnionInt32ArrayAllowSharedOrLongSequence(const Vector<int32_t>& value) : content_type_(ContentType::kLongSequence), member_long_sequence_(value) {
  
}

 V8UnionInt32ArrayAllowSharedOrLongSequence::V8UnionInt32ArrayAllowSharedOrLongSequence(Vector<int32_t>&& value) : content_type_(ContentType::kLongSequence), member_long_sequence_(std::move(value)) {
  
}







void V8UnionInt32ArrayAllowSharedOrLongSequence::Set(const Vector<int32_t>& value) {
  Clear();
member_long_sequence_ = value;
content_type_ = ContentType::kLongSequence;
}

void V8UnionInt32ArrayAllowSharedOrLongSequence::Set(Vector<int32_t>&& value) {
  Clear();
member_long_sequence_ = std::move(value);
content_type_ = ContentType::kLongSequence;
}


void V8UnionInt32ArrayAllowSharedOrLongSequence::Trace(Visitor* visitor) const {
  visitor->Trace(member_int32_array_allow_shared_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionInt32ArrayAllowSharedOrLongSequence::Clear() {
  member_int32_array_allow_shared_.Clear();
member_long_sequence_.clear();
}



}  // namespace blink
