// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_SANITIZER_SANITIZERCONFIG_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_SANITIZER_SANITIZERCONFIG_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class Sanitizer;
class SanitizerConfig;
class ScriptState;

class CORE_EXPORT V8UnionSanitizerOrSanitizerConfig final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kSanitizer, kSanitizerConfig
};

static V8UnionSanitizerOrSanitizerConfig* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionSanitizerOrSanitizerConfig(Sanitizer* value) : content_type_(ContentType::kSanitizer), member_sanitizer_(value) {
  DCHECK(value);
}
explicit  V8UnionSanitizerOrSanitizerConfig(SanitizerConfig* value) : content_type_(ContentType::kSanitizerConfig), member_sanitizer_config_(value) {
  DCHECK(value);
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsSanitizer() const {
  return content_type_ == ContentType::kSanitizer;
}
Sanitizer* GetAsSanitizer() const {
  DCHECK_EQ(content_type_, ContentType::kSanitizer);
return member_sanitizer_.Get();
}
void Set(Sanitizer* value) {
  DCHECK(value);
Clear();
member_sanitizer_ = value;
content_type_ = ContentType::kSanitizer;
}

bool IsSanitizerConfig() const {
  return content_type_ == ContentType::kSanitizerConfig;
}
SanitizerConfig* GetAsSanitizerConfig() const {
  DCHECK_EQ(content_type_, ContentType::kSanitizerConfig);
return member_sanitizer_config_.Get();
}
void Set(SanitizerConfig* value) {
  DCHECK(value);
Clear();
member_sanitizer_config_ = value;
content_type_ = ContentType::kSanitizerConfig;
}


void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(Sanitizer or SanitizerConfig)";
}

ContentType content_type_;

Member<Sanitizer> member_sanitizer_;
Member<SanitizerConfig> member_sanitizer_config_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_SANITIZER_SANITIZERCONFIG_H_
