// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_SANITIZERATTRIBUTENAMESPACE_STRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_SANITIZERATTRIBUTENAMESPACE_STRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class SanitizerAttributeNamespace;
class ScriptState;

class CORE_EXPORT V8UnionSanitizerAttributeNamespaceOrString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kSanitizerAttributeNamespace, kString
};

static V8UnionSanitizerAttributeNamespaceOrString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionSanitizerAttributeNamespaceOrString(SanitizerAttributeNamespace* value) : content_type_(ContentType::kSanitizerAttributeNamespace), member_sanitizer_attribute_namespace_(value) {
  DCHECK(value);
}
explicit  V8UnionSanitizerAttributeNamespaceOrString(const String& value);
explicit  V8UnionSanitizerAttributeNamespaceOrString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsSanitizerAttributeNamespace() const {
  return content_type_ == ContentType::kSanitizerAttributeNamespace;
}
SanitizerAttributeNamespace* GetAsSanitizerAttributeNamespace() const {
  DCHECK_EQ(content_type_, ContentType::kSanitizerAttributeNamespace);
return member_sanitizer_attribute_namespace_.Get();
}
void Set(SanitizerAttributeNamespace* value) {
  DCHECK(value);
Clear();
member_sanitizer_attribute_namespace_ = value;
content_type_ = ContentType::kSanitizerAttributeNamespace;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);


v8::Local<v8::Value> ToV8(ScriptState* script_state) const;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or SanitizerAttributeNamespace)";
}

ContentType content_type_;

Member<SanitizerAttributeNamespace> member_sanitizer_attribute_namespace_;
String member_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_SANITIZERATTRIBUTENAMESPACE_STRING_H_
