// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRING_TRUSTEDHTML_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRING_TRUSTEDHTML_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class ScriptState;
class TrustedHTML;

class CORE_EXPORT V8UnionStringOrTrustedHTML final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kString, kTrustedHTML
};

static V8UnionStringOrTrustedHTML* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionStringOrTrustedHTML(const String& value);
explicit  V8UnionStringOrTrustedHTML(String&& value);
explicit  V8UnionStringOrTrustedHTML(TrustedHTML* value) : content_type_(ContentType::kTrustedHTML), member_trusted_html_(value) {
  DCHECK(value);
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);

bool IsTrustedHTML() const {
  return content_type_ == ContentType::kTrustedHTML;
}
TrustedHTML* GetAsTrustedHTML() const {
  DCHECK_EQ(content_type_, ContentType::kTrustedHTML);
return member_trusted_html_.Get();
}
void Set(TrustedHTML* value) {
  DCHECK(value);
Clear();
member_trusted_html_ = value;
content_type_ = ContentType::kTrustedHTML;
}


void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or TrustedHTML)";
}

ContentType content_type_;

String member_string_;
Member<TrustedHTML> member_trusted_html_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRING_TRUSTEDHTML_H_
