// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_UINT_32_ARRAYALLOWSHARED_UNSIGNEDLONGSEQUENCE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_UINT_32_ARRAYALLOWSHARED_UNSIGNEDLONGSEQUENCE_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/core/typed_arrays/array_buffer_view_helpers.h"
#include "third_party/blink/renderer/core/typed_arrays/dom_typed_array.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class ScriptState;

class CORE_EXPORT V8UnionUint32ArrayAllowSharedOrUnsignedLongSequence final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kUint32ArrayAllowShared, kUnsignedLongSequence
};

static V8UnionUint32ArrayAllowSharedOrUnsignedLongSequence* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionUint32ArrayAllowSharedOrUnsignedLongSequence(MaybeShared<DOMUint32Array> value) : content_type_(ContentType::kUint32ArrayAllowShared), member_uint32_array_allow_shared_(value) {
  DCHECK(value);
}
explicit  V8UnionUint32ArrayAllowSharedOrUnsignedLongSequence(const Vector<uint32_t>& value);
explicit  V8UnionUint32ArrayAllowSharedOrUnsignedLongSequence(Vector<uint32_t>&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsUint32ArrayAllowShared() const {
  return content_type_ == ContentType::kUint32ArrayAllowShared;
}
MaybeShared<DOMUint32Array> GetAsUint32ArrayAllowShared() const {
  DCHECK_EQ(content_type_, ContentType::kUint32ArrayAllowShared);
return member_uint32_array_allow_shared_;
}
void Set(MaybeShared<DOMUint32Array> value) {
  DCHECK(value);
Clear();
member_uint32_array_allow_shared_ = value;
content_type_ = ContentType::kUint32ArrayAllowShared;
}

bool IsUnsignedLongSequence() const {
  return content_type_ == ContentType::kUnsignedLongSequence;
}
const Vector<uint32_t>& GetAsUnsignedLongSequence() const {
  DCHECK_EQ(content_type_, ContentType::kUnsignedLongSequence);
return member_unsigned_long_sequence_;
}
void Set(const Vector<uint32_t>& value);
void Set(Vector<uint32_t>&& value);


void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "([AllowShared] Uint32Array or sequence<unsigned long>)";
}

ContentType content_type_;

MaybeShared<DOMUint32Array> member_uint32_array_allow_shared_;
Vector<uint32_t> member_unsigned_long_sequence_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_UINT_32_ARRAYALLOWSHARED_UNSIGNEDLONGSEQUENCE_H_
