// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_UNDEFINED_UNSIGNEDLONGLONGENFORCERANGE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_UNDEFINED_UNSIGNEDLONGLONGENFORCERANGE_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"

namespace blink {

class ExceptionState;
class ScriptState;

class CORE_EXPORT V8UnionUndefinedOrUnsignedLongLongEnforceRange final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kUndefined, kUnsignedLongLongEnforceRange, kV8GPUSize64 = kUnsignedLongLongEnforceRange
};

static V8UnionUndefinedOrUnsignedLongLongEnforceRange* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionUndefinedOrUnsignedLongLongEnforceRange(const ToV8UndefinedGenerator& value) : content_type_(ContentType::kUndefined), member_undefined_(value) {
  
}
explicit  V8UnionUndefinedOrUnsignedLongLongEnforceRange(uint64_t value) : content_type_(ContentType::kUnsignedLongLongEnforceRange), member_unsigned_long_long_enforce_range_(value) {
  
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsUndefined() const {
  return content_type_ == ContentType::kUndefined;
}
const ToV8UndefinedGenerator& GetAsUndefined() const {
  DCHECK_EQ(content_type_, ContentType::kUndefined);
return member_undefined_;
}
void Set(const ToV8UndefinedGenerator& value) {
  Clear();
member_undefined_ = value;
content_type_ = ContentType::kUndefined;
}

bool IsUnsignedLongLongEnforceRange() const {
  return content_type_ == ContentType::kUnsignedLongLongEnforceRange;
}
uint64_t GetAsUnsignedLongLongEnforceRange() const {
  DCHECK_EQ(content_type_, ContentType::kUnsignedLongLongEnforceRange);
return member_unsigned_long_long_enforce_range_;
}
void Set(uint64_t value) {
  Clear();
member_unsigned_long_long_enforce_range_ = value;
content_type_ = ContentType::kUnsignedLongLongEnforceRange;
}
bool IsV8GPUSize64() const {
  return content_type_ == ContentType::kV8GPUSize64;
}
uint64_t GetAsV8GPUSize64() const {
  DCHECK_EQ(content_type_, ContentType::kV8GPUSize64);
return member_unsigned_long_long_enforce_range_;
}


void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "([EnforceRange] unsigned long long or undefined)";
}

ContentType content_type_;

ToV8UndefinedGenerator member_undefined_;
uint64_t member_unsigned_long_long_enforce_range_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_UNDEFINED_UNSIGNEDLONGLONGENFORCERANGE_H_
