// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ad_auction_one_seller.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"coordinatorOrigin",
"seller",
};


}  // namespace 

AdAuctionOneSeller* AdAuctionOneSeller::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AdAuctionOneSeller* dictionary = MakeGarbageCollected<AdAuctionOneSeller>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AdAuctionOneSeller";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AdAuctionOneSeller::AdAuctionOneSeller() {
  
}

 AdAuctionOneSeller::AdAuctionOneSeller(v8::Isolate* isolate) {
  
}



String AdAuctionOneSeller::getCoordinatorOriginOr(const String& fallback_value) const {
  if (!hasCoordinatorOrigin()) {
  return fallback_value;
}
return member_coordinator_origin_;
}

String AdAuctionOneSeller::getCoordinatorOriginOr(String&& fallback_value) const {
  if (!hasCoordinatorOrigin()) {
  return std::move(fallback_value);
}
return member_coordinator_origin_;
}

void AdAuctionOneSeller::setCoordinatorOrigin(const String& value) {
  member_coordinator_origin_ = value;
has_coordinator_origin_ = true;
}

void AdAuctionOneSeller::setCoordinatorOrigin(String&& value) {
  member_coordinator_origin_ = std::move(value);
has_coordinator_origin_ = true;
}




void AdAuctionOneSeller::setSeller(const String& value) {
  member_seller_ = value;
}

void AdAuctionOneSeller::setSeller(String&& value) {
  member_seller_ = std::move(value);
}




void AdAuctionOneSeller::Trace(Visitor* visitor) const {
  bindings::InputDictionaryBase::Trace(visitor);
}

void AdAuctionOneSeller::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AdAuctionOneSeller";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("coordinatorOrigin");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_coordinator_origin_, member_coordinator_origin_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("seller");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_seller_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AdAuctionOneSeller::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
