// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ad_auction_per_seller_data.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"error",
"request",
"seller",
};


}  // namespace 

AdAuctionPerSellerData* AdAuctionPerSellerData::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AdAuctionPerSellerData* dictionary = MakeGarbageCollected<AdAuctionPerSellerData>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AdAuctionPerSellerData";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AdAuctionPerSellerData::AdAuctionPerSellerData() {
  
}

 AdAuctionPerSellerData::AdAuctionPerSellerData(v8::Isolate* isolate) {
  
}



String AdAuctionPerSellerData::getErrorOr(const String& fallback_value) const {
  if (!hasError()) {
  return fallback_value;
}
return member_error_;
}

String AdAuctionPerSellerData::getErrorOr(String&& fallback_value) const {
  if (!hasError()) {
  return std::move(fallback_value);
}
return member_error_;
}

void AdAuctionPerSellerData::setError(const String& value) {
  member_error_ = value;
has_error_ = true;
}

void AdAuctionPerSellerData::setError(String&& value) {
  member_error_ = std::move(value);
has_error_ = true;
}











void AdAuctionPerSellerData::setSeller(const String& value) {
  member_seller_ = value;
}

void AdAuctionPerSellerData::setSeller(String&& value) {
  member_seller_ = std::move(value);
}




void AdAuctionPerSellerData::Trace(Visitor* visitor) const {
  visitor->Trace(member_request_);
bindings::DictionaryBase::Trace(visitor);
}

void AdAuctionPerSellerData::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AdAuctionPerSellerData::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasError()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_error_);
DCHECK(!values[0].IsEmpty());
}
if (hasRequest()) {
  values[1] = ToV8Traits<NotShared<DOMUint8Array>>::ToV8(script_state, member_request_);
DCHECK(!values[1].IsEmpty());
}
if (hasSeller()) {
  values[2] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_seller_);
DCHECK(!values[2].IsEmpty());
}
}

const void* AdAuctionPerSellerData::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AdAuctionPerSellerData::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AdAuctionPerSellerData::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AdAuctionPerSellerData";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("error");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_error_, member_error_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("request");
if (!bindings::GetDictionaryMemberFromV8Object<NotShared<DOMUint8Array>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_request_, member_request_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("seller");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_seller_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AdAuctionPerSellerData::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
