// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ai_language_model_create_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ai_create_monitor_callback.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ai_language_model_initial_prompt.h"
#include "third_party/blink/renderer/core/dom/abort_signal.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"initialPrompts",
"monitor",
"signal",
"systemPrompt",
"temperature",
"topK",
};


}  // namespace 

AILanguageModelCreateOptions* AILanguageModelCreateOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AILanguageModelCreateOptions* dictionary = MakeGarbageCollected<AILanguageModelCreateOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AILanguageModelCreateOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AILanguageModelCreateOptions::AILanguageModelCreateOptions() {
  
}

 AILanguageModelCreateOptions::AILanguageModelCreateOptions(v8::Isolate* isolate) {
  
}



HeapVector<Member<AILanguageModelInitialPrompt>> AILanguageModelCreateOptions::getInitialPromptsOr(const HeapVector<Member<AILanguageModelInitialPrompt>>& fallback_value) const {
  if (!hasInitialPrompts()) {
  return fallback_value;
}
return member_initial_prompts_;
}

HeapVector<Member<AILanguageModelInitialPrompt>> AILanguageModelCreateOptions::getInitialPromptsOr(HeapVector<Member<AILanguageModelInitialPrompt>>&& fallback_value) const {
  if (!hasInitialPrompts()) {
  return std::move(fallback_value);
}
return member_initial_prompts_;
}

void AILanguageModelCreateOptions::setInitialPrompts(const HeapVector<Member<AILanguageModelInitialPrompt>>& value) {
  member_initial_prompts_ = value;
has_initial_prompts_ = true;
}

void AILanguageModelCreateOptions::setInitialPrompts(HeapVector<Member<AILanguageModelInitialPrompt>>&& value) {
  member_initial_prompts_ = std::move(value);
has_initial_prompts_ = true;
}


















String AILanguageModelCreateOptions::getSystemPromptOr(const String& fallback_value) const {
  if (!hasSystemPrompt()) {
  return fallback_value;
}
return member_system_prompt_;
}

String AILanguageModelCreateOptions::getSystemPromptOr(String&& fallback_value) const {
  if (!hasSystemPrompt()) {
  return std::move(fallback_value);
}
return member_system_prompt_;
}

void AILanguageModelCreateOptions::setSystemPrompt(const String& value) {
  member_system_prompt_ = value;
has_system_prompt_ = true;
}

void AILanguageModelCreateOptions::setSystemPrompt(String&& value) {
  member_system_prompt_ = std::move(value);
has_system_prompt_ = true;
}


















void AILanguageModelCreateOptions::Trace(Visitor* visitor) const {
  visitor->Trace(member_initial_prompts_);
visitor->Trace(member_monitor_);
visitor->Trace(member_signal_);
bindings::InputDictionaryBase::Trace(visitor);
}

void AILanguageModelCreateOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AILanguageModelCreateOptions";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("initialPrompts");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<AILanguageModelInitialPrompt>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_initial_prompts_, member_initial_prompts_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("monitor");
if (!bindings::GetDictionaryMemberFromV8Object<V8AICreateMonitorCallback, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_monitor_, member_monitor_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("signal");
if (!bindings::GetDictionaryMemberFromV8Object<AbortSignal, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_signal_, member_signal_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("systemPrompt");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_system_prompt_, member_system_prompt_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("temperature");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_temperature_, member_temperature_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("topK");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_top_k_, member_top_k_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AILanguageModelCreateOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
