// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_LANGUAGE_MODEL_CREATE_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_LANGUAGE_MODEL_CREATE_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class AILanguageModelInitialPrompt;
class AbortSignal;
class ExceptionState;
class V8AICreateMonitorCallback;

class MODULES_EXPORT AILanguageModelCreateOptions : public bindings::InputDictionaryBase {
  
  public:
static AILanguageModelCreateOptions* Create() {
  return MakeGarbageCollected<AILanguageModelCreateOptions>();
}
static AILanguageModelCreateOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<AILanguageModelCreateOptions>(isolate);
}
static AILanguageModelCreateOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  AILanguageModelCreateOptions();
explicit  AILanguageModelCreateOptions(v8::Isolate* isolate);

bool hasInitialPrompts() const {
  return has_initial_prompts_;
}
const HeapVector<Member<AILanguageModelInitialPrompt>>& initialPrompts() const {
  DCHECK(hasInitialPrompts());
return member_initial_prompts_;
}
HeapVector<Member<AILanguageModelInitialPrompt>> getInitialPromptsOr(const HeapVector<Member<AILanguageModelInitialPrompt>>& fallback_value) const;
HeapVector<Member<AILanguageModelInitialPrompt>> getInitialPromptsOr(HeapVector<Member<AILanguageModelInitialPrompt>>&& fallback_value) const;
void setInitialPrompts(const HeapVector<Member<AILanguageModelInitialPrompt>>& value);
void setInitialPrompts(HeapVector<Member<AILanguageModelInitialPrompt>>&& value);

bool hasMonitor() const {
  return has_monitor_;
}
V8AICreateMonitorCallback* monitor() const {
  DCHECK(hasMonitor());
return member_monitor_.Get();
}
V8AICreateMonitorCallback* getMonitorOr(V8AICreateMonitorCallback* fallback_value) const {
  if (!hasMonitor()) {
  return fallback_value;
}
return member_monitor_.Get();
}
void setMonitor(V8AICreateMonitorCallback* value) {
  member_monitor_ = value;
has_monitor_ = true;
DCHECK(member_monitor_);
}

bool hasSignal() const {
  return has_signal_;
}
AbortSignal* signal() const {
  DCHECK(hasSignal());
return member_signal_.Get();
}
AbortSignal* getSignalOr(AbortSignal* fallback_value) const {
  if (!hasSignal()) {
  return fallback_value;
}
return member_signal_.Get();
}
void setSignal(AbortSignal* value) {
  member_signal_ = value;
has_signal_ = true;
DCHECK(member_signal_);
}

bool hasSystemPrompt() const {
  return has_system_prompt_;
}
const String& systemPrompt() const {
  DCHECK(hasSystemPrompt());
return member_system_prompt_;
}
String getSystemPromptOr(const String& fallback_value) const;
String getSystemPromptOr(String&& fallback_value) const;
void setSystemPrompt(const String& value);
void setSystemPrompt(String&& value);

bool hasTemperature() const {
  return has_temperature_;
}
float temperature() const {
  DCHECK(hasTemperature());
return member_temperature_;
}
float getTemperatureOr(float fallback_value) const {
  if (!hasTemperature()) {
  return fallback_value;
}
return member_temperature_;
}
void setTemperature(float value) {
  member_temperature_ = value;
has_temperature_ = true;
}

bool hasTopK() const {
  return has_top_k_;
}
uint32_t topK() const {
  DCHECK(hasTopK());
return member_top_k_;
}
uint32_t getTopKOr(uint32_t fallback_value) const {
  if (!hasTopK()) {
  return fallback_value;
}
return member_top_k_;
}
void setTopK(uint32_t value) {
  member_top_k_ = value;
has_top_k_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 6;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_initial_prompts_ = false;
bool has_monitor_ = false;
bool has_signal_ = false;
bool has_system_prompt_ = false;
bool has_temperature_ = false;
bool has_top_k_ = false;

HeapVector<Member<AILanguageModelInitialPrompt>> member_initial_prompts_;
Member<V8AICreateMonitorCallback> member_monitor_;
Member<AbortSignal> member_signal_;
String member_system_prompt_;
float member_temperature_;
uint32_t member_top_k_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_LANGUAGE_MODEL_CREATE_OPTIONS_H_
