// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_request.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_request_provider.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"providers",
"requests",
};


}  // namespace 

DigitalCredentialRequestOptions* DigitalCredentialRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DigitalCredentialRequestOptions* dictionary = MakeGarbageCollected<DigitalCredentialRequestOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DigitalCredentialRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 DigitalCredentialRequestOptions::DigitalCredentialRequestOptions() {
  
}

 DigitalCredentialRequestOptions::DigitalCredentialRequestOptions(v8::Isolate* isolate) {
  
}



HeapVector<Member<IdentityRequestProvider>> DigitalCredentialRequestOptions::getProvidersOr(const HeapVector<Member<IdentityRequestProvider>>& fallback_value) const {
  if (!hasProviders()) {
  return fallback_value;
}
return member_providers_;
}

HeapVector<Member<IdentityRequestProvider>> DigitalCredentialRequestOptions::getProvidersOr(HeapVector<Member<IdentityRequestProvider>>&& fallback_value) const {
  if (!hasProviders()) {
  return std::move(fallback_value);
}
return member_providers_;
}

void DigitalCredentialRequestOptions::setProviders(const HeapVector<Member<IdentityRequestProvider>>& value) {
  member_providers_ = value;
has_providers_ = true;
}

void DigitalCredentialRequestOptions::setProviders(HeapVector<Member<IdentityRequestProvider>>&& value) {
  member_providers_ = std::move(value);
has_providers_ = true;
}




HeapVector<Member<DigitalCredentialRequest>> DigitalCredentialRequestOptions::getRequestsOr(const HeapVector<Member<DigitalCredentialRequest>>& fallback_value) const {
  if (!hasRequests()) {
  return fallback_value;
}
return member_requests_;
}

HeapVector<Member<DigitalCredentialRequest>> DigitalCredentialRequestOptions::getRequestsOr(HeapVector<Member<DigitalCredentialRequest>>&& fallback_value) const {
  if (!hasRequests()) {
  return std::move(fallback_value);
}
return member_requests_;
}

void DigitalCredentialRequestOptions::setRequests(const HeapVector<Member<DigitalCredentialRequest>>& value) {
  member_requests_ = value;
has_requests_ = true;
}

void DigitalCredentialRequestOptions::setRequests(HeapVector<Member<DigitalCredentialRequest>>&& value) {
  member_requests_ = std::move(value);
has_requests_ = true;
}




void DigitalCredentialRequestOptions::Trace(Visitor* visitor) const {
  visitor->Trace(member_providers_);
visitor->Trace(member_requests_);
bindings::InputDictionaryBase::Trace(visitor);
}

void DigitalCredentialRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "DigitalCredentialRequestOptions";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("providers");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IdentityRequestProvider>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_providers_, member_providers_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("requests");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<DigitalCredentialRequest>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_requests_, member_requests_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DigitalCredentialRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
