// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_REQUEST_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_REQUEST_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class DigitalCredentialRequest;
class ExceptionState;
class IdentityRequestProvider;

class MODULES_EXPORT DigitalCredentialRequestOptions : public bindings::InputDictionaryBase {
  
  public:
static DigitalCredentialRequestOptions* Create() {
  return MakeGarbageCollected<DigitalCredentialRequestOptions>();
}
static DigitalCredentialRequestOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DigitalCredentialRequestOptions>(isolate);
}
static DigitalCredentialRequestOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DigitalCredentialRequestOptions();
explicit  DigitalCredentialRequestOptions(v8::Isolate* isolate);

bool hasProviders() const {
  return has_providers_;
}
const HeapVector<Member<IdentityRequestProvider>>& providers() const {
  DCHECK(hasProviders());
return member_providers_;
}
HeapVector<Member<IdentityRequestProvider>> getProvidersOr(const HeapVector<Member<IdentityRequestProvider>>& fallback_value) const;
HeapVector<Member<IdentityRequestProvider>> getProvidersOr(HeapVector<Member<IdentityRequestProvider>>&& fallback_value) const;
void setProviders(const HeapVector<Member<IdentityRequestProvider>>& value);
void setProviders(HeapVector<Member<IdentityRequestProvider>>&& value);

bool hasRequests() const {
  return has_requests_;
}
const HeapVector<Member<DigitalCredentialRequest>>& requests() const {
  DCHECK(hasRequests());
return member_requests_;
}
HeapVector<Member<DigitalCredentialRequest>> getRequestsOr(const HeapVector<Member<DigitalCredentialRequest>>& fallback_value) const;
HeapVector<Member<DigitalCredentialRequest>> getRequestsOr(HeapVector<Member<DigitalCredentialRequest>>&& fallback_value) const;
void setRequests(const HeapVector<Member<DigitalCredentialRequest>>& value);
void setRequests(HeapVector<Member<DigitalCredentialRequest>>&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 2;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_providers_ = false;
bool has_requests_ = false;

HeapVector<Member<IdentityRequestProvider>> member_providers_;
HeapVector<Member<DigitalCredentialRequest>> member_requests_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_REQUEST_OPTIONS_H_
