// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_extendable_message_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_client_messageport_serviceworker.h"
#include "third_party/blink/renderer/core/messaging/message_port.h"
#include "third_party/blink/renderer/modules/service_worker/service_worker.h"
#include "third_party/blink/renderer/modules/service_worker/service_worker_client.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"data",
"lastEventId",
"origin",
"ports",
"source",
};


}  // namespace 

ExtendableMessageEventInit* ExtendableMessageEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ExtendableMessageEventInit* dictionary = MakeGarbageCollected<ExtendableMessageEventInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ExtendableMessageEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 ExtendableMessageEventInit::ExtendableMessageEventInit() {
  
}

 ExtendableMessageEventInit::ExtendableMessageEventInit(v8::Isolate* isolate) : ExtendableEventInit(isolate) {
  
}










String ExtendableMessageEventInit::getLastEventIdOr(const String& fallback_value) const {
  if (!hasLastEventId()) {
  return fallback_value;
}
return member_last_event_id_;
}

String ExtendableMessageEventInit::getLastEventIdOr(String&& fallback_value) const {
  if (!hasLastEventId()) {
  return std::move(fallback_value);
}
return member_last_event_id_;
}

void ExtendableMessageEventInit::setLastEventId(const String& value) {
  member_last_event_id_ = value;
has_last_event_id_ = true;
}

void ExtendableMessageEventInit::setLastEventId(String&& value) {
  member_last_event_id_ = std::move(value);
has_last_event_id_ = true;
}




String ExtendableMessageEventInit::getOriginOr(const String& fallback_value) const {
  if (!hasOrigin()) {
  return fallback_value;
}
return member_origin_;
}

String ExtendableMessageEventInit::getOriginOr(String&& fallback_value) const {
  if (!hasOrigin()) {
  return std::move(fallback_value);
}
return member_origin_;
}

void ExtendableMessageEventInit::setOrigin(const String& value) {
  member_origin_ = value;
has_origin_ = true;
}

void ExtendableMessageEventInit::setOrigin(String&& value) {
  member_origin_ = std::move(value);
has_origin_ = true;
}




HeapVector<Member<MessagePort>> ExtendableMessageEventInit::getPortsOr(const HeapVector<Member<MessagePort>>& fallback_value) const {
  if (!hasPorts()) {
  return fallback_value;
}
return member_ports_;
}

HeapVector<Member<MessagePort>> ExtendableMessageEventInit::getPortsOr(HeapVector<Member<MessagePort>>&& fallback_value) const {
  if (!hasPorts()) {
  return std::move(fallback_value);
}
return member_ports_;
}

void ExtendableMessageEventInit::setPorts(const HeapVector<Member<MessagePort>>& value) {
  member_ports_ = value;
has_ports_ = true;
}

void ExtendableMessageEventInit::setPorts(HeapVector<Member<MessagePort>>&& value) {
  member_ports_ = std::move(value);
has_ports_ = true;
}











void ExtendableMessageEventInit::Trace(Visitor* visitor) const {
  visitor->Trace(member_data_);
visitor->Trace(member_ports_);
visitor->Trace(member_source_);
ExtendableEventInit::Trace(visitor);
}

void ExtendableMessageEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
ExtendableEventInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "ExtendableMessageEventInit";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("data");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLAny, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_data_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("lastEventId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_last_event_id_, member_last_event_id_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("origin");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_origin_, member_origin_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("ports");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MessagePort>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_ports_, member_ports_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("source");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8UnionClientOrMessagePortOrServiceWorker>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_source_, member_source_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ExtendableMessageEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
