// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_FILE_SYSTEM_HANDLE_PERMISSION_DESCRIPTOR_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_FILE_SYSTEM_HANDLE_PERMISSION_DESCRIPTOR_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_file_system_permission_mode.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT FileSystemHandlePermissionDescriptor : public bindings::InputDictionaryBase {
  
  public:
static FileSystemHandlePermissionDescriptor* Create() {
  return MakeGarbageCollected<FileSystemHandlePermissionDescriptor>();
}
static FileSystemHandlePermissionDescriptor* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<FileSystemHandlePermissionDescriptor>(isolate);
}
static FileSystemHandlePermissionDescriptor* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  FileSystemHandlePermissionDescriptor();
explicit  FileSystemHandlePermissionDescriptor(v8::Isolate* isolate);

bool hasMode() const {
  return true;
}
V8FileSystemPermissionMode mode() const {
  return member_mode_;
}
void setMode(V8FileSystemPermissionMode value) {
  member_mode_ = value;
}
void setMode(V8FileSystemPermissionMode::Enum value) {
  member_mode_ = V8FileSystemPermissionMode(value);
}


// Obsolete accessor functions
void setMode(const String& value) {
  member_mode_ = V8FileSystemPermissionMode::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 1;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



V8FileSystemPermissionMode member_mode_{V8FileSystemPermissionMode::Enum::kRead};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_FILE_SYSTEM_HANDLE_PERMISSION_DESCRIPTOR_H_
