// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_file_system_observer_callback.h"

#include <tuple>

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/callback_invoke_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_file_system_change_record.h"
#include "third_party/blink/renderer/modules/file_system_access/file_system_observer.h"

namespace blink {





const char* V8FileSystemObserverCallback::NameInHeapSnapshot() const {
  return "V8FileSystemObserverCallback";
}

v8::Maybe<void> V8FileSystemObserverCallback::Invoke(bindings::V8ValueOrScriptWrappableAdapter arg0_receiver, const HeapVector<Member<FileSystemChangeRecord>>& arg1_records, FileSystemObserver* arg2_observer) {
  const char* const class_like_name = "FileSystemObserverCallback";
const char* const property_name = "invoke";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<void>();
}

if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::Isolate* isolate = GetIsolate();
v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
V8ThrowException::ThrowError(isolate,"The provided callback is no longer runnable.");
return v8::Nothing<void>();
}

bindings::CallbackInvokeHelper<CallbackFunctionBase, bindings::CallbackInvokeHelperMode::kDefault, bindings::CallbackReturnTypeIsPromise::kNo> helper(
    this, class_like_name, property_name);
if (!helper.PrepareForCall(arg0_receiver)) [[unlikely]] {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}
v8::Local<v8::Value> argv_arr[2];
base::span<v8::Local<v8::Value>> argv(argv_arr);
v8::Local<v8::Value> v8_arg1_records;
ScriptState* script_state = CallbackRelevantScriptState();
v8_arg1_records = ToV8Traits<IDLSequence<FileSystemChangeRecord>>::ToV8(script_state, arg1_records);
argv[0] = v8_arg1_records;
v8::Local<v8::Value> v8_arg2_observer;
v8_arg2_observer = ToV8Traits<FileSystemObserver>::ToV8(script_state, arg2_observer);
argv[1] = v8_arg2_observer;
if (!helper.Call(static_cast<int>(argv.size()), argv.data())) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}

v8::Maybe<void> V8FileSystemObserverCallback::Construct(const HeapVector<Member<FileSystemChangeRecord>>& arg1_records, FileSystemObserver* arg2_observer) {
  const char* const class_like_name = "FileSystemObserverCallback";
const char* const property_name = "construct";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<void>();
}

if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::Isolate* isolate = GetIsolate();
v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
V8ThrowException::ThrowError(isolate,"The provided callback is no longer runnable.");
return v8::Nothing<void>();
}

bindings::CallbackInvokeHelper<CallbackFunctionBase, bindings::CallbackInvokeHelperMode::kConstructorCall, bindings::CallbackReturnTypeIsPromise::kNo> helper(
    this, class_like_name, property_name);
if (!helper.PrepareForCall(nullptr)) [[unlikely]] {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}
v8::Local<v8::Value> argv_arr[2];
base::span<v8::Local<v8::Value>> argv(argv_arr);
v8::Local<v8::Value> v8_arg1_records;
ScriptState* script_state = CallbackRelevantScriptState();
v8_arg1_records = ToV8Traits<IDLSequence<FileSystemChangeRecord>>::ToV8(script_state, arg1_records);
argv[0] = v8_arg1_records;
v8::Local<v8::Value> v8_arg2_observer;
v8_arg2_observer = ToV8Traits<FileSystemObserver>::ToV8(script_state, arg2_observer);
argv[1] = v8_arg2_observer;
if (!helper.Call(static_cast<int>(argv.size()), argv.data())) {
  return v8::Nothing<void>();
}
return v8::JustVoid();
}

void V8FileSystemObserverCallback::InvokeAndReportException(bindings::V8ValueOrScriptWrappableAdapter arg0_receiver, const HeapVector<Member<FileSystemChangeRecord>>& arg1_records, FileSystemObserver* arg2_observer) {
  v8::Isolate* isolate = GetIsolate();
v8::TryCatch try_catch(isolate);
try_catch.SetVerbose(true);

std::ignore = Invoke(arg0_receiver, arg1_records, arg2_observer);
}



}  // namespace blink
