// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IMAGE_RESOURCE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IMAGE_RESOURCE_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT ManifestImageResource : public bindings::InputDictionaryBase {
  
  public:
static ManifestImageResource* Create() {
  return MakeGarbageCollected<ManifestImageResource>();
}
static ManifestImageResource* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<ManifestImageResource>(isolate);
}
static ManifestImageResource* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  ManifestImageResource();
explicit  ManifestImageResource(v8::Isolate* isolate);

bool hasPlatform() const {
  return has_platform_;
}
const String& platform() const {
  DCHECK(hasPlatform());
return member_platform_;
}
String getPlatformOr(const String& fallback_value) const;
String getPlatformOr(String&& fallback_value) const;
void setPlatform(const String& value);
void setPlatform(String&& value);

bool hasPurpose() const {
  return has_purpose_;
}
const String& purpose() const {
  DCHECK(hasPurpose());
return member_purpose_;
}
String getPurposeOr(const String& fallback_value) const;
String getPurposeOr(String&& fallback_value) const;
void setPurpose(const String& value);
void setPurpose(String&& value);

bool hasSizes() const {
  return has_sizes_;
}
const String& sizes() const {
  DCHECK(hasSizes());
return member_sizes_;
}
String getSizesOr(const String& fallback_value) const;
String getSizesOr(String&& fallback_value) const;
void setSizes(const String& value);
void setSizes(String&& value);

bool hasSrc() const {
  return true;
}
const String& src() const {
  return member_src_;
}
void setSrc(const String& value);
void setSrc(String&& value);

bool hasType() const {
  return has_type_;
}
const String& type() const {
  DCHECK(hasType());
return member_type_;
}
String getTypeOr(const String& fallback_value) const;
String getTypeOr(String&& fallback_value) const;
void setType(const String& value);
void setType(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 5;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_platform_ = false;
bool has_purpose_ = false;
bool has_sizes_ = false;
bool has_type_ = false;

String member_platform_;
String member_purpose_;
String member_sizes_;
String member_src_;
String member_type_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IMAGE_RESOURCE_H_
