// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_LSTM_CELL_SUPPORT_LIMITS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_LSTM_CELL_SUPPORT_LIMITS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class MLDataTypeLimits;

class MODULES_EXPORT MLLstmCellSupportLimits : public bindings::DictionaryBase {
  
  public:
static MLLstmCellSupportLimits* Create() {
  return MakeGarbageCollected<MLLstmCellSupportLimits>();
}
static MLLstmCellSupportLimits* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLLstmCellSupportLimits>(isolate);
}
static MLLstmCellSupportLimits* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLLstmCellSupportLimits();
explicit  MLLstmCellSupportLimits(v8::Isolate* isolate);

bool hasBias() const {
  return has_bias_;
}
MLDataTypeLimits* bias() const {
  DCHECK(hasBias());
return member_bias_.Get();
}
MLDataTypeLimits* getBiasOr(MLDataTypeLimits* fallback_value) const {
  if (!hasBias()) {
  return fallback_value;
}
return member_bias_.Get();
}
void setBias(MLDataTypeLimits* value) {
  member_bias_ = value;
has_bias_ = true;
DCHECK(member_bias_);
}

bool hasCellState() const {
  return has_cell_state_;
}
MLDataTypeLimits* cellState() const {
  DCHECK(hasCellState());
return member_cell_state_.Get();
}
MLDataTypeLimits* getCellStateOr(MLDataTypeLimits* fallback_value) const {
  if (!hasCellState()) {
  return fallback_value;
}
return member_cell_state_.Get();
}
void setCellState(MLDataTypeLimits* value) {
  member_cell_state_ = value;
has_cell_state_ = true;
DCHECK(member_cell_state_);
}

bool hasHiddenState() const {
  return has_hidden_state_;
}
MLDataTypeLimits* hiddenState() const {
  DCHECK(hasHiddenState());
return member_hidden_state_.Get();
}
MLDataTypeLimits* getHiddenStateOr(MLDataTypeLimits* fallback_value) const {
  if (!hasHiddenState()) {
  return fallback_value;
}
return member_hidden_state_.Get();
}
void setHiddenState(MLDataTypeLimits* value) {
  member_hidden_state_ = value;
has_hidden_state_ = true;
DCHECK(member_hidden_state_);
}

bool hasInput() const {
  return has_input_;
}
MLDataTypeLimits* input() const {
  DCHECK(hasInput());
return member_input_.Get();
}
MLDataTypeLimits* getInputOr(MLDataTypeLimits* fallback_value) const {
  if (!hasInput()) {
  return fallback_value;
}
return member_input_.Get();
}
void setInput(MLDataTypeLimits* value) {
  member_input_ = value;
has_input_ = true;
DCHECK(member_input_);
}

bool hasOutputs() const {
  return has_outputs_;
}
MLDataTypeLimits* outputs() const {
  DCHECK(hasOutputs());
return member_outputs_.Get();
}
MLDataTypeLimits* getOutputsOr(MLDataTypeLimits* fallback_value) const {
  if (!hasOutputs()) {
  return fallback_value;
}
return member_outputs_.Get();
}
void setOutputs(MLDataTypeLimits* value) {
  member_outputs_ = value;
has_outputs_ = true;
DCHECK(member_outputs_);
}

bool hasPeepholeWeight() const {
  return has_peephole_weight_;
}
MLDataTypeLimits* peepholeWeight() const {
  DCHECK(hasPeepholeWeight());
return member_peephole_weight_.Get();
}
MLDataTypeLimits* getPeepholeWeightOr(MLDataTypeLimits* fallback_value) const {
  if (!hasPeepholeWeight()) {
  return fallback_value;
}
return member_peephole_weight_.Get();
}
void setPeepholeWeight(MLDataTypeLimits* value) {
  member_peephole_weight_ = value;
has_peephole_weight_ = true;
DCHECK(member_peephole_weight_);
}

bool hasRecurrentBias() const {
  return has_recurrent_bias_;
}
MLDataTypeLimits* recurrentBias() const {
  DCHECK(hasRecurrentBias());
return member_recurrent_bias_.Get();
}
MLDataTypeLimits* getRecurrentBiasOr(MLDataTypeLimits* fallback_value) const {
  if (!hasRecurrentBias()) {
  return fallback_value;
}
return member_recurrent_bias_.Get();
}
void setRecurrentBias(MLDataTypeLimits* value) {
  member_recurrent_bias_ = value;
has_recurrent_bias_ = true;
DCHECK(member_recurrent_bias_);
}

bool hasRecurrentWeight() const {
  return has_recurrent_weight_;
}
MLDataTypeLimits* recurrentWeight() const {
  DCHECK(hasRecurrentWeight());
return member_recurrent_weight_.Get();
}
MLDataTypeLimits* getRecurrentWeightOr(MLDataTypeLimits* fallback_value) const {
  if (!hasRecurrentWeight()) {
  return fallback_value;
}
return member_recurrent_weight_.Get();
}
void setRecurrentWeight(MLDataTypeLimits* value) {
  member_recurrent_weight_ = value;
has_recurrent_weight_ = true;
DCHECK(member_recurrent_weight_);
}

bool hasWeight() const {
  return has_weight_;
}
MLDataTypeLimits* weight() const {
  DCHECK(hasWeight());
return member_weight_.Get();
}
MLDataTypeLimits* getWeightOr(MLDataTypeLimits* fallback_value) const {
  if (!hasWeight()) {
  return fallback_value;
}
return member_weight_.Get();
}
void setWeight(MLDataTypeLimits* value) {
  member_weight_ = value;
has_weight_ = true;
DCHECK(member_weight_);
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 9;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_bias_ = false;
bool has_cell_state_ = false;
bool has_hidden_state_ = false;
bool has_input_ = false;
bool has_outputs_ = false;
bool has_peephole_weight_ = false;
bool has_recurrent_bias_ = false;
bool has_recurrent_weight_ = false;
bool has_weight_ = false;

Member<MLDataTypeLimits> member_bias_;
Member<MLDataTypeLimits> member_cell_state_;
Member<MLDataTypeLimits> member_hidden_state_;
Member<MLDataTypeLimits> member_input_;
Member<MLDataTypeLimits> member_outputs_;
Member<MLDataTypeLimits> member_peephole_weight_;
Member<MLDataTypeLimits> member_recurrent_bias_;
Member<MLDataTypeLimits> member_recurrent_weight_;
Member<MLDataTypeLimits> member_weight_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_LSTM_CELL_SUPPORT_LIMITS_H_
