// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRESENTATION_SOURCE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRESENTATION_SOURCE_H_

#include <optional>

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_audio_playback_destination.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_capture_latency.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_presentation_source_type.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT PresentationSource : public bindings::InputDictionaryBase {
  
  public:
static PresentationSource* Create() {
  return MakeGarbageCollected<PresentationSource>();
}
static PresentationSource* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<PresentationSource>(isolate);
}
static PresentationSource* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  PresentationSource();
explicit  PresentationSource(v8::Isolate* isolate);

bool hasAudioPlayback() const {
  return has_audio_playback_;
}
const std::optional<V8AudioPlaybackDestination>& audioPlayback() const {
  DCHECK(hasAudioPlayback());
return member_audio_playback_;
}
std::optional<V8AudioPlaybackDestination> getAudioPlaybackOr(const std::optional<V8AudioPlaybackDestination>& fallback_value) const {
  if (!hasAudioPlayback()) {
  return fallback_value;
}
return member_audio_playback_;
}
void setAudioPlayback(const std::optional<V8AudioPlaybackDestination>& value) {
  member_audio_playback_ = value;
has_audio_playback_ = true;
}
void setAudioPlayback(V8AudioPlaybackDestination value) {
  member_audio_playback_ = value;
has_audio_playback_ = true;
}
void setAudioPlayback(V8AudioPlaybackDestination::Enum value) {
  member_audio_playback_ = V8AudioPlaybackDestination(value);
has_audio_playback_ = true;
}

bool hasLatencyHint() const {
  return has_latency_hint_;
}
const std::optional<V8CaptureLatency>& latencyHint() const {
  DCHECK(hasLatencyHint());
return member_latency_hint_;
}
std::optional<V8CaptureLatency> getLatencyHintOr(const std::optional<V8CaptureLatency>& fallback_value) const {
  if (!hasLatencyHint()) {
  return fallback_value;
}
return member_latency_hint_;
}
void setLatencyHint(const std::optional<V8CaptureLatency>& value) {
  member_latency_hint_ = value;
has_latency_hint_ = true;
}
void setLatencyHint(V8CaptureLatency value) {
  member_latency_hint_ = value;
has_latency_hint_ = true;
}
void setLatencyHint(V8CaptureLatency::Enum value) {
  member_latency_hint_ = V8CaptureLatency(value);
has_latency_hint_ = true;
}

bool hasType() const {
  return true;
}
V8PresentationSourceType type() const {
  return member_type_;
}
void setType(V8PresentationSourceType value) {
  member_type_ = value;
}
void setType(V8PresentationSourceType::Enum value) {
  member_type_ = V8PresentationSourceType(value);
}

bool hasUrl() const {
  return has_url_;
}
const String& url() const {
  DCHECK(hasUrl());
return member_url_;
}
String getUrlOr(const String& fallback_value) const;
String getUrlOr(String&& fallback_value) const;
void setUrl(const String& value);
void setUrl(String&& value);


// Obsolete accessor functions
void setAudioPlayback(const String& value) {
  member_audio_playback_ = V8AudioPlaybackDestination::Create(value).value();
has_audio_playback_ = true;
}
bool hasAudioPlaybackNonNull() const {
  return hasAudioPlayback() && audioPlayback().has_value();
}
V8AudioPlaybackDestination audioPlaybackNonNull() const {
  DCHECK(hasAudioPlaybackNonNull());
return audioPlayback().value();
}
void setLatencyHint(const String& value) {
  member_latency_hint_ = V8CaptureLatency::Create(value).value();
has_latency_hint_ = true;
}
bool hasLatencyHintNonNull() const {
  return hasLatencyHint() && latencyHint().has_value();
}
V8CaptureLatency latencyHintNonNull() const {
  DCHECK(hasLatencyHintNonNull());
return latencyHint().value();
}
void setType(const String& value) {
  member_type_ = V8PresentationSourceType::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 4;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_audio_playback_ = false;
bool has_latency_hint_ = false;
bool has_url_ = false;

std::optional<V8AudioPlaybackDestination> member_audio_playback_;
std::optional<V8CaptureLatency> member_latency_hint_;
V8PresentationSourceType member_type_{static_cast<V8PresentationSourceType::Enum>(0)};
String member_url_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRESENTATION_SOURCE_H_
