// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_ACK_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_ACK_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT RTCRtpAck : public bindings::DictionaryBase {
  
  public:
static RTCRtpAck* Create() {
  return MakeGarbageCollected<RTCRtpAck>();
}
static RTCRtpAck* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<RTCRtpAck>(isolate);
}
static RTCRtpAck* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  RTCRtpAck();
explicit  RTCRtpAck(v8::Isolate* isolate);

bool hasAckId() const {
  return has_ack_id_;
}
uint64_t ackId() const {
  DCHECK(hasAckId());
return member_ack_id_;
}
uint64_t getAckIdOr(uint64_t fallback_value) const {
  if (!hasAckId()) {
  return fallback_value;
}
return member_ack_id_;
}
void setAckId(uint64_t value) {
  member_ack_id_ = value;
has_ack_id_ = true;
}

bool hasRemoteReceiveTimestamp() const {
  return has_remote_receive_timestamp_;
}
uint64_t remoteReceiveTimestamp() const {
  DCHECK(hasRemoteReceiveTimestamp());
return member_remote_receive_timestamp_;
}
uint64_t getRemoteReceiveTimestampOr(uint64_t fallback_value) const {
  if (!hasRemoteReceiveTimestamp()) {
  return fallback_value;
}
return member_remote_receive_timestamp_;
}
void setRemoteReceiveTimestamp(uint64_t value) {
  member_remote_receive_timestamp_ = value;
has_remote_receive_timestamp_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 2;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_ack_id_ = false;
bool has_remote_receive_timestamp_ = false;

uint64_t member_ack_id_;
uint64_t member_remote_receive_timestamp_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_ACK_H_
