// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_usb_device_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_usb_device_filter.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"exclusionFilters",
"filters",
};


}  // namespace 

USBDeviceRequestOptions* USBDeviceRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  USBDeviceRequestOptions* dictionary = MakeGarbageCollected<USBDeviceRequestOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "USBDeviceRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 USBDeviceRequestOptions::USBDeviceRequestOptions() {
  
}

 USBDeviceRequestOptions::USBDeviceRequestOptions(v8::Isolate* isolate) {
  
}



void USBDeviceRequestOptions::setExclusionFilters(const HeapVector<Member<USBDeviceFilter>>& value) {
  member_exclusion_filters_ = value;
}

void USBDeviceRequestOptions::setExclusionFilters(HeapVector<Member<USBDeviceFilter>>&& value) {
  member_exclusion_filters_ = std::move(value);
}




void USBDeviceRequestOptions::setFilters(const HeapVector<Member<USBDeviceFilter>>& value) {
  member_filters_ = value;
}

void USBDeviceRequestOptions::setFilters(HeapVector<Member<USBDeviceFilter>>&& value) {
  member_filters_ = std::move(value);
}




void USBDeviceRequestOptions::Trace(Visitor* visitor) const {
  visitor->Trace(member_exclusion_filters_);
visitor->Trace(member_filters_);
bindings::InputDictionaryBase::Trace(visitor);
}

void USBDeviceRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "USBDeviceRequestOptions";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("exclusionFilters");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<USBDeviceFilter>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_exclusion_filters_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("filters");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<USBDeviceFilter>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_filters_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> USBDeviceRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
