// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_video_color_space_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"fullRange",
"matrix",
"primaries",
"transfer",
};


}  // namespace 

VideoColorSpaceInit* VideoColorSpaceInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  VideoColorSpaceInit* dictionary = MakeGarbageCollected<VideoColorSpaceInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "VideoColorSpaceInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 VideoColorSpaceInit::VideoColorSpaceInit() {
  
}

 VideoColorSpaceInit::VideoColorSpaceInit(v8::Isolate* isolate) {
  
}























void VideoColorSpaceInit::Trace(Visitor* visitor) const {
  bindings::DictionaryBase::Trace(visitor);
}

void VideoColorSpaceInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void VideoColorSpaceInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasFullRange()) {
  values[0] = ToV8Traits<IDLNullable<IDLBoolean>>::ToV8(script_state, member_full_range_);
DCHECK(!values[0].IsEmpty());
}
if (hasMatrix()) {
  values[1] = ToV8Traits<IDLNullable<V8VideoMatrixCoefficients>>::ToV8(script_state, member_matrix_);
DCHECK(!values[1].IsEmpty());
}
if (hasPrimaries()) {
  values[2] = ToV8Traits<IDLNullable<V8VideoColorPrimaries>>::ToV8(script_state, member_primaries_);
DCHECK(!values[2].IsEmpty());
}
if (hasTransfer()) {
  values[3] = ToV8Traits<IDLNullable<V8VideoTransferCharacteristics>>::ToV8(script_state, member_transfer_);
DCHECK(!values[3].IsEmpty());
}
}

const void* VideoColorSpaceInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> VideoColorSpaceInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void VideoColorSpaceInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "VideoColorSpaceInit";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("fullRange");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLBoolean>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_full_range_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("matrix");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8VideoMatrixCoefficients>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_matrix_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("primaries");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8VideoColorPrimaries>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_primaries_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("transfer");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8VideoTransferCharacteristics>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_transfer_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> VideoColorSpaceInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
