// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_transport_connection_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_web_transport_datagram_stats.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"datagrams",
"estimatedSendRate",
"minRtt",
"rttVariation",
"smoothedRtt",
};


}  // namespace 

WebTransportConnectionStats* WebTransportConnectionStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebTransportConnectionStats* dictionary = MakeGarbageCollected<WebTransportConnectionStats>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebTransportConnectionStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 WebTransportConnectionStats::WebTransportConnectionStats() {
  
}

 WebTransportConnectionStats::WebTransportConnectionStats(v8::Isolate* isolate) {
  
}






































void WebTransportConnectionStats::Trace(Visitor* visitor) const {
  visitor->Trace(member_datagrams_);
bindings::DictionaryBase::Trace(visitor);
}

void WebTransportConnectionStats::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void WebTransportConnectionStats::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasDatagrams()) {
  values[0] = ToV8Traits<WebTransportDatagramStats>::ToV8(script_state, member_datagrams_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasEstimatedSendRate()) {
  values[1] = ToV8Traits<IDLNullable<IDLUnsignedLongLong>>::ToV8(script_state, member_estimated_send_rate_);
DCHECK(!values[1].IsEmpty());
}
if (hasMinRtt()) {
  values[2] = ToV8Traits<IDLDouble>::ToV8(script_state, member_min_rtt_);
DCHECK(!values[2].IsEmpty());
}
if (hasRttVariation()) {
  values[3] = ToV8Traits<IDLDouble>::ToV8(script_state, member_rtt_variation_);
DCHECK(!values[3].IsEmpty());
}
if (hasSmoothedRtt()) {
  values[4] = ToV8Traits<IDLDouble>::ToV8(script_state, member_smoothed_rtt_);
DCHECK(!values[4].IsEmpty());
}
}

const void* WebTransportConnectionStats::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> WebTransportConnectionStats::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void WebTransportConnectionStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "WebTransportConnectionStats";
DictionaryConversionContext dictionary_from_v8_context(isolate, class_like_name);
dictionary_from_v8_context.SetCurrentPropertyName("datagrams");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<WebTransportDatagramStats, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_datagrams_, member_datagrams_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("estimatedSendRate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLUnsignedLongLong>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_estimated_send_rate_, member_estimated_send_rate_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("minRtt");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_min_rtt_, member_min_rtt_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("rttVariation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_rtt_variation_, member_rtt_variation_, class_like_name, exception_state)) {
  return;
}
dictionary_from_v8_context.SetCurrentPropertyName("smoothedRtt");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_smoothed_rtt_, member_smoothed_rtt_, class_like_name, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebTransportConnectionStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
