// Copyright 2014 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/make_names.h.tmpl
// and input files:
//   ../../third_party/blink/renderer/platform/network/http_names.json5


#ifndef THIRD_PARTY_BLINK_RENDERER_PLATFORM_NETWORK_HTTP_NAMES_H_
#define THIRD_PARTY_BLINK_RENDERER_PLATFORM_NETWORK_HTTP_NAMES_H_

#include "third_party/blink/renderer/platform/wtf/text/atomic_string.h"
#include "third_party/blink/renderer/platform/platform_export.h"

namespace blink {
namespace http_names {

PLATFORM_EXPORT extern const WTF::AtomicString& kAccept;
PLATFORM_EXPORT extern const WTF::AtomicString& kAcceptCH;
PLATFORM_EXPORT extern const WTF::AtomicString& kAcceptLanguage;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlAllowCredentials;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlAllowExternal;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlAllowHeaders;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlAllowMethods;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlAllowOrigin;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlExposeHeaders;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlMaxAge;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlRequestExternal;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlRequestHeaders;
PLATFORM_EXPORT extern const WTF::AtomicString& kAccessControlRequestMethod;
PLATFORM_EXPORT extern const WTF::AtomicString& kAllowCSPFrom;
PLATFORM_EXPORT extern const WTF::AtomicString& kAttributionReportingInfo;
PLATFORM_EXPORT extern const WTF::AtomicString& kAttributionReportingRegisterOSSource;
PLATFORM_EXPORT extern const WTF::AtomicString& kAttributionReportingRegisterOSTrigger;
PLATFORM_EXPORT extern const WTF::AtomicString& kAttributionReportingRegisterSource;
PLATFORM_EXPORT extern const WTF::AtomicString& kAttributionReportingRegisterTrigger;
PLATFORM_EXPORT extern const WTF::AtomicString& kAuthorization;
PLATFORM_EXPORT extern const WTF::AtomicString& kCacheControl;
PLATFORM_EXPORT extern const WTF::AtomicString& kContentDPR;
PLATFORM_EXPORT extern const WTF::AtomicString& kContentDisposition;
PLATFORM_EXPORT extern const WTF::AtomicString& kContentEncoding;
PLATFORM_EXPORT extern const WTF::AtomicString& kContentLanguage;
PLATFORM_EXPORT extern const WTF::AtomicString& kContentSecurityPolicy;
PLATFORM_EXPORT extern const WTF::AtomicString& kContentSecurityPolicyReportOnly;
PLATFORM_EXPORT extern const WTF::AtomicString& kContentType;
PLATFORM_EXPORT extern const WTF::AtomicString& kDELETE;
PLATFORM_EXPORT extern const WTF::AtomicString& kDark;
PLATFORM_EXPORT extern const WTF::AtomicString& kDate;
PLATFORM_EXPORT extern const WTF::AtomicString& kDelegateCH;
PLATFORM_EXPORT extern const WTF::AtomicString& kDeviceMemory;
PLATFORM_EXPORT extern const WTF::AtomicString& kDeviceMemory_DEPRECATED;
PLATFORM_EXPORT extern const WTF::AtomicString& kDocumentPolicy;
PLATFORM_EXPORT extern const WTF::AtomicString& kDocumentPolicyReportOnly;
PLATFORM_EXPORT extern const WTF::AtomicString& kDownlink_DEPRECATED;
PLATFORM_EXPORT extern const WTF::AtomicString& kDpr;
PLATFORM_EXPORT extern const WTF::AtomicString& kDpr_DEPRECATED;
PLATFORM_EXPORT extern const WTF::AtomicString& kETag;
PLATFORM_EXPORT extern const WTF::AtomicString& kEct_DEPRECATED;
PLATFORM_EXPORT extern const WTF::AtomicString& kExpectCT;
PLATFORM_EXPORT extern const WTF::AtomicString& kExpires;
PLATFORM_EXPORT extern const WTF::AtomicString& kFeaturePolicy;
PLATFORM_EXPORT extern const WTF::AtomicString& kFeaturePolicyReportOnly;
PLATFORM_EXPORT extern const WTF::AtomicString& kGET;
PLATFORM_EXPORT extern const WTF::AtomicString& kHEAD;
PLATFORM_EXPORT extern const WTF::AtomicString& kIdentityDigest;
PLATFORM_EXPORT extern const WTF::AtomicString& kIfMatch;
PLATFORM_EXPORT extern const WTF::AtomicString& kIfModifiedSince;
PLATFORM_EXPORT extern const WTF::AtomicString& kIfNoneMatch;
PLATFORM_EXPORT extern const WTF::AtomicString& kIfRange;
PLATFORM_EXPORT extern const WTF::AtomicString& kIfUnmodifiedSince;
PLATFORM_EXPORT extern const WTF::AtomicString& kLastEventID;
PLATFORM_EXPORT extern const WTF::AtomicString& kLastModified;
PLATFORM_EXPORT extern const WTF::AtomicString& kLight;
PLATFORM_EXPORT extern const WTF::AtomicString& kLink;
PLATFORM_EXPORT extern const WTF::AtomicString& kLocation;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerAge;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerCacheControl;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerContentDisposition;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerContentLength;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerContentRange;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerContentType;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerCrossOriginEmbedderPolicy;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerDate;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerETag;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerExpires;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerLastModified;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerPragma;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerRange;
PLATFORM_EXPORT extern const WTF::AtomicString& kLowerSetCookie;
PLATFORM_EXPORT extern const WTF::AtomicString& kNoPreference;
PLATFORM_EXPORT extern const WTF::AtomicString& kNoVarySearch;
PLATFORM_EXPORT extern const WTF::AtomicString& kOPTIONS;
PLATFORM_EXPORT extern const WTF::AtomicString& kOn;
PLATFORM_EXPORT extern const WTF::AtomicString& kOrigin;
PLATFORM_EXPORT extern const WTF::AtomicString& kOriginAgentCluster;
PLATFORM_EXPORT extern const WTF::AtomicString& kOriginTrial;
PLATFORM_EXPORT extern const WTF::AtomicString& kPOST;
PLATFORM_EXPORT extern const WTF::AtomicString& kPUT;
PLATFORM_EXPORT extern const WTF::AtomicString& kPermissionsPolicy;
PLATFORM_EXPORT extern const WTF::AtomicString& kPermissionsPolicyReportOnly;
PLATFORM_EXPORT extern const WTF::AtomicString& kPingFrom;
PLATFORM_EXPORT extern const WTF::AtomicString& kPingTo;
PLATFORM_EXPORT extern const WTF::AtomicString& kPragma;
PLATFORM_EXPORT extern const WTF::AtomicString& kPrefersColorScheme;
PLATFORM_EXPORT extern const WTF::AtomicString& kPrefersReducedMotion;
PLATFORM_EXPORT extern const WTF::AtomicString& kPrefersReducedTransparency;
PLATFORM_EXPORT extern const WTF::AtomicString& kRange;
PLATFORM_EXPORT extern const WTF::AtomicString& kReduce;
PLATFORM_EXPORT extern const WTF::AtomicString& kReferer;
PLATFORM_EXPORT extern const WTF::AtomicString& kReferrerPolicy;
PLATFORM_EXPORT extern const WTF::AtomicString& kRefresh;
PLATFORM_EXPORT extern const WTF::AtomicString& kRequestOTR;
PLATFORM_EXPORT extern const WTF::AtomicString& kRequireDocumentPolicy;
PLATFORM_EXPORT extern const WTF::AtomicString& kResourceFreshness;
PLATFORM_EXPORT extern const WTF::AtomicString& kResourceWidth;
PLATFORM_EXPORT extern const WTF::AtomicString& kResourceWidth_DEPRECATED;
PLATFORM_EXPORT extern const WTF::AtomicString& kRtt_DEPRECATED;
PLATFORM_EXPORT extern const WTF::AtomicString& kSaveData;
PLATFORM_EXPORT extern const WTF::AtomicString& kSecPurpose;
PLATFORM_EXPORT extern const WTF::AtomicString& kSecSharedStorageWritable;
PLATFORM_EXPORT extern const WTF::AtomicString& kServerTiming;
PLATFORM_EXPORT extern const WTF::AtomicString& kSignature;
PLATFORM_EXPORT extern const WTF::AtomicString& kSignatureInput;
PLATFORM_EXPORT extern const WTF::AtomicString& kSourceMap;
PLATFORM_EXPORT extern const WTF::AtomicString& kSpeculationRules;
PLATFORM_EXPORT extern const WTF::AtomicString& kTimingAllowOrigin;
PLATFORM_EXPORT extern const WTF::AtomicString& kUA;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAArch;
PLATFORM_EXPORT extern const WTF::AtomicString& kUABitness;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAFormFactors;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAFullVersion;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAFullVersionList;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAMobile;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAModel;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAPlatform;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAPlatformVersion;
PLATFORM_EXPORT extern const WTF::AtomicString& kUAWoW64;
PLATFORM_EXPORT extern const WTF::AtomicString& kUnencodedDigest;
PLATFORM_EXPORT extern const WTF::AtomicString& kUpgradeInsecureRequests;
PLATFORM_EXPORT extern const WTF::AtomicString& kUserAgent;
PLATFORM_EXPORT extern const WTF::AtomicString& kVary;
PLATFORM_EXPORT extern const WTF::AtomicString& kViewportHeight;
PLATFORM_EXPORT extern const WTF::AtomicString& kViewportWidth;
PLATFORM_EXPORT extern const WTF::AtomicString& kViewportWidth_DEPRECATED;
PLATFORM_EXPORT extern const WTF::AtomicString& kXContentTypeOptions;
PLATFORM_EXPORT extern const WTF::AtomicString& kXDNSPrefetchControl;
PLATFORM_EXPORT extern const WTF::AtomicString& kXFrameOptions;
PLATFORM_EXPORT extern const WTF::AtomicString& kXSourceMap;
PLATFORM_EXPORT extern const WTF::AtomicString& kXXSSProtection;

constexpr unsigned kNamesCount = 132;

PLATFORM_EXPORT void Init();

}  // namespace http_names
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_PLATFORM_NETWORK_HTTP_NAMES_H_
