// ui/gfx/mojom/gpu_extra_info.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "ui/gfx/mojom/gpu_extra_info.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "ui/gfx/mojom/gpu_extra_info.mojom-params-data.h"
#include "ui/gfx/mojom/gpu_extra_info.mojom-shared-message-ids.h"

#include "ui/gfx/mojom/gpu_extra_info.mojom-import-headers.h"
#include "ui/gfx/mojom/gpu_extra_info.mojom-test-utils.h"


namespace gfx::mojom {
ANGLEFeature::ANGLEFeature()
    : name(),
      category(),
      status() {}

ANGLEFeature::ANGLEFeature(
    const std::string& name_in,
    const std::string& category_in,
    const std::string& status_in)
    : name(std::move(name_in)),
      category(std::move(category_in)),
      status(std::move(status_in)) {}

ANGLEFeature::~ANGLEFeature() = default;

void ANGLEFeature::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "name"), this->name,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "category"), this->category,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "status"), this->status,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ANGLEFeature::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
GpuExtraInfo::GpuExtraInfo()
    : angle_features(),
      gpu_memory_buffer_support_x11() {}

GpuExtraInfo::GpuExtraInfo(
    std::vector<::gfx::ANGLEFeature> angle_features_in,
    std::vector<::gfx::BufferUsageAndFormat> gpu_memory_buffer_support_x11_in)
    : angle_features(std::move(angle_features_in)),
      gpu_memory_buffer_support_x11(std::move(gpu_memory_buffer_support_x11_in)) {}

GpuExtraInfo::~GpuExtraInfo() = default;

void GpuExtraInfo::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "angle_features"), this->angle_features,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<::gfx::ANGLEFeature>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "gpu_memory_buffer_support_x11"), this->gpu_memory_buffer_support_x11,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<::gfx::BufferUsageAndFormat>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool GpuExtraInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}


}  // gfx::mojom


namespace mojo {


// static
bool StructTraits<::gfx::mojom::ANGLEFeature::DataView, ::gfx::mojom::ANGLEFeaturePtr>::Read(
    ::gfx::mojom::ANGLEFeature::DataView input,
    ::gfx::mojom::ANGLEFeaturePtr* output) {
  bool success = true;
  ::gfx::mojom::ANGLEFeaturePtr result(::gfx::mojom::ANGLEFeature::New());
  
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success && !input.ReadCategory(&result->category))
        success = false;
      if (success && !input.ReadStatus(&result->status))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::gfx::mojom::GpuExtraInfo::DataView, ::gfx::mojom::GpuExtraInfoPtr>::Read(
    ::gfx::mojom::GpuExtraInfo::DataView input,
    ::gfx::mojom::GpuExtraInfoPtr* output) {
  bool success = true;
  ::gfx::mojom::GpuExtraInfoPtr result(::gfx::mojom::GpuExtraInfo::New());
  
      if (success && !input.ReadAngleFeatures(&result->angle_features))
        success = false;
      if (success && !input.ReadGpuMemoryBufferSupportX11(&result->gpu_memory_buffer_support_x11))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace gfx::mojom {




}  // gfx::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif