// ui/ozone/platform/wayland/mojom/wayland_presentation_info.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_PRESENTATION_INFO_MOJOM_H_
#define UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_PRESENTATION_INFO_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/ozone/platform/wayland/mojom/wayland_presentation_info.mojom-features.h"  // IWYU pragma: export
#include "ui/ozone/platform/wayland/mojom/wayland_presentation_info.mojom-shared.h"  // IWYU pragma: export
#include "ui/ozone/platform/wayland/mojom/wayland_presentation_info.mojom-forward.h"  // IWYU pragma: export
#include "ui/gfx/mojom/presentation_feedback.mojom.h"
#include <string>
#include <vector>




#include "ui/ozone/platform/wayland/mojom/wayland_presentation_info_mojom_traits.h"




namespace wl::mojom {








class  WaylandPresentationInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WaylandPresentationInfo, T>::value>;
  using DataView = WaylandPresentationInfoDataView;
  using Data_ = internal::WaylandPresentationInfo_Data;

  template <typename... Args>
  static WaylandPresentationInfoPtr New(Args&&... args) {
    return WaylandPresentationInfoPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WaylandPresentationInfoPtr From(const U& u) {
    return mojo::TypeConverter<WaylandPresentationInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WaylandPresentationInfo>::Convert(*this);
  }


  WaylandPresentationInfo();

  WaylandPresentationInfo(
      uint32_t frame_id,
      const ::gfx::PresentationFeedback& feedback);


  ~WaylandPresentationInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WaylandPresentationInfoPtr>
  WaylandPresentationInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WaylandPresentationInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WaylandPresentationInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WaylandPresentationInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        WaylandPresentationInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WaylandPresentationInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WaylandPresentationInfo_UnserializedMessageContext<
            UserType, WaylandPresentationInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WaylandPresentationInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return WaylandPresentationInfo::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WaylandPresentationInfo_UnserializedMessageContext<
            UserType, WaylandPresentationInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WaylandPresentationInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t frame_id;
  
  ::gfx::PresentationFeedback feedback;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WaylandPresentationInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WaylandPresentationInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WaylandPresentationInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WaylandPresentationInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
WaylandPresentationInfoPtr WaylandPresentationInfo::Clone() const {
  return New(
      mojo::Clone(frame_id),
      mojo::Clone(feedback)
  );
}

template <typename T, WaylandPresentationInfo::EnableIfSame<T>*>
bool WaylandPresentationInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->frame_id, other_struct.frame_id))
    return false;
  if (!mojo::Equals(this->feedback, other_struct.feedback))
    return false;
  return true;
}

template <typename T, WaylandPresentationInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.frame_id < rhs.frame_id)
    return true;
  if (rhs.frame_id < lhs.frame_id)
    return false;
  if (lhs.feedback < rhs.feedback)
    return true;
  if (rhs.feedback < lhs.feedback)
    return false;
  return false;
}


}  // wl::mojom

namespace mojo {


template <>
struct  StructTraits<::wl::mojom::WaylandPresentationInfo::DataView,
                                         ::wl::mojom::WaylandPresentationInfoPtr> {
  static bool IsNull(const ::wl::mojom::WaylandPresentationInfoPtr& input) { return !input; }
  static void SetToNull(::wl::mojom::WaylandPresentationInfoPtr* output) { output->reset(); }

  static decltype(::wl::mojom::WaylandPresentationInfo::frame_id) frame_id(
      const ::wl::mojom::WaylandPresentationInfoPtr& input) {
    return input->frame_id;
  }

  static const decltype(::wl::mojom::WaylandPresentationInfo::feedback)& feedback(
      const ::wl::mojom::WaylandPresentationInfoPtr& input) {
    return input->feedback;
  }

  static bool Read(::wl::mojom::WaylandPresentationInfo::DataView input, ::wl::mojom::WaylandPresentationInfoPtr* output);
};

}  // namespace mojo

#endif  // UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_PRESENTATION_INFO_MOJOM_H_