// Copyright 2024 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/renderer/core/html/html_search_element.h"

#include "third_party/blink/renderer/core/dom/document.h"
#include "third_party/blink/renderer/core/frame/web_feature.h"
#include "third_party/blink/renderer/platform/instrumentation/use_counter.h"

namespace blink {

HTMLSearchElement::HTMLSearchElement(Document& document)
    : HTMLElement(html_names::kSearchTag, document) {
  UseCounter::Count(document, WebFeature::kHTMLSearchElement);
}

}  // namespace blink
