/*
 * Copyright (C) 2010 Google, Inc. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

// THIS FILE IS GENERATED BY build/scripts/make_html_entity_table.py.
// DO NOT EDIT (unless you are a ninja)!

#include "third_party/blink/renderer/core/html/parser/html_entity_table.h"

namespace blink {

namespace {

const LChar kStaticEntityStringStorage[] = {
'A', 'E', 'l', 'i', 'g',
';',
'A', 'M', 'P',
';',
'A', 'a', 'c', 'u', 't', 'e',
';',
'A', 'b', 'r', 'e', 'v', 'e', ';',
'A', 'c', 'i', 'r', 'c',
';',
'A', 'c', 'y', ';',
'A', 'f', 'r', ';',
'A', 'g', 'r', 'a', 'v', 'e',
';',
'A', 'l', 'p', 'h', 'a', ';',
'A', 'm', 'a', 'c', 'r', ';',
'A', 'n', 'd', ';',
'A', 'o', 'g', 'o', 'n', ';',
'A', 'o', 'p', 'f', ';',
'A', 'p', 'p', 'l', 'y', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', ';',
'A', 'r', 'i', 'n', 'g',
';',
'A', 's', 'c', 'r', ';',
'A', 's', 's', 'i', 'g', 'n', ';',
'A', 't', 'i', 'l', 'd', 'e',
';',
'A', 'u', 'm', 'l',
';',
'B', 'a', 'c', 'k', 's', 'l', 'a', 's', 'h', ';',
'B', 'a', 'r', 'v', ';',
'B', 'a', 'r', 'w', 'e', 'd', ';',
'B', 'c', 'y', ';',
'B', 'e', 'c', 'a', 'u', 's', 'e', ';',
'B', 'e', 'r', 'n', 'o', 'u', 'l', 'l', 'i', 's', ';',
'B', 'e', 't', 'a', ';',
'B', 'f', 'r', ';',
'B', 'o', 'p', 'f', ';',
'B', 'r', 'e', 'v', 'e', ';',
'B', 's', 'c', 'r', ';',
'B', 'u', 'm', 'p', 'e', 'q', ';',
'C', 'H', 'c', 'y', ';',
'C', 'O', 'P', 'Y',
';',
'C', 'a', 'c', 'u', 't', 'e', ';',
'C', 'a', 'p', ';',
'C', 'a', 'p', 'i', 't', 'a', 'l', 'D', 'i', 'f', 'f', 'e', 'r', 'e', 'n', 't', 'i', 'a', 'l', 'D', ';',
'C', 'a', 'y', 'l', 'e', 'y', 's', ';',
'C', 'c', 'a', 'r', 'o', 'n', ';',
'C', 'c', 'e', 'd', 'i', 'l',
';',
'C', 'c', 'i', 'r', 'c', ';',
'C', 'c', 'o', 'n', 'i', 'n', 't', ';',
'C', 'd', 'o', 't', ';',
'C', 'e', 'd', 'i', 'l', 'l', 'a', ';',
'C', 'e', 'n', 't', 'e', 'r', 'D', 'o', 't', ';',
'C', 'f', 'r', ';',
'C', 'h', 'i', ';',
'C', 'i', 'r', 'c', 'l', 'e', 'D', 'o', 't', ';',
'C', 'i', 'r', 'c', 'l', 'e', 'M', 'i', 'n', 'u', 's', ';',
'C', 'i', 'r', 'c', 'l', 'e', 'P', 'l', 'u', 's', ';',
'C', 'i', 'r', 'c', 'l', 'e', 'T', 'i', 'm', 'e', 's', ';',
'C', 'l', 'o', 'c', 'k', 'w', 'i', 's', 'e', 'C', 'o', 'n', 't', 'o', 'u', 'r', 'I', 'n', 't', 'e', 'g', 'r', 'a', 'l', ';',
'C', 'l', 'o', 's', 'e', 'C', 'u', 'r', 'l', 'y', 'D', 'o', 'u', 'b', 'l', 'e', 'Q', 'u', 'o', 't', 'e', ';',
'C', 'l', 'o', 's', 'e', 'C', 'u', 'r', 'l', 'y', 'Q', 'u', 'o', 't', 'e', ';',
'C', 'o', 'l', 'o', 'n', ';',
'C', 'o', 'l', 'o', 'n', 'e', ';',
'C', 'o', 'n', 'g', 'r', 'u', 'e', 'n', 't', ';',
'C', 'o', 'n', 'i', 'n', 't', ';',
'C', 'o', 'p', 'f', ';',
'C', 'o', 'p', 'r', 'o', 'd', 'u', 'c', 't', ';',
'C', 'o', 'u', 'n', 't', 'e', 'r', 'C', 'l', 'o', 'c', 'k', 'w', 'i', 's', 'e', 'C', 'o', 'n', 't', 'o', 'u', 'r', 'I', 'n', 't', 'e', 'g', 'r', 'a', 'l', ';',
'C', 'r', 'o', 's', 's', ';',
'C', 's', 'c', 'r', ';',
'C', 'u', 'p', ';',
'C', 'u', 'p', 'C', 'a', 'p', ';',
'D', 'D', ';',
'D', 'D', 'o', 't', 'r', 'a', 'h', 'd', ';',
'D', 'J', 'c', 'y', ';',
'D', 'S', 'c', 'y', ';',
'D', 'Z', 'c', 'y', ';',
'D', 'a', 'g', 'g', 'e', 'r', ';',
'D', 'a', 'r', 'r', ';',
'D', 'a', 's', 'h', 'v', ';',
'D', 'c', 'a', 'r', 'o', 'n', ';',
'D', 'c', 'y', ';',
'D', 'e', 'l', ';',
'D', 'e', 'l', 't', 'a', ';',
'D', 'f', 'r', ';',
'D', 'i', 'a', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'A', 'c', 'u', 't', 'e', ';',
'D', 'i', 'a', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'D', 'o', 't', ';',
'D', 'i', 'a', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'D', 'o', 'u', 'b', 'l', 'e', 'A', 'c', 'u', 't', 'e', ';',
'D', 'i', 'a', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'G', 'r', 'a', 'v', 'e', ';',
'D', 'i', 'a', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'T', 'i', 'l', 'd', 'e', ';',
'D', 'i', 'a', 'm', 'o', 'n', 'd', ';',
'D', 'o', 'p', 'f', ';',
'D', 'o', 't', 'D', 'o', 't', ';',
'D', 'o', 't', 'E', 'q', 'u', 'a', 'l', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'C', 'o', 'n', 't', 'o', 'u', 'r', 'I', 'n', 't', 'e', 'g', 'r', 'a', 'l', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'D', 'o', 't', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'D', 'o', 'w', 'n', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'L', 'e', 'f', 't', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'L', 'e', 'f', 't', 'T', 'e', 'e', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'L', 'o', 'n', 'g', 'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'L', 'o', 'n', 'g', 'L', 'e', 'f', 't', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'L', 'o', 'n', 'g', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'R', 'i', 'g', 'h', 't', 'T', 'e', 'e', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'U', 'p', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'U', 'p', 'D', 'o', 'w', 'n', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'u', 'b', 'l', 'e', 'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'B', 'a', 'r', ';',
'D', 'o', 'w', 'n', 'A', 'r', 'r', 'o', 'w', 'B', 'a', 'r', ';',
'D', 'o', 'w', 'n', 'A', 'r', 'r', 'o', 'w', 'U', 'p', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'w', 'n', 'B', 'r', 'e', 'v', 'e', ';',
'D', 'o', 'w', 'n', 'L', 'e', 'f', 't', 'R', 'i', 'g', 'h', 't', 'V', 'e', 'c', 't', 'o', 'r', ';',
'D', 'o', 'w', 'n', 'L', 'e', 'f', 't', 'T', 'e', 'e', 'V', 'e', 'c', 't', 'o', 'r', ';',
'D', 'o', 'w', 'n', 'L', 'e', 'f', 't', 'V', 'e', 'c', 't', 'o', 'r', ';',
'D', 'o', 'w', 'n', 'L', 'e', 'f', 't', 'V', 'e', 'c', 't', 'o', 'r', 'B', 'a', 'r', ';',
'D', 'o', 'w', 'n', 'R', 'i', 'g', 'h', 't', 'T', 'e', 'e', 'V', 'e', 'c', 't', 'o', 'r', ';',
'D', 'o', 'w', 'n', 'R', 'i', 'g', 'h', 't', 'V', 'e', 'c', 't', 'o', 'r', ';',
'D', 'o', 'w', 'n', 'R', 'i', 'g', 'h', 't', 'V', 'e', 'c', 't', 'o', 'r', 'B', 'a', 'r', ';',
'D', 'o', 'w', 'n', 'T', 'e', 'e', ';',
'D', 'o', 'w', 'n', 'T', 'e', 'e', 'A', 'r', 'r', 'o', 'w', ';',
'D', 'o', 'w', 'n', 'a', 'r', 'r', 'o', 'w', ';',
'D', 's', 'c', 'r', ';',
'D', 's', 't', 'r', 'o', 'k', ';',
'E', 'N', 'G', ';',
'E', 'T', 'H',
';',
'E', 'a', 'c', 'u', 't', 'e',
';',
'E', 'c', 'a', 'r', 'o', 'n', ';',
'E', 'c', 'i', 'r', 'c',
';',
'E', 'c', 'y', ';',
'E', 'd', 'o', 't', ';',
'E', 'f', 'r', ';',
'E', 'g', 'r', 'a', 'v', 'e',
';',
'E', 'l', 'e', 'm', 'e', 'n', 't', ';',
'E', 'm', 'a', 'c', 'r', ';',
'E', 'm', 'p', 't', 'y', 'S', 'm', 'a', 'l', 'l', 'S', 'q', 'u', 'a', 'r', 'e', ';',
'E', 'm', 'p', 't', 'y', 'V', 'e', 'r', 'y', 'S', 'm', 'a', 'l', 'l', 'S', 'q', 'u', 'a', 'r', 'e', ';',
'E', 'o', 'g', 'o', 'n', ';',
'E', 'o', 'p', 'f', ';',
'E', 'p', 's', 'i', 'l', 'o', 'n', ';',
'E', 'q', 'u', 'a', 'l', 'T', 'i', 'l', 'd', 'e', ';',
'E', 'q', 'u', 'i', 'l', 'i', 'b', 'r', 'i', 'u', 'm', ';',
'E', 's', 'c', 'r', ';',
'E', 's', 'i', 'm', ';',
'E', 't', 'a', ';',
'E', 'u', 'm', 'l',
';',
'E', 'x', 'i', 's', 't', 's', ';',
'E', 'x', 'p', 'o', 'n', 'e', 'n', 't', 'i', 'a', 'l', 'E', ';',
'F', 'c', 'y', ';',
'F', 'f', 'r', ';',
'F', 'i', 'l', 'l', 'e', 'd', 'S', 'm', 'a', 'l', 'l', 'S', 'q', 'u', 'a', 'r', 'e', ';',
'F', 'i', 'l', 'l', 'e', 'd', 'V', 'e', 'r', 'y', 'S', 'm', 'a', 'l', 'l', 'S', 'q', 'u', 'a', 'r', 'e', ';',
'F', 'o', 'p', 'f', ';',
'F', 'o', 'r', 'A', 'l', 'l', ';',
'F', 'o', 'u', 'r', 'i', 'e', 'r', 't', 'r', 'f', ';',
'F', 's', 'c', 'r', ';',
'G', 'J', 'c', 'y', ';',
'G', 'T',
';',
'G', 'a', 'm', 'm', 'a', ';',
'G', 'a', 'm', 'm', 'a', 'd', ';',
'G', 'b', 'r', 'e', 'v', 'e', ';',
'G', 'c', 'e', 'd', 'i', 'l', ';',
'G', 'c', 'i', 'r', 'c', ';',
'G', 'c', 'y', ';',
'G', 'd', 'o', 't', ';',
'G', 'f', 'r', ';',
'G', 'g', ';',
'G', 'o', 'p', 'f', ';',
'G', 'r', 'e', 'a', 't', 'e', 'r', 'E', 'q', 'u', 'a', 'l', ';',
'G', 'r', 'e', 'a', 't', 'e', 'r', 'E', 'q', 'u', 'a', 'l', 'L', 'e', 's', 's', ';',
'G', 'r', 'e', 'a', 't', 'e', 'r', 'F', 'u', 'l', 'l', 'E', 'q', 'u', 'a', 'l', ';',
'G', 'r', 'e', 'a', 't', 'e', 'r', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'G', 'r', 'e', 'a', 't', 'e', 'r', 'L', 'e', 's', 's', ';',
'G', 'r', 'e', 'a', 't', 'e', 'r', 'S', 'l', 'a', 'n', 't', 'E', 'q', 'u', 'a', 'l', ';',
'G', 'r', 'e', 'a', 't', 'e', 'r', 'T', 'i', 'l', 'd', 'e', ';',
'G', 's', 'c', 'r', ';',
'G', 't', ';',
'H', 'A', 'R', 'D', 'c', 'y', ';',
'H', 'a', 'c', 'e', 'k', ';',
'H', 'a', 't', ';',
'H', 'c', 'i', 'r', 'c', ';',
'H', 'f', 'r', ';',
'H', 'i', 'l', 'b', 'e', 'r', 't', 'S', 'p', 'a', 'c', 'e', ';',
'H', 'o', 'p', 'f', ';',
'H', 'o', 'r', 'i', 'z', 'o', 'n', 't', 'a', 'l', 'L', 'i', 'n', 'e', ';',
'H', 's', 'c', 'r', ';',
'H', 's', 't', 'r', 'o', 'k', ';',
'H', 'u', 'm', 'p', 'D', 'o', 'w', 'n', 'H', 'u', 'm', 'p', ';',
'H', 'u', 'm', 'p', 'E', 'q', 'u', 'a', 'l', ';',
'I', 'E', 'c', 'y', ';',
'I', 'J', 'l', 'i', 'g', ';',
'I', 'O', 'c', 'y', ';',
'I', 'a', 'c', 'u', 't', 'e',
';',
'I', 'c', 'i', 'r', 'c',
';',
'I', 'c', 'y', ';',
'I', 'd', 'o', 't', ';',
'I', 'f', 'r', ';',
'I', 'g', 'r', 'a', 'v', 'e',
';',
'I', 'm', ';',
'I', 'm', 'a', 'c', 'r', ';',
'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y', 'I', ';',
'I', 'm', 'p', 'l', 'i', 'e', 's', ';',
'I', 'n', 't', ';',
'I', 'n', 't', 'e', 'r', 's', 'e', 'c', 't', 'i', 'o', 'n', ';',
'I', 'n', 'v', 'i', 's', 'i', 'b', 'l', 'e', 'C', 'o', 'm', 'm', 'a', ';',
'I', 'n', 'v', 'i', 's', 'i', 'b', 'l', 'e', 'T', 'i', 'm', 'e', 's', ';',
'I', 'o', 'g', 'o', 'n', ';',
'I', 'o', 'p', 'f', ';',
'I', 'o', 't', 'a', ';',
'I', 's', 'c', 'r', ';',
'I', 't', 'i', 'l', 'd', 'e', ';',
'I', 'u', 'k', 'c', 'y', ';',
'I', 'u', 'm', 'l',
';',
'J', 'c', 'i', 'r', 'c', ';',
'J', 'f', 'r', ';',
'J', 'o', 'p', 'f', ';',
'J', 's', 'c', 'r', ';',
'J', 's', 'e', 'r', 'c', 'y', ';',
'J', 'u', 'k', 'c', 'y', ';',
'K', 'H', 'c', 'y', ';',
'K', 'J', 'c', 'y', ';',
'K', 'a', 'p', 'p', 'a', ';',
'K', 'c', 'e', 'd', 'i', 'l', ';',
'K', 'c', 'y', ';',
'K', 'f', 'r', ';',
'K', 'o', 'p', 'f', ';',
'K', 's', 'c', 'r', ';',
'L', 'J', 'c', 'y', ';',
'L', 'T',
';',
'L', 'a', 'c', 'u', 't', 'e', ';',
'L', 'a', 'm', 'b', 'd', 'a', ';',
'L', 'a', 'n', 'g', ';',
'L', 'a', 'p', 'l', 'a', 'c', 'e', 't', 'r', 'f', ';',
'L', 'a', 'r', 'r', ';',
'L', 'c', 'a', 'r', 'o', 'n', ';',
'L', 'c', 'e', 'd', 'i', 'l', ';',
'L', 'c', 'y', ';',
'L', 'e', 'f', 't', 'A', 'n', 'g', 'l', 'e', 'B', 'r', 'a', 'c', 'k', 'e', 't', ';',
'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', 'B', 'a', 'r', ';',
'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'L', 'e', 'f', 't', 'C', 'e', 'i', 'l', 'i', 'n', 'g', ';',
'L', 'e', 'f', 't', 'D', 'o', 'u', 'b', 'l', 'e', 'B', 'r', 'a', 'c', 'k', 'e', 't', ';',
'L', 'e', 'f', 't', 'D', 'o', 'w', 'n', 'T', 'e', 'e', 'V', 'e', 'c', 't', 'o', 'r', ';',
'L', 'e', 'f', 't', 'D', 'o', 'w', 'n', 'V', 'e', 'c', 't', 'o', 'r', ';',
'L', 'e', 'f', 't', 'D', 'o', 'w', 'n', 'V', 'e', 'c', 't', 'o', 'r', 'B', 'a', 'r', ';',
'L', 'e', 'f', 't', 'F', 'l', 'o', 'o', 'r', ';',
'L', 'e', 'f', 't', 'T', 'e', 'e', 'A', 'r', 'r', 'o', 'w', ';',
'L', 'e', 'f', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', ';',
'L', 'e', 'f', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'B', 'a', 'r', ';',
'L', 'e', 'f', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'E', 'q', 'u', 'a', 'l', ';',
'L', 'e', 'f', 't', 'U', 'p', 'D', 'o', 'w', 'n', 'V', 'e', 'c', 't', 'o', 'r', ';',
'L', 'e', 'f', 't', 'U', 'p', 'T', 'e', 'e', 'V', 'e', 'c', 't', 'o', 'r', ';',
'L', 'e', 'f', 't', 'U', 'p', 'V', 'e', 'c', 't', 'o', 'r', ';',
'L', 'e', 'f', 't', 'U', 'p', 'V', 'e', 'c', 't', 'o', 'r', 'B', 'a', 'r', ';',
'L', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
'L', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'L', 'e', 's', 's', 'E', 'q', 'u', 'a', 'l', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'L', 'e', 's', 's', 'F', 'u', 'l', 'l', 'E', 'q', 'u', 'a', 'l', ';',
'L', 'e', 's', 's', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'L', 'e', 's', 's', 'L', 'e', 's', 's', ';',
'L', 'e', 's', 's', 'S', 'l', 'a', 'n', 't', 'E', 'q', 'u', 'a', 'l', ';',
'L', 'e', 's', 's', 'T', 'i', 'l', 'd', 'e', ';',
'L', 'f', 'r', ';',
'L', 'l', ';',
'L', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
'L', 'm', 'i', 'd', 'o', 't', ';',
'L', 'o', 'n', 'g', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
'L', 'o', 'n', 'g', 'l', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'L', 'o', 'n', 'g', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'L', 'o', 'p', 'f', ';',
'L', 'o', 'w', 'e', 'r', 'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', ';',
'L', 'o', 'w', 'e', 'r', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'L', 's', 'c', 'r', ';',
'L', 's', 'h', ';',
'L', 's', 't', 'r', 'o', 'k', ';',
'L', 't', ';',
'M', 'a', 'p', ';',
'M', 'c', 'y', ';',
'M', 'e', 'd', 'i', 'u', 'm', 'S', 'p', 'a', 'c', 'e', ';',
'M', 'e', 'l', 'l', 'i', 'n', 't', 'r', 'f', ';',
'M', 'f', 'r', ';',
'M', 'i', 'n', 'u', 's', 'P', 'l', 'u', 's', ';',
'M', 'o', 'p', 'f', ';',
'M', 's', 'c', 'r', ';',
'M', 'u', ';',
'N', 'J', 'c', 'y', ';',
'N', 'a', 'c', 'u', 't', 'e', ';',
'N', 'c', 'a', 'r', 'o', 'n', ';',
'N', 'c', 'e', 'd', 'i', 'l', ';',
'N', 'c', 'y', ';',
'N', 'e', 'g', 'a', 't', 'i', 'v', 'e', 'M', 'e', 'd', 'i', 'u', 'm', 'S', 'p', 'a', 'c', 'e', ';',
'N', 'e', 'g', 'a', 't', 'i', 'v', 'e', 'T', 'h', 'i', 'c', 'k', 'S', 'p', 'a', 'c', 'e', ';',
'N', 'e', 'g', 'a', 't', 'i', 'v', 'e', 'T', 'h', 'i', 'n', 'S', 'p', 'a', 'c', 'e', ';',
'N', 'e', 'g', 'a', 't', 'i', 'v', 'e', 'V', 'e', 'r', 'y', 'T', 'h', 'i', 'n', 'S', 'p', 'a', 'c', 'e', ';',
'N', 'e', 's', 't', 'e', 'd', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'N', 'e', 's', 't', 'e', 'd', 'L', 'e', 's', 's', 'L', 'e', 's', 's', ';',
'N', 'e', 'w', 'L', 'i', 'n', 'e', ';',
'N', 'f', 'r', ';',
'N', 'o', 'B', 'r', 'e', 'a', 'k', ';',
'N', 'o', 'n', 'B', 'r', 'e', 'a', 'k', 'i', 'n', 'g', 'S', 'p', 'a', 'c', 'e', ';',
'N', 'o', 'p', 'f', ';',
'N', 'o', 't', ';',
'N', 'o', 't', 'C', 'o', 'n', 'g', 'r', 'u', 'e', 'n', 't', ';',
'N', 'o', 't', 'C', 'u', 'p', 'C', 'a', 'p', ';',
'N', 'o', 't', 'D', 'o', 'u', 'b', 'l', 'e', 'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'B', 'a', 'r', ';',
'N', 'o', 't', 'E', 'l', 'e', 'm', 'e', 'n', 't', ';',
'N', 'o', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'E', 'q', 'u', 'a', 'l', 'T', 'i', 'l', 'd', 'e', ';',
'N', 'o', 't', 'E', 'x', 'i', 's', 't', 's', ';',
'N', 'o', 't', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'N', 'o', 't', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'F', 'u', 'l', 'l', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'N', 'o', 't', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'L', 'e', 's', 's', ';',
'N', 'o', 't', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'S', 'l', 'a', 'n', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'T', 'i', 'l', 'd', 'e', ';',
'N', 'o', 't', 'H', 'u', 'm', 'p', 'D', 'o', 'w', 'n', 'H', 'u', 'm', 'p', ';',
'N', 'o', 't', 'H', 'u', 'm', 'p', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'L', 'e', 'f', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', ';',
'N', 'o', 't', 'L', 'e', 'f', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'B', 'a', 'r', ';',
'N', 'o', 't', 'L', 'e', 'f', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'L', 'e', 's', 's', ';',
'N', 'o', 't', 'L', 'e', 's', 's', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'L', 'e', 's', 's', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'N', 'o', 't', 'L', 'e', 's', 's', 'L', 'e', 's', 's', ';',
'N', 'o', 't', 'L', 'e', 's', 's', 'S', 'l', 'a', 'n', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'L', 'e', 's', 's', 'T', 'i', 'l', 'd', 'e', ';',
'N', 'o', 't', 'N', 'e', 's', 't', 'e', 'd', 'G', 'r', 'e', 'a', 't', 'e', 'r', 'G', 'r', 'e', 'a', 't', 'e', 'r', ';',
'N', 'o', 't', 'N', 'e', 's', 't', 'e', 'd', 'L', 'e', 's', 's', 'L', 'e', 's', 's', ';',
'N', 'o', 't', 'P', 'r', 'e', 'c', 'e', 'd', 'e', 's', ';',
'N', 'o', 't', 'P', 'r', 'e', 'c', 'e', 'd', 'e', 's', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'P', 'r', 'e', 'c', 'e', 'd', 'e', 's', 'S', 'l', 'a', 'n', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'R', 'e', 'v', 'e', 'r', 's', 'e', 'E', 'l', 'e', 'm', 'e', 'n', 't', ';',
'N', 'o', 't', 'R', 'i', 'g', 'h', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', ';',
'N', 'o', 't', 'R', 'i', 'g', 'h', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'B', 'a', 'r', ';',
'N', 'o', 't', 'R', 'i', 'g', 'h', 't', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'S', 'q', 'u', 'a', 'r', 'e', 'S', 'u', 'b', 's', 'e', 't', ';',
'N', 'o', 't', 'S', 'q', 'u', 'a', 'r', 'e', 'S', 'u', 'b', 's', 'e', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'S', 'q', 'u', 'a', 'r', 'e', 'S', 'u', 'p', 'e', 'r', 's', 'e', 't', ';',
'N', 'o', 't', 'S', 'q', 'u', 'a', 'r', 'e', 'S', 'u', 'p', 'e', 'r', 's', 'e', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'S', 'u', 'b', 's', 'e', 't', ';',
'N', 'o', 't', 'S', 'u', 'b', 's', 'e', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'S', 'u', 'c', 'c', 'e', 'e', 'd', 's', ';',
'N', 'o', 't', 'S', 'u', 'c', 'c', 'e', 'e', 'd', 's', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'S', 'u', 'c', 'c', 'e', 'e', 'd', 's', 'S', 'l', 'a', 'n', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'S', 'u', 'c', 'c', 'e', 'e', 'd', 's', 'T', 'i', 'l', 'd', 'e', ';',
'N', 'o', 't', 'S', 'u', 'p', 'e', 'r', 's', 'e', 't', ';',
'N', 'o', 't', 'S', 'u', 'p', 'e', 'r', 's', 'e', 't', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'T', 'i', 'l', 'd', 'e', ';',
'N', 'o', 't', 'T', 'i', 'l', 'd', 'e', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'T', 'i', 'l', 'd', 'e', 'F', 'u', 'l', 'l', 'E', 'q', 'u', 'a', 'l', ';',
'N', 'o', 't', 'T', 'i', 'l', 'd', 'e', 'T', 'i', 'l', 'd', 'e', ';',
'N', 'o', 't', 'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'B', 'a', 'r', ';',
'N', 's', 'c', 'r', ';',
'N', 't', 'i', 'l', 'd', 'e',
';',
'N', 'u', ';',
'O', 'E', 'l', 'i', 'g', ';',
'O', 'a', 'c', 'u', 't', 'e',
';',
'O', 'c', 'i', 'r', 'c',
';',
'O', 'd', 'b', 'l', 'a', 'c', ';',
'O', 'f', 'r', ';',
'O', 'g', 'r', 'a', 'v', 'e',
';',
'O', 'm', 'a', 'c', 'r', ';',
'O', 'm', 'e', 'g', 'a', ';',
'O', 'm', 'i', 'c', 'r', 'o', 'n', ';',
'O', 'o', 'p', 'f', ';',
'O', 'p', 'e', 'n', 'C', 'u', 'r', 'l', 'y', 'D', 'o', 'u', 'b', 'l', 'e', 'Q', 'u', 'o', 't', 'e', ';',
'O', 'p', 'e', 'n', 'C', 'u', 'r', 'l', 'y', 'Q', 'u', 'o', 't', 'e', ';',
'O', 'r', ';',
'O', 's', 'c', 'r', ';',
'O', 's', 'l', 'a', 's', 'h',
';',
'O', 't', 'i', 'l', 'd', 'e',
';',
'O', 't', 'i', 'm', 'e', 's', ';',
'O', 'u', 'm', 'l',
';',
'O', 'v', 'e', 'r', 'B', 'a', 'r', ';',
'O', 'v', 'e', 'r', 'B', 'r', 'a', 'c', 'e', ';',
'O', 'v', 'e', 'r', 'B', 'r', 'a', 'c', 'k', 'e', 't', ';',
'O', 'v', 'e', 'r', 'P', 'a', 'r', 'e', 'n', 't', 'h', 'e', 's', 'i', 's', ';',
'P', 'a', 'r', 't', 'i', 'a', 'l', 'D', ';',
'P', 'c', 'y', ';',
'P', 'f', 'r', ';',
'P', 'h', 'i', ';',
'P', 'i', ';',
'P', 'l', 'u', 's', 'M', 'i', 'n', 'u', 's', ';',
'P', 'o', 'i', 'n', 'c', 'a', 'r', 'e', 'p', 'l', 'a', 'n', 'e', ';',
'P', 'o', 'p', 'f', ';',
'P', 'r', ';',
'P', 'r', 'e', 'c', 'e', 'd', 'e', 's', 'T', 'i', 'l', 'd', 'e', ';',
'P', 'r', 'i', 'm', 'e', ';',
'P', 'r', 'o', 'd', 'u', 'c', 't', ';',
'P', 'r', 'o', 'p', 'o', 'r', 't', 'i', 'o', 'n', ';',
'P', 'r', 'o', 'p', 'o', 'r', 't', 'i', 'o', 'n', 'a', 'l', ';',
'P', 's', 'c', 'r', ';',
'P', 's', 'i', ';',
'Q', 'U', 'O', 'T',
';',
'Q', 'f', 'r', ';',
'Q', 'o', 'p', 'f', ';',
'Q', 's', 'c', 'r', ';',
'R', 'B', 'a', 'r', 'r', ';',
'R', 'E', 'G',
';',
'R', 'a', 'c', 'u', 't', 'e', ';',
'R', 'a', 'n', 'g', ';',
'R', 'a', 'r', 'r', ';',
'R', 'a', 'r', 'r', 't', 'l', ';',
'R', 'c', 'a', 'r', 'o', 'n', ';',
'R', 'c', 'e', 'd', 'i', 'l', ';',
'R', 'c', 'y', ';',
'R', 'e', ';',
'R', 'e', 'v', 'e', 'r', 's', 'e', 'E', 'q', 'u', 'i', 'l', 'i', 'b', 'r', 'i', 'u', 'm', ';',
'R', 'e', 'v', 'e', 'r', 's', 'e', 'U', 'p', 'E', 'q', 'u', 'i', 'l', 'i', 'b', 'r', 'i', 'u', 'm', ';',
'R', 'f', 'r', ';',
'R', 'h', 'o', ';',
'R', 'i', 'g', 'h', 't', 'A', 'n', 'g', 'l', 'e', 'B', 'r', 'a', 'c', 'k', 'e', 't', ';',
'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', 'B', 'a', 'r', ';',
'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', 'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', ';',
'R', 'i', 'g', 'h', 't', 'C', 'e', 'i', 'l', 'i', 'n', 'g', ';',
'R', 'i', 'g', 'h', 't', 'D', 'o', 'u', 'b', 'l', 'e', 'B', 'r', 'a', 'c', 'k', 'e', 't', ';',
'R', 'i', 'g', 'h', 't', 'D', 'o', 'w', 'n', 'T', 'e', 'e', 'V', 'e', 'c', 't', 'o', 'r', ';',
'R', 'i', 'g', 'h', 't', 'D', 'o', 'w', 'n', 'V', 'e', 'c', 't', 'o', 'r', ';',
'R', 'i', 'g', 'h', 't', 'D', 'o', 'w', 'n', 'V', 'e', 'c', 't', 'o', 'r', 'B', 'a', 'r', ';',
'R', 'i', 'g', 'h', 't', 'F', 'l', 'o', 'o', 'r', ';',
'R', 'i', 'g', 'h', 't', 'T', 'e', 'e', 'A', 'r', 'r', 'o', 'w', ';',
'R', 'i', 'g', 'h', 't', 'U', 'p', 'D', 'o', 'w', 'n', 'V', 'e', 'c', 't', 'o', 'r', ';',
'R', 'i', 'g', 'h', 't', 'U', 'p', 'T', 'e', 'e', 'V', 'e', 'c', 't', 'o', 'r', ';',
'R', 'i', 'g', 'h', 't', 'U', 'p', 'V', 'e', 'c', 't', 'o', 'r', ';',
'R', 'i', 'g', 'h', 't', 'U', 'p', 'V', 'e', 'c', 't', 'o', 'r', 'B', 'a', 'r', ';',
'R', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'R', 'o', 'p', 'f', ';',
'R', 'o', 'u', 'n', 'd', 'I', 'm', 'p', 'l', 'i', 'e', 's', ';',
'R', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'R', 's', 'c', 'r', ';',
'R', 's', 'h', ';',
'R', 'u', 'l', 'e', 'D', 'e', 'l', 'a', 'y', 'e', 'd', ';',
'S', 'H', 'C', 'H', 'c', 'y', ';',
'S', 'H', 'c', 'y', ';',
'S', 'O', 'F', 'T', 'c', 'y', ';',
'S', 'a', 'c', 'u', 't', 'e', ';',
'S', 'c', ';',
'S', 'c', 'a', 'r', 'o', 'n', ';',
'S', 'c', 'e', 'd', 'i', 'l', ';',
'S', 'c', 'i', 'r', 'c', ';',
'S', 'f', 'r', ';',
'S', 'h', 'o', 'r', 't', 'D', 'o', 'w', 'n', 'A', 'r', 'r', 'o', 'w', ';',
'S', 'h', 'o', 'r', 't', 'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', ';',
'S', 'h', 'o', 'r', 't', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'S', 'h', 'o', 'r', 't', 'U', 'p', 'A', 'r', 'r', 'o', 'w', ';',
'S', 'i', 'g', 'm', 'a', ';',
'S', 'm', 'a', 'l', 'l', 'C', 'i', 'r', 'c', 'l', 'e', ';',
'S', 'o', 'p', 'f', ';',
'S', 'q', 'r', 't', ';',
'S', 'q', 'u', 'a', 'r', 'e', 'I', 'n', 't', 'e', 'r', 's', 'e', 'c', 't', 'i', 'o', 'n', ';',
'S', 'q', 'u', 'a', 'r', 'e', 'U', 'n', 'i', 'o', 'n', ';',
'S', 's', 'c', 'r', ';',
'S', 't', 'a', 'r', ';',
'S', 'u', 'b', ';',
'S', 'u', 'c', 'h', 'T', 'h', 'a', 't', ';',
'S', 'u', 'm', ';',
'S', 'u', 'p', ';',
'S', 'u', 'p', 's', 'e', 't', ';',
'T', 'H', 'O', 'R', 'N',
';',
'T', 'R', 'A', 'D', 'E', ';',
'T', 'S', 'H', 'c', 'y', ';',
'T', 'S', 'c', 'y', ';',
'T', 'a', 'b', ';',
'T', 'a', 'u', ';',
'T', 'c', 'a', 'r', 'o', 'n', ';',
'T', 'c', 'e', 'd', 'i', 'l', ';',
'T', 'f', 'r', ';',
'T', 'h', 'e', 'r', 'e', 'f', 'o', 'r', 'e', ';',
'T', 'h', 'e', 't', 'a', ';',
'T', 'o', 'p', 'f', ';',
'T', 'r', 'i', 'p', 'l', 'e', 'D', 'o', 't', ';',
'T', 's', 'c', 'r', ';',
'T', 's', 't', 'r', 'o', 'k', ';',
'U', 'a', 'c', 'u', 't', 'e',
';',
'U', 'a', 'r', 'r', ';',
'U', 'a', 'r', 'r', 'o', 'c', 'i', 'r', ';',
'U', 'b', 'r', 'c', 'y', ';',
'U', 'b', 'r', 'e', 'v', 'e', ';',
'U', 'c', 'i', 'r', 'c',
';',
'U', 'c', 'y', ';',
'U', 'd', 'b', 'l', 'a', 'c', ';',
'U', 'f', 'r', ';',
'U', 'g', 'r', 'a', 'v', 'e',
';',
'U', 'm', 'a', 'c', 'r', ';',
'U', 'n', 'd', 'e', 'r', 'B', 'a', 'r', ';',
'U', 'n', 'd', 'e', 'r', 'B', 'r', 'a', 'c', 'e', ';',
'U', 'n', 'd', 'e', 'r', 'B', 'r', 'a', 'c', 'k', 'e', 't', ';',
'U', 'n', 'd', 'e', 'r', 'P', 'a', 'r', 'e', 'n', 't', 'h', 'e', 's', 'i', 's', ';',
'U', 'n', 'i', 'o', 'n', 'P', 'l', 'u', 's', ';',
'U', 'o', 'g', 'o', 'n', ';',
'U', 'o', 'p', 'f', ';',
'U', 'p', 'A', 'r', 'r', 'o', 'w', 'B', 'a', 'r', ';',
'U', 'p', 'A', 'r', 'r', 'o', 'w', 'D', 'o', 'w', 'n', 'A', 'r', 'r', 'o', 'w', ';',
'U', 'p', 'T', 'e', 'e', ';',
'U', 'p', 'T', 'e', 'e', 'A', 'r', 'r', 'o', 'w', ';',
'U', 'p', 'a', 'r', 'r', 'o', 'w', ';',
'U', 'p', 'd', 'o', 'w', 'n', 'a', 'r', 'r', 'o', 'w', ';',
'U', 'p', 'p', 'e', 'r', 'L', 'e', 'f', 't', 'A', 'r', 'r', 'o', 'w', ';',
'U', 'p', 'p', 'e', 'r', 'R', 'i', 'g', 'h', 't', 'A', 'r', 'r', 'o', 'w', ';',
'U', 'p', 's', 'i', ';',
'U', 'p', 's', 'i', 'l', 'o', 'n', ';',
'U', 'r', 'i', 'n', 'g', ';',
'U', 's', 'c', 'r', ';',
'U', 't', 'i', 'l', 'd', 'e', ';',
'U', 'u', 'm', 'l',
';',
'V', 'D', 'a', 's', 'h', ';',
'V', 'b', 'a', 'r', ';',
'V', 'c', 'y', ';',
'V', 'd', 'a', 's', 'h', ';',
'V', 'd', 'a', 's', 'h', 'l', ';',
'V', 'e', 'e', ';',
'V', 'e', 'r', 'b', 'a', 'r', ';',
'V', 'e', 'r', 't', ';',
'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'L', 'i', 'n', 'e', ';',
'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'S', 'e', 'p', 'a', 'r', 'a', 't', 'o', 'r', ';',
'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'T', 'i', 'l', 'd', 'e', ';',
'V', 'f', 'r', ';',
'V', 'o', 'p', 'f', ';',
'V', 's', 'c', 'r', ';',
'V', 'v', 'd', 'a', 's', 'h', ';',
'W', 'c', 'i', 'r', 'c', ';',
'W', 'e', 'd', 'g', 'e', ';',
'W', 'f', 'r', ';',
'W', 'o', 'p', 'f', ';',
'W', 's', 'c', 'r', ';',
'X', 'f', 'r', ';',
'X', 'i', ';',
'X', 'o', 'p', 'f', ';',
'X', 's', 'c', 'r', ';',
'Y', 'A', 'c', 'y', ';',
'Y', 'I', 'c', 'y', ';',
'Y', 'U', 'c', 'y', ';',
'Y', 'a', 'c', 'u', 't', 'e',
';',
'Y', 'c', 'i', 'r', 'c', ';',
'Y', 'c', 'y', ';',
'Y', 'f', 'r', ';',
'Y', 'o', 'p', 'f', ';',
'Y', 's', 'c', 'r', ';',
'Y', 'u', 'm', 'l', ';',
'Z', 'H', 'c', 'y', ';',
'Z', 'a', 'c', 'u', 't', 'e', ';',
'Z', 'c', 'a', 'r', 'o', 'n', ';',
'Z', 'd', 'o', 't', ';',
'Z', 'e', 'r', 'o', 'W', 'i', 'd', 't', 'h', 'S', 'p', 'a', 'c', 'e', ';',
'Z', 'e', 't', 'a', ';',
'Z', 'f', 'r', ';',
'Z', 'o', 'p', 'f', ';',
'Z', 's', 'c', 'r', ';',
'a', 'a', 'c', 'u', 't', 'e',
';',
'a', 'b', 'r', 'e', 'v', 'e', ';',
'a', 'c', 'E', ';',
'a', 'c', 'd', ';',
'a', 'c', 'i', 'r', 'c',
';',
'a', 'c', 'y', ';',
'a', 'e', 'l', 'i', 'g',
';',
'a', 'f', ';',
'a', 'f', 'r', ';',
'a', 'g', 'r', 'a', 'v', 'e',
';',
'a', 'l', 'e', 'f', 's', 'y', 'm', ';',
'a', 'l', 'e', 'p', 'h', ';',
'a', 'l', 'p', 'h', 'a', ';',
'a', 'm', 'a', 'c', 'r', ';',
'a', 'm', 'a', 'l', 'g', ';',
'a', 'm', 'p',
';',
'a', 'n', 'd', ';',
'a', 'n', 'd', 'a', 'n', 'd', ';',
'a', 'n', 'd', 'd', ';',
'a', 'n', 'd', 's', 'l', 'o', 'p', 'e', ';',
'a', 'n', 'd', 'v', ';',
'a', 'n', 'g', 'e', ';',
'a', 'n', 'g', 'm', 's', 'd', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'a', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'b', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'c', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'd', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'e', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'f', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'g', ';',
'a', 'n', 'g', 'm', 's', 'd', 'a', 'h', ';',
'a', 'n', 'g', 'r', 't', ';',
'a', 'n', 'g', 'r', 't', 'v', 'b', ';',
'a', 'n', 'g', 'r', 't', 'v', 'b', 'd', ';',
'a', 'n', 'g', 's', 'p', 'h', ';',
'a', 'n', 'g', 's', 't', ';',
'a', 'n', 'g', 'z', 'a', 'r', 'r', ';',
'a', 'o', 'g', 'o', 'n', ';',
'a', 'o', 'p', 'f', ';',
'a', 'p', 'E', ';',
'a', 'p', 'a', 'c', 'i', 'r', ';',
'a', 'p', 'e', ';',
'a', 'p', 'i', 'd', ';',
'a', 'p', 'o', 's', ';',
'a', 'p', 'p', 'r', 'o', 'x', ';',
'a', 'p', 'p', 'r', 'o', 'x', 'e', 'q', ';',
'a', 'r', 'i', 'n', 'g',
';',
'a', 's', 'c', 'r', ';',
'a', 's', 't', ';',
'a', 's', 'y', 'm', 'p', ';',
'a', 's', 'y', 'm', 'p', 'e', 'q', ';',
'a', 't', 'i', 'l', 'd', 'e',
';',
'a', 'u', 'm', 'l',
';',
'a', 'w', 'c', 'o', 'n', 'i', 'n', 't', ';',
'a', 'w', 'i', 'n', 't', ';',
'b', 'N', 'o', 't', ';',
'b', 'a', 'c', 'k', 'c', 'o', 'n', 'g', ';',
'b', 'a', 'c', 'k', 'e', 'p', 's', 'i', 'l', 'o', 'n', ';',
'b', 'a', 'c', 'k', 'p', 'r', 'i', 'm', 'e', ';',
'b', 'a', 'c', 'k', 's', 'i', 'm', ';',
'b', 'a', 'c', 'k', 's', 'i', 'm', 'e', 'q', ';',
'b', 'a', 'r', 'v', 'e', 'e', ';',
'b', 'a', 'r', 'w', 'e', 'd', ';',
'b', 'a', 'r', 'w', 'e', 'd', 'g', 'e', ';',
'b', 'b', 'r', 'k', ';',
'b', 'b', 'r', 'k', 't', 'b', 'r', 'k', ';',
'b', 'c', 'o', 'n', 'g', ';',
'b', 'c', 'y', ';',
'b', 'd', 'q', 'u', 'o', ';',
'b', 'e', 'c', 'a', 'u', 's', ';',
'b', 'e', 'c', 'a', 'u', 's', 'e', ';',
'b', 'e', 'm', 'p', 't', 'y', 'v', ';',
'b', 'e', 'p', 's', 'i', ';',
'b', 'e', 'r', 'n', 'o', 'u', ';',
'b', 'e', 't', 'a', ';',
'b', 'e', 't', 'h', ';',
'b', 'e', 't', 'w', 'e', 'e', 'n', ';',
'b', 'f', 'r', ';',
'b', 'i', 'g', 'c', 'a', 'p', ';',
'b', 'i', 'g', 'c', 'i', 'r', 'c', ';',
'b', 'i', 'g', 'c', 'u', 'p', ';',
'b', 'i', 'g', 'o', 'd', 'o', 't', ';',
'b', 'i', 'g', 'o', 'p', 'l', 'u', 's', ';',
'b', 'i', 'g', 'o', 't', 'i', 'm', 'e', 's', ';',
'b', 'i', 'g', 's', 'q', 'c', 'u', 'p', ';',
'b', 'i', 'g', 's', 't', 'a', 'r', ';',
'b', 'i', 'g', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'd', 'o', 'w', 'n', ';',
'b', 'i', 'g', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'u', 'p', ';',
'b', 'i', 'g', 'u', 'p', 'l', 'u', 's', ';',
'b', 'i', 'g', 'v', 'e', 'e', ';',
'b', 'i', 'g', 'w', 'e', 'd', 'g', 'e', ';',
'b', 'k', 'a', 'r', 'o', 'w', ';',
'b', 'l', 'a', 'c', 'k', 'l', 'o', 'z', 'e', 'n', 'g', 'e', ';',
'b', 'l', 'a', 'c', 'k', 's', 'q', 'u', 'a', 'r', 'e', ';',
'b', 'l', 'a', 'c', 'k', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', ';',
'b', 'l', 'a', 'c', 'k', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'd', 'o', 'w', 'n', ';',
'b', 'l', 'a', 'c', 'k', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'l', 'e', 'f', 't', ';',
'b', 'l', 'a', 'c', 'k', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'r', 'i', 'g', 'h', 't', ';',
'b', 'l', 'a', 'n', 'k', ';',
'b', 'l', 'k', '1', '2', ';',
'b', 'l', 'k', '1', '4', ';',
'b', 'l', 'k', '3', '4', ';',
'b', 'l', 'o', 'c', 'k', ';',
'b', 'n', 'e', ';',
'b', 'n', 'e', 'q', 'u', 'i', 'v', ';',
'b', 'n', 'o', 't', ';',
'b', 'o', 'p', 'f', ';',
'b', 'o', 't', ';',
'b', 'o', 't', 't', 'o', 'm', ';',
'b', 'o', 'w', 't', 'i', 'e', ';',
'b', 'o', 'x', 'D', 'L', ';',
'b', 'o', 'x', 'D', 'R', ';',
'b', 'o', 'x', 'D', 'l', ';',
'b', 'o', 'x', 'D', 'r', ';',
'b', 'o', 'x', 'H', ';',
'b', 'o', 'x', 'H', 'D', ';',
'b', 'o', 'x', 'H', 'U', ';',
'b', 'o', 'x', 'H', 'd', ';',
'b', 'o', 'x', 'H', 'u', ';',
'b', 'o', 'x', 'U', 'L', ';',
'b', 'o', 'x', 'U', 'R', ';',
'b', 'o', 'x', 'U', 'l', ';',
'b', 'o', 'x', 'U', 'r', ';',
'b', 'o', 'x', 'V', ';',
'b', 'o', 'x', 'V', 'H', ';',
'b', 'o', 'x', 'V', 'L', ';',
'b', 'o', 'x', 'V', 'R', ';',
'b', 'o', 'x', 'V', 'h', ';',
'b', 'o', 'x', 'V', 'l', ';',
'b', 'o', 'x', 'V', 'r', ';',
'b', 'o', 'x', 'b', 'o', 'x', ';',
'b', 'o', 'x', 'd', 'L', ';',
'b', 'o', 'x', 'd', 'R', ';',
'b', 'o', 'x', 'd', 'l', ';',
'b', 'o', 'x', 'd', 'r', ';',
'b', 'o', 'x', 'h', ';',
'b', 'o', 'x', 'h', 'D', ';',
'b', 'o', 'x', 'h', 'U', ';',
'b', 'o', 'x', 'h', 'd', ';',
'b', 'o', 'x', 'h', 'u', ';',
'b', 'o', 'x', 'm', 'i', 'n', 'u', 's', ';',
'b', 'o', 'x', 'p', 'l', 'u', 's', ';',
'b', 'o', 'x', 't', 'i', 'm', 'e', 's', ';',
'b', 'o', 'x', 'u', 'L', ';',
'b', 'o', 'x', 'u', 'R', ';',
'b', 'o', 'x', 'u', 'l', ';',
'b', 'o', 'x', 'u', 'r', ';',
'b', 'o', 'x', 'v', ';',
'b', 'o', 'x', 'v', 'H', ';',
'b', 'o', 'x', 'v', 'L', ';',
'b', 'o', 'x', 'v', 'R', ';',
'b', 'o', 'x', 'v', 'h', ';',
'b', 'o', 'x', 'v', 'l', ';',
'b', 'o', 'x', 'v', 'r', ';',
'b', 'p', 'r', 'i', 'm', 'e', ';',
'b', 'r', 'v', 'b', 'a', 'r',
';',
'b', 's', 'c', 'r', ';',
'b', 's', 'e', 'm', 'i', ';',
'b', 's', 'i', 'm', ';',
'b', 's', 'i', 'm', 'e', ';',
'b', 's', 'o', 'l', ';',
'b', 's', 'o', 'l', 'b', ';',
'b', 's', 'o', 'l', 'h', 's', 'u', 'b', ';',
'b', 'u', 'l', 'l', ';',
'b', 'u', 'l', 'l', 'e', 't', ';',
'b', 'u', 'm', 'p', ';',
'b', 'u', 'm', 'p', 'E', ';',
'b', 'u', 'm', 'p', 'e', ';',
'b', 'u', 'm', 'p', 'e', 'q', ';',
'c', 'a', 'c', 'u', 't', 'e', ';',
'c', 'a', 'p', 'a', 'n', 'd', ';',
'c', 'a', 'p', 'b', 'r', 'c', 'u', 'p', ';',
'c', 'a', 'p', 'c', 'a', 'p', ';',
'c', 'a', 'p', 'c', 'u', 'p', ';',
'c', 'a', 'p', 'd', 'o', 't', ';',
'c', 'a', 'p', 's', ';',
'c', 'a', 'r', 'e', 't', ';',
'c', 'c', 'a', 'p', 's', ';',
'c', 'c', 'a', 'r', 'o', 'n', ';',
'c', 'c', 'e', 'd', 'i', 'l',
';',
'c', 'c', 'i', 'r', 'c', ';',
'c', 'c', 'u', 'p', 's', ';',
'c', 'c', 'u', 'p', 's', 's', 'm', ';',
'c', 'd', 'o', 't', ';',
'c', 'e', 'm', 'p', 't', 'y', 'v', ';',
'c', 'e', 'n', 't',
';',
'c', 'e', 'n', 't', 'e', 'r', 'd', 'o', 't', ';',
'c', 'f', 'r', ';',
'c', 'h', 'c', 'y', ';',
'c', 'h', 'e', 'c', 'k', ';',
'c', 'h', 'e', 'c', 'k', 'm', 'a', 'r', 'k', ';',
'c', 'h', 'i', ';',
'c', 'i', 'r', 'E', ';',
'c', 'i', 'r', 'c', 'e', 'q', ';',
'c', 'i', 'r', 'c', 'l', 'e', 'a', 'r', 'r', 'o', 'w', 'l', 'e', 'f', 't', ';',
'c', 'i', 'r', 'c', 'l', 'e', 'a', 'r', 'r', 'o', 'w', 'r', 'i', 'g', 'h', 't', ';',
'c', 'i', 'r', 'c', 'l', 'e', 'd', 'R', ';',
'c', 'i', 'r', 'c', 'l', 'e', 'd', 'S', ';',
'c', 'i', 'r', 'c', 'l', 'e', 'd', 'a', 's', 't', ';',
'c', 'i', 'r', 'c', 'l', 'e', 'd', 'c', 'i', 'r', 'c', ';',
'c', 'i', 'r', 'c', 'l', 'e', 'd', 'd', 'a', 's', 'h', ';',
'c', 'i', 'r', 'e', ';',
'c', 'i', 'r', 'f', 'n', 'i', 'n', 't', ';',
'c', 'i', 'r', 'm', 'i', 'd', ';',
'c', 'i', 'r', 's', 'c', 'i', 'r', ';',
'c', 'l', 'u', 'b', 's', ';',
'c', 'l', 'u', 'b', 's', 'u', 'i', 't', ';',
'c', 'o', 'l', 'o', 'n', ';',
'c', 'o', 'l', 'o', 'n', 'e', ';',
'c', 'o', 'l', 'o', 'n', 'e', 'q', ';',
'c', 'o', 'm', 'm', 'a', ';',
'c', 'o', 'm', 'm', 'a', 't', ';',
'c', 'o', 'm', 'p', ';',
'c', 'o', 'm', 'p', 'f', 'n', ';',
'c', 'o', 'm', 'p', 'l', 'e', 'm', 'e', 'n', 't', ';',
'c', 'o', 'm', 'p', 'l', 'e', 'x', 'e', 's', ';',
'c', 'o', 'n', 'g', 'd', 'o', 't', ';',
'c', 'o', 'p', 'f', ';',
'c', 'o', 'p', 'r', 'o', 'd', ';',
'c', 'o', 'p', 'y',
';',
'c', 'o', 'p', 'y', 's', 'r', ';',
'c', 'r', 'a', 'r', 'r', ';',
'c', 'r', 'o', 's', 's', ';',
'c', 's', 'c', 'r', ';',
'c', 's', 'u', 'b', ';',
'c', 's', 'u', 'b', 'e', ';',
'c', 's', 'u', 'p', ';',
'c', 's', 'u', 'p', 'e', ';',
'c', 't', 'd', 'o', 't', ';',
'c', 'u', 'd', 'a', 'r', 'r', 'l', ';',
'c', 'u', 'd', 'a', 'r', 'r', 'r', ';',
'c', 'u', 'e', 'p', 'r', ';',
'c', 'u', 'e', 's', 'c', ';',
'c', 'u', 'l', 'a', 'r', 'r', ';',
'c', 'u', 'l', 'a', 'r', 'r', 'p', ';',
'c', 'u', 'p', 'b', 'r', 'c', 'a', 'p', ';',
'c', 'u', 'p', 'c', 'a', 'p', ';',
'c', 'u', 'p', 'c', 'u', 'p', ';',
'c', 'u', 'p', 'd', 'o', 't', ';',
'c', 'u', 'p', 'o', 'r', ';',
'c', 'u', 'r', 'a', 'r', 'r', ';',
'c', 'u', 'r', 'a', 'r', 'r', 'm', ';',
'c', 'u', 'r', 'l', 'y', 'e', 'q', 'p', 'r', 'e', 'c', ';',
'c', 'u', 'r', 'l', 'y', 'e', 'q', 's', 'u', 'c', 'c', ';',
'c', 'u', 'r', 'l', 'y', 'v', 'e', 'e', ';',
'c', 'u', 'r', 'l', 'y', 'w', 'e', 'd', 'g', 'e', ';',
'c', 'u', 'r', 'r', 'e', 'n',
';',
'c', 'u', 'r', 'v', 'e', 'a', 'r', 'r', 'o', 'w', 'l', 'e', 'f', 't', ';',
'c', 'u', 'r', 'v', 'e', 'a', 'r', 'r', 'o', 'w', 'r', 'i', 'g', 'h', 't', ';',
'c', 'u', 'v', 'e', 'e', ';',
'c', 'u', 'w', 'e', 'd', ';',
'c', 'w', 'c', 'o', 'n', 'i', 'n', 't', ';',
'c', 'w', 'i', 'n', 't', ';',
'c', 'y', 'l', 'c', 't', 'y', ';',
'd', 'A', 'r', 'r', ';',
'd', 'H', 'a', 'r', ';',
'd', 'a', 'g', 'g', 'e', 'r', ';',
'd', 'a', 'l', 'e', 't', 'h', ';',
'd', 'a', 'r', 'r', ';',
'd', 'a', 's', 'h', 'v', ';',
'd', 'b', 'k', 'a', 'r', 'o', 'w', ';',
'd', 'c', 'a', 'r', 'o', 'n', ';',
'd', 'c', 'y', ';',
'd', 'd', 'a', 'g', 'g', 'e', 'r', ';',
'd', 'd', 'a', 'r', 'r', ';',
'd', 'd', 'o', 't', 's', 'e', 'q', ';',
'd', 'e', 'g',
';',
'd', 'e', 'l', 't', 'a', ';',
'd', 'e', 'm', 'p', 't', 'y', 'v', ';',
'd', 'f', 'i', 's', 'h', 't', ';',
'd', 'f', 'r', ';',
'd', 'h', 'a', 'r', 'l', ';',
'd', 'h', 'a', 'r', 'r', ';',
'd', 'i', 'a', 'm', ';',
'd', 'i', 'a', 'm', 'o', 'n', 'd', ';',
'd', 'i', 'a', 'm', 'o', 'n', 'd', 's', 'u', 'i', 't', ';',
'd', 'i', 'a', 'm', 's', ';',
'd', 'i', 'e', ';',
'd', 'i', 'g', 'a', 'm', 'm', 'a', ';',
'd', 'i', 's', 'i', 'n', ';',
'd', 'i', 'v', ';',
'd', 'i', 'v', 'i', 'd', 'e',
';',
'd', 'i', 'v', 'i', 'd', 'e', 'o', 'n', 't', 'i', 'm', 'e', 's', ';',
'd', 'i', 'v', 'o', 'n', 'x', ';',
'd', 'j', 'c', 'y', ';',
'd', 'l', 'c', 'o', 'r', 'n', ';',
'd', 'l', 'c', 'r', 'o', 'p', ';',
'd', 'o', 'l', 'l', 'a', 'r', ';',
'd', 'o', 'p', 'f', ';',
'd', 'o', 't', 'e', 'q', ';',
'd', 'o', 't', 'e', 'q', 'd', 'o', 't', ';',
'd', 'o', 't', 'm', 'i', 'n', 'u', 's', ';',
'd', 'o', 't', 'p', 'l', 'u', 's', ';',
'd', 'o', 't', 's', 'q', 'u', 'a', 'r', 'e', ';',
'd', 'o', 'u', 'b', 'l', 'e', 'b', 'a', 'r', 'w', 'e', 'd', 'g', 'e', ';',
'd', 'o', 'w', 'n', 'd', 'o', 'w', 'n', 'a', 'r', 'r', 'o', 'w', 's', ';',
'd', 'o', 'w', 'n', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'l', 'e', 'f', 't', ';',
'd', 'o', 'w', 'n', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'r', 'i', 'g', 'h', 't', ';',
'd', 'r', 'b', 'k', 'a', 'r', 'o', 'w', ';',
'd', 'r', 'c', 'o', 'r', 'n', ';',
'd', 'r', 'c', 'r', 'o', 'p', ';',
'd', 's', 'c', 'r', ';',
'd', 's', 'c', 'y', ';',
'd', 's', 'o', 'l', ';',
'd', 's', 't', 'r', 'o', 'k', ';',
'd', 't', 'd', 'o', 't', ';',
'd', 't', 'r', 'i', ';',
'd', 't', 'r', 'i', 'f', ';',
'd', 'u', 'a', 'r', 'r', ';',
'd', 'u', 'h', 'a', 'r', ';',
'd', 'w', 'a', 'n', 'g', 'l', 'e', ';',
'd', 'z', 'c', 'y', ';',
'd', 'z', 'i', 'g', 'r', 'a', 'r', 'r', ';',
'e', 'D', 'D', 'o', 't', ';',
'e', 'a', 'c', 'u', 't', 'e',
';',
'e', 'a', 's', 't', 'e', 'r', ';',
'e', 'c', 'a', 'r', 'o', 'n', ';',
'e', 'c', 'i', 'r', ';',
'e', 'c', 'i', 'r', 'c',
';',
'e', 'c', 'o', 'l', 'o', 'n', ';',
'e', 'c', 'y', ';',
'e', 'd', 'o', 't', ';',
'e', 'f', 'D', 'o', 't', ';',
'e', 'f', 'r', ';',
'e', 'g', 'r', 'a', 'v', 'e',
';',
'e', 'g', 's', ';',
'e', 'g', 's', 'd', 'o', 't', ';',
'e', 'l', 'i', 'n', 't', 'e', 'r', 's', ';',
'e', 'l', 'l', ';',
'e', 'l', 's', ';',
'e', 'l', 's', 'd', 'o', 't', ';',
'e', 'm', 'a', 'c', 'r', ';',
'e', 'm', 'p', 't', 'y', ';',
'e', 'm', 'p', 't', 'y', 's', 'e', 't', ';',
'e', 'm', 's', 'p', '1', '3', ';',
'e', 'm', 's', 'p', '1', '4', ';',
'e', 'm', 's', 'p', ';',
'e', 'n', 'g', ';',
'e', 'n', 's', 'p', ';',
'e', 'o', 'g', 'o', 'n', ';',
'e', 'o', 'p', 'f', ';',
'e', 'p', 'a', 'r', ';',
'e', 'p', 'a', 'r', 's', 'l', ';',
'e', 'p', 'l', 'u', 's', ';',
'e', 'p', 's', 'i', 'v', ';',
'e', 'q', 'c', 'i', 'r', 'c', ';',
'e', 'q', 'c', 'o', 'l', 'o', 'n', ';',
'e', 'q', 's', 'i', 'm', ';',
'e', 'q', 's', 'l', 'a', 'n', 't', 'g', 't', 'r', ';',
'e', 'q', 's', 'l', 'a', 'n', 't', 'l', 'e', 's', 's', ';',
'e', 'q', 'u', 'a', 'l', 's', ';',
'e', 'q', 'u', 'e', 's', 't', ';',
'e', 'q', 'u', 'i', 'v', 'D', 'D', ';',
'e', 'q', 'v', 'p', 'a', 'r', 's', 'l', ';',
'e', 'r', 'a', 'r', 'r', ';',
'e', 's', 'c', 'r', ';',
'e', 's', 'd', 'o', 't', ';',
'e', 's', 'i', 'm', ';',
'e', 'u', 'm', 'l',
';',
'e', 'u', 'r', 'o', ';',
'e', 'x', 'c', 'l', ';',
'e', 'x', 'i', 's', 't', ';',
'e', 'x', 'p', 'e', 'c', 't', 'a', 't', 'i', 'o', 'n', ';',
'e', 'x', 'p', 'o', 'n', 'e', 'n', 't', 'i', 'a', 'l', 'e', ';',
'f', 'a', 'l', 'l', 'i', 'n', 'g', 'd', 'o', 't', 's', 'e', 'q', ';',
'f', 'c', 'y', ';',
'f', 'e', 'm', 'a', 'l', 'e', ';',
'f', 'f', 'i', 'l', 'i', 'g', ';',
'f', 'f', 'l', 'i', 'g', ';',
'f', 'f', 'l', 'l', 'i', 'g', ';',
'f', 'f', 'r', ';',
'f', 'j', 'l', 'i', 'g', ';',
'f', 'l', 'a', 't', ';',
'f', 'l', 't', 'n', 's', ';',
'f', 'n', 'o', 'f', ';',
'f', 'o', 'p', 'f', ';',
'f', 'o', 'r', 'a', 'l', 'l', ';',
'f', 'o', 'r', 'k', ';',
'f', 'o', 'r', 'k', 'v', ';',
'f', 'p', 'a', 'r', 't', 'i', 'n', 't', ';',
'f', 'r', 'a', 'c', '1', '2',
';',
'f', 'r', 'a', 'c', '1', '3', ';',
'f', 'r', 'a', 'c', '1', '4',
';',
'f', 'r', 'a', 'c', '1', '5', ';',
'f', 'r', 'a', 'c', '1', '6', ';',
'f', 'r', 'a', 'c', '1', '8', ';',
'f', 'r', 'a', 'c', '2', '3', ';',
'f', 'r', 'a', 'c', '2', '5', ';',
'f', 'r', 'a', 'c', '3', '4',
';',
'f', 'r', 'a', 'c', '3', '5', ';',
'f', 'r', 'a', 'c', '3', '8', ';',
'f', 'r', 'a', 'c', '4', '5', ';',
'f', 'r', 'a', 'c', '5', '6', ';',
'f', 'r', 'a', 'c', '5', '8', ';',
'f', 'r', 'a', 'c', '7', '8', ';',
'f', 'r', 'a', 's', 'l', ';',
'f', 'r', 'o', 'w', 'n', ';',
'f', 's', 'c', 'r', ';',
'g', 'E', ';',
'g', 'E', 'l', ';',
'g', 'a', 'c', 'u', 't', 'e', ';',
'g', 'a', 'm', 'm', 'a', 'd', ';',
'g', 'a', 'p', ';',
'g', 'b', 'r', 'e', 'v', 'e', ';',
'g', 'c', 'y', ';',
'g', 'e', 'l', ';',
'g', 'e', 'q', ';',
'g', 'e', 'q', 'q', ';',
'g', 'e', 'q', 's', 'l', 'a', 'n', 't', ';',
'g', 'e', 's', ';',
'g', 'e', 's', 'c', 'c', ';',
'g', 'e', 's', 'd', 'o', 't', ';',
'g', 'e', 's', 'd', 'o', 't', 'o', ';',
'g', 'e', 's', 'd', 'o', 't', 'o', 'l', ';',
'g', 'e', 's', 'l', ';',
'g', 'e', 's', 'l', 'e', 's', ';',
'g', 'f', 'r', ';',
'g', 'g', ';',
'g', 'g', 'g', ';',
'g', 'i', 'm', 'e', 'l', ';',
'g', 'j', 'c', 'y', ';',
'g', 'l', ';',
'g', 'l', 'E', ';',
'g', 'l', 'a', ';',
'g', 'l', 'j', ';',
'g', 'n', 'E', ';',
'g', 'n', 'a', 'p', ';',
'g', 'n', 'a', 'p', 'p', 'r', 'o', 'x', ';',
'g', 'n', 'e', ';',
'g', 'n', 'e', 'q', ';',
'g', 'n', 'e', 'q', 'q', ';',
'g', 'n', 's', 'i', 'm', ';',
'g', 'o', 'p', 'f', ';',
'g', 's', 'c', 'r', ';',
'g', 's', 'i', 'm', ';',
'g', 's', 'i', 'm', 'e', ';',
'g', 's', 'i', 'm', 'l', ';',
'g', 't', ';',
'g', 't', 'c', 'c', ';',
'g', 't', 'c', 'i', 'r', ';',
'g', 't', 'd', 'o', 't', ';',
'g', 't', 'l', 'P', 'a', 'r', ';',
'g', 't', 'q', 'u', 'e', 's', 't', ';',
'g', 't', 'r', 'a', 'p', 'p', 'r', 'o', 'x', ';',
'g', 't', 'r', 'a', 'r', 'r', ';',
'g', 't', 'r', 'd', 'o', 't', ';',
'g', 't', 'r', 'e', 'q', 'l', 'e', 's', 's', ';',
'g', 't', 'r', 'e', 'q', 'q', 'l', 'e', 's', 's', ';',
'g', 't', 'r', 'l', 'e', 's', 's', ';',
'g', 't', 'r', 's', 'i', 'm', ';',
'g', 'v', 'e', 'r', 't', 'n', 'e', 'q', 'q', ';',
'g', 'v', 'n', 'E', ';',
'h', 'A', 'r', 'r', ';',
'h', 'a', 'i', 'r', 's', 'p', ';',
'h', 'a', 'l', 'f', ';',
'h', 'a', 'm', 'i', 'l', 't', ';',
'h', 'a', 'r', 'd', 'c', 'y', ';',
'h', 'a', 'r', 'r', 'c', 'i', 'r', ';',
'h', 'a', 'r', 'r', 'w', ';',
'h', 'b', 'a', 'r', ';',
'h', 'c', 'i', 'r', 'c', ';',
'h', 'e', 'a', 'r', 't', 's', ';',
'h', 'e', 'a', 'r', 't', 's', 'u', 'i', 't', ';',
'h', 'e', 'l', 'l', 'i', 'p', ';',
'h', 'e', 'r', 'c', 'o', 'n', ';',
'h', 'f', 'r', ';',
'h', 'k', 's', 'e', 'a', 'r', 'o', 'w', ';',
'h', 'k', 's', 'w', 'a', 'r', 'o', 'w', ';',
'h', 'o', 'a', 'r', 'r', ';',
'h', 'o', 'm', 't', 'h', 't', ';',
'h', 'o', 'o', 'k', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
'h', 'o', 'o', 'k', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'h', 'o', 'p', 'f', ';',
'h', 'o', 'r', 'b', 'a', 'r', ';',
'h', 's', 'c', 'r', ';',
'h', 's', 'l', 'a', 's', 'h', ';',
'h', 's', 't', 'r', 'o', 'k', ';',
'h', 'y', 'b', 'u', 'l', 'l', ';',
'h', 'y', 'p', 'h', 'e', 'n', ';',
'i', 'a', 'c', 'u', 't', 'e',
';',
'i', 'c', ';',
'i', 'c', 'i', 'r', 'c',
';',
'i', 'c', 'y', ';',
'i', 'e', 'c', 'y', ';',
'i', 'e', 'x', 'c', 'l',
';',
'i', 'f', 'f', ';',
'i', 'f', 'r', ';',
'i', 'g', 'r', 'a', 'v', 'e',
';',
'i', 'i', ';',
'i', 'i', 'i', 'i', 'n', 't', ';',
'i', 'i', 'n', 'f', 'i', 'n', ';',
'i', 'i', 'o', 't', 'a', ';',
'i', 'j', 'l', 'i', 'g', ';',
'i', 'm', 'a', 'c', 'r', ';',
'i', 'm', 'a', 'g', 'e', ';',
'i', 'm', 'a', 'g', 'l', 'i', 'n', 'e', ';',
'i', 'm', 'a', 'g', 'p', 'a', 'r', 't', ';',
'i', 'm', 'a', 't', 'h', ';',
'i', 'm', 'o', 'f', ';',
'i', 'm', 'p', 'e', 'd', ';',
'i', 'n', 'c', 'a', 'r', 'e', ';',
'i', 'n', 'f', 'i', 'n', 't', 'i', 'e', ';',
'i', 'n', 'o', 'd', 'o', 't', ';',
'i', 'n', 't', 'c', 'a', 'l', ';',
'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ';',
'i', 'n', 't', 'e', 'r', 'c', 'a', 'l', ';',
'i', 'n', 't', 'l', 'a', 'r', 'h', 'k', ';',
'i', 'n', 't', 'p', 'r', 'o', 'd', ';',
'i', 'o', 'c', 'y', ';',
'i', 'o', 'g', 'o', 'n', ';',
'i', 'o', 'p', 'f', ';',
'i', 'p', 'r', 'o', 'd', ';',
'i', 'q', 'u', 'e', 's', 't',
';',
'i', 's', 'c', 'r', ';',
'i', 's', 'i', 'n', 'E', ';',
'i', 's', 'i', 'n', 'd', 'o', 't', ';',
'i', 's', 'i', 'n', 's', ';',
'i', 's', 'i', 'n', 's', 'v', ';',
'i', 's', 'i', 'n', 'v', ';',
'i', 't', 'i', 'l', 'd', 'e', ';',
'i', 'u', 'k', 'c', 'y', ';',
'i', 'u', 'm', 'l',
';',
'j', 'c', 'i', 'r', 'c', ';',
'j', 'f', 'r', ';',
'j', 'm', 'a', 't', 'h', ';',
'j', 'o', 'p', 'f', ';',
'j', 's', 'c', 'r', ';',
'j', 's', 'e', 'r', 'c', 'y', ';',
'j', 'u', 'k', 'c', 'y', ';',
'k', 'a', 'p', 'p', 'a', ';',
'k', 'a', 'p', 'p', 'a', 'v', ';',
'k', 'c', 'e', 'd', 'i', 'l', ';',
'k', 'f', 'r', ';',
'k', 'g', 'r', 'e', 'e', 'n', ';',
'k', 'h', 'c', 'y', ';',
'k', 'j', 'c', 'y', ';',
'k', 'o', 'p', 'f', ';',
'k', 's', 'c', 'r', ';',
'l', 'A', 'a', 'r', 'r', ';',
'l', 'A', 'r', 'r', ';',
'l', 'A', 't', 'a', 'i', 'l', ';',
'l', 'B', 'a', 'r', 'r', ';',
'l', 'E', 'g', ';',
'l', 'H', 'a', 'r', ';',
'l', 'a', 'c', 'u', 't', 'e', ';',
'l', 'a', 'e', 'm', 'p', 't', 'y', 'v', ';',
'l', 'a', 'g', 'r', 'a', 'n', ';',
'l', 'a', 'm', 'b', 'd', 'a', ';',
'l', 'a', 'n', 'g', ';',
'l', 'a', 'n', 'g', 'd', ';',
'l', 'a', 'n', 'g', 'l', 'e', ';',
'l', 'a', 'p', ';',
'l', 'a', 'q', 'u', 'o',
';',
'l', 'a', 'r', 'r', 'b', ';',
'l', 'a', 'r', 'r', 'b', 'f', 's', ';',
'l', 'a', 'r', 'r', 'f', 's', ';',
'l', 'a', 'r', 'r', 'h', 'k', ';',
'l', 'a', 'r', 'r', 'l', 'p', ';',
'l', 'a', 'r', 'r', 'p', 'l', ';',
'l', 'a', 'r', 'r', 's', 'i', 'm', ';',
'l', 'a', 'r', 'r', 't', 'l', ';',
'l', 'a', 't', 'a', 'i', 'l', ';',
'l', 'a', 't', 'e', ';',
'l', 'a', 't', 'e', 's', ';',
'l', 'b', 'a', 'r', 'r', ';',
'l', 'b', 'b', 'r', 'k', ';',
'l', 'b', 'r', 'a', 'c', 'e', ';',
'l', 'b', 'r', 'a', 'c', 'k', ';',
'l', 'b', 'r', 'k', 'e', ';',
'l', 'b', 'r', 'k', 's', 'l', 'd', ';',
'l', 'b', 'r', 'k', 's', 'l', 'u', ';',
'l', 'c', 'a', 'r', 'o', 'n', ';',
'l', 'c', 'e', 'd', 'i', 'l', ';',
'l', 'c', 'e', 'i', 'l', ';',
'l', 'c', 'u', 'b', ';',
'l', 'c', 'y', ';',
'l', 'd', 'c', 'a', ';',
'l', 'd', 'q', 'u', 'o', ';',
'l', 'd', 'q', 'u', 'o', 'r', ';',
'l', 'd', 'r', 'd', 'h', 'a', 'r', ';',
'l', 'd', 'r', 'u', 's', 'h', 'a', 'r', ';',
'l', 'd', 's', 'h', ';',
'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', 't', 'a', 'i', 'l', ';',
'l', 'e', 'f', 't', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'd', 'o', 'w', 'n', ';',
'l', 'e', 'f', 't', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'u', 'p', ';',
'l', 'e', 'f', 't', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', 's', ';',
'l', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', 's', ';',
'l', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 's', ';',
'l', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 's', 'q', 'u', 'i', 'g', 'a', 'r', 'r', 'o', 'w', ';',
'l', 'e', 'f', 't', 't', 'h', 'r', 'e', 'e', 't', 'i', 'm', 'e', 's', ';',
'l', 'e', 'g', ';',
'l', 'e', 'q', ';',
'l', 'e', 'q', 'q', ';',
'l', 'e', 'q', 's', 'l', 'a', 'n', 't', ';',
'l', 'e', 's', 'c', 'c', ';',
'l', 'e', 's', 'd', 'o', 't', ';',
'l', 'e', 's', 'd', 'o', 't', 'o', ';',
'l', 'e', 's', 'd', 'o', 't', 'o', 'r', ';',
'l', 'e', 's', 'g', ';',
'l', 'e', 's', 'g', 'e', 's', ';',
'l', 'e', 's', 's', 'a', 'p', 'p', 'r', 'o', 'x', ';',
'l', 'e', 's', 's', 'd', 'o', 't', ';',
'l', 'e', 's', 's', 'e', 'q', 'g', 't', 'r', ';',
'l', 'e', 's', 's', 'e', 'q', 'q', 'g', 't', 'r', ';',
'l', 'e', 's', 's', 'g', 't', 'r', ';',
'l', 'e', 's', 's', 's', 'i', 'm', ';',
'l', 'f', 'i', 's', 'h', 't', ';',
'l', 'f', 'l', 'o', 'o', 'r', ';',
'l', 'f', 'r', ';',
'l', 'g', 'E', ';',
'l', 'h', 'a', 'r', 'd', ';',
'l', 'h', 'a', 'r', 'u', ';',
'l', 'h', 'a', 'r', 'u', 'l', ';',
'l', 'h', 'b', 'l', 'k', ';',
'l', 'j', 'c', 'y', ';',
'l', 'l', 'a', 'r', 'r', ';',
'l', 'l', 'c', 'o', 'r', 'n', 'e', 'r', ';',
'l', 'l', 'h', 'a', 'r', 'd', ';',
'l', 'l', 't', 'r', 'i', ';',
'l', 'm', 'i', 'd', 'o', 't', ';',
'l', 'm', 'o', 'u', 's', 't', ';',
'l', 'm', 'o', 'u', 's', 't', 'a', 'c', 'h', 'e', ';',
'l', 'n', 'E', ';',
'l', 'n', 'a', 'p', ';',
'l', 'n', 'a', 'p', 'p', 'r', 'o', 'x', ';',
'l', 'n', 'e', ';',
'l', 'n', 'e', 'q', ';',
'l', 'n', 'e', 'q', 'q', ';',
'l', 'n', 's', 'i', 'm', ';',
'l', 'o', 'a', 'n', 'g', ';',
'l', 'o', 'a', 'r', 'r', ';',
'l', 'o', 'b', 'r', 'k', ';',
'l', 'o', 'n', 'g', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
'l', 'o', 'n', 'g', 'l', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'l', 'o', 'n', 'g', 'm', 'a', 'p', 's', 't', 'o', ';',
'l', 'o', 'n', 'g', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'l', 'o', 'o', 'p', 'a', 'r', 'r', 'o', 'w', 'l', 'e', 'f', 't', ';',
'l', 'o', 'o', 'p', 'a', 'r', 'r', 'o', 'w', 'r', 'i', 'g', 'h', 't', ';',
'l', 'o', 'p', 'a', 'r', ';',
'l', 'o', 'p', 'f', ';',
'l', 'o', 'p', 'l', 'u', 's', ';',
'l', 'o', 't', 'i', 'm', 'e', 's', ';',
'l', 'o', 'w', 'a', 's', 't', ';',
'l', 'o', 'w', 'b', 'a', 'r', ';',
'l', 'o', 'z', ';',
'l', 'o', 'z', 'f', ';',
'l', 'p', 'a', 'r', ';',
'l', 'p', 'a', 'r', 'l', 't', ';',
'l', 'r', 'a', 'r', 'r', ';',
'l', 'r', 'c', 'o', 'r', 'n', 'e', 'r', ';',
'l', 'r', 'h', 'a', 'r', ';',
'l', 'r', 'h', 'a', 'r', 'd', ';',
'l', 'r', 'm', ';',
'l', 'r', 't', 'r', 'i', ';',
'l', 's', 'a', 'q', 'u', 'o', ';',
'l', 's', 'c', 'r', ';',
'l', 's', 'h', ';',
'l', 's', 'i', 'm', ';',
'l', 's', 'i', 'm', 'e', ';',
'l', 's', 'i', 'm', 'g', ';',
'l', 's', 'q', 'b', ';',
'l', 's', 'q', 'u', 'o', ';',
'l', 's', 'q', 'u', 'o', 'r', ';',
'l', 's', 't', 'r', 'o', 'k', ';',
'l', 't', 'c', 'c', ';',
'l', 't', 'c', 'i', 'r', ';',
'l', 't', 'd', 'o', 't', ';',
'l', 't', 'h', 'r', 'e', 'e', ';',
'l', 't', 'i', 'm', 'e', 's', ';',
'l', 't', 'l', 'a', 'r', 'r', ';',
'l', 't', 'q', 'u', 'e', 's', 't', ';',
'l', 't', 'r', 'P', 'a', 'r', ';',
'l', 't', 'r', 'i', 'e', ';',
'l', 't', 'r', 'i', 'f', ';',
'l', 'u', 'r', 'd', 's', 'h', 'a', 'r', ';',
'l', 'u', 'r', 'u', 'h', 'a', 'r', ';',
'l', 'v', 'e', 'r', 't', 'n', 'e', 'q', 'q', ';',
'l', 'v', 'n', 'E', ';',
'm', 'D', 'D', 'o', 't', ';',
'm', 'a', 'l', 't', ';',
'm', 'a', 'l', 't', 'e', 's', 'e', ';',
'm', 'a', 'p', ';',
'm', 'a', 'p', 's', 't', 'o', 'd', 'o', 'w', 'n', ';',
'm', 'a', 'p', 's', 't', 'o', 'l', 'e', 'f', 't', ';',
'm', 'a', 'p', 's', 't', 'o', 'u', 'p', ';',
'm', 'a', 'r', 'k', 'e', 'r', ';',
'm', 'c', 'o', 'm', 'm', 'a', ';',
'm', 'c', 'y', ';',
'm', 'd', 'a', 's', 'h', ';',
'm', 'e', 'a', 's', 'u', 'r', 'e', 'd', 'a', 'n', 'g', 'l', 'e', ';',
'm', 'f', 'r', ';',
'm', 'h', 'o', ';',
'm', 'i', 'c', 'r', 'o', ';',
'm', 'i', 'd', 'a', 's', 't', ';',
'm', 'i', 'd', 'c', 'i', 'r', ';',
'm', 'i', 'd', 'd', 'o', 't',
';',
'm', 'i', 'n', 'u', 's', 'b', ';',
'm', 'i', 'n', 'u', 's', 'd', ';',
'm', 'i', 'n', 'u', 's', 'd', 'u', ';',
'm', 'l', 'c', 'p', ';',
'm', 'l', 'd', 'r', ';',
'm', 'n', 'p', 'l', 'u', 's', ';',
'm', 'o', 'd', 'e', 'l', 's', ';',
'm', 'o', 'p', 'f', ';',
'm', 's', 'c', 'r', ';',
'm', 's', 't', 'p', 'o', 's', ';',
'm', 'u', ';',
'm', 'u', 'l', 't', 'i', 'm', 'a', 'p', ';',
'm', 'u', 'm', 'a', 'p', ';',
'n', 'G', 'g', ';',
'n', 'G', 't', ';',
'n', 'G', 't', 'v', ';',
'n', 'L', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'L', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'L', 'l', ';',
'n', 'L', 't', ';',
'n', 'L', 't', 'v', ';',
'n', 'R', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'V', 'D', 'a', 's', 'h', ';',
'n', 'V', 'd', 'a', 's', 'h', ';',
'n', 'a', 'b', 'l', 'a', ';',
'n', 'a', 'c', 'u', 't', 'e', ';',
'n', 'a', 'n', 'g', ';',
'n', 'a', 'p', 'E', ';',
'n', 'a', 'p', 'i', 'd', ';',
'n', 'a', 'p', 'o', 's', ';',
'n', 'a', 't', 'u', 'r', ';',
'n', 'a', 't', 'u', 'r', 'a', 'l', ';',
'n', 'a', 't', 'u', 'r', 'a', 'l', 's', ';',
'n', 'b', 's', 'p',
';',
'n', 'b', 'u', 'm', 'p', ';',
'n', 'b', 'u', 'm', 'p', 'e', ';',
'n', 'c', 'a', 'p', ';',
'n', 'c', 'a', 'r', 'o', 'n', ';',
'n', 'c', 'e', 'd', 'i', 'l', ';',
'n', 'c', 'o', 'n', 'g', ';',
'n', 'c', 'o', 'n', 'g', 'd', 'o', 't', ';',
'n', 'c', 'u', 'p', ';',
'n', 'c', 'y', ';',
'n', 'd', 'a', 's', 'h', ';',
'n', 'e', 'A', 'r', 'r', ';',
'n', 'e', 'a', 'r', 'h', 'k', ';',
'n', 'e', 'a', 'r', 'r', ';',
'n', 'e', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'e', 'd', 'o', 't', ';',
'n', 'e', 's', 'e', 'a', 'r', ';',
'n', 'e', 's', 'i', 'm', ';',
'n', 'e', 'x', 'i', 's', 't', ';',
'n', 'e', 'x', 'i', 's', 't', 's', ';',
'n', 'f', 'r', ';',
'n', 'g', 'E', ';',
'n', 'g', 'e', 'q', ';',
'n', 'g', 'e', 'q', 'q', ';',
'n', 'g', 'e', 'q', 's', 'l', 'a', 'n', 't', ';',
'n', 'g', 'e', 's', ';',
'n', 'g', 's', 'i', 'm', ';',
'n', 'g', 't', ';',
'n', 'g', 't', 'r', ';',
'n', 'h', 'A', 'r', 'r', ';',
'n', 'h', 'a', 'r', 'r', ';',
'n', 'h', 'p', 'a', 'r', ';',
'n', 'i', ';',
'n', 'i', 's', ';',
'n', 'i', 's', 'd', ';',
'n', 'i', 'v', ';',
'n', 'j', 'c', 'y', ';',
'n', 'l', 'A', 'r', 'r', ';',
'n', 'l', 'E', ';',
'n', 'l', 'a', 'r', 'r', ';',
'n', 'l', 'd', 'r', ';',
'n', 'l', 'e', ';',
'n', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'l', 'e', 'f', 't', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'l', 'e', 'q', ';',
'n', 'l', 'e', 'q', 'q', ';',
'n', 'l', 'e', 'q', 's', 'l', 'a', 'n', 't', ';',
'n', 'l', 'e', 's', ';',
'n', 'l', 'e', 's', 's', ';',
'n', 'l', 's', 'i', 'm', ';',
'n', 'l', 't', ';',
'n', 'l', 't', 'r', 'i', ';',
'n', 'l', 't', 'r', 'i', 'e', ';',
'n', 'm', 'i', 'd', ';',
'n', 'o', 'p', 'f', ';',
'n', 'o', 't', 'i', 'n', ';',
'n', 'o', 't', 'i', 'n', 'E', ';',
'n', 'o', 't', 'i', 'n', 'd', 'o', 't', ';',
'n', 'o', 't', 'i', 'n', 'v', 'a', ';',
'n', 'o', 't', 'i', 'n', 'v', 'b', ';',
'n', 'o', 't', 'i', 'n', 'v', 'c', ';',
'n', 'o', 't', 'n', 'i', ';',
'n', 'o', 't', 'n', 'i', 'v', 'a', ';',
'n', 'o', 't', 'n', 'i', 'v', 'b', ';',
'n', 'o', 't', 'n', 'i', 'v', 'c', ';',
'n', 'p', 'a', 'r', ';',
'n', 'p', 'a', 'r', 'a', 'l', 'l', 'e', 'l', ';',
'n', 'p', 'a', 'r', 's', 'l', ';',
'n', 'p', 'a', 'r', 't', ';',
'n', 'p', 'o', 'l', 'i', 'n', 't', ';',
'n', 'p', 'r', ';',
'n', 'p', 'r', 'c', 'u', 'e', ';',
'n', 'p', 'r', 'e', ';',
'n', 'p', 'r', 'e', 'c', ';',
'n', 'p', 'r', 'e', 'c', 'e', 'q', ';',
'n', 'r', 'A', 'r', 'r', ';',
'n', 'r', 'a', 'r', 'r', ';',
'n', 'r', 'a', 'r', 'r', 'c', ';',
'n', 'r', 'a', 'r', 'r', 'w', ';',
'n', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'r', 't', 'r', 'i', ';',
'n', 'r', 't', 'r', 'i', 'e', ';',
'n', 's', 'c', ';',
'n', 's', 'c', 'c', 'u', 'e', ';',
'n', 's', 'c', 'e', ';',
'n', 's', 'c', 'r', ';',
'n', 's', 'h', 'o', 'r', 't', 'm', 'i', 'd', ';',
'n', 's', 'h', 'o', 'r', 't', 'p', 'a', 'r', 'a', 'l', 'l', 'e', 'l', ';',
'n', 's', 'i', 'm', 'e', ';',
'n', 's', 'i', 'm', 'e', 'q', ';',
'n', 's', 'm', 'i', 'd', ';',
'n', 's', 'p', 'a', 'r', ';',
'n', 's', 'q', 's', 'u', 'b', 'e', ';',
'n', 's', 'q', 's', 'u', 'p', 'e', ';',
'n', 's', 'u', 'b', ';',
'n', 's', 'u', 'b', 'E', ';',
'n', 's', 'u', 'b', 'e', ';',
'n', 's', 'u', 'b', 's', 'e', 't', ';',
'n', 's', 'u', 'b', 's', 'e', 't', 'e', 'q', ';',
'n', 's', 'u', 'b', 's', 'e', 't', 'e', 'q', 'q', ';',
'n', 's', 'u', 'c', 'c', ';',
'n', 's', 'u', 'c', 'c', 'e', 'q', ';',
'n', 's', 'u', 'p', ';',
'n', 's', 'u', 'p', 'E', ';',
'n', 's', 'u', 'p', 'e', ';',
'n', 's', 'u', 'p', 's', 'e', 't', ';',
'n', 's', 'u', 'p', 's', 'e', 't', 'e', 'q', ';',
'n', 's', 'u', 'p', 's', 'e', 't', 'e', 'q', 'q', ';',
'n', 't', 'g', 'l', ';',
'n', 't', 'i', 'l', 'd', 'e',
';',
'n', 't', 'l', 'g', ';',
'n', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'l', 'e', 'f', 't', ';',
'n', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'l', 'e', 'f', 't', 'e', 'q', ';',
'n', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'r', 'i', 'g', 'h', 't', ';',
'n', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'r', 'i', 'g', 'h', 't', 'e', 'q', ';',
'n', 'u', ';',
'n', 'u', 'm', ';',
'n', 'u', 'm', 'e', 'r', 'o', ';',
'n', 'u', 'm', 's', 'p', ';',
'n', 'v', 'D', 'a', 's', 'h', ';',
'n', 'v', 'H', 'a', 'r', 'r', ';',
'n', 'v', 'a', 'p', ';',
'n', 'v', 'd', 'a', 's', 'h', ';',
'n', 'v', 'g', 'e', ';',
'n', 'v', 'g', 't', ';',
'n', 'v', 'i', 'n', 'f', 'i', 'n', ';',
'n', 'v', 'l', 'A', 'r', 'r', ';',
'n', 'v', 'l', 'e', ';',
'n', 'v', 'l', 't', ';',
'n', 'v', 'l', 't', 'r', 'i', 'e', ';',
'n', 'v', 'r', 'A', 'r', 'r', ';',
'n', 'v', 'r', 't', 'r', 'i', 'e', ';',
'n', 'v', 's', 'i', 'm', ';',
'n', 'w', 'A', 'r', 'r', ';',
'n', 'w', 'a', 'r', 'h', 'k', ';',
'n', 'w', 'a', 'r', 'r', ';',
'n', 'w', 'a', 'r', 'r', 'o', 'w', ';',
'n', 'w', 'n', 'e', 'a', 'r', ';',
'o', 'S', ';',
'o', 'a', 'c', 'u', 't', 'e',
';',
'o', 'a', 's', 't', ';',
'o', 'c', 'i', 'r', 'c',
';',
'o', 'd', 'a', 's', 'h', ';',
'o', 'd', 'b', 'l', 'a', 'c', ';',
'o', 'd', 'i', 'v', ';',
'o', 'd', 's', 'o', 'l', 'd', ';',
'o', 'e', 'l', 'i', 'g', ';',
'o', 'f', 'c', 'i', 'r', ';',
'o', 'f', 'r', ';',
'o', 'g', 'r', 'a', 'v', 'e',
';',
'o', 'g', 't', ';',
'o', 'h', 'b', 'a', 'r', ';',
'o', 'h', 'm', ';',
'o', 'i', 'n', 't', ';',
'o', 'l', 'a', 'r', 'r', ';',
'o', 'l', 'c', 'i', 'r', ';',
'o', 'l', 'c', 'r', 'o', 's', 's', ';',
'o', 'l', 'i', 'n', 'e', ';',
'o', 'l', 't', ';',
'o', 'm', 'a', 'c', 'r', ';',
'o', 'm', 'e', 'g', 'a', ';',
'o', 'm', 'i', 'c', 'r', 'o', 'n', ';',
'o', 'm', 'i', 'd', ';',
'o', 'm', 'i', 'n', 'u', 's', ';',
'o', 'o', 'p', 'f', ';',
'o', 'p', 'e', 'r', 'p', ';',
'o', 'r', 'a', 'r', 'r', ';',
'o', 'r', 'd', ';',
'o', 'r', 'd', 'e', 'r', ';',
'o', 'r', 'd', 'e', 'r', 'o', 'f', ';',
'o', 'r', 'd', 'f',
';',
'o', 'r', 'd', 'm',
';',
'o', 'r', 'i', 'g', 'o', 'f', ';',
'o', 'r', 'o', 'r', ';',
'o', 'r', 's', 'l', 'o', 'p', 'e', ';',
'o', 'r', 'v', ';',
'o', 's', 'c', 'r', ';',
'o', 's', 'l', 'a', 's', 'h',
';',
'o', 's', 'o', 'l', ';',
'o', 't', 'i', 'l', 'd', 'e',
';',
'o', 't', 'i', 'm', 'e', 's', 'a', 's', ';',
'o', 'u', 'm', 'l',
';',
'o', 'v', 'b', 'a', 'r', ';',
'p', 'a', 'r', 'a', ';',
'p', 'a', 'r', 's', 'i', 'm', ';',
'p', 'c', 'y', ';',
'p', 'e', 'r', 'c', 'n', 't', ';',
'p', 'e', 'r', 'i', 'o', 'd', ';',
'p', 'e', 'r', 'm', 'i', 'l', ';',
'p', 'e', 'r', 't', 'e', 'n', 'k', ';',
'p', 'f', 'r', ';',
'p', 'h', 'i', ';',
'p', 'h', 'i', 'v', ';',
'p', 'h', 'm', 'm', 'a', 't', ';',
'p', 'h', 'o', 'n', 'e', ';',
'p', 'i', ';',
'p', 'i', 't', 'c', 'h', 'f', 'o', 'r', 'k', ';',
'p', 'i', 'v', ';',
'p', 'l', 'a', 'n', 'c', 'k', ';',
'p', 'l', 'a', 'n', 'c', 'k', 'h', ';',
'p', 'l', 'a', 'n', 'k', 'v', ';',
'p', 'l', 'u', 's', 'a', 'c', 'i', 'r', ';',
'p', 'l', 'u', 's', 'b', ';',
'p', 'l', 'u', 's', 'c', 'i', 'r', ';',
'p', 'l', 'u', 's', 'd', 'o', ';',
'p', 'l', 'u', 's', 'd', 'u', ';',
'p', 'l', 'u', 's', 'e', ';',
'p', 'l', 'u', 's', 'm', 'n',
';',
'p', 'l', 'u', 's', 's', 'i', 'm', ';',
'p', 'l', 'u', 's', 't', 'w', 'o', ';',
'p', 'm', ';',
'p', 'o', 'i', 'n', 't', 'i', 'n', 't', ';',
'p', 'o', 'p', 'f', ';',
'p', 'o', 'u', 'n', 'd',
';',
'p', 'r', 'E', ';',
'p', 'r', 'a', 'p', ';',
'p', 'r', 'e', 'c', 'a', 'p', 'p', 'r', 'o', 'x', ';',
'p', 'r', 'e', 'c', 'c', 'u', 'r', 'l', 'y', 'e', 'q', ';',
'p', 'r', 'e', 'c', 'n', 'a', 'p', 'p', 'r', 'o', 'x', ';',
'p', 'r', 'e', 'c', 'n', 'e', 'q', 'q', ';',
'p', 'r', 'e', 'c', 'n', 's', 'i', 'm', ';',
'p', 'r', 'e', 'c', 's', 'i', 'm', ';',
'p', 'r', 'i', 'm', 'e', 's', ';',
'p', 'r', 'n', 'E', ';',
'p', 'r', 'n', 'a', 'p', ';',
'p', 'r', 'n', 's', 'i', 'm', ';',
'p', 'r', 'o', 'f', 'a', 'l', 'a', 'r', ';',
'p', 'r', 'o', 'f', 'l', 'i', 'n', 'e', ';',
'p', 'r', 'o', 'f', 's', 'u', 'r', 'f', ';',
'p', 'r', 'o', 'p', ';',
'p', 'r', 'o', 'p', 't', 'o', ';',
'p', 'r', 's', 'i', 'm', ';',
'p', 'r', 'u', 'r', 'e', 'l', ';',
'p', 's', 'c', 'r', ';',
'p', 'u', 'n', 'c', 's', 'p', ';',
'q', 'f', 'r', ';',
'q', 'i', 'n', 't', ';',
'q', 'o', 'p', 'f', ';',
'q', 'p', 'r', 'i', 'm', 'e', ';',
'q', 's', 'c', 'r', ';',
'q', 'u', 'a', 't', 'e', 'r', 'n', 'i', 'o', 'n', 's', ';',
'q', 'u', 'a', 't', 'i', 'n', 't', ';',
'q', 'u', 'e', 's', 't', 'e', 'q', ';',
'q', 'u', 'o', 't',
';',
'r', 'A', 'a', 'r', 'r', ';',
'r', 'A', 't', 'a', 'i', 'l', ';',
'r', 'B', 'a', 'r', 'r', ';',
'r', 'H', 'a', 'r', ';',
'r', 'a', 'c', 'u', 't', 'e', ';',
'r', 'a', 'd', 'i', 'c', ';',
'r', 'a', 'e', 'm', 'p', 't', 'y', 'v', ';',
'r', 'a', 'n', 'g', ';',
'r', 'a', 'n', 'g', 'd', ';',
'r', 'a', 'n', 'g', 'e', ';',
'r', 'a', 'n', 'g', 'l', 'e', ';',
'r', 'a', 'q', 'u', 'o',
';',
'r', 'a', 'r', 'r', 'a', 'p', ';',
'r', 'a', 'r', 'r', 'b', ';',
'r', 'a', 'r', 'r', 'b', 'f', 's', ';',
'r', 'a', 'r', 'r', 'f', 's', ';',
'r', 'a', 'r', 'r', 'h', 'k', ';',
'r', 'a', 'r', 'r', 'l', 'p', ';',
'r', 'a', 'r', 'r', 'p', 'l', ';',
'r', 'a', 'r', 'r', 's', 'i', 'm', ';',
'r', 'a', 'r', 'r', 't', 'l', ';',
'r', 'a', 't', 'a', 'i', 'l', ';',
'r', 'a', 't', 'i', 'o', ';',
'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ';',
'r', 'b', 'a', 'r', 'r', ';',
'r', 'b', 'b', 'r', 'k', ';',
'r', 'b', 'r', 'a', 'c', 'e', ';',
'r', 'b', 'r', 'a', 'c', 'k', ';',
'r', 'b', 'r', 'k', 'e', ';',
'r', 'b', 'r', 'k', 's', 'l', 'd', ';',
'r', 'b', 'r', 'k', 's', 'l', 'u', ';',
'r', 'c', 'a', 'r', 'o', 'n', ';',
'r', 'c', 'e', 'd', 'i', 'l', ';',
'r', 'c', 'e', 'i', 'l', ';',
'r', 'c', 'u', 'b', ';',
'r', 'd', 'c', 'a', ';',
'r', 'd', 'l', 'd', 'h', 'a', 'r', ';',
'r', 'd', 'q', 'u', 'o', ';',
'r', 'd', 'q', 'u', 'o', 'r', ';',
'r', 'd', 's', 'h', ';',
'r', 'e', 'a', 'l', ';',
'r', 'e', 'a', 'l', 'i', 'n', 'e', ';',
'r', 'e', 'a', 'l', 'p', 'a', 'r', 't', ';',
'r', 'e', 'a', 'l', 's', ';',
'r', 'e', 'c', 't', ';',
'r', 'e', 'g',
';',
'r', 'f', 'i', 's', 'h', 't', ';',
'r', 'f', 'l', 'o', 'o', 'r', ';',
'r', 'f', 'r', ';',
'r', 'h', 'a', 'r', 'u', ';',
'r', 'h', 'a', 'r', 'u', 'l', ';',
'r', 'h', 'o', ';',
'r', 'h', 'o', 'v', ';',
'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', 't', 'a', 'i', 'l', ';',
'r', 'i', 'g', 'h', 't', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'd', 'o', 'w', 'n', ';',
'r', 'i', 'g', 'h', 't', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'u', 'p', ';',
'r', 'i', 'g', 'h', 't', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', 's', ';',
'r', 'i', 'g', 'h', 't', 'l', 'e', 'f', 't', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 's', ';',
'r', 'i', 'g', 'h', 't', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', 's', ';',
'r', 'i', 'g', 'h', 't', 't', 'h', 'r', 'e', 'e', 't', 'i', 'm', 'e', 's', ';',
'r', 'i', 's', 'i', 'n', 'g', 'd', 'o', 't', 's', 'e', 'q', ';',
'r', 'l', 'a', 'r', 'r', ';',
'r', 'l', 'h', 'a', 'r', ';',
'r', 'l', 'm', ';',
'r', 'm', 'o', 'u', 's', 't', ';',
'r', 'm', 'o', 'u', 's', 't', 'a', 'c', 'h', 'e', ';',
'r', 'n', 'm', 'i', 'd', ';',
'r', 'o', 'a', 'n', 'g', ';',
'r', 'o', 'a', 'r', 'r', ';',
'r', 'o', 'b', 'r', 'k', ';',
'r', 'o', 'p', 'a', 'r', ';',
'r', 'o', 'p', 'f', ';',
'r', 'o', 'p', 'l', 'u', 's', ';',
'r', 'o', 't', 'i', 'm', 'e', 's', ';',
'r', 'p', 'a', 'r', ';',
'r', 'p', 'a', 'r', 'g', 't', ';',
'r', 'p', 'p', 'o', 'l', 'i', 'n', 't', ';',
'r', 'r', 'a', 'r', 'r', ';',
'r', 's', 'a', 'q', 'u', 'o', ';',
'r', 's', 'c', 'r', ';',
'r', 's', 'h', ';',
'r', 's', 'q', 'b', ';',
'r', 's', 'q', 'u', 'o', ';',
'r', 's', 'q', 'u', 'o', 'r', ';',
'r', 't', 'h', 'r', 'e', 'e', ';',
'r', 't', 'i', 'm', 'e', 's', ';',
'r', 't', 'r', 'i', 'f', ';',
'r', 't', 'r', 'i', 'l', 't', 'r', 'i', ';',
'r', 'u', 'l', 'u', 'h', 'a', 'r', ';',
'r', 'x', ';',
's', 'a', 'c', 'u', 't', 'e', ';',
's', 'b', 'q', 'u', 'o', ';',
's', 'c', 'E', ';',
's', 'c', 'a', 'p', ';',
's', 'c', 'a', 'r', 'o', 'n', ';',
's', 'c', 'e', 'd', 'i', 'l', ';',
's', 'c', 'i', 'r', 'c', ';',
's', 'c', 'n', 'E', ';',
's', 'c', 'n', 'a', 'p', ';',
's', 'c', 'n', 's', 'i', 'm', ';',
's', 'c', 'p', 'o', 'l', 'i', 'n', 't', ';',
's', 'c', 's', 'i', 'm', ';',
's', 'd', 'o', 't', 'b', ';',
's', 'd', 'o', 't', 'e', ';',
's', 'e', 'A', 'r', 'r', ';',
's', 'e', 'a', 'r', 'h', 'k', ';',
's', 'e', 'a', 'r', 'r', ';',
's', 'e', 'a', 'r', 'r', 'o', 'w', ';',
's', 'e', 'c', 't', ';',
's', 'e', 's', 'w', 'a', 'r', ';',
's', 'e', 't', 'm', 'i', 'n', 'u', 's', ';',
's', 'e', 't', 'm', 'n', ';',
's', 'e', 'x', 't', ';',
's', 'f', 'r', ';',
's', 'f', 'r', 'o', 'w', 'n', ';',
's', 'h', 'a', 'r', 'p', ';',
's', 'h', 'c', 'h', 'c', 'y', ';',
's', 'h', 'c', 'y', ';',
's', 'h', 'y',
';',
's', 'i', 'g', 'm', 'a', ';',
's', 'i', 'g', 'm', 'a', 'f', ';',
's', 'i', 'g', 'm', 'a', 'v', ';',
's', 'i', 'm', 'd', 'o', 't', ';',
's', 'i', 'm', 'g', 'E', ';',
's', 'i', 'm', 'l', 'E', ';',
's', 'i', 'm', 'n', 'e', ';',
's', 'i', 'm', 'p', 'l', 'u', 's', ';',
's', 'i', 'm', 'r', 'a', 'r', 'r', ';',
's', 'l', 'a', 'r', 'r', ';',
's', 'm', 'a', 'l', 'l', 's', 'e', 't', 'm', 'i', 'n', 'u', 's', ';',
's', 'm', 'a', 's', 'h', 'p', ';',
's', 'm', 'e', 'p', 'a', 'r', 's', 'l', ';',
's', 'm', 'i', 'l', 'e', ';',
's', 'm', 't', ';',
's', 'm', 't', 'e', ';',
's', 'm', 't', 'e', 's', ';',
's', 'o', 'f', 't', 'c', 'y', ';',
's', 'o', 'l', 'b', 'a', 'r', ';',
's', 'o', 'p', 'f', ';',
's', 'p', 'a', 'd', 'e', 's', ';',
's', 'p', 'a', 'd', 'e', 's', 'u', 'i', 't', ';',
's', 'q', 'c', 'a', 'p', ';',
's', 'q', 'c', 'a', 'p', 's', ';',
's', 'q', 'c', 'u', 'p', 's', ';',
's', 'q', 's', 'u', 'b', ';',
's', 'q', 's', 'u', 'b', 's', 'e', 't', ';',
's', 'q', 's', 'u', 'b', 's', 'e', 't', 'e', 'q', ';',
's', 'q', 's', 'u', 'p', ';',
's', 'q', 's', 'u', 'p', 's', 'e', 't', ';',
's', 'q', 's', 'u', 'p', 's', 'e', 't', 'e', 'q', ';',
's', 'q', 'u', ';',
's', 'q', 'u', 'a', 'r', 'f', ';',
's', 'q', 'u', 'f', ';',
's', 'r', 'a', 'r', 'r', ';',
's', 's', 'c', 'r', ';',
's', 's', 'e', 't', 'm', 'n', ';',
's', 's', 'm', 'i', 'l', 'e', ';',
's', 's', 't', 'a', 'r', 'f', ';',
's', 't', 'r', 'a', 'i', 'g', 'h', 't', 'e', 'p', 's', 'i', 'l', 'o', 'n', ';',
's', 't', 'r', 'a', 'i', 'g', 'h', 't', 'p', 'h', 'i', ';',
's', 't', 'r', 'n', 's', ';',
's', 'u', 'b', 'd', 'o', 't', ';',
's', 'u', 'b', 'e', 'd', 'o', 't', ';',
's', 'u', 'b', 'm', 'u', 'l', 't', ';',
's', 'u', 'b', 'n', 'E', ';',
's', 'u', 'b', 'n', 'e', ';',
's', 'u', 'b', 'p', 'l', 'u', 's', ';',
's', 'u', 'b', 'r', 'a', 'r', 'r', ';',
's', 'u', 'b', 's', 'e', 't', 'n', 'e', 'q', ';',
's', 'u', 'b', 's', 'e', 't', 'n', 'e', 'q', 'q', ';',
's', 'u', 'b', 's', 'i', 'm', ';',
's', 'u', 'b', 's', 'u', 'b', ';',
's', 'u', 'b', 's', 'u', 'p', ';',
's', 'u', 'c', 'c', 'a', 'p', 'p', 'r', 'o', 'x', ';',
's', 'u', 'c', 'c', 'c', 'u', 'r', 'l', 'y', 'e', 'q', ';',
's', 'u', 'c', 'c', 'n', 'a', 'p', 'p', 'r', 'o', 'x', ';',
's', 'u', 'c', 'c', 'n', 'e', 'q', 'q', ';',
's', 'u', 'c', 'c', 'n', 's', 'i', 'm', ';',
's', 'u', 'c', 'c', 's', 'i', 'm', ';',
's', 'u', 'm', ';',
's', 'u', 'n', 'g', ';',
's', 'u', 'p', '1',
';',
's', 'u', 'p', '2',
';',
's', 'u', 'p', '3',
';',
's', 'u', 'p', 'd', 'o', 't', ';',
's', 'u', 'p', 'd', 's', 'u', 'b', ';',
's', 'u', 'p', 'e', 'd', 'o', 't', ';',
's', 'u', 'p', 'h', 's', 'o', 'l', ';',
's', 'u', 'p', 'h', 's', 'u', 'b', ';',
's', 'u', 'p', 'l', 'a', 'r', 'r', ';',
's', 'u', 'p', 'm', 'u', 'l', 't', ';',
's', 'u', 'p', 'n', 'E', ';',
's', 'u', 'p', 'n', 'e', ';',
's', 'u', 'p', 'p', 'l', 'u', 's', ';',
's', 'u', 'p', 's', 'e', 't', 'n', 'e', 'q', ';',
's', 'u', 'p', 's', 'e', 't', 'n', 'e', 'q', 'q', ';',
's', 'u', 'p', 's', 'i', 'm', ';',
's', 'u', 'p', 's', 'u', 'b', ';',
's', 'u', 'p', 's', 'u', 'p', ';',
's', 'w', 'A', 'r', 'r', ';',
's', 'w', 'a', 'r', 'h', 'k', ';',
's', 'w', 'a', 'r', 'r', ';',
's', 'w', 'a', 'r', 'r', 'o', 'w', ';',
's', 'w', 'n', 'w', 'a', 'r', ';',
's', 'z', 'l', 'i', 'g',
';',
't', 'a', 'r', 'g', 'e', 't', ';',
't', 'a', 'u', ';',
't', 'c', 'a', 'r', 'o', 'n', ';',
't', 'c', 'e', 'd', 'i', 'l', ';',
't', 'e', 'l', 'r', 'e', 'c', ';',
't', 'f', 'r', ';',
't', 'h', 'e', 'r', 'e', '4', ';',
't', 'h', 'e', 'r', 'e', 'f', 'o', 'r', 'e', ';',
't', 'h', 'e', 't', 'a', ';',
't', 'h', 'e', 't', 'a', 's', 'y', 'm', ';',
't', 'h', 'e', 't', 'a', 'v', ';',
't', 'h', 'i', 'c', 'k', 'a', 'p', 'p', 'r', 'o', 'x', ';',
't', 'h', 'i', 'c', 'k', 's', 'i', 'm', ';',
't', 'h', 'i', 'n', 's', 'p', ';',
't', 'h', 'k', 'a', 'p', ';',
't', 'h', 'k', 's', 'i', 'm', ';',
't', 'h', 'o', 'r', 'n',
';',
't', 'i', 'm', 'e', 's', 'b', ';',
't', 'i', 'm', 'e', 's', 'b', 'a', 'r', ';',
't', 'i', 'm', 'e', 's', 'd', ';',
't', 'o', 'e', 'a', ';',
't', 'o', 'p', ';',
't', 'o', 'p', 'b', 'o', 't', ';',
't', 'o', 'p', 'c', 'i', 'r', ';',
't', 'o', 'p', 'f', ';',
't', 'o', 'p', 'f', 'o', 'r', 'k', ';',
't', 'o', 's', 'a', ';',
't', 'p', 'r', 'i', 'm', 'e', ';',
't', 'r', 'a', 'd', 'e', ';',
't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'q', ';',
't', 'r', 'i', 'd', 'o', 't', ';',
't', 'r', 'i', 'm', 'i', 'n', 'u', 's', ';',
't', 'r', 'i', 'p', 'l', 'u', 's', ';',
't', 'r', 'i', 's', 'b', ';',
't', 'r', 'i', 't', 'i', 'm', 'e', ';',
't', 'r', 'p', 'e', 'z', 'i', 'u', 'm', ';',
't', 's', 'c', 'r', ';',
't', 's', 'c', 'y', ';',
't', 's', 'h', 'c', 'y', ';',
't', 's', 't', 'r', 'o', 'k', ';',
't', 'w', 'i', 'x', 't', ';',
't', 'w', 'o', 'h', 'e', 'a', 'd', 'l', 'e', 'f', 't', 'a', 'r', 'r', 'o', 'w', ';',
't', 'w', 'o', 'h', 'e', 'a', 'd', 'r', 'i', 'g', 'h', 't', 'a', 'r', 'r', 'o', 'w', ';',
'u', 'A', 'r', 'r', ';',
'u', 'H', 'a', 'r', ';',
'u', 'a', 'c', 'u', 't', 'e',
';',
'u', 'b', 'r', 'c', 'y', ';',
'u', 'b', 'r', 'e', 'v', 'e', ';',
'u', 'c', 'i', 'r', 'c',
';',
'u', 'c', 'y', ';',
'u', 'd', 'a', 'r', 'r', ';',
'u', 'd', 'b', 'l', 'a', 'c', ';',
'u', 'd', 'h', 'a', 'r', ';',
'u', 'f', 'i', 's', 'h', 't', ';',
'u', 'f', 'r', ';',
'u', 'g', 'r', 'a', 'v', 'e',
';',
'u', 'h', 'a', 'r', 'l', ';',
'u', 'h', 'a', 'r', 'r', ';',
'u', 'h', 'b', 'l', 'k', ';',
'u', 'l', 'c', 'o', 'r', 'n', ';',
'u', 'l', 'c', 'o', 'r', 'n', 'e', 'r', ';',
'u', 'l', 'c', 'r', 'o', 'p', ';',
'u', 'l', 't', 'r', 'i', ';',
'u', 'm', 'a', 'c', 'r', ';',
'u', 'o', 'g', 'o', 'n', ';',
'u', 'o', 'p', 'f', ';',
'u', 'p', 'a', 'r', 'r', 'o', 'w', ';',
'u', 'p', 'd', 'o', 'w', 'n', 'a', 'r', 'r', 'o', 'w', ';',
'u', 'p', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'l', 'e', 'f', 't', ';',
'u', 'p', 'h', 'a', 'r', 'p', 'o', 'o', 'n', 'r', 'i', 'g', 'h', 't', ';',
'u', 'p', 's', 'i', ';',
'u', 'p', 's', 'i', 'h', ';',
'u', 'p', 's', 'i', 'l', 'o', 'n', ';',
'u', 'p', 'u', 'p', 'a', 'r', 'r', 'o', 'w', 's', ';',
'u', 'r', 'c', 'o', 'r', 'n', ';',
'u', 'r', 'c', 'o', 'r', 'n', 'e', 'r', ';',
'u', 'r', 'c', 'r', 'o', 'p', ';',
'u', 'r', 'i', 'n', 'g', ';',
'u', 'r', 't', 'r', 'i', ';',
'u', 's', 'c', 'r', ';',
'u', 't', 'd', 'o', 't', ';',
'u', 't', 'i', 'l', 'd', 'e', ';',
'u', 't', 'r', 'i', ';',
'u', 't', 'r', 'i', 'f', ';',
'u', 'u', 'a', 'r', 'r', ';',
'u', 'u', 'm', 'l',
';',
'u', 'w', 'a', 'n', 'g', 'l', 'e', ';',
'v', 'A', 'r', 'r', ';',
'v', 'B', 'a', 'r', ';',
'v', 'B', 'a', 'r', 'v', ';',
'v', 'a', 'n', 'g', 'r', 't', ';',
'v', 'a', 'r', 'e', 'p', 's', 'i', 'l', 'o', 'n', ';',
'v', 'a', 'r', 'k', 'a', 'p', 'p', 'a', ';',
'v', 'a', 'r', 'n', 'o', 't', 'h', 'i', 'n', 'g', ';',
'v', 'a', 'r', 'p', 'h', 'i', ';',
'v', 'a', 'r', 'p', 'i', ';',
'v', 'a', 'r', 'p', 'r', 'o', 'p', 't', 'o', ';',
'v', 'a', 'r', 'r', ';',
'v', 'a', 'r', 'r', 'h', 'o', ';',
'v', 'a', 'r', 's', 'i', 'g', 'm', 'a', ';',
'v', 'a', 'r', 's', 'u', 'b', 's', 'e', 't', 'n', 'e', 'q', ';',
'v', 'a', 'r', 's', 'u', 'b', 's', 'e', 't', 'n', 'e', 'q', 'q', ';',
'v', 'a', 'r', 's', 'u', 'p', 's', 'e', 't', 'n', 'e', 'q', ';',
'v', 'a', 'r', 's', 'u', 'p', 's', 'e', 't', 'n', 'e', 'q', 'q', ';',
'v', 'a', 'r', 't', 'h', 'e', 't', 'a', ';',
'v', 'a', 'r', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'l', 'e', 'f', 't', ';',
'v', 'a', 'r', 't', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 'r', 'i', 'g', 'h', 't', ';',
'v', 'c', 'y', ';',
'v', 'e', 'e', 'b', 'a', 'r', ';',
'v', 'e', 'e', 'e', 'q', ';',
'v', 'e', 'l', 'l', 'i', 'p', ';',
'v', 'e', 'r', 'b', 'a', 'r', ';',
'v', 'e', 'r', 't', ';',
'v', 'f', 'r', ';',
'v', 'l', 't', 'r', 'i', ';',
'v', 'n', 's', 'u', 'b', ';',
'v', 'n', 's', 'u', 'p', ';',
'v', 'o', 'p', 'f', ';',
'v', 'p', 'r', 'o', 'p', ';',
'v', 'r', 't', 'r', 'i', ';',
'v', 's', 'c', 'r', ';',
'v', 's', 'u', 'b', 'n', 'E', ';',
'v', 's', 'u', 'b', 'n', 'e', ';',
'v', 's', 'u', 'p', 'n', 'E', ';',
'v', 's', 'u', 'p', 'n', 'e', ';',
'v', 'z', 'i', 'g', 'z', 'a', 'g', ';',
'w', 'c', 'i', 'r', 'c', ';',
'w', 'e', 'd', 'b', 'a', 'r', ';',
'w', 'e', 'd', 'g', 'e', 'q', ';',
'w', 'e', 'i', 'e', 'r', 'p', ';',
'w', 'f', 'r', ';',
'w', 'o', 'p', 'f', ';',
'w', 'p', ';',
'w', 'r', ';',
'w', 'r', 'e', 'a', 't', 'h', ';',
'w', 's', 'c', 'r', ';',
'x', 'c', 'a', 'p', ';',
'x', 'c', 'i', 'r', 'c', ';',
'x', 'c', 'u', 'p', ';',
'x', 'd', 't', 'r', 'i', ';',
'x', 'f', 'r', ';',
'x', 'h', 'A', 'r', 'r', ';',
'x', 'h', 'a', 'r', 'r', ';',
'x', 'i', ';',
'x', 'l', 'A', 'r', 'r', ';',
'x', 'l', 'a', 'r', 'r', ';',
'x', 'm', 'a', 'p', ';',
'x', 'n', 'i', 's', ';',
'x', 'o', 'd', 'o', 't', ';',
'x', 'o', 'p', 'f', ';',
'x', 'o', 'p', 'l', 'u', 's', ';',
'x', 'o', 't', 'i', 'm', 'e', ';',
'x', 'r', 'A', 'r', 'r', ';',
'x', 'r', 'a', 'r', 'r', ';',
'x', 's', 'c', 'r', ';',
'x', 's', 'q', 'c', 'u', 'p', ';',
'x', 'u', 'p', 'l', 'u', 's', ';',
'x', 'u', 't', 'r', 'i', ';',
'x', 'v', 'e', 'e', ';',
'x', 'w', 'e', 'd', 'g', 'e', ';',
'y', 'a', 'c', 'u', 't', 'e',
';',
'y', 'a', 'c', 'y', ';',
'y', 'c', 'i', 'r', 'c', ';',
'y', 'c', 'y', ';',
'y', 'e', 'n',
';',
'y', 'f', 'r', ';',
'y', 'i', 'c', 'y', ';',
'y', 'o', 'p', 'f', ';',
'y', 's', 'c', 'r', ';',
'y', 'u', 'c', 'y', ';',
'y', 'u', 'm', 'l',
';',
'z', 'a', 'c', 'u', 't', 'e', ';',
'z', 'c', 'a', 'r', 'o', 'n', ';',
'z', 'd', 'o', 't', ';',
'z', 'e', 'e', 't', 'r', 'f', ';',
'z', 'e', 't', 'a', ';',
'z', 'f', 'r', ';',
'z', 'h', 'c', 'y', ';',
'z', 'o', 'p', 'f', ';',
'z', 's', 'c', 'r', ';',
'z', 'w', 'j', ';',
'z', 'w', 'n', 'j', ';'};

const HTMLEntityTableEntry kStaticEntityTable[2231] = {
    { 0x000C6, 0, 0, 5 }, // &AElig
    { 0x000C6, 0, 0, 6 }, // &AElig;
    { 0x00026, 0, 6, 3 }, // &AMP
    { 0x00026, 0, 6, 4 }, // &AMP;
    { 0x000C1, 0, 10, 6 }, // &Aacute
    { 0x000C1, 0, 10, 7 }, // &Aacute;
    { 0x00102, 0, 17, 7 }, // &Abreve;
    { 0x000C2, 0, 24, 5 }, // &Acirc
    { 0x000C2, 0, 24, 6 }, // &Acirc;
    { 0x00410, 0, 30, 4 }, // &Acy;
    { 0x1D504, 0, 34, 4 }, // &Afr;
    { 0x000C0, 0, 38, 6 }, // &Agrave
    { 0x000C0, 0, 38, 7 }, // &Agrave;
    { 0x00391, 0, 45, 6 }, // &Alpha;
    { 0x00100, 0, 51, 6 }, // &Amacr;
    { 0x02A53, 0, 57, 4 }, // &And;
    { 0x00104, 0, 61, 6 }, // &Aogon;
    { 0x1D538, 0, 67, 5 }, // &Aopf;
    { 0x02061, 0, 72, 14 }, // &ApplyFunction;
    { 0x000C5, 0, 86, 5 }, // &Aring
    { 0x000C5, 0, 86, 6 }, // &Aring;
    { 0x1D49C, 0, 92, 5 }, // &Ascr;
    { 0x02254, 0, 97, 7 }, // &Assign;
    { 0x000C3, 0, 104, 6 }, // &Atilde
    { 0x000C3, 0, 104, 7 }, // &Atilde;
    { 0x000C4, 0, 111, 4 }, // &Auml
    { 0x000C4, 0, 111, 5 }, // &Auml;
    { 0x02216, 0, 116, 10 }, // &Backslash;
    { 0x02AE7, 0, 126, 5 }, // &Barv;
    { 0x02306, 0, 131, 7 }, // &Barwed;
    { 0x00411, 0, 138, 4 }, // &Bcy;
    { 0x02235, 0, 142, 8 }, // &Because;
    { 0x0212C, 0, 150, 11 }, // &Bernoullis;
    { 0x00392, 0, 161, 5 }, // &Beta;
    { 0x1D505, 0, 166, 4 }, // &Bfr;
    { 0x1D539, 0, 170, 5 }, // &Bopf;
    { 0x002D8, 0, 175, 6 }, // &Breve;
    { 0x0212C, 0, 181, 5 }, // &Bscr;
    { 0x0224E, 0, 186, 7 }, // &Bumpeq;
    { 0x00427, 0, 193, 5 }, // &CHcy;
    { 0x000A9, 0, 198, 4 }, // &COPY
    { 0x000A9, 0, 198, 5 }, // &COPY;
    { 0x00106, 0, 203, 7 }, // &Cacute;
    { 0x022D2, 0, 210, 4 }, // &Cap;
    { 0x02145, 0, 214, 21 }, // &CapitalDifferentialD;
    { 0x0212D, 0, 235, 8 }, // &Cayleys;
    { 0x0010C, 0, 243, 7 }, // &Ccaron;
    { 0x000C7, 0, 250, 6 }, // &Ccedil
    { 0x000C7, 0, 250, 7 }, // &Ccedil;
    { 0x00108, 0, 257, 6 }, // &Ccirc;
    { 0x02230, 0, 263, 8 }, // &Cconint;
    { 0x0010A, 0, 271, 5 }, // &Cdot;
    { 0x000B8, 0, 276, 8 }, // &Cedilla;
    { 0x000B7, 0, 284, 10 }, // &CenterDot;
    { 0x0212D, 0, 294, 4 }, // &Cfr;
    { 0x003A7, 0, 298, 4 }, // &Chi;
    { 0x02299, 0, 302, 10 }, // &CircleDot;
    { 0x02296, 0, 312, 12 }, // &CircleMinus;
    { 0x02295, 0, 324, 11 }, // &CirclePlus;
    { 0x02297, 0, 335, 12 }, // &CircleTimes;
    { 0x02232, 0, 347, 25 }, // &ClockwiseContourIntegral;
    { 0x0201D, 0, 372, 22 }, // &CloseCurlyDoubleQuote;
    { 0x02019, 0, 394, 16 }, // &CloseCurlyQuote;
    { 0x02237, 0, 410, 6 }, // &Colon;
    { 0x02A74, 0, 416, 7 }, // &Colone;
    { 0x02261, 0, 423, 10 }, // &Congruent;
    { 0x0222F, 0, 433, 7 }, // &Conint;
    { 0x0222E, 0, 356, 16 }, // &ContourIntegral;
    { 0x02102, 0, 440, 5 }, // &Copf;
    { 0x02210, 0, 445, 10 }, // &Coproduct;
    { 0x02233, 0, 455, 32 }, // &CounterClockwiseContourIntegral;
    { 0x02A2F, 0, 487, 6 }, // &Cross;
    { 0x1D49E, 0, 493, 5 }, // &Cscr;
    { 0x022D3, 0, 498, 4 }, // &Cup;
    { 0x0224D, 0, 502, 7 }, // &CupCap;
    { 0x02145, 0, 509, 3 }, // &DD;
    { 0x02911, 0, 512, 9 }, // &DDotrahd;
    { 0x00402, 0, 521, 5 }, // &DJcy;
    { 0x00405, 0, 526, 5 }, // &DScy;
    { 0x0040F, 0, 531, 5 }, // &DZcy;
    { 0x02021, 0, 536, 7 }, // &Dagger;
    { 0x021A1, 0, 543, 5 }, // &Darr;
    { 0x02AE4, 0, 548, 6 }, // &Dashv;
    { 0x0010E, 0, 554, 7 }, // &Dcaron;
    { 0x00414, 0, 561, 4 }, // &Dcy;
    { 0x02207, 0, 565, 4 }, // &Del;
    { 0x00394, 0, 569, 6 }, // &Delta;
    { 0x1D507, 0, 575, 4 }, // &Dfr;
    { 0x000B4, 0, 579, 17 }, // &DiacriticalAcute;
    { 0x002D9, 0, 596, 15 }, // &DiacriticalDot;
    { 0x002DD, 0, 611, 23 }, // &DiacriticalDoubleAcute;
    { 0x00060, 0, 634, 17 }, // &DiacriticalGrave;
    { 0x002DC, 0, 651, 17 }, // &DiacriticalTilde;
    { 0x022C4, 0, 668, 8 }, // &Diamond;
    { 0x02146, 0, 221, 14 }, // &DifferentialD;
    { 0x1D53B, 0, 676, 5 }, // &Dopf;
    { 0x000A8, 0, 290, 4 }, // &Dot;
    { 0x020DC, 0, 681, 7 }, // &DotDot;
    { 0x02250, 0, 688, 9 }, // &DotEqual;
    { 0x0222F, 0, 697, 22 }, // &DoubleContourIntegral;
    { 0x000A8, 0, 719, 10 }, // &DoubleDot;
    { 0x021D3, 0, 729, 16 }, // &DoubleDownArrow;
    { 0x021D0, 0, 745, 16 }, // &DoubleLeftArrow;
    { 0x021D4, 0, 761, 21 }, // &DoubleLeftRightArrow;
    { 0x02AE4, 0, 782, 14 }, // &DoubleLeftTee;
    { 0x027F8, 0, 796, 20 }, // &DoubleLongLeftArrow;
    { 0x027FA, 0, 816, 25 }, // &DoubleLongLeftRightArrow;
    { 0x027F9, 0, 841, 21 }, // &DoubleLongRightArrow;
    { 0x021D2, 0, 862, 17 }, // &DoubleRightArrow;
    { 0x022A8, 0, 879, 15 }, // &DoubleRightTee;
    { 0x021D1, 0, 894, 14 }, // &DoubleUpArrow;
    { 0x021D5, 0, 908, 18 }, // &DoubleUpDownArrow;
    { 0x02225, 0, 926, 18 }, // &DoubleVerticalBar;
    { 0x02193, 0, 735, 10 }, // &DownArrow;
    { 0x02913, 0, 944, 13 }, // &DownArrowBar;
    { 0x021F5, 0, 957, 17 }, // &DownArrowUpArrow;
    { 0x00311, 0, 974, 10 }, // &DownBreve;
    { 0x02950, 0, 984, 20 }, // &DownLeftRightVector;
    { 0x0295E, 0, 1004, 18 }, // &DownLeftTeeVector;
    { 0x021BD, 0, 1022, 15 }, // &DownLeftVector;
    { 0x02956, 0, 1037, 18 }, // &DownLeftVectorBar;
    { 0x0295F, 0, 1055, 19 }, // &DownRightTeeVector;
    { 0x021C1, 0, 1074, 16 }, // &DownRightVector;
    { 0x02957, 0, 1090, 19 }, // &DownRightVectorBar;
    { 0x022A4, 0, 1109, 8 }, // &DownTee;
    { 0x021A7, 0, 1117, 13 }, // &DownTeeArrow;
    { 0x021D3, 0, 1130, 10 }, // &Downarrow;
    { 0x1D49F, 0, 1140, 5 }, // &Dscr;
    { 0x00110, 0, 1145, 7 }, // &Dstrok;
    { 0x0014A, 0, 1152, 4 }, // &ENG;
    { 0x000D0, 0, 1156, 3 }, // &ETH
    { 0x000D0, 0, 1156, 4 }, // &ETH;
    { 0x000C9, 0, 1160, 6 }, // &Eacute
    { 0x000C9, 0, 1160, 7 }, // &Eacute;
    { 0x0011A, 0, 1167, 7 }, // &Ecaron;
    { 0x000CA, 0, 1174, 5 }, // &Ecirc
    { 0x000CA, 0, 1174, 6 }, // &Ecirc;
    { 0x0042D, 0, 1180, 4 }, // &Ecy;
    { 0x00116, 0, 1184, 5 }, // &Edot;
    { 0x1D508, 0, 1189, 4 }, // &Efr;
    { 0x000C8, 0, 1193, 6 }, // &Egrave
    { 0x000C8, 0, 1193, 7 }, // &Egrave;
    { 0x02208, 0, 1200, 8 }, // &Element;
    { 0x00112, 0, 1208, 6 }, // &Emacr;
    { 0x025FB, 0, 1214, 17 }, // &EmptySmallSquare;
    { 0x025AB, 0, 1231, 21 }, // &EmptyVerySmallSquare;
    { 0x00118, 0, 1252, 6 }, // &Eogon;
    { 0x1D53C, 0, 1258, 5 }, // &Eopf;
    { 0x00395, 0, 1263, 8 }, // &Epsilon;
    { 0x02A75, 0, 691, 6 }, // &Equal;
    { 0x02242, 0, 1271, 11 }, // &EqualTilde;
    { 0x021CC, 0, 1282, 12 }, // &Equilibrium;
    { 0x02130, 0, 1294, 5 }, // &Escr;
    { 0x02A73, 0, 1299, 5 }, // &Esim;
    { 0x00397, 0, 1304, 4 }, // &Eta;
    { 0x000CB, 0, 1308, 4 }, // &Euml
    { 0x000CB, 0, 1308, 5 }, // &Euml;
    { 0x02203, 0, 1313, 7 }, // &Exists;
    { 0x02147, 0, 1320, 13 }, // &ExponentialE;
    { 0x00424, 0, 1333, 4 }, // &Fcy;
    { 0x1D509, 0, 1337, 4 }, // &Ffr;
    { 0x025FC, 0, 1341, 18 }, // &FilledSmallSquare;
    { 0x025AA, 0, 1359, 22 }, // &FilledVerySmallSquare;
    { 0x1D53D, 0, 1381, 5 }, // &Fopf;
    { 0x02200, 0, 1386, 7 }, // &ForAll;
    { 0x02131, 0, 1393, 11 }, // &Fouriertrf;
    { 0x02131, 0, 1404, 5 }, // &Fscr;
    { 0x00403, 0, 1409, 5 }, // &GJcy;
    { 0x0003E, 0, 1414, 2 }, // &GT
    { 0x0003E, 0, 1414, 3 }, // &GT;
    { 0x00393, 0, 1417, 6 }, // &Gamma;
    { 0x003DC, 0, 1423, 7 }, // &Gammad;
    { 0x0011E, 0, 1430, 7 }, // &Gbreve;
    { 0x00122, 0, 1437, 7 }, // &Gcedil;
    { 0x0011C, 0, 1444, 6 }, // &Gcirc;
    { 0x00413, 0, 1450, 4 }, // &Gcy;
    { 0x00120, 0, 1454, 5 }, // &Gdot;
    { 0x1D50A, 0, 1459, 4 }, // &Gfr;
    { 0x022D9, 0, 1463, 3 }, // &Gg;
    { 0x1D53E, 0, 1466, 5 }, // &Gopf;
    { 0x02265, 0, 1471, 13 }, // &GreaterEqual;
    { 0x022DB, 0, 1484, 17 }, // &GreaterEqualLess;
    { 0x02267, 0, 1501, 17 }, // &GreaterFullEqual;
    { 0x02AA2, 0, 1518, 15 }, // &GreaterGreater;
    { 0x02277, 0, 1533, 12 }, // &GreaterLess;
    { 0x02A7E, 0, 1545, 18 }, // &GreaterSlantEqual;
    { 0x02273, 0, 1563, 13 }, // &GreaterTilde;
    { 0x1D4A2, 0, 1576, 5 }, // &Gscr;
    { 0x0226B, 0, 1581, 3 }, // &Gt;
    { 0x0042A, 0, 1584, 7 }, // &HARDcy;
    { 0x002C7, 0, 1591, 6 }, // &Hacek;
    { 0x0005E, 0, 1597, 4 }, // &Hat;
    { 0x00124, 0, 1601, 6 }, // &Hcirc;
    { 0x0210C, 0, 1607, 4 }, // &Hfr;
    { 0x0210B, 0, 1611, 13 }, // &HilbertSpace;
    { 0x0210D, 0, 1624, 5 }, // &Hopf;
    { 0x02500, 0, 1629, 15 }, // &HorizontalLine;
    { 0x0210B, 0, 1644, 5 }, // &Hscr;
    { 0x00126, 0, 1649, 7 }, // &Hstrok;
    { 0x0224E, 0, 1656, 13 }, // &HumpDownHump;
    { 0x0224F, 0, 1669, 10 }, // &HumpEqual;
    { 0x00415, 0, 1679, 5 }, // &IEcy;
    { 0x00132, 0, 1684, 6 }, // &IJlig;
    { 0x00401, 0, 1690, 5 }, // &IOcy;
    { 0x000CD, 0, 1695, 6 }, // &Iacute
    { 0x000CD, 0, 1695, 7 }, // &Iacute;
    { 0x000CE, 0, 1702, 5 }, // &Icirc
    { 0x000CE, 0, 1702, 6 }, // &Icirc;
    { 0x00418, 0, 1708, 4 }, // &Icy;
    { 0x00130, 0, 1712, 5 }, // &Idot;
    { 0x02111, 0, 1717, 4 }, // &Ifr;
    { 0x000CC, 0, 1721, 6 }, // &Igrave
    { 0x000CC, 0, 1721, 7 }, // &Igrave;
    { 0x02111, 0, 1728, 3 }, // &Im;
    { 0x0012A, 0, 1731, 6 }, // &Imacr;
    { 0x02148, 0, 1737, 11 }, // &ImaginaryI;
    { 0x021D2, 0, 1748, 8 }, // &Implies;
    { 0x0222C, 0, 1756, 4 }, // &Int;
    { 0x0222B, 0, 363, 9 }, // &Integral;
    { 0x022C2, 0, 1760, 13 }, // &Intersection;
    { 0x02063, 0, 1773, 15 }, // &InvisibleComma;
    { 0x02062, 0, 1788, 15 }, // &InvisibleTimes;
    { 0x0012E, 0, 1803, 6 }, // &Iogon;
    { 0x1D540, 0, 1809, 5 }, // &Iopf;
    { 0x00399, 0, 1814, 5 }, // &Iota;
    { 0x02110, 0, 1819, 5 }, // &Iscr;
    { 0x00128, 0, 1824, 7 }, // &Itilde;
    { 0x00406, 0, 1831, 6 }, // &Iukcy;
    { 0x000CF, 0, 1837, 4 }, // &Iuml
    { 0x000CF, 0, 1837, 5 }, // &Iuml;
    { 0x00134, 0, 1842, 6 }, // &Jcirc;
    { 0x00419, 0, 522, 4 }, // &Jcy;
    { 0x1D50D, 0, 1848, 4 }, // &Jfr;
    { 0x1D541, 0, 1852, 5 }, // &Jopf;
    { 0x1D4A5, 0, 1857, 5 }, // &Jscr;
    { 0x00408, 0, 1862, 7 }, // &Jsercy;
    { 0x00404, 0, 1869, 6 }, // &Jukcy;
    { 0x00425, 0, 1875, 5 }, // &KHcy;
    { 0x0040C, 0, 1880, 5 }, // &KJcy;
    { 0x0039A, 0, 1885, 6 }, // &Kappa;
    { 0x00136, 0, 1891, 7 }, // &Kcedil;
    { 0x0041A, 0, 1898, 4 }, // &Kcy;
    { 0x1D50E, 0, 1902, 4 }, // &Kfr;
    { 0x1D542, 0, 1906, 5 }, // &Kopf;
    { 0x1D4A6, 0, 1911, 5 }, // &Kscr;
    { 0x00409, 0, 1916, 5 }, // &LJcy;
    { 0x0003C, 0, 1921, 2 }, // &LT
    { 0x0003C, 0, 1921, 3 }, // &LT;
    { 0x00139, 0, 1924, 7 }, // &Lacute;
    { 0x0039B, 0, 1931, 7 }, // &Lambda;
    { 0x027EA, 0, 1938, 5 }, // &Lang;
    { 0x02112, 0, 1943, 11 }, // &Laplacetrf;
    { 0x0219E, 0, 1954, 5 }, // &Larr;
    { 0x0013D, 0, 1959, 7 }, // &Lcaron;
    { 0x0013B, 0, 1966, 7 }, // &Lcedil;
    { 0x0041B, 0, 1973, 4 }, // &Lcy;
    { 0x027E8, 0, 1977, 17 }, // &LeftAngleBracket;
    { 0x02190, 0, 751, 10 }, // &LeftArrow;
    { 0x021E4, 0, 1994, 13 }, // &LeftArrowBar;
    { 0x021C6, 0, 2007, 20 }, // &LeftArrowRightArrow;
    { 0x02308, 0, 2027, 12 }, // &LeftCeiling;
    { 0x027E6, 0, 2039, 18 }, // &LeftDoubleBracket;
    { 0x02961, 0, 2057, 18 }, // &LeftDownTeeVector;
    { 0x021C3, 0, 2075, 15 }, // &LeftDownVector;
    { 0x02959, 0, 2090, 18 }, // &LeftDownVectorBar;
    { 0x0230A, 0, 2108, 10 }, // &LeftFloor;
    { 0x02194, 0, 767, 15 }, // &LeftRightArrow;
    { 0x0294E, 0, 988, 16 }, // &LeftRightVector;
    { 0x022A3, 0, 788, 8 }, // &LeftTee;
    { 0x021A4, 0, 2118, 13 }, // &LeftTeeArrow;
    { 0x0295A, 0, 1008, 14 }, // &LeftTeeVector;
    { 0x022B2, 0, 2131, 13 }, // &LeftTriangle;
    { 0x029CF, 0, 2144, 16 }, // &LeftTriangleBar;
    { 0x022B4, 0, 2160, 18 }, // &LeftTriangleEqual;
    { 0x02951, 0, 2178, 17 }, // &LeftUpDownVector;
    { 0x02960, 0, 2195, 16 }, // &LeftUpTeeVector;
    { 0x021BF, 0, 2211, 13 }, // &LeftUpVector;
    { 0x02958, 0, 2224, 16 }, // &LeftUpVectorBar;
    { 0x021BC, 0, 1026, 11 }, // &LeftVector;
    { 0x02952, 0, 1041, 14 }, // &LeftVectorBar;
    { 0x021D0, 0, 2240, 10 }, // &Leftarrow;
    { 0x021D4, 0, 2250, 15 }, // &Leftrightarrow;
    { 0x022DA, 0, 2265, 17 }, // &LessEqualGreater;
    { 0x02266, 0, 2282, 14 }, // &LessFullEqual;
    { 0x02276, 0, 2296, 12 }, // &LessGreater;
    { 0x02AA1, 0, 2308, 9 }, // &LessLess;
    { 0x02A7D, 0, 2317, 15 }, // &LessSlantEqual;
    { 0x02272, 0, 2332, 10 }, // &LessTilde;
    { 0x1D50F, 0, 2342, 4 }, // &Lfr;
    { 0x022D8, 0, 2346, 3 }, // &Ll;
    { 0x021DA, 0, 2349, 11 }, // &Lleftarrow;
    { 0x0013F, 0, 2360, 7 }, // &Lmidot;
    { 0x027F5, 0, 802, 14 }, // &LongLeftArrow;
    { 0x027F7, 0, 822, 19 }, // &LongLeftRightArrow;
    { 0x027F6, 0, 847, 15 }, // &LongRightArrow;
    { 0x027F8, 0, 2367, 14 }, // &Longleftarrow;
    { 0x027FA, 0, 2381, 19 }, // &Longleftrightarrow;
    { 0x027F9, 0, 2400, 15 }, // &Longrightarrow;
    { 0x1D543, 0, 2415, 5 }, // &Lopf;
    { 0x02199, 0, 2420, 15 }, // &LowerLeftArrow;
    { 0x02198, 0, 2435, 16 }, // &LowerRightArrow;
    { 0x02112, 0, 2451, 5 }, // &Lscr;
    { 0x021B0, 0, 2456, 4 }, // &Lsh;
    { 0x00141, 0, 2460, 7 }, // &Lstrok;
    { 0x0226A, 0, 2467, 3 }, // &Lt;
    { 0x02905, 0, 2470, 4 }, // &Map;
    { 0x0041C, 0, 2474, 4 }, // &Mcy;
    { 0x0205F, 0, 2478, 12 }, // &MediumSpace;
    { 0x02133, 0, 2490, 10 }, // &Mellintrf;
    { 0x1D510, 0, 2500, 4 }, // &Mfr;
    { 0x02213, 0, 2504, 10 }, // &MinusPlus;
    { 0x1D544, 0, 2514, 5 }, // &Mopf;
    { 0x02133, 0, 2519, 5 }, // &Mscr;
    { 0x0039C, 0, 2524, 3 }, // &Mu;
    { 0x0040A, 0, 2527, 5 }, // &NJcy;
    { 0x00143, 0, 2532, 7 }, // &Nacute;
    { 0x00147, 0, 2539, 7 }, // &Ncaron;
    { 0x00145, 0, 2546, 7 }, // &Ncedil;
    { 0x0041D, 0, 2553, 4 }, // &Ncy;
    { 0x0200B, 0, 2557, 20 }, // &NegativeMediumSpace;
    { 0x0200B, 0, 2577, 19 }, // &NegativeThickSpace;
    { 0x0200B, 0, 2596, 18 }, // &NegativeThinSpace;
    { 0x0200B, 0, 2614, 22 }, // &NegativeVeryThinSpace;
    { 0x0226B, 0, 2636, 21 }, // &NestedGreaterGreater;
    { 0x0226A, 0, 2657, 15 }, // &NestedLessLess;
    { 0x0000A, 0, 2672, 8 }, // &NewLine;
    { 0x1D511, 0, 2680, 4 }, // &Nfr;
    { 0x02060, 0, 2684, 8 }, // &NoBreak;
    { 0x000A0, 0, 2692, 17 }, // &NonBreakingSpace;
    { 0x02115, 0, 2709, 5 }, // &Nopf;
    { 0x02AEC, 0, 2714, 4 }, // &Not;
    { 0x02262, 0, 2718, 13 }, // &NotCongruent;
    { 0x0226D, 0, 2731, 10 }, // &NotCupCap;
    { 0x02226, 0, 2741, 21 }, // &NotDoubleVerticalBar;
    { 0x02209, 0, 2762, 11 }, // &NotElement;
    { 0x02260, 0, 2773, 9 }, // &NotEqual;
    { 0x02242, 0x00338, 2782, 14 }, // &NotEqualTilde;
    { 0x02204, 0, 2796, 10 }, // &NotExists;
    { 0x0226F, 0, 2806, 11 }, // &NotGreater;
    { 0x02271, 0, 2817, 16 }, // &NotGreaterEqual;
    { 0x02267, 0x00338, 2833, 20 }, // &NotGreaterFullEqual;
    { 0x0226B, 0x00338, 2853, 18 }, // &NotGreaterGreater;
    { 0x02279, 0, 2871, 15 }, // &NotGreaterLess;
    { 0x02A7E, 0x00338, 2886, 21 }, // &NotGreaterSlantEqual;
    { 0x02275, 0, 2907, 16 }, // &NotGreaterTilde;
    { 0x0224E, 0x00338, 2923, 16 }, // &NotHumpDownHump;
    { 0x0224F, 0x00338, 2939, 13 }, // &NotHumpEqual;
    { 0x022EA, 0, 2952, 16 }, // &NotLeftTriangle;
    { 0x029CF, 0x00338, 2968, 19 }, // &NotLeftTriangleBar;
    { 0x022EC, 0, 2987, 21 }, // &NotLeftTriangleEqual;
    { 0x0226E, 0, 3008, 8 }, // &NotLess;
    { 0x02270, 0, 3016, 13 }, // &NotLessEqual;
    { 0x02278, 0, 3029, 15 }, // &NotLessGreater;
    { 0x0226A, 0x00338, 3044, 12 }, // &NotLessLess;
    { 0x02A7D, 0x00338, 3056, 18 }, // &NotLessSlantEqual;
    { 0x02274, 0, 3074, 13 }, // &NotLessTilde;
    { 0x02AA2, 0x00338, 3087, 24 }, // &NotNestedGreaterGreater;
    { 0x02AA1, 0x00338, 3111, 18 }, // &NotNestedLessLess;
    { 0x02280, 0, 3129, 12 }, // &NotPrecedes;
    { 0x02AAF, 0x00338, 3141, 17 }, // &NotPrecedesEqual;
    { 0x022E0, 0, 3158, 22 }, // &NotPrecedesSlantEqual;
    { 0x0220C, 0, 3180, 18 }, // &NotReverseElement;
    { 0x022EB, 0, 3198, 17 }, // &NotRightTriangle;
    { 0x029D0, 0x00338, 3215, 20 }, // &NotRightTriangleBar;
    { 0x022ED, 0, 3235, 22 }, // &NotRightTriangleEqual;
    { 0x0228F, 0x00338, 3257, 16 }, // &NotSquareSubset;
    { 0x022E2, 0, 3273, 21 }, // &NotSquareSubsetEqual;
    { 0x02290, 0x00338, 3294, 18 }, // &NotSquareSuperset;
    { 0x022E3, 0, 3312, 23 }, // &NotSquareSupersetEqual;
    { 0x02282, 0x020D2, 3335, 10 }, // &NotSubset;
    { 0x02288, 0, 3345, 15 }, // &NotSubsetEqual;
    { 0x02281, 0, 3360, 12 }, // &NotSucceeds;
    { 0x02AB0, 0x00338, 3372, 17 }, // &NotSucceedsEqual;
    { 0x022E1, 0, 3389, 22 }, // &NotSucceedsSlantEqual;
    { 0x0227F, 0x00338, 3411, 17 }, // &NotSucceedsTilde;
    { 0x02283, 0x020D2, 3428, 12 }, // &NotSuperset;
    { 0x02289, 0, 3440, 17 }, // &NotSupersetEqual;
    { 0x02241, 0, 3457, 9 }, // &NotTilde;
    { 0x02244, 0, 3466, 14 }, // &NotTildeEqual;
    { 0x02247, 0, 3480, 18 }, // &NotTildeFullEqual;
    { 0x02249, 0, 3498, 14 }, // &NotTildeTilde;
    { 0x02224, 0, 3512, 15 }, // &NotVerticalBar;
    { 0x1D4A9, 0, 3527, 5 }, // &Nscr;
    { 0x000D1, 0, 3532, 6 }, // &Ntilde
    { 0x000D1, 0, 3532, 7 }, // &Ntilde;
    { 0x0039D, 0, 3539, 3 }, // &Nu;
    { 0x00152, 0, 3542, 6 }, // &OElig;
    { 0x000D3, 0, 3548, 6 }, // &Oacute
    { 0x000D3, 0, 3548, 7 }, // &Oacute;
    { 0x000D4, 0, 3555, 5 }, // &Ocirc
    { 0x000D4, 0, 3555, 6 }, // &Ocirc;
    { 0x0041E, 0, 1691, 4 }, // &Ocy;
    { 0x00150, 0, 3561, 7 }, // &Odblac;
    { 0x1D512, 0, 3568, 4 }, // &Ofr;
    { 0x000D2, 0, 3572, 6 }, // &Ograve
    { 0x000D2, 0, 3572, 7 }, // &Ograve;
    { 0x0014C, 0, 3579, 6 }, // &Omacr;
    { 0x003A9, 0, 3585, 6 }, // &Omega;
    { 0x0039F, 0, 3591, 8 }, // &Omicron;
    { 0x1D546, 0, 3599, 5 }, // &Oopf;
    { 0x0201C, 0, 3604, 21 }, // &OpenCurlyDoubleQuote;
    { 0x02018, 0, 3625, 15 }, // &OpenCurlyQuote;
    { 0x02A54, 0, 3640, 3 }, // &Or;
    { 0x1D4AA, 0, 3643, 5 }, // &Oscr;
    { 0x000D8, 0, 3648, 6 }, // &Oslash
    { 0x000D8, 0, 3648, 7 }, // &Oslash;
    { 0x000D5, 0, 3655, 6 }, // &Otilde
    { 0x000D5, 0, 3655, 7 }, // &Otilde;
    { 0x02A37, 0, 3662, 7 }, // &Otimes;
    { 0x000D6, 0, 3669, 4 }, // &Ouml
    { 0x000D6, 0, 3669, 5 }, // &Ouml;
    { 0x0203E, 0, 3674, 8 }, // &OverBar;
    { 0x023DE, 0, 3682, 10 }, // &OverBrace;
    { 0x023B4, 0, 3692, 12 }, // &OverBracket;
    { 0x023DC, 0, 3704, 16 }, // &OverParenthesis;
    { 0x02202, 0, 3720, 9 }, // &PartialD;
    { 0x0041F, 0, 3729, 4 }, // &Pcy;
    { 0x1D513, 0, 3733, 4 }, // &Pfr;
    { 0x003A6, 0, 3737, 4 }, // &Phi;
    { 0x003A0, 0, 3741, 3 }, // &Pi;
    { 0x000B1, 0, 3744, 10 }, // &PlusMinus;
    { 0x0210C, 0, 3754, 14 }, // &Poincareplane;
    { 0x02119, 0, 3768, 5 }, // &Popf;
    { 0x02ABB, 0, 3773, 3 }, // &Pr;
    { 0x0227A, 0, 3132, 9 }, // &Precedes;
    { 0x02AAF, 0, 3144, 14 }, // &PrecedesEqual;
    { 0x0227C, 0, 3161, 19 }, // &PrecedesSlantEqual;
    { 0x0227E, 0, 3776, 14 }, // &PrecedesTilde;
    { 0x02033, 0, 3790, 6 }, // &Prime;
    { 0x0220F, 0, 3796, 8 }, // &Product;
    { 0x02237, 0, 3804, 11 }, // &Proportion;
    { 0x0221D, 0, 3815, 13 }, // &Proportional;
    { 0x1D4AB, 0, 3828, 5 }, // &Pscr;
    { 0x003A8, 0, 3833, 4 }, // &Psi;
    { 0x00022, 0, 3837, 4 }, // &QUOT
    { 0x00022, 0, 3837, 5 }, // &QUOT;
    { 0x1D514, 0, 3842, 4 }, // &Qfr;
    { 0x0211A, 0, 3846, 5 }, // &Qopf;
    { 0x1D4AC, 0, 3851, 5 }, // &Qscr;
    { 0x02910, 0, 3856, 6 }, // &RBarr;
    { 0x000AE, 0, 3862, 3 }, // &REG
    { 0x000AE, 0, 3862, 4 }, // &REG;
    { 0x00154, 0, 3866, 7 }, // &Racute;
    { 0x027EB, 0, 3873, 5 }, // &Rang;
    { 0x021A0, 0, 3878, 5 }, // &Rarr;
    { 0x02916, 0, 3883, 7 }, // &Rarrtl;
    { 0x00158, 0, 3890, 7 }, // &Rcaron;
    { 0x00156, 0, 3897, 7 }, // &Rcedil;
    { 0x00420, 0, 3904, 4 }, // &Rcy;
    { 0x0211C, 0, 3908, 3 }, // &Re;
    { 0x0220B, 0, 3183, 15 }, // &ReverseElement;
    { 0x021CB, 0, 3911, 19 }, // &ReverseEquilibrium;
    { 0x0296F, 0, 3930, 21 }, // &ReverseUpEquilibrium;
    { 0x0211C, 0, 3951, 4 }, // &Rfr;
    { 0x003A1, 0, 3955, 4 }, // &Rho;
    { 0x027E9, 0, 3959, 18 }, // &RightAngleBracket;
    { 0x02192, 0, 771, 11 }, // &RightArrow;
    { 0x021E5, 0, 3977, 14 }, // &RightArrowBar;
    { 0x021C4, 0, 3991, 20 }, // &RightArrowLeftArrow;
    { 0x02309, 0, 4011, 13 }, // &RightCeiling;
    { 0x027E7, 0, 4024, 19 }, // &RightDoubleBracket;
    { 0x0295D, 0, 4043, 19 }, // &RightDownTeeVector;
    { 0x021C2, 0, 4062, 16 }, // &RightDownVector;
    { 0x02955, 0, 4078, 19 }, // &RightDownVectorBar;
    { 0x0230B, 0, 4097, 11 }, // &RightFloor;
    { 0x022A2, 0, 885, 9 }, // &RightTee;
    { 0x021A6, 0, 4108, 14 }, // &RightTeeArrow;
    { 0x0295B, 0, 1059, 15 }, // &RightTeeVector;
    { 0x022B3, 0, 3201, 14 }, // &RightTriangle;
    { 0x029D0, 0, 3218, 17 }, // &RightTriangleBar;
    { 0x022B5, 0, 3238, 19 }, // &RightTriangleEqual;
    { 0x0294F, 0, 4122, 18 }, // &RightUpDownVector;
    { 0x0295C, 0, 4140, 17 }, // &RightUpTeeVector;
    { 0x021BE, 0, 4157, 14 }, // &RightUpVector;
    { 0x02954, 0, 4171, 17 }, // &RightUpVectorBar;
    { 0x021C0, 0, 992, 12 }, // &RightVector;
    { 0x02953, 0, 1094, 15 }, // &RightVectorBar;
    { 0x021D2, 0, 4188, 11 }, // &Rightarrow;
    { 0x0211D, 0, 4199, 5 }, // &Ropf;
    { 0x02970, 0, 4204, 13 }, // &RoundImplies;
    { 0x021DB, 0, 4217, 12 }, // &Rrightarrow;
    { 0x0211B, 0, 4229, 5 }, // &Rscr;
    { 0x021B1, 0, 4234, 4 }, // &Rsh;
    { 0x029F4, 0, 4238, 12 }, // &RuleDelayed;
    { 0x00429, 0, 4250, 7 }, // &SHCHcy;
    { 0x00428, 0, 4257, 5 }, // &SHcy;
    { 0x0042C, 0, 4262, 7 }, // &SOFTcy;
    { 0x0015A, 0, 4269, 7 }, // &Sacute;
    { 0x02ABC, 0, 4276, 3 }, // &Sc;
    { 0x00160, 0, 4279, 7 }, // &Scaron;
    { 0x0015E, 0, 4286, 7 }, // &Scedil;
    { 0x0015C, 0, 4293, 6 }, // &Scirc;
    { 0x00421, 0, 527, 4 }, // &Scy;
    { 0x1D516, 0, 4299, 4 }, // &Sfr;
    { 0x02193, 0, 4303, 15 }, // &ShortDownArrow;
    { 0x02190, 0, 4318, 15 }, // &ShortLeftArrow;
    { 0x02192, 0, 4333, 16 }, // &ShortRightArrow;
    { 0x02191, 0, 4349, 13 }, // &ShortUpArrow;
    { 0x003A3, 0, 4362, 6 }, // &Sigma;
    { 0x02218, 0, 4368, 12 }, // &SmallCircle;
    { 0x1D54A, 0, 4380, 5 }, // &Sopf;
    { 0x0221A, 0, 4385, 5 }, // &Sqrt;
    { 0x025A1, 0, 1224, 7 }, // &Square;
    { 0x02293, 0, 4390, 19 }, // &SquareIntersection;
    { 0x0228F, 0, 3260, 13 }, // &SquareSubset;
    { 0x02291, 0, 3276, 18 }, // &SquareSubsetEqual;
    { 0x02290, 0, 3297, 15 }, // &SquareSuperset;
    { 0x02292, 0, 3315, 20 }, // &SquareSupersetEqual;
    { 0x02294, 0, 4409, 12 }, // &SquareUnion;
    { 0x1D4AE, 0, 4421, 5 }, // &Sscr;
    { 0x022C6, 0, 4426, 5 }, // &Star;
    { 0x022D0, 0, 4431, 4 }, // &Sub;
    { 0x022D0, 0, 3266, 7 }, // &Subset;
    { 0x02286, 0, 3282, 12 }, // &SubsetEqual;
    { 0x0227B, 0, 3363, 9 }, // &Succeeds;
    { 0x02AB0, 0, 3375, 14 }, // &SucceedsEqual;
    { 0x0227D, 0, 3392, 19 }, // &SucceedsSlantEqual;
    { 0x0227F, 0, 3414, 14 }, // &SucceedsTilde;
    { 0x0220B, 0, 4435, 9 }, // &SuchThat;
    { 0x02211, 0, 4444, 4 }, // &Sum;
    { 0x022D1, 0, 4448, 4 }, // &Sup;
    { 0x02283, 0, 3303, 9 }, // &Superset;
    { 0x02287, 0, 3321, 14 }, // &SupersetEqual;
    { 0x022D1, 0, 4452, 7 }, // &Supset;
    { 0x000DE, 0, 4459, 5 }, // &THORN
    { 0x000DE, 0, 4459, 6 }, // &THORN;
    { 0x02122, 0, 4465, 6 }, // &TRADE;
    { 0x0040B, 0, 4471, 6 }, // &TSHcy;
    { 0x00426, 0, 4477, 5 }, // &TScy;
    { 0x00009, 0, 4482, 4 }, // &Tab;
    { 0x003A4, 0, 4486, 4 }, // &Tau;
    { 0x00164, 0, 4490, 7 }, // &Tcaron;
    { 0x00162, 0, 4497, 7 }, // &Tcedil;
    { 0x00422, 0, 4265, 4 }, // &Tcy;
    { 0x1D517, 0, 4504, 4 }, // &Tfr;
    { 0x02234, 0, 4508, 10 }, // &Therefore;
    { 0x00398, 0, 4518, 6 }, // &Theta;
    { 0x0205F, 0x0200A, 2585, 11 }, // &ThickSpace;
    { 0x02009, 0, 2604, 10 }, // &ThinSpace;
    { 0x0223C, 0, 662, 6 }, // &Tilde;
    { 0x02243, 0, 3469, 11 }, // &TildeEqual;
    { 0x02245, 0, 3483, 15 }, // &TildeFullEqual;
    { 0x02248, 0, 3501, 11 }, // &TildeTilde;
    { 0x1D54B, 0, 4524, 5 }, // &Topf;
    { 0x020DB, 0, 4529, 10 }, // &TripleDot;
    { 0x1D4AF, 0, 4539, 5 }, // &Tscr;
    { 0x00166, 0, 4544, 7 }, // &Tstrok;
    { 0x000DA, 0, 4551, 6 }, // &Uacute
    { 0x000DA, 0, 4551, 7 }, // &Uacute;
    { 0x0219F, 0, 4558, 5 }, // &Uarr;
    { 0x02949, 0, 4563, 9 }, // &Uarrocir;
    { 0x0040E, 0, 4572, 6 }, // &Ubrcy;
    { 0x0016C, 0, 4578, 7 }, // &Ubreve;
    { 0x000DB, 0, 4585, 5 }, // &Ucirc
    { 0x000DB, 0, 4585, 6 }, // &Ucirc;
    { 0x00423, 0, 4591, 4 }, // &Ucy;
    { 0x00170, 0, 4595, 7 }, // &Udblac;
    { 0x1D518, 0, 4602, 4 }, // &Ufr;
    { 0x000D9, 0, 4606, 6 }, // &Ugrave
    { 0x000D9, 0, 4606, 7 }, // &Ugrave;
    { 0x0016A, 0, 4613, 6 }, // &Umacr;
    { 0x0005F, 0, 4619, 9 }, // &UnderBar;
    { 0x023DF, 0, 4628, 11 }, // &UnderBrace;
    { 0x023B5, 0, 4639, 13 }, // &UnderBracket;
    { 0x023DD, 0, 4652, 17 }, // &UnderParenthesis;
    { 0x022C3, 0, 4415, 6 }, // &Union;
    { 0x0228E, 0, 4669, 10 }, // &UnionPlus;
    { 0x00172, 0, 4679, 6 }, // &Uogon;
    { 0x1D54C, 0, 4685, 5 }, // &Uopf;
    { 0x02191, 0, 900, 8 }, // &UpArrow;
    { 0x02912, 0, 4690, 11 }, // &UpArrowBar;
    { 0x021C5, 0, 4701, 17 }, // &UpArrowDownArrow;
    { 0x02195, 0, 914, 12 }, // &UpDownArrow;
    { 0x0296E, 0, 3937, 14 }, // &UpEquilibrium;
    { 0x022A5, 0, 4718, 6 }, // &UpTee;
    { 0x021A5, 0, 4724, 11 }, // &UpTeeArrow;
    { 0x021D1, 0, 4735, 8 }, // &Uparrow;
    { 0x021D5, 0, 4743, 12 }, // &Updownarrow;
    { 0x02196, 0, 4755, 15 }, // &UpperLeftArrow;
    { 0x02197, 0, 4770, 16 }, // &UpperRightArrow;
    { 0x003D2, 0, 4786, 5 }, // &Upsi;
    { 0x003A5, 0, 4791, 8 }, // &Upsilon;
    { 0x0016E, 0, 4799, 6 }, // &Uring;
    { 0x1D4B0, 0, 4805, 5 }, // &Uscr;
    { 0x00168, 0, 4810, 7 }, // &Utilde;
    { 0x000DC, 0, 4817, 4 }, // &Uuml
    { 0x000DC, 0, 4817, 5 }, // &Uuml;
    { 0x022AB, 0, 4822, 6 }, // &VDash;
    { 0x02AEB, 0, 4828, 5 }, // &Vbar;
    { 0x00412, 0, 4833, 4 }, // &Vcy;
    { 0x022A9, 0, 4837, 6 }, // &Vdash;
    { 0x02AE6, 0, 4843, 7 }, // &Vdashl;
    { 0x022C1, 0, 4850, 4 }, // &Vee;
    { 0x02016, 0, 4854, 7 }, // &Verbar;
    { 0x02016, 0, 4861, 5 }, // &Vert;
    { 0x02223, 0, 932, 12 }, // &VerticalBar;
    { 0x0007C, 0, 4866, 13 }, // &VerticalLine;
    { 0x02758, 0, 4879, 18 }, // &VerticalSeparator;
    { 0x02240, 0, 4897, 14 }, // &VerticalTilde;
    { 0x0200A, 0, 2622, 14 }, // &VeryThinSpace;
    { 0x1D519, 0, 4911, 4 }, // &Vfr;
    { 0x1D54D, 0, 4915, 5 }, // &Vopf;
    { 0x1D4B1, 0, 4920, 5 }, // &Vscr;
    { 0x022AA, 0, 4925, 7 }, // &Vvdash;
    { 0x00174, 0, 4932, 6 }, // &Wcirc;
    { 0x022C0, 0, 4938, 6 }, // &Wedge;
    { 0x1D51A, 0, 4944, 4 }, // &Wfr;
    { 0x1D54E, 0, 4948, 5 }, // &Wopf;
    { 0x1D4B2, 0, 4953, 5 }, // &Wscr;
    { 0x1D51B, 0, 4958, 4 }, // &Xfr;
    { 0x0039E, 0, 4962, 3 }, // &Xi;
    { 0x1D54F, 0, 4965, 5 }, // &Xopf;
    { 0x1D4B3, 0, 4970, 5 }, // &Xscr;
    { 0x0042F, 0, 4975, 5 }, // &YAcy;
    { 0x00407, 0, 4980, 5 }, // &YIcy;
    { 0x0042E, 0, 4985, 5 }, // &YUcy;
    { 0x000DD, 0, 4990, 6 }, // &Yacute
    { 0x000DD, 0, 4990, 7 }, // &Yacute;
    { 0x00176, 0, 4997, 6 }, // &Ycirc;
    { 0x0042B, 0, 5003, 4 }, // &Ycy;
    { 0x1D51C, 0, 5007, 4 }, // &Yfr;
    { 0x1D550, 0, 5011, 5 }, // &Yopf;
    { 0x1D4B4, 0, 5016, 5 }, // &Yscr;
    { 0x00178, 0, 5021, 5 }, // &Yuml;
    { 0x00416, 0, 5026, 5 }, // &ZHcy;
    { 0x00179, 0, 5031, 7 }, // &Zacute;
    { 0x0017D, 0, 5038, 7 }, // &Zcaron;
    { 0x00417, 0, 532, 4 }, // &Zcy;
    { 0x0017B, 0, 5045, 5 }, // &Zdot;
    { 0x0200B, 0, 5050, 15 }, // &ZeroWidthSpace;
    { 0x00396, 0, 5065, 5 }, // &Zeta;
    { 0x02128, 0, 5070, 4 }, // &Zfr;
    { 0x02124, 0, 5074, 5 }, // &Zopf;
    { 0x1D4B5, 0, 5079, 5 }, // &Zscr;
    { 0x000E1, 0, 5084, 6 }, // &aacute
    { 0x000E1, 0, 5084, 7 }, // &aacute;
    { 0x00103, 0, 5091, 7 }, // &abreve;
    { 0x0223E, 0, 3565, 3 }, // &ac;
    { 0x0223E, 0x00333, 5098, 4 }, // &acE;
    { 0x0223F, 0, 5102, 4 }, // &acd;
    { 0x000E2, 0, 5106, 5 }, // &acirc
    { 0x000E2, 0, 5106, 6 }, // &acirc;
    { 0x000B4, 0, 11, 5 }, // &acute
    { 0x000B4, 0, 11, 6 }, // &acute;
    { 0x00430, 0, 5112, 4 }, // &acy;
    { 0x000E6, 0, 5116, 5 }, // &aelig
    { 0x000E6, 0, 5116, 6 }, // &aelig;
    { 0x02061, 0, 5122, 3 }, // &af;
    { 0x1D51E, 0, 5125, 4 }, // &afr;
    { 0x000E0, 0, 5129, 6 }, // &agrave
    { 0x000E0, 0, 5129, 7 }, // &agrave;
    { 0x02135, 0, 5136, 8 }, // &alefsym;
    { 0x02135, 0, 5144, 6 }, // &aleph;
    { 0x003B1, 0, 5150, 6 }, // &alpha;
    { 0x00101, 0, 5156, 6 }, // &amacr;
    { 0x02A3F, 0, 5162, 6 }, // &amalg;
    { 0x00026, 0, 5168, 3 }, // &amp
    { 0x00026, 0, 5168, 4 }, // &amp;
    { 0x02227, 0, 5172, 4 }, // &and;
    { 0x02A55, 0, 5176, 7 }, // &andand;
    { 0x02A5C, 0, 5183, 5 }, // &andd;
    { 0x02A58, 0, 5188, 9 }, // &andslope;
    { 0x02A5A, 0, 5197, 5 }, // &andv;
    { 0x02220, 0, 1939, 4 }, // &ang;
    { 0x029A4, 0, 5202, 5 }, // &ange;
    { 0x02220, 0, 2138, 6 }, // &angle;
    { 0x02221, 0, 5207, 7 }, // &angmsd;
    { 0x029A8, 0, 5214, 9 }, // &angmsdaa;
    { 0x029A9, 0, 5223, 9 }, // &angmsdab;
    { 0x029AA, 0, 5232, 9 }, // &angmsdac;
    { 0x029AB, 0, 5241, 9 }, // &angmsdad;
    { 0x029AC, 0, 5250, 9 }, // &angmsdae;
    { 0x029AD, 0, 5259, 9 }, // &angmsdaf;
    { 0x029AE, 0, 5268, 9 }, // &angmsdag;
    { 0x029AF, 0, 5277, 9 }, // &angmsdah;
    { 0x0221F, 0, 5286, 6 }, // &angrt;
    { 0x022BE, 0, 5292, 8 }, // &angrtvb;
    { 0x0299D, 0, 5300, 9 }, // &angrtvbd;
    { 0x02222, 0, 5309, 7 }, // &angsph;
    { 0x000C5, 0, 5316, 6 }, // &angst;
    { 0x0237C, 0, 5322, 8 }, // &angzarr;
    { 0x00105, 0, 5330, 6 }, // &aogon;
    { 0x1D552, 0, 5336, 5 }, // &aopf;
    { 0x02248, 0, 211, 3 }, // &ap;
    { 0x02A70, 0, 5341, 4 }, // &apE;
    { 0x02A6F, 0, 5345, 7 }, // &apacir;
    { 0x0224A, 0, 5352, 4 }, // &ape;
    { 0x0224B, 0, 5356, 5 }, // &apid;
    { 0x00027, 0, 5361, 5 }, // &apos;
    { 0x02248, 0, 5366, 7 }, // &approx;
    { 0x0224A, 0, 5373, 9 }, // &approxeq;
    { 0x000E5, 0, 5382, 5 }, // &aring
    { 0x000E5, 0, 5382, 6 }, // &aring;
    { 0x1D4B6, 0, 5388, 5 }, // &ascr;
    { 0x0002A, 0, 5393, 4 }, // &ast;
    { 0x02248, 0, 5397, 6 }, // &asymp;
    { 0x0224D, 0, 5403, 8 }, // &asympeq;
    { 0x000E3, 0, 5411, 6 }, // &atilde
    { 0x000E3, 0, 5411, 7 }, // &atilde;
    { 0x000E4, 0, 5418, 4 }, // &auml
    { 0x000E4, 0, 5418, 5 }, // &auml;
    { 0x02233, 0, 5423, 9 }, // &awconint;
    { 0x02A11, 0, 5432, 6 }, // &awint;
    { 0x02AED, 0, 5438, 5 }, // &bNot;
    { 0x0224C, 0, 5443, 9 }, // &backcong;
    { 0x003F6, 0, 5452, 12 }, // &backepsilon;
    { 0x02035, 0, 5464, 10 }, // &backprime;
    { 0x0223D, 0, 5474, 8 }, // &backsim;
    { 0x022CD, 0, 5482, 10 }, // &backsimeq;
    { 0x022BD, 0, 5492, 7 }, // &barvee;
    { 0x02305, 0, 5499, 7 }, // &barwed;
    { 0x02305, 0, 5506, 9 }, // &barwedge;
    { 0x023B5, 0, 5515, 5 }, // &bbrk;
    { 0x023B6, 0, 5520, 9 }, // &bbrktbrk;
    { 0x0224C, 0, 5529, 6 }, // &bcong;
    { 0x00431, 0, 5535, 4 }, // &bcy;
    { 0x0201E, 0, 5539, 6 }, // &bdquo;
    { 0x02235, 0, 5545, 7 }, // &becaus;
    { 0x02235, 0, 5552, 8 }, // &because;
    { 0x029B0, 0, 5560, 8 }, // &bemptyv;
    { 0x003F6, 0, 5568, 6 }, // &bepsi;
    { 0x0212C, 0, 5574, 7 }, // &bernou;
    { 0x003B2, 0, 5581, 5 }, // &beta;
    { 0x02136, 0, 5586, 5 }, // &beth;
    { 0x0226C, 0, 5591, 8 }, // &between;
    { 0x1D51F, 0, 5599, 4 }, // &bfr;
    { 0x022C2, 0, 5603, 7 }, // &bigcap;
    { 0x025EF, 0, 5610, 8 }, // &bigcirc;
    { 0x022C3, 0, 5618, 7 }, // &bigcup;
    { 0x02A00, 0, 5625, 8 }, // &bigodot;
    { 0x02A01, 0, 5633, 9 }, // &bigoplus;
    { 0x02A02, 0, 5642, 10 }, // &bigotimes;
    { 0x02A06, 0, 5652, 9 }, // &bigsqcup;
    { 0x02605, 0, 5661, 8 }, // &bigstar;
    { 0x025BD, 0, 5669, 16 }, // &bigtriangledown;
    { 0x025B3, 0, 5685, 14 }, // &bigtriangleup;
    { 0x02A04, 0, 5699, 9 }, // &biguplus;
    { 0x022C1, 0, 5708, 7 }, // &bigvee;
    { 0x022C0, 0, 5715, 9 }, // &bigwedge;
    { 0x0290D, 0, 5724, 7 }, // &bkarow;
    { 0x029EB, 0, 5731, 13 }, // &blacklozenge;
    { 0x025AA, 0, 5744, 12 }, // &blacksquare;
    { 0x025B4, 0, 5756, 14 }, // &blacktriangle;
    { 0x025BE, 0, 5770, 18 }, // &blacktriangledown;
    { 0x025C2, 0, 5788, 18 }, // &blacktriangleleft;
    { 0x025B8, 0, 5806, 19 }, // &blacktriangleright;
    { 0x02423, 0, 5825, 6 }, // &blank;
    { 0x02592, 0, 5831, 6 }, // &blk12;
    { 0x02591, 0, 5837, 6 }, // &blk14;
    { 0x02593, 0, 5843, 6 }, // &blk34;
    { 0x02588, 0, 5849, 6 }, // &block;
    { 0x0003D, 0x020E5, 5855, 4 }, // &bne;
    { 0x02261, 0x020E5, 5859, 8 }, // &bnequiv;
    { 0x02310, 0, 5867, 5 }, // &bnot;
    { 0x1D553, 0, 5872, 5 }, // &bopf;
    { 0x022A5, 0, 5877, 4 }, // &bot;
    { 0x022A5, 0, 5881, 7 }, // &bottom;
    { 0x022C8, 0, 5888, 7 }, // &bowtie;
    { 0x02557, 0, 5895, 6 }, // &boxDL;
    { 0x02554, 0, 5901, 6 }, // &boxDR;
    { 0x02556, 0, 5907, 6 }, // &boxDl;
    { 0x02553, 0, 5913, 6 }, // &boxDr;
    { 0x02550, 0, 5919, 5 }, // &boxH;
    { 0x02566, 0, 5924, 6 }, // &boxHD;
    { 0x02569, 0, 5930, 6 }, // &boxHU;
    { 0x02564, 0, 5936, 6 }, // &boxHd;
    { 0x02567, 0, 5942, 6 }, // &boxHu;
    { 0x0255D, 0, 5948, 6 }, // &boxUL;
    { 0x0255A, 0, 5954, 6 }, // &boxUR;
    { 0x0255C, 0, 5960, 6 }, // &boxUl;
    { 0x02559, 0, 5966, 6 }, // &boxUr;
    { 0x02551, 0, 5972, 5 }, // &boxV;
    { 0x0256C, 0, 5977, 6 }, // &boxVH;
    { 0x02563, 0, 5983, 6 }, // &boxVL;
    { 0x02560, 0, 5989, 6 }, // &boxVR;
    { 0x0256B, 0, 5995, 6 }, // &boxVh;
    { 0x02562, 0, 6001, 6 }, // &boxVl;
    { 0x0255F, 0, 6007, 6 }, // &boxVr;
    { 0x029C9, 0, 6013, 7 }, // &boxbox;
    { 0x02555, 0, 6020, 6 }, // &boxdL;
    { 0x02552, 0, 6026, 6 }, // &boxdR;
    { 0x02510, 0, 6032, 6 }, // &boxdl;
    { 0x0250C, 0, 6038, 6 }, // &boxdr;
    { 0x02500, 0, 6044, 5 }, // &boxh;
    { 0x02565, 0, 6049, 6 }, // &boxhD;
    { 0x02568, 0, 6055, 6 }, // &boxhU;
    { 0x0252C, 0, 6061, 6 }, // &boxhd;
    { 0x02534, 0, 6067, 6 }, // &boxhu;
    { 0x0229F, 0, 6073, 9 }, // &boxminus;
    { 0x0229E, 0, 6082, 8 }, // &boxplus;
    { 0x022A0, 0, 6090, 9 }, // &boxtimes;
    { 0x0255B, 0, 6099, 6 }, // &boxuL;
    { 0x02558, 0, 6105, 6 }, // &boxuR;
    { 0x02518, 0, 6111, 6 }, // &boxul;
    { 0x02514, 0, 6117, 6 }, // &boxur;
    { 0x02502, 0, 6123, 5 }, // &boxv;
    { 0x0256A, 0, 6128, 6 }, // &boxvH;
    { 0x02561, 0, 6134, 6 }, // &boxvL;
    { 0x0255E, 0, 6140, 6 }, // &boxvR;
    { 0x0253C, 0, 6146, 6 }, // &boxvh;
    { 0x02524, 0, 6152, 6 }, // &boxvl;
    { 0x0251C, 0, 6158, 6 }, // &boxvr;
    { 0x02035, 0, 6164, 7 }, // &bprime;
    { 0x002D8, 0, 18, 6 }, // &breve;
    { 0x000A6, 0, 6171, 6 }, // &brvbar
    { 0x000A6, 0, 6171, 7 }, // &brvbar;
    { 0x1D4B7, 0, 6178, 5 }, // &bscr;
    { 0x0204F, 0, 6183, 6 }, // &bsemi;
    { 0x0223D, 0, 6189, 5 }, // &bsim;
    { 0x022CD, 0, 6194, 6 }, // &bsime;
    { 0x0005C, 0, 6200, 5 }, // &bsol;
    { 0x029C5, 0, 6205, 6 }, // &bsolb;
    { 0x027C8, 0, 6211, 9 }, // &bsolhsub;
    { 0x02022, 0, 6220, 5 }, // &bull;
    { 0x02022, 0, 6225, 7 }, // &bullet;
    { 0x0224E, 0, 6232, 5 }, // &bump;
    { 0x02AAE, 0, 6237, 6 }, // &bumpE;
    { 0x0224F, 0, 6243, 6 }, // &bumpe;
    { 0x0224F, 0, 6249, 7 }, // &bumpeq;
    { 0x00107, 0, 6256, 7 }, // &cacute;
    { 0x02229, 0, 5606, 4 }, // &cap;
    { 0x02A44, 0, 6263, 7 }, // &capand;
    { 0x02A49, 0, 6270, 9 }, // &capbrcup;
    { 0x02A4B, 0, 6279, 7 }, // &capcap;
    { 0x02A47, 0, 6286, 7 }, // &capcup;
    { 0x02A40, 0, 6293, 7 }, // &capdot;
    { 0x02229, 0x0FE00, 6300, 5 }, // &caps;
    { 0x02041, 0, 6305, 6 }, // &caret;
    { 0x002C7, 0, 244, 6 }, // &caron;
    { 0x02A4D, 0, 6311, 6 }, // &ccaps;
    { 0x0010D, 0, 6317, 7 }, // &ccaron;
    { 0x000E7, 0, 6324, 6 }, // &ccedil
    { 0x000E7, 0, 6324, 7 }, // &ccedil;
    { 0x00109, 0, 6331, 6 }, // &ccirc;
    { 0x02A4C, 0, 6337, 6 }, // &ccups;
    { 0x02A50, 0, 6343, 8 }, // &ccupssm;
    { 0x0010B, 0, 6351, 5 }, // &cdot;
    { 0x000B8, 0, 251, 5 }, // &cedil
    { 0x000B8, 0, 251, 6 }, // &cedil;
    { 0x029B2, 0, 6356, 8 }, // &cemptyv;
    { 0x000A2, 0, 6364, 4 }, // &cent
    { 0x000A2, 0, 6364, 5 }, // &cent;
    { 0x000B7, 0, 6369, 10 }, // &centerdot;
    { 0x1D520, 0, 6379, 4 }, // &cfr;
    { 0x00447, 0, 6383, 5 }, // &chcy;
    { 0x02713, 0, 6388, 6 }, // &check;
    { 0x02713, 0, 6394, 10 }, // &checkmark;
    { 0x003C7, 0, 6404, 4 }, // &chi;
    { 0x025CB, 0, 4568, 4 }, // &cir;
    { 0x029C3, 0, 6408, 5 }, // &cirE;
    { 0x002C6, 0, 25, 5 }, // &circ;
    { 0x02257, 0, 6413, 7 }, // &circeq;
    { 0x021BA, 0, 6420, 16 }, // &circlearrowleft;
    { 0x021BB, 0, 6436, 17 }, // &circlearrowright;
    { 0x000AE, 0, 6453, 9 }, // &circledR;
    { 0x024C8, 0, 6462, 9 }, // &circledS;
    { 0x0229B, 0, 6471, 11 }, // &circledast;
    { 0x0229A, 0, 6482, 12 }, // &circledcirc;
    { 0x0229D, 0, 6494, 12 }, // &circleddash;
    { 0x02257, 0, 6506, 5 }, // &cire;
    { 0x02A10, 0, 6511, 9 }, // &cirfnint;
    { 0x02AEF, 0, 6520, 7 }, // &cirmid;
    { 0x029C2, 0, 6527, 8 }, // &cirscir;
    { 0x02663, 0, 6535, 6 }, // &clubs;
    { 0x02663, 0, 6541, 9 }, // &clubsuit;
    { 0x0003A, 0, 6550, 6 }, // &colon;
    { 0x02254, 0, 6556, 7 }, // &colone;
    { 0x02254, 0, 6563, 8 }, // &coloneq;
    { 0x0002C, 0, 6571, 6 }, // &comma;
    { 0x00040, 0, 6577, 7 }, // &commat;
    { 0x02201, 0, 6584, 5 }, // &comp;
    { 0x02218, 0, 6589, 7 }, // &compfn;
    { 0x02201, 0, 6596, 11 }, // &complement;
    { 0x02102, 0, 6607, 10 }, // &complexes;
    { 0x02245, 0, 5447, 5 }, // &cong;
    { 0x02A6D, 0, 6617, 8 }, // &congdot;
    { 0x0222E, 0, 264, 7 }, // &conint;
    { 0x1D554, 0, 6625, 5 }, // &copf;
    { 0x02210, 0, 6630, 7 }, // &coprod;
    { 0x000A9, 0, 6637, 4 }, // &copy
    { 0x000A9, 0, 6637, 5 }, // &copy;
    { 0x02117, 0, 6642, 7 }, // &copysr;
    { 0x021B5, 0, 6649, 6 }, // &crarr;
    { 0x02717, 0, 6655, 6 }, // &cross;
    { 0x1D4B8, 0, 6661, 5 }, // &cscr;
    { 0x02ACF, 0, 6666, 5 }, // &csub;
    { 0x02AD1, 0, 6671, 6 }, // &csube;
    { 0x02AD0, 0, 6677, 5 }, // &csup;
    { 0x02AD2, 0, 6682, 6 }, // &csupe;
    { 0x022EF, 0, 6688, 6 }, // &ctdot;
    { 0x02938, 0, 6694, 8 }, // &cudarrl;
    { 0x02935, 0, 6702, 8 }, // &cudarrr;
    { 0x022DE, 0, 6710, 6 }, // &cuepr;
    { 0x022DF, 0, 6716, 6 }, // &cuesc;
    { 0x021B6, 0, 6722, 7 }, // &cularr;
    { 0x0293D, 0, 6729, 8 }, // &cularrp;
    { 0x0222A, 0, 5621, 4 }, // &cup;
    { 0x02A48, 0, 6737, 9 }, // &cupbrcap;
    { 0x02A46, 0, 6746, 7 }, // &cupcap;
    { 0x02A4A, 0, 6753, 7 }, // &cupcup;
    { 0x0228D, 0, 6760, 7 }, // &cupdot;
    { 0x02A45, 0, 6767, 6 }, // &cupor;
    { 0x0222A, 0x0FE00, 6338, 5 }, // &cups;
    { 0x021B7, 0, 6773, 7 }, // &curarr;
    { 0x0293C, 0, 6780, 8 }, // &curarrm;
    { 0x022DE, 0, 6788, 12 }, // &curlyeqprec;
    { 0x022DF, 0, 6800, 12 }, // &curlyeqsucc;
    { 0x022CE, 0, 6812, 9 }, // &curlyvee;
    { 0x022CF, 0, 6821, 11 }, // &curlywedge;
    { 0x000A4, 0, 6832, 6 }, // &curren
    { 0x000A4, 0, 6832, 7 }, // &curren;
    { 0x021B6, 0, 6839, 15 }, // &curvearrowleft;
    { 0x021B7, 0, 6854, 16 }, // &curvearrowright;
    { 0x022CE, 0, 6870, 6 }, // &cuvee;
    { 0x022CF, 0, 6876, 6 }, // &cuwed;
    { 0x02232, 0, 6882, 9 }, // &cwconint;
    { 0x02231, 0, 6891, 6 }, // &cwint;
    { 0x0232D, 0, 6897, 7 }, // &cylcty;
    { 0x021D3, 0, 6904, 5 }, // &dArr;
    { 0x02965, 0, 6909, 5 }, // &dHar;
    { 0x02020, 0, 6914, 7 }, // &dagger;
    { 0x02138, 0, 6921, 7 }, // &daleth;
    { 0x02193, 0, 6928, 5 }, // &darr;
    { 0x02010, 0, 4838, 5 }, // &dash;
    { 0x022A3, 0, 6933, 6 }, // &dashv;
    { 0x0290F, 0, 6939, 8 }, // &dbkarow;
    { 0x002DD, 0, 3562, 6 }, // &dblac;
    { 0x0010F, 0, 6947, 7 }, // &dcaron;
    { 0x00434, 0, 6954, 4 }, // &dcy;
    { 0x02146, 0, 5185, 3 }, // &dd;
    { 0x02021, 0, 6958, 8 }, // &ddagger;
    { 0x021CA, 0, 6966, 6 }, // &ddarr;
    { 0x02A77, 0, 6972, 8 }, // &ddotseq;
    { 0x000B0, 0, 6980, 3 }, // &deg
    { 0x000B0, 0, 6980, 4 }, // &deg;
    { 0x003B4, 0, 6984, 6 }, // &delta;
    { 0x029B1, 0, 6990, 8 }, // &demptyv;
    { 0x0297F, 0, 6998, 7 }, // &dfisht;
    { 0x1D521, 0, 7005, 4 }, // &dfr;
    { 0x021C3, 0, 7009, 6 }, // &dharl;
    { 0x021C2, 0, 7015, 6 }, // &dharr;
    { 0x022C4, 0, 7021, 5 }, // &diam;
    { 0x022C4, 0, 7026, 8 }, // &diamond;
    { 0x02666, 0, 7034, 12 }, // &diamondsuit;
    { 0x02666, 0, 7046, 6 }, // &diams;
    { 0x000A8, 0, 7052, 4 }, // &die;
    { 0x003DD, 0, 7056, 8 }, // &digamma;
    { 0x022F2, 0, 7064, 6 }, // &disin;
    { 0x000F7, 0, 7070, 4 }, // &div;
    { 0x000F7, 0, 7074, 6 }, // &divide
    { 0x000F7, 0, 7074, 7 }, // &divide;
    { 0x022C7, 0, 7081, 14 }, // &divideontimes;
    { 0x022C7, 0, 7095, 7 }, // &divonx;
    { 0x00452, 0, 7102, 5 }, // &djcy;
    { 0x0231E, 0, 7107, 7 }, // &dlcorn;
    { 0x0230D, 0, 7114, 7 }, // &dlcrop;
    { 0x00024, 0, 7121, 7 }, // &dollar;
    { 0x1D555, 0, 7128, 5 }, // &dopf;
    { 0x002D9, 0, 272, 4 }, // &dot;
    { 0x02250, 0, 7133, 6 }, // &doteq;
    { 0x02251, 0, 7139, 9 }, // &doteqdot;
    { 0x02238, 0, 7148, 9 }, // &dotminus;
    { 0x02214, 0, 7157, 8 }, // &dotplus;
    { 0x022A1, 0, 7165, 10 }, // &dotsquare;
    { 0x02306, 0, 7175, 15 }, // &doublebarwedge;
    { 0x02193, 0, 4745, 10 }, // &downarrow;
    { 0x021CA, 0, 7190, 15 }, // &downdownarrows;
    { 0x021C3, 0, 7205, 16 }, // &downharpoonleft;
    { 0x021C2, 0, 7221, 17 }, // &downharpoonright;
    { 0x02910, 0, 7238, 9 }, // &drbkarow;
    { 0x0231F, 0, 7247, 7 }, // &drcorn;
    { 0x0230C, 0, 7254, 7 }, // &drcrop;
    { 0x1D4B9, 0, 7261, 5 }, // &dscr;
    { 0x00455, 0, 7266, 5 }, // &dscy;
    { 0x029F6, 0, 7271, 5 }, // &dsol;
    { 0x00111, 0, 7276, 7 }, // &dstrok;
    { 0x022F1, 0, 7283, 6 }, // &dtdot;
    { 0x025BF, 0, 7289, 5 }, // &dtri;
    { 0x025BE, 0, 7294, 6 }, // &dtrif;
    { 0x021F5, 0, 7300, 6 }, // &duarr;
    { 0x0296F, 0, 7306, 6 }, // &duhar;
    { 0x029A6, 0, 7312, 8 }, // &dwangle;
    { 0x0045F, 0, 7320, 5 }, // &dzcy;
    { 0x027FF, 0, 7325, 9 }, // &dzigrarr;
    { 0x02A77, 0, 7334, 6 }, // &eDDot;
    { 0x02251, 0, 307, 5 }, // &eDot;
    { 0x000E9, 0, 7340, 6 }, // &eacute
    { 0x000E9, 0, 7340, 7 }, // &eacute;
    { 0x02A6E, 0, 7347, 7 }, // &easter;
    { 0x0011B, 0, 7354, 7 }, // &ecaron;
    { 0x02256, 0, 7361, 5 }, // &ecir;
    { 0x000EA, 0, 7366, 5 }, // &ecirc
    { 0x000EA, 0, 7366, 6 }, // &ecirc;
    { 0x02255, 0, 7372, 7 }, // &ecolon;
    { 0x0044D, 0, 7379, 4 }, // &ecy;
    { 0x00117, 0, 7383, 5 }, // &edot;
    { 0x02147, 0, 793, 3 }, // &ee;
    { 0x02252, 0, 7388, 6 }, // &efDot;
    { 0x1D522, 0, 7394, 4 }, // &efr;
    { 0x02A9A, 0, 6981, 3 }, // &eg;
    { 0x000E8, 0, 7398, 6 }, // &egrave
    { 0x000E8, 0, 7398, 7 }, // &egrave;
    { 0x02A96, 0, 7405, 4 }, // &egs;
    { 0x02A98, 0, 7409, 7 }, // &egsdot;
    { 0x02A99, 0, 566, 3 }, // &el;
    { 0x023E7, 0, 7416, 9 }, // &elinters;
    { 0x02113, 0, 7425, 4 }, // &ell;
    { 0x02A95, 0, 7429, 4 }, // &els;
    { 0x02A97, 0, 7433, 7 }, // &elsdot;
    { 0x00113, 0, 7440, 6 }, // &emacr;
    { 0x02205, 0, 7446, 6 }, // &empty;
    { 0x02205, 0, 7452, 9 }, // &emptyset;
    { 0x02205, 0, 5561, 7 }, // &emptyv;
    { 0x02004, 0, 7461, 7 }, // &emsp13;
    { 0x02005, 0, 7468, 7 }, // &emsp14;
    { 0x02003, 0, 7475, 5 }, // &emsp;
    { 0x0014B, 0, 7480, 4 }, // &eng;
    { 0x02002, 0, 7484, 5 }, // &ensp;
    { 0x00119, 0, 7489, 6 }, // &eogon;
    { 0x1D556, 0, 7495, 5 }, // &eopf;
    { 0x022D5, 0, 7500, 5 }, // &epar;
    { 0x029E3, 0, 7505, 7 }, // &eparsl;
    { 0x02A71, 0, 7512, 6 }, // &eplus;
    { 0x003B5, 0, 5569, 5 }, // &epsi;
    { 0x003B5, 0, 5456, 8 }, // &epsilon;
    { 0x003F5, 0, 7518, 6 }, // &epsiv;
    { 0x02256, 0, 7524, 7 }, // &eqcirc;
    { 0x02255, 0, 7531, 8 }, // &eqcolon;
    { 0x02242, 0, 7539, 6 }, // &eqsim;
    { 0x02A96, 0, 7545, 11 }, // &eqslantgtr;
    { 0x02A95, 0, 7556, 12 }, // &eqslantless;
    { 0x0003D, 0, 7568, 7 }, // &equals;
    { 0x0225F, 0, 7575, 7 }, // &equest;
    { 0x02261, 0, 5861, 6 }, // &equiv;
    { 0x02A78, 0, 7582, 8 }, // &equivDD;
    { 0x029E5, 0, 7590, 9 }, // &eqvparsl;
    { 0x02253, 0, 288, 6 }, // &erDot;
    { 0x02971, 0, 7599, 6 }, // &erarr;
    { 0x0212F, 0, 7605, 5 }, // &escr;
    { 0x02250, 0, 7610, 6 }, // &esdot;
    { 0x02242, 0, 7616, 5 }, // &esim;
    { 0x003B7, 0, 162, 4 }, // &eta;
    { 0x000F0, 0, 5587, 3 }, // &eth
    { 0x000F0, 0, 5587, 4 }, // &eth;
    { 0x000EB, 0, 7621, 4 }, // &euml
    { 0x000EB, 0, 7621, 5 }, // &euml;
    { 0x020AC, 0, 7626, 5 }, // &euro;
    { 0x00021, 0, 7631, 5 }, // &excl;
    { 0x02203, 0, 7636, 6 }, // &exist;
    { 0x02130, 0, 7642, 12 }, // &expectation;
    { 0x02147, 0, 7654, 13 }, // &exponentiale;
    { 0x02252, 0, 7667, 14 }, // &fallingdotseq;
    { 0x00444, 0, 7681, 4 }, // &fcy;
    { 0x02640, 0, 7685, 7 }, // &female;
    { 0x0FB03, 0, 7692, 7 }, // &ffilig;
    { 0x0FB00, 0, 7699, 6 }, // &fflig;
    { 0x0FB04, 0, 7705, 7 }, // &ffllig;
    { 0x1D523, 0, 7712, 4 }, // &ffr;
    { 0x0FB01, 0, 7693, 6 }, // &filig;
    { 0x00066, 0x0006A, 7716, 6 }, // &fjlig;
    { 0x0266D, 0, 7722, 5 }, // &flat;
    { 0x0FB02, 0, 7706, 6 }, // &fllig;
    { 0x025B1, 0, 7727, 6 }, // &fltns;
    { 0x00192, 0, 7733, 5 }, // &fnof;
    { 0x1D557, 0, 7738, 5 }, // &fopf;
    { 0x02200, 0, 7743, 7 }, // &forall;
    { 0x022D4, 0, 7750, 5 }, // &fork;
    { 0x02AD9, 0, 7755, 6 }, // &forkv;
    { 0x02A0D, 0, 7761, 9 }, // &fpartint;
    { 0x000BD, 0, 7770, 6 }, // &frac12
    { 0x000BD, 0, 7770, 7 }, // &frac12;
    { 0x02153, 0, 7777, 7 }, // &frac13;
    { 0x000BC, 0, 7784, 6 }, // &frac14
    { 0x000BC, 0, 7784, 7 }, // &frac14;
    { 0x02155, 0, 7791, 7 }, // &frac15;
    { 0x02159, 0, 7798, 7 }, // &frac16;
    { 0x0215B, 0, 7805, 7 }, // &frac18;
    { 0x02154, 0, 7812, 7 }, // &frac23;
    { 0x02156, 0, 7819, 7 }, // &frac25;
    { 0x000BE, 0, 7826, 6 }, // &frac34
    { 0x000BE, 0, 7826, 7 }, // &frac34;
    { 0x02157, 0, 7833, 7 }, // &frac35;
    { 0x0215C, 0, 7840, 7 }, // &frac38;
    { 0x02158, 0, 7847, 7 }, // &frac45;
    { 0x0215A, 0, 7854, 7 }, // &frac56;
    { 0x0215D, 0, 7861, 7 }, // &frac58;
    { 0x0215E, 0, 7868, 7 }, // &frac78;
    { 0x02044, 0, 7875, 6 }, // &frasl;
    { 0x02322, 0, 7881, 6 }, // &frown;
    { 0x1D4BB, 0, 7887, 5 }, // &fscr;
    { 0x02267, 0, 7892, 3 }, // &gE;
    { 0x02A8C, 0, 7895, 4 }, // &gEl;
    { 0x001F5, 0, 7899, 7 }, // &gacute;
    { 0x003B3, 0, 7058, 6 }, // &gamma;
    { 0x003DD, 0, 7906, 7 }, // &gammad;
    { 0x02A86, 0, 7913, 4 }, // &gap;
    { 0x0011F, 0, 7917, 7 }, // &gbreve;
    { 0x0011D, 0, 5612, 6 }, // &gcirc;
    { 0x00433, 0, 7924, 4 }, // &gcy;
    { 0x00121, 0, 6620, 5 }, // &gdot;
    { 0x02265, 0, 4941, 3 }, // &ge;
    { 0x022DB, 0, 7928, 4 }, // &gel;
    { 0x02265, 0, 7932, 4 }, // &geq;
    { 0x02267, 0, 7936, 5 }, // &geqq;
    { 0x02A7E, 0, 7941, 9 }, // &geqslant;
    { 0x02A7E, 0, 7950, 4 }, // &ges;
    { 0x02AA9, 0, 7954, 6 }, // &gescc;
    { 0x02A80, 0, 7960, 7 }, // &gesdot;
    { 0x02A82, 0, 7967, 8 }, // &gesdoto;
    { 0x02A84, 0, 7975, 9 }, // &gesdotol;
    { 0x022DB, 0x0FE00, 7984, 5 }, // &gesl;
    { 0x02A94, 0, 7989, 7 }, // &gesles;
    { 0x1D524, 0, 7996, 4 }, // &gfr;
    { 0x0226B, 0, 8000, 3 }, // &gg;
    { 0x022D9, 0, 8003, 4 }, // &ggg;
    { 0x02137, 0, 8007, 6 }, // &gimel;
    { 0x00453, 0, 8013, 5 }, // &gjcy;
    { 0x02277, 0, 8018, 3 }, // &gl;
    { 0x02A92, 0, 8021, 4 }, // &glE;
    { 0x02AA5, 0, 8025, 4 }, // &gla;
    { 0x02AA4, 0, 8029, 4 }, // &glj;
    { 0x02269, 0, 8033, 4 }, // &gnE;
    { 0x02A8A, 0, 8037, 5 }, // &gnap;
    { 0x02A8A, 0, 8042, 9 }, // &gnapprox;
    { 0x02A88, 0, 8051, 4 }, // &gne;
    { 0x02A88, 0, 8055, 5 }, // &gneq;
    { 0x02269, 0, 8060, 6 }, // &gneqq;
    { 0x022E7, 0, 8066, 6 }, // &gnsim;
    { 0x1D558, 0, 8072, 5 }, // &gopf;
    { 0x00060, 0, 39, 6 }, // &grave;
    { 0x0210A, 0, 8077, 5 }, // &gscr;
    { 0x02273, 0, 8082, 5 }, // &gsim;
    { 0x02A8E, 0, 8087, 6 }, // &gsime;
    { 0x02A90, 0, 8093, 6 }, // &gsiml;
    { 0x0003E, 0, 5671, 2 }, // &gt
    { 0x0003E, 0, 8099, 3 }, // &gt;
    { 0x02AA7, 0, 8102, 5 }, // &gtcc;
    { 0x02A7A, 0, 8107, 6 }, // &gtcir;
    { 0x022D7, 0, 8113, 6 }, // &gtdot;
    { 0x02995, 0, 8119, 7 }, // &gtlPar;
    { 0x02A7C, 0, 8126, 8 }, // &gtquest;
    { 0x02A86, 0, 8134, 10 }, // &gtrapprox;
    { 0x02978, 0, 8144, 7 }, // &gtrarr;
    { 0x022D7, 0, 8151, 7 }, // &gtrdot;
    { 0x022DB, 0, 8158, 10 }, // &gtreqless;
    { 0x02A8C, 0, 8168, 11 }, // &gtreqqless;
    { 0x02277, 0, 8179, 8 }, // &gtrless;
    { 0x02273, 0, 8187, 7 }, // &gtrsim;
    { 0x02269, 0x0FE00, 8194, 10 }, // &gvertneqq;
    { 0x02269, 0x0FE00, 8204, 5 }, // &gvnE;
    { 0x021D4, 0, 8209, 5 }, // &hArr;
    { 0x0200A, 0, 8214, 7 }, // &hairsp;
    { 0x000BD, 0, 8221, 5 }, // &half;
    { 0x0210B, 0, 8226, 7 }, // &hamilt;
    { 0x0044A, 0, 8233, 7 }, // &hardcy;
    { 0x02194, 0, 7016, 5 }, // &harr;
    { 0x02948, 0, 8240, 8 }, // &harrcir;
    { 0x021AD, 0, 8248, 6 }, // &harrw;
    { 0x0210F, 0, 8254, 5 }, // &hbar;
    { 0x00125, 0, 8259, 6 }, // &hcirc;
    { 0x02665, 0, 8265, 7 }, // &hearts;
    { 0x02665, 0, 8272, 10 }, // &heartsuit;
    { 0x02026, 0, 8282, 7 }, // &hellip;
    { 0x022B9, 0, 8289, 7 }, // &hercon;
    { 0x1D525, 0, 8296, 4 }, // &hfr;
    { 0x02925, 0, 8300, 9 }, // &hksearow;
    { 0x02926, 0, 8309, 9 }, // &hkswarow;
    { 0x021FF, 0, 8318, 6 }, // &hoarr;
    { 0x0223B, 0, 8324, 7 }, // &homtht;
    { 0x021A9, 0, 8331, 14 }, // &hookleftarrow;
    { 0x021AA, 0, 8345, 15 }, // &hookrightarrow;
    { 0x1D559, 0, 8360, 5 }, // &hopf;
    { 0x02015, 0, 8365, 7 }, // &horbar;
    { 0x1D4BD, 0, 8372, 5 }, // &hscr;
    { 0x0210F, 0, 8377, 7 }, // &hslash;
    { 0x00127, 0, 8384, 7 }, // &hstrok;
    { 0x02043, 0, 8391, 7 }, // &hybull;
    { 0x02010, 0, 8398, 7 }, // &hyphen;
    { 0x000ED, 0, 8405, 6 }, // &iacute
    { 0x000ED, 0, 8405, 7 }, // &iacute;
    { 0x02063, 0, 8412, 3 }, // &ic;
    { 0x000EE, 0, 8415, 5 }, // &icirc
    { 0x000EE, 0, 8415, 6 }, // &icirc;
    { 0x00438, 0, 8421, 4 }, // &icy;
    { 0x00435, 0, 8425, 5 }, // &iecy;
    { 0x000A1, 0, 8430, 5 }, // &iexcl
    { 0x000A1, 0, 8430, 6 }, // &iexcl;
    { 0x021D4, 0, 8436, 4 }, // &iff;
    { 0x1D526, 0, 8440, 4 }, // &ifr;
    { 0x000EC, 0, 8444, 6 }, // &igrave
    { 0x000EC, 0, 8444, 7 }, // &igrave;
    { 0x02148, 0, 8451, 3 }, // &ii;
    { 0x02A0C, 0, 8454, 7 }, // &iiiint;
    { 0x0222D, 0, 8455, 6 }, // &iiint;
    { 0x029DC, 0, 8461, 7 }, // &iinfin;
    { 0x02129, 0, 8468, 6 }, // &iiota;
    { 0x00133, 0, 8474, 6 }, // &ijlig;
    { 0x0012B, 0, 8480, 6 }, // &imacr;
    { 0x02111, 0, 8486, 6 }, // &image;
    { 0x02110, 0, 8492, 9 }, // &imagline;
    { 0x02111, 0, 8501, 9 }, // &imagpart;
    { 0x00131, 0, 8510, 6 }, // &imath;
    { 0x022B7, 0, 8516, 5 }, // &imof;
    { 0x001B5, 0, 8521, 6 }, // &imped;
    { 0x02208, 0, 7067, 3 }, // &in;
    { 0x02105, 0, 8527, 7 }, // &incare;
    { 0x0221E, 0, 8462, 6 }, // &infin;
    { 0x029DD, 0, 8534, 9 }, // &infintie;
    { 0x00131, 0, 8543, 7 }, // &inodot;
    { 0x0222B, 0, 267, 4 }, // &int;
    { 0x022BA, 0, 8550, 7 }, // &intcal;
    { 0x02124, 0, 8557, 9 }, // &integers;
    { 0x022BA, 0, 8566, 9 }, // &intercal;
    { 0x02A17, 0, 8575, 9 }, // &intlarhk;
    { 0x02A3C, 0, 8584, 8 }, // &intprod;
    { 0x00451, 0, 8592, 5 }, // &iocy;
    { 0x0012F, 0, 8597, 6 }, // &iogon;
    { 0x1D55A, 0, 8603, 5 }, // &iopf;
    { 0x003B9, 0, 8469, 5 }, // &iota;
    { 0x02A3C, 0, 8608, 6 }, // &iprod;
    { 0x000BF, 0, 8614, 6 }, // &iquest
    { 0x000BF, 0, 8614, 7 }, // &iquest;
    { 0x1D4BE, 0, 8621, 5 }, // &iscr;
    { 0x02208, 0, 7065, 5 }, // &isin;
    { 0x022F9, 0, 8626, 6 }, // &isinE;
    { 0x022F5, 0, 8632, 8 }, // &isindot;
    { 0x022F4, 0, 8640, 6 }, // &isins;
    { 0x022F3, 0, 8646, 7 }, // &isinsv;
    { 0x02208, 0, 8653, 6 }, // &isinv;
    { 0x02062, 0, 6547, 3 }, // &it;
    { 0x00129, 0, 8659, 7 }, // &itilde;
    { 0x00456, 0, 8666, 6 }, // &iukcy;
    { 0x000EF, 0, 8672, 4 }, // &iuml
    { 0x000EF, 0, 8672, 5 }, // &iuml;
    { 0x00135, 0, 8677, 6 }, // &jcirc;
    { 0x00439, 0, 7103, 4 }, // &jcy;
    { 0x1D527, 0, 8683, 4 }, // &jfr;
    { 0x00237, 0, 8687, 6 }, // &jmath;
    { 0x1D55B, 0, 8693, 5 }, // &jopf;
    { 0x1D4BF, 0, 8698, 5 }, // &jscr;
    { 0x00458, 0, 8703, 7 }, // &jsercy;
    { 0x00454, 0, 8710, 6 }, // &jukcy;
    { 0x003BA, 0, 8716, 6 }, // &kappa;
    { 0x003F0, 0, 8722, 7 }, // &kappav;
    { 0x00137, 0, 8729, 7 }, // &kcedil;
    { 0x0043A, 0, 1833, 4 }, // &kcy;
    { 0x1D528, 0, 8736, 4 }, // &kfr;
    { 0x00138, 0, 8740, 7 }, // &kgreen;
    { 0x00445, 0, 8747, 5 }, // &khcy;
    { 0x0045C, 0, 8752, 5 }, // &kjcy;
    { 0x1D55C, 0, 8757, 5 }, // &kopf;
    { 0x1D4C0, 0, 8762, 5 }, // &kscr;
    { 0x021DA, 0, 8767, 6 }, // &lAarr;
    { 0x021D0, 0, 8773, 5 }, // &lArr;
    { 0x0291B, 0, 8778, 7 }, // &lAtail;
    { 0x0290E, 0, 8785, 6 }, // &lBarr;
    { 0x02266, 0, 1330, 3 }, // &lE;
    { 0x02A8B, 0, 8791, 4 }, // &lEg;
    { 0x02962, 0, 8795, 5 }, // &lHar;
    { 0x0013A, 0, 8800, 7 }, // &lacute;
    { 0x029B4, 0, 8807, 9 }, // &laemptyv;
    { 0x02112, 0, 8816, 7 }, // &lagran;
    { 0x003BB, 0, 8823, 7 }, // &lambda;
    { 0x027E8, 0, 8830, 5 }, // &lang;
    { 0x02991, 0, 8835, 6 }, // &langd;
    { 0x027E8, 0, 8841, 7 }, // &langle;
    { 0x02A85, 0, 8848, 4 }, // &lap;
    { 0x000AB, 0, 8852, 5 }, // &laquo
    { 0x000AB, 0, 8852, 6 }, // &laquo;
    { 0x02190, 0, 6724, 5 }, // &larr;
    { 0x021E4, 0, 8858, 6 }, // &larrb;
    { 0x0291F, 0, 8864, 8 }, // &larrbfs;
    { 0x0291D, 0, 8872, 7 }, // &larrfs;
    { 0x021A9, 0, 8879, 7 }, // &larrhk;
    { 0x021AB, 0, 8886, 7 }, // &larrlp;
    { 0x02939, 0, 8893, 7 }, // &larrpl;
    { 0x02973, 0, 8900, 8 }, // &larrsim;
    { 0x021A2, 0, 8908, 7 }, // &larrtl;
    { 0x02AAB, 0, 7723, 4 }, // &lat;
    { 0x02919, 0, 8915, 7 }, // &latail;
    { 0x02AAD, 0, 8922, 5 }, // &late;
    { 0x02AAD, 0x0FE00, 8927, 6 }, // &lates;
    { 0x0290C, 0, 8933, 6 }, // &lbarr;
    { 0x02772, 0, 8939, 6 }, // &lbbrk;
    { 0x0007B, 0, 8945, 7 }, // &lbrace;
    { 0x0005B, 0, 8952, 7 }, // &lbrack;
    { 0x0298B, 0, 8959, 6 }, // &lbrke;
    { 0x0298F, 0, 8965, 8 }, // &lbrksld;
    { 0x0298D, 0, 8973, 8 }, // &lbrkslu;
    { 0x0013E, 0, 8981, 7 }, // &lcaron;
    { 0x0013C, 0, 8988, 7 }, // &lcedil;
    { 0x02308, 0, 8995, 6 }, // &lceil;
    { 0x0007B, 0, 9001, 5 }, // &lcub;
    { 0x0043B, 0, 9006, 4 }, // &lcy;
    { 0x02936, 0, 9010, 5 }, // &ldca;
    { 0x0201C, 0, 9015, 6 }, // &ldquo;
    { 0x0201E, 0, 9021, 7 }, // &ldquor;
    { 0x02967, 0, 9028, 8 }, // &ldrdhar;
    { 0x0294B, 0, 9036, 9 }, // &ldrushar;
    { 0x021B2, 0, 9045, 5 }, // &ldsh;
    { 0x02264, 0, 2141, 3 }, // &le;
    { 0x02190, 0, 2350, 10 }, // &leftarrow;
    { 0x021A2, 0, 9050, 14 }, // &leftarrowtail;
    { 0x021BD, 0, 9064, 16 }, // &leftharpoondown;
    { 0x021BC, 0, 9080, 14 }, // &leftharpoonup;
    { 0x021C7, 0, 9094, 15 }, // &leftleftarrows;
    { 0x02194, 0, 2385, 15 }, // &leftrightarrow;
    { 0x021C6, 0, 9109, 16 }, // &leftrightarrows;
    { 0x021CB, 0, 9125, 18 }, // &leftrightharpoons;
    { 0x021AD, 0, 9143, 20 }, // &leftrightsquigarrow;
    { 0x022CB, 0, 9163, 15 }, // &leftthreetimes;
    { 0x022DA, 0, 9178, 4 }, // &leg;
    { 0x02264, 0, 9182, 4 }, // &leq;
    { 0x02266, 0, 9186, 5 }, // &leqq;
    { 0x02A7D, 0, 9191, 9 }, // &leqslant;
    { 0x02A7D, 0, 7992, 4 }, // &les;
    { 0x02AA8, 0, 9200, 6 }, // &lescc;
    { 0x02A7F, 0, 9206, 7 }, // &lesdot;
    { 0x02A81, 0, 9213, 8 }, // &lesdoto;
    { 0x02A83, 0, 9221, 9 }, // &lesdotor;
    { 0x022DA, 0x0FE00, 9230, 5 }, // &lesg;
    { 0x02A93, 0, 9235, 7 }, // &lesges;
    { 0x02A85, 0, 9242, 11 }, // &lessapprox;
    { 0x022D6, 0, 9253, 8 }, // &lessdot;
    { 0x022DA, 0, 9261, 10 }, // &lesseqgtr;
    { 0x02A8B, 0, 9271, 11 }, // &lesseqqgtr;
    { 0x02276, 0, 9282, 8 }, // &lessgtr;
    { 0x02272, 0, 9290, 8 }, // &lesssim;
    { 0x0297C, 0, 9298, 7 }, // &lfisht;
    { 0x0230A, 0, 9305, 7 }, // &lfloor;
    { 0x1D529, 0, 9312, 4 }, // &lfr;
    { 0x02276, 0, 5165, 3 }, // &lg;
    { 0x02A91, 0, 9316, 4 }, // &lgE;
    { 0x021BD, 0, 9320, 6 }, // &lhard;
    { 0x021BC, 0, 9326, 6 }, // &lharu;
    { 0x0296A, 0, 9332, 7 }, // &lharul;
    { 0x02584, 0, 9339, 6 }, // &lhblk;
    { 0x00459, 0, 9345, 5 }, // &ljcy;
    { 0x0226A, 0, 1390, 3 }, // &ll;
    { 0x021C7, 0, 9350, 6 }, // &llarr;
    { 0x0231E, 0, 9356, 9 }, // &llcorner;
    { 0x0296B, 0, 9365, 7 }, // &llhard;
    { 0x025FA, 0, 9372, 6 }, // &lltri;
    { 0x00140, 0, 9378, 7 }, // &lmidot;
    { 0x023B0, 0, 9385, 7 }, // &lmoust;
    { 0x023B0, 0, 9392, 11 }, // &lmoustache;
    { 0x02268, 0, 9403, 4 }, // &lnE;
    { 0x02A89, 0, 9407, 5 }, // &lnap;
    { 0x02A89, 0, 9412, 9 }, // &lnapprox;
    { 0x02A87, 0, 9421, 4 }, // &lne;
    { 0x02A87, 0, 9425, 5 }, // &lneq;
    { 0x02268, 0, 9430, 6 }, // &lneqq;
    { 0x022E6, 0, 9436, 6 }, // &lnsim;
    { 0x027EC, 0, 9442, 6 }, // &loang;
    { 0x021FD, 0, 9448, 6 }, // &loarr;
    { 0x027E6, 0, 9454, 6 }, // &lobrk;
    { 0x027F5, 0, 9460, 14 }, // &longleftarrow;
    { 0x027F7, 0, 9474, 19 }, // &longleftrightarrow;
    { 0x027FC, 0, 9493, 11 }, // &longmapsto;
    { 0x027F6, 0, 9504, 15 }, // &longrightarrow;
    { 0x021AB, 0, 9519, 14 }, // &looparrowleft;
    { 0x021AC, 0, 9533, 15 }, // &looparrowright;
    { 0x02985, 0, 9548, 6 }, // &lopar;
    { 0x1D55D, 0, 9554, 5 }, // &lopf;
    { 0x02A2D, 0, 9559, 7 }, // &loplus;
    { 0x02A34, 0, 9566, 8 }, // &lotimes;
    { 0x02217, 0, 9574, 7 }, // &lowast;
    { 0x0005F, 0, 9581, 7 }, // &lowbar;
    { 0x025CA, 0, 9588, 4 }, // &loz;
    { 0x025CA, 0, 5736, 8 }, // &lozenge;
    { 0x029EB, 0, 9592, 5 }, // &lozf;
    { 0x00028, 0, 9597, 5 }, // &lpar;
    { 0x02993, 0, 9602, 7 }, // &lparlt;
    { 0x021C6, 0, 9609, 6 }, // &lrarr;
    { 0x0231F, 0, 9615, 9 }, // &lrcorner;
    { 0x021CB, 0, 9624, 6 }, // &lrhar;
    { 0x0296D, 0, 9630, 7 }, // &lrhard;
    { 0x0200E, 0, 9637, 4 }, // &lrm;
    { 0x022BF, 0, 9641, 6 }, // &lrtri;
    { 0x02039, 0, 9647, 7 }, // &lsaquo;
    { 0x1D4C1, 0, 9654, 5 }, // &lscr;
    { 0x021B0, 0, 9659, 4 }, // &lsh;
    { 0x02272, 0, 9663, 5 }, // &lsim;
    { 0x02A8D, 0, 9668, 6 }, // &lsime;
    { 0x02A8F, 0, 9674, 6 }, // &lsimg;
    { 0x0005B, 0, 9680, 5 }, // &lsqb;
    { 0x02018, 0, 9685, 6 }, // &lsquo;
    { 0x0201A, 0, 9691, 7 }, // &lsquor;
    { 0x00142, 0, 9698, 7 }, // &lstrok;
    { 0x0003C, 0, 571, 2 }, // &lt
    { 0x0003C, 0, 8230, 3 }, // &lt;
    { 0x02AA6, 0, 9705, 5 }, // &ltcc;
    { 0x02A79, 0, 9710, 6 }, // &ltcir;
    { 0x022D6, 0, 9716, 6 }, // &ltdot;
    { 0x022CB, 0, 9722, 7 }, // &lthree;
    { 0x022C9, 0, 9729, 7 }, // &ltimes;
    { 0x02976, 0, 9736, 7 }, // &ltlarr;
    { 0x02A7B, 0, 9743, 8 }, // &ltquest;
    { 0x02996, 0, 9751, 7 }, // &ltrPar;
    { 0x025C3, 0, 9373, 5 }, // &ltri;
    { 0x022B4, 0, 9758, 6 }, // &ltrie;
    { 0x025C2, 0, 9764, 6 }, // &ltrif;
    { 0x0294A, 0, 9770, 9 }, // &lurdshar;
    { 0x02966, 0, 9779, 8 }, // &luruhar;
    { 0x02268, 0x0FE00, 9787, 10 }, // &lvertneqq;
    { 0x02268, 0x0FE00, 9797, 5 }, // &lvnE;
    { 0x0223A, 0, 9802, 6 }, // &mDDot;
    { 0x000AF, 0, 52, 4 }, // &macr
    { 0x000AF, 0, 52, 5 }, // &macr;
    { 0x02642, 0, 7687, 5 }, // &male;
    { 0x02720, 0, 9808, 5 }, // &malt;
    { 0x02720, 0, 9813, 8 }, // &maltese;
    { 0x021A6, 0, 9821, 4 }, // &map;
    { 0x021A6, 0, 9497, 7 }, // &mapsto;
    { 0x021A7, 0, 9825, 11 }, // &mapstodown;
    { 0x021A4, 0, 9836, 11 }, // &mapstoleft;
    { 0x021A5, 0, 9847, 9 }, // &mapstoup;
    { 0x025AE, 0, 9856, 7 }, // &marker;
    { 0x02A29, 0, 9863, 7 }, // &mcomma;
    { 0x0043C, 0, 9870, 4 }, // &mcy;
    { 0x02014, 0, 9874, 6 }, // &mdash;
    { 0x02221, 0, 9880, 14 }, // &measuredangle;
    { 0x1D52A, 0, 9894, 4 }, // &mfr;
    { 0x02127, 0, 9898, 4 }, // &mho;
    { 0x000B5, 0, 3592, 5 }, // &micro
    { 0x000B5, 0, 9902, 6 }, // &micro;
    { 0x02223, 0, 6523, 4 }, // &mid;
    { 0x0002A, 0, 9908, 7 }, // &midast;
    { 0x02AF0, 0, 9915, 7 }, // &midcir;
    { 0x000B7, 0, 9922, 6 }, // &middot
    { 0x000B7, 0, 9922, 7 }, // &middot;
    { 0x02212, 0, 6076, 6 }, // &minus;
    { 0x0229F, 0, 9929, 7 }, // &minusb;
    { 0x02238, 0, 9936, 7 }, // &minusd;
    { 0x02A2A, 0, 9943, 8 }, // &minusdu;
    { 0x02ADB, 0, 9951, 5 }, // &mlcp;
    { 0x02026, 0, 9956, 5 }, // &mldr;
    { 0x02213, 0, 9961, 7 }, // &mnplus;
    { 0x022A7, 0, 9968, 7 }, // &models;
    { 0x1D55E, 0, 9975, 5 }, // &mopf;
    { 0x02213, 0, 1666, 3 }, // &mp;
    { 0x1D4C2, 0, 9980, 5 }, // &mscr;
    { 0x0223E, 0, 9985, 7 }, // &mstpos;
    { 0x003BC, 0, 9992, 3 }, // &mu;
    { 0x022B8, 0, 9995, 9 }, // &multimap;
    { 0x022B8, 0, 10004, 6 }, // &mumap;
    { 0x022D9, 0x00338, 10010, 4 }, // &nGg;
    { 0x0226B, 0x020D2, 10014, 4 }, // &nGt;
    { 0x0226B, 0x00338, 10018, 5 }, // &nGtv;
    { 0x021CD, 0, 10023, 11 }, // &nLeftarrow;
    { 0x021CE, 0, 10034, 16 }, // &nLeftrightarrow;
    { 0x022D8, 0x00338, 10050, 4 }, // &nLl;
    { 0x0226A, 0x020D2, 10054, 4 }, // &nLt;
    { 0x0226A, 0x00338, 10058, 5 }, // &nLtv;
    { 0x021CF, 0, 10063, 12 }, // &nRightarrow;
    { 0x022AF, 0, 10075, 7 }, // &nVDash;
    { 0x022AE, 0, 10082, 7 }, // &nVdash;
    { 0x02207, 0, 10089, 6 }, // &nabla;
    { 0x00144, 0, 10095, 7 }, // &nacute;
    { 0x02220, 0x020D2, 10102, 5 }, // &nang;
    { 0x02249, 0, 8038, 4 }, // &nap;
    { 0x02A70, 0x00338, 10107, 5 }, // &napE;
    { 0x0224B, 0x00338, 10112, 6 }, // &napid;
    { 0x00149, 0, 10118, 6 }, // &napos;
    { 0x02249, 0, 8043, 8 }, // &napprox;
    { 0x0266E, 0, 10124, 6 }, // &natur;
    { 0x0266E, 0, 10130, 8 }, // &natural;
    { 0x02115, 0, 10138, 9 }, // &naturals;
    { 0x000A0, 0, 10147, 4 }, // &nbsp
    { 0x000A0, 0, 10147, 5 }, // &nbsp;
    { 0x0224E, 0x00338, 10152, 6 }, // &nbump;
    { 0x0224F, 0x00338, 10158, 7 }, // &nbumpe;
    { 0x02A43, 0, 10165, 5 }, // &ncap;
    { 0x00148, 0, 10170, 7 }, // &ncaron;
    { 0x00146, 0, 10177, 7 }, // &ncedil;
    { 0x02247, 0, 10184, 6 }, // &ncong;
    { 0x02A6D, 0x00338, 10190, 9 }, // &ncongdot;
    { 0x02A42, 0, 10199, 5 }, // &ncup;
    { 0x0043D, 0, 10204, 4 }, // &ncy;
    { 0x02013, 0, 10208, 6 }, // &ndash;
    { 0x02260, 0, 420, 3 }, // &ne;
    { 0x021D7, 0, 10214, 6 }, // &neArr;
    { 0x02924, 0, 10220, 7 }, // &nearhk;
    { 0x02197, 0, 10227, 6 }, // &nearr;
    { 0x02197, 0, 10233, 8 }, // &nearrow;
    { 0x02250, 0x00338, 10241, 6 }, // &nedot;
    { 0x02262, 0, 5860, 7 }, // &nequiv;
    { 0x02928, 0, 10247, 7 }, // &nesear;
    { 0x02242, 0x00338, 10254, 6 }, // &nesim;
    { 0x02204, 0, 10260, 7 }, // &nexist;
    { 0x02204, 0, 10267, 8 }, // &nexists;
    { 0x1D52B, 0, 10275, 4 }, // &nfr;
    { 0x02267, 0x00338, 10279, 4 }, // &ngE;
    { 0x02271, 0, 5203, 4 }, // &nge;
    { 0x02271, 0, 10283, 5 }, // &ngeq;
    { 0x02267, 0x00338, 10288, 6 }, // &ngeqq;
    { 0x02A7E, 0x00338, 10294, 10 }, // &ngeqslant;
    { 0x02A7E, 0x00338, 10304, 5 }, // &nges;
    { 0x02275, 0, 10309, 6 }, // &ngsim;
    { 0x0226F, 0, 10315, 4 }, // &ngt;
    { 0x0226F, 0, 10319, 5 }, // &ngtr;
    { 0x021CE, 0, 10324, 6 }, // &nhArr;
    { 0x021AE, 0, 10330, 6 }, // &nharr;
    { 0x02AF2, 0, 10336, 6 }, // &nhpar;
    { 0x0220B, 0, 10342, 3 }, // &ni;
    { 0x022FC, 0, 10345, 4 }, // &nis;
    { 0x022FA, 0, 10349, 5 }, // &nisd;
    { 0x0220B, 0, 10354, 4 }, // &niv;
    { 0x0045A, 0, 10358, 5 }, // &njcy;
    { 0x021CD, 0, 10363, 6 }, // &nlArr;
    { 0x02266, 0x00338, 10369, 4 }, // &nlE;
    { 0x0219A, 0, 10373, 6 }, // &nlarr;
    { 0x02025, 0, 10379, 5 }, // &nldr;
    { 0x02270, 0, 10384, 4 }, // &nle;
    { 0x0219A, 0, 10388, 11 }, // &nleftarrow;
    { 0x021AE, 0, 10399, 16 }, // &nleftrightarrow;
    { 0x02270, 0, 10415, 5 }, // &nleq;
    { 0x02266, 0x00338, 10420, 6 }, // &nleqq;
    { 0x02A7D, 0x00338, 10426, 10 }, // &nleqslant;
    { 0x02A7D, 0x00338, 10436, 5 }, // &nles;
    { 0x0226E, 0, 10441, 6 }, // &nless;
    { 0x02274, 0, 10447, 6 }, // &nlsim;
    { 0x0226E, 0, 10453, 4 }, // &nlt;
    { 0x022EA, 0, 10457, 6 }, // &nltri;
    { 0x022EC, 0, 10463, 7 }, // &nltrie;
    { 0x02224, 0, 10470, 5 }, // &nmid;
    { 0x1D55F, 0, 10475, 5 }, // &nopf;
    { 0x000AC, 0, 5868, 3 }, // &not
    { 0x000AC, 0, 5868, 4 }, // &not;
    { 0x02209, 0, 10480, 6 }, // &notin;
    { 0x022F9, 0x00338, 10486, 7 }, // &notinE;
    { 0x022F5, 0x00338, 10493, 9 }, // &notindot;
    { 0x02209, 0, 10502, 8 }, // &notinva;
    { 0x022F7, 0, 10510, 8 }, // &notinvb;
    { 0x022F6, 0, 10518, 8 }, // &notinvc;
    { 0x0220C, 0, 10526, 6 }, // &notni;
    { 0x0220C, 0, 10532, 8 }, // &notniva;
    { 0x022FE, 0, 10540, 8 }, // &notnivb;
    { 0x022FD, 0, 10548, 8 }, // &notnivc;
    { 0x02226, 0, 10556, 5 }, // &npar;
    { 0x02226, 0, 10561, 10 }, // &nparallel;
    { 0x02AFD, 0x020E5, 10571, 7 }, // &nparsl;
    { 0x02202, 0x00338, 10578, 6 }, // &npart;
    { 0x02A14, 0, 10584, 8 }, // &npolint;
    { 0x02280, 0, 10592, 4 }, // &npr;
    { 0x022E0, 0, 10596, 7 }, // &nprcue;
    { 0x02AAF, 0x00338, 10603, 5 }, // &npre;
    { 0x02280, 0, 10608, 6 }, // &nprec;
    { 0x02AAF, 0x00338, 10614, 8 }, // &npreceq;
    { 0x021CF, 0, 10622, 6 }, // &nrArr;
    { 0x0219B, 0, 10628, 6 }, // &nrarr;
    { 0x02933, 0x00338, 10634, 7 }, // &nrarrc;
    { 0x0219D, 0x00338, 10641, 7 }, // &nrarrw;
    { 0x0219B, 0, 10648, 12 }, // &nrightarrow;
    { 0x022EB, 0, 10660, 6 }, // &nrtri;
    { 0x022ED, 0, 10666, 7 }, // &nrtrie;
    { 0x02281, 0, 10673, 4 }, // &nsc;
    { 0x022E1, 0, 10677, 7 }, // &nsccue;
    { 0x02AB0, 0x00338, 10684, 5 }, // &nsce;
    { 0x1D4C3, 0, 10689, 5 }, // &nscr;
    { 0x02224, 0, 10694, 10 }, // &nshortmid;
    { 0x02226, 0, 10704, 15 }, // &nshortparallel;
    { 0x02241, 0, 8067, 5 }, // &nsim;
    { 0x02244, 0, 10719, 6 }, // &nsime;
    { 0x02244, 0, 10725, 7 }, // &nsimeq;
    { 0x02224, 0, 10732, 6 }, // &nsmid;
    { 0x02226, 0, 10738, 6 }, // &nspar;
    { 0x022E2, 0, 10744, 8 }, // &nsqsube;
    { 0x022E3, 0, 10752, 8 }, // &nsqsupe;
    { 0x02284, 0, 10760, 5 }, // &nsub;
    { 0x02AC5, 0x00338, 10765, 6 }, // &nsubE;
    { 0x02288, 0, 10771, 6 }, // &nsube;
    { 0x02282, 0x020D2, 10777, 8 }, // &nsubset;
    { 0x02288, 0, 10785, 10 }, // &nsubseteq;
    { 0x02AC5, 0x00338, 10795, 11 }, // &nsubseteqq;
    { 0x02281, 0, 10806, 6 }, // &nsucc;
    { 0x02AB0, 0x00338, 10812, 8 }, // &nsucceq;
    { 0x02285, 0, 10820, 5 }, // &nsup;
    { 0x02AC6, 0x00338, 10825, 6 }, // &nsupE;
    { 0x02289, 0, 10831, 6 }, // &nsupe;
    { 0x02283, 0x020D2, 10837, 8 }, // &nsupset;
    { 0x02289, 0, 10845, 10 }, // &nsupseteq;
    { 0x02AC6, 0x00338, 10855, 11 }, // &nsupseteqq;
    { 0x02279, 0, 10866, 5 }, // &ntgl;
    { 0x000F1, 0, 10871, 6 }, // &ntilde
    { 0x000F1, 0, 10871, 7 }, // &ntilde;
    { 0x02278, 0, 10878, 5 }, // &ntlg;
    { 0x022EA, 0, 10883, 14 }, // &ntriangleleft;
    { 0x022EC, 0, 10897, 16 }, // &ntrianglelefteq;
    { 0x022EB, 0, 10913, 15 }, // &ntriangleright;
    { 0x022ED, 0, 10928, 17 }, // &ntrianglerighteq;
    { 0x003BD, 0, 10945, 3 }, // &nu;
    { 0x00023, 0, 10948, 4 }, // &num;
    { 0x02116, 0, 10952, 7 }, // &numero;
    { 0x02007, 0, 10959, 6 }, // &numsp;
    { 0x022AD, 0, 10965, 7 }, // &nvDash;
    { 0x02904, 0, 10972, 7 }, // &nvHarr;
    { 0x0224D, 0x020D2, 10979, 5 }, // &nvap;
    { 0x022AC, 0, 10984, 7 }, // &nvdash;
    { 0x02265, 0x020D2, 10991, 5 }, // &nvge;
    { 0x0003E, 0x020D2, 10996, 5 }, // &nvgt;
    { 0x029DE, 0, 11001, 8 }, // &nvinfin;
    { 0x02902, 0, 11009, 7 }, // &nvlArr;
    { 0x02264, 0x020D2, 11016, 5 }, // &nvle;
    { 0x0003C, 0x020D2, 11021, 5 }, // &nvlt;
    { 0x022B4, 0x020D2, 11026, 8 }, // &nvltrie;
    { 0x02903, 0, 11034, 7 }, // &nvrArr;
    { 0x022B5, 0x020D2, 11041, 8 }, // &nvrtrie;
    { 0x0223C, 0x020D2, 11049, 6 }, // &nvsim;
    { 0x021D6, 0, 11055, 6 }, // &nwArr;
    { 0x02923, 0, 11061, 7 }, // &nwarhk;
    { 0x02196, 0, 11068, 6 }, // &nwarr;
    { 0x02196, 0, 11074, 8 }, // &nwarrow;
    { 0x02927, 0, 11082, 7 }, // &nwnear;
    { 0x024C8, 0, 11089, 3 }, // &oS;
    { 0x000F3, 0, 11092, 6 }, // &oacute
    { 0x000F3, 0, 11092, 7 }, // &oacute;
    { 0x0229B, 0, 11099, 5 }, // &oast;
    { 0x0229A, 0, 4567, 5 }, // &ocir;
    { 0x000F4, 0, 11104, 5 }, // &ocirc
    { 0x000F4, 0, 11104, 6 }, // &ocirc;
    { 0x0043E, 0, 8593, 4 }, // &ocy;
    { 0x0229D, 0, 11110, 6 }, // &odash;
    { 0x00151, 0, 11116, 7 }, // &odblac;
    { 0x02A38, 0, 11123, 5 }, // &odiv;
    { 0x02299, 0, 5628, 5 }, // &odot;
    { 0x029BC, 0, 11128, 7 }, // &odsold;
    { 0x00153, 0, 11135, 6 }, // &oelig;
    { 0x029BF, 0, 11141, 6 }, // &ofcir;
    { 0x1D52C, 0, 11147, 4 }, // &ofr;
    { 0x002DB, 0, 62, 5 }, // &ogon;
    { 0x000F2, 0, 11151, 6 }, // &ograve
    { 0x000F2, 0, 11151, 7 }, // &ograve;
    { 0x029C1, 0, 11158, 4 }, // &ogt;
    { 0x029B5, 0, 11162, 6 }, // &ohbar;
    { 0x003A9, 0, 11168, 4 }, // &ohm;
    { 0x0222E, 0, 11172, 5 }, // &oint;
    { 0x021BA, 0, 11177, 6 }, // &olarr;
    { 0x029BE, 0, 11183, 6 }, // &olcir;
    { 0x029BB, 0, 11189, 8 }, // &olcross;
    { 0x0203E, 0, 11197, 6 }, // &oline;
    { 0x029C0, 0, 11203, 4 }, // &olt;
    { 0x0014D, 0, 11207, 6 }, // &omacr;
    { 0x003C9, 0, 11213, 6 }, // &omega;
    { 0x003BF, 0, 11219, 8 }, // &omicron;
    { 0x029B6, 0, 11227, 5 }, // &omid;
    { 0x02296, 0, 11232, 7 }, // &ominus;
    { 0x1D560, 0, 11239, 5 }, // &oopf;
    { 0x029B7, 0, 9549, 5 }, // &opar;
    { 0x029B9, 0, 11244, 6 }, // &operp;
    { 0x02295, 0, 5636, 6 }, // &oplus;
    { 0x02228, 0, 1001, 3 }, // &or;
    { 0x021BB, 0, 11250, 6 }, // &orarr;
    { 0x02A5D, 0, 11256, 4 }, // &ord;
    { 0x02134, 0, 11260, 6 }, // &order;
    { 0x02134, 0, 11266, 8 }, // &orderof;
    { 0x000AA, 0, 11274, 4 }, // &ordf
    { 0x000AA, 0, 11274, 5 }, // &ordf;
    { 0x000BA, 0, 11279, 4 }, // &ordm
    { 0x000BA, 0, 11279, 5 }, // &ordm;
    { 0x022B6, 0, 11284, 7 }, // &origof;
    { 0x02A56, 0, 11291, 5 }, // &oror;
    { 0x02A57, 0, 11296, 8 }, // &orslope;
    { 0x02A5B, 0, 11304, 4 }, // &orv;
    { 0x02134, 0, 11308, 5 }, // &oscr;
    { 0x000F8, 0, 11313, 6 }, // &oslash
    { 0x000F8, 0, 11313, 7 }, // &oslash;
    { 0x02298, 0, 11320, 5 }, // &osol;
    { 0x000F5, 0, 11325, 6 }, // &otilde
    { 0x000F5, 0, 11325, 7 }, // &otilde;
    { 0x02297, 0, 5645, 7 }, // &otimes;
    { 0x02A36, 0, 11332, 9 }, // &otimesas;
    { 0x000F6, 0, 11341, 4 }, // &ouml
    { 0x000F6, 0, 11341, 5 }, // &ouml;
    { 0x0233D, 0, 11346, 6 }, // &ovbar;
    { 0x02225, 0, 7501, 4 }, // &par;
    { 0x000B6, 0, 4889, 4 }, // &para
    { 0x000B6, 0, 11352, 5 }, // &para;
    { 0x02225, 0, 10562, 9 }, // &parallel;
    { 0x02AF3, 0, 11357, 7 }, // &parsim;
    { 0x02AFD, 0, 7506, 6 }, // &parsl;
    { 0x02202, 0, 8505, 5 }, // &part;
    { 0x0043F, 0, 11364, 4 }, // &pcy;
    { 0x00025, 0, 11368, 7 }, // &percnt;
    { 0x0002E, 0, 11375, 7 }, // &period;
    { 0x02030, 0, 11382, 7 }, // &permil;
    { 0x022A5, 0, 11245, 5 }, // &perp;
    { 0x02031, 0, 11389, 8 }, // &pertenk;
    { 0x1D52D, 0, 11397, 4 }, // &pfr;
    { 0x003C6, 0, 11401, 4 }, // &phi;
    { 0x003D5, 0, 11405, 5 }, // &phiv;
    { 0x02133, 0, 11410, 7 }, // &phmmat;
    { 0x0260E, 0, 11417, 6 }, // &phone;
    { 0x003C0, 0, 11423, 3 }, // &pi;
    { 0x022D4, 0, 11426, 10 }, // &pitchfork;
    { 0x003D6, 0, 11436, 4 }, // &piv;
    { 0x0210F, 0, 11440, 7 }, // &planck;
    { 0x0210E, 0, 11447, 8 }, // &planckh;
    { 0x0210F, 0, 11455, 7 }, // &plankv;
    { 0x0002B, 0, 5637, 5 }, // &plus;
    { 0x02A23, 0, 11462, 9 }, // &plusacir;
    { 0x0229E, 0, 11471, 6 }, // &plusb;
    { 0x02A22, 0, 11477, 8 }, // &pluscir;
    { 0x02214, 0, 11485, 7 }, // &plusdo;
    { 0x02A25, 0, 11492, 7 }, // &plusdu;
    { 0x02A72, 0, 11499, 6 }, // &pluse;
    { 0x000B1, 0, 11505, 6 }, // &plusmn
    { 0x000B1, 0, 11505, 7 }, // &plusmn;
    { 0x02A26, 0, 11512, 8 }, // &plussim;
    { 0x02A27, 0, 11520, 8 }, // &plustwo;
    { 0x000B1, 0, 11528, 3 }, // &pm;
    { 0x02A15, 0, 11531, 9 }, // &pointint;
    { 0x1D561, 0, 11540, 5 }, // &popf;
    { 0x000A3, 0, 11545, 5 }, // &pound
    { 0x000A3, 0, 11545, 6 }, // &pound;
    { 0x0227A, 0, 6713, 3 }, // &pr;
    { 0x02AB3, 0, 11551, 4 }, // &prE;
    { 0x02AB7, 0, 11555, 5 }, // &prap;
    { 0x0227C, 0, 10597, 6 }, // &prcue;
    { 0x02AAF, 0, 10604, 4 }, // &pre;
    { 0x0227A, 0, 6795, 5 }, // &prec;
    { 0x02AB7, 0, 11560, 11 }, // &precapprox;
    { 0x0227C, 0, 11571, 12 }, // &preccurlyeq;
    { 0x02AAF, 0, 10615, 7 }, // &preceq;
    { 0x02AB9, 0, 11583, 12 }, // &precnapprox;
    { 0x02AB5, 0, 11595, 9 }, // &precneqq;
    { 0x022E8, 0, 11604, 9 }, // &precnsim;
    { 0x0227E, 0, 11613, 8 }, // &precsim;
    { 0x02032, 0, 5468, 6 }, // &prime;
    { 0x02119, 0, 11621, 7 }, // &primes;
    { 0x02AB5, 0, 11628, 5 }, // &prnE;
    { 0x02AB9, 0, 11633, 6 }, // &prnap;
    { 0x022E8, 0, 11639, 7 }, // &prnsim;
    { 0x0220F, 0, 6632, 5 }, // &prod;
    { 0x0232E, 0, 11646, 9 }, // &profalar;
    { 0x02312, 0, 11655, 9 }, // &profline;
    { 0x02313, 0, 11664, 9 }, // &profsurf;
    { 0x0221D, 0, 11673, 5 }, // &prop;
    { 0x0221D, 0, 11678, 7 }, // &propto;
    { 0x0227E, 0, 11685, 6 }, // &prsim;
    { 0x022B0, 0, 11691, 7 }, // &prurel;
    { 0x1D4C5, 0, 11698, 5 }, // &pscr;
    { 0x003C8, 0, 4787, 4 }, // &psi;
    { 0x02008, 0, 11703, 7 }, // &puncsp;
    { 0x1D52E, 0, 11710, 4 }, // &qfr;
    { 0x02A0C, 0, 11714, 5 }, // &qint;
    { 0x1D562, 0, 11719, 5 }, // &qopf;
    { 0x02057, 0, 11724, 7 }, // &qprime;
    { 0x1D4C6, 0, 11731, 5 }, // &qscr;
    { 0x0210D, 0, 11736, 12 }, // &quaternions;
    { 0x02A16, 0, 11748, 8 }, // &quatint;
    { 0x0003F, 0, 7576, 6 }, // &quest;
    { 0x0225F, 0, 11756, 8 }, // &questeq;
    { 0x00022, 0, 11764, 4 }, // &quot
    { 0x00022, 0, 11764, 5 }, // &quot;
    { 0x021DB, 0, 11769, 6 }, // &rAarr;
    { 0x021D2, 0, 10623, 5 }, // &rArr;
    { 0x0291C, 0, 11775, 7 }, // &rAtail;
    { 0x0290F, 0, 11782, 6 }, // &rBarr;
    { 0x02964, 0, 11788, 5 }, // &rHar;
    { 0x0223D, 0x00331, 3687, 5 }, // &race;
    { 0x00155, 0, 11793, 7 }, // &racute;
    { 0x0221A, 0, 11800, 6 }, // &radic;
    { 0x029B3, 0, 11806, 9 }, // &raemptyv;
    { 0x027E9, 0, 11815, 5 }, // &rang;
    { 0x02992, 0, 11820, 6 }, // &rangd;
    { 0x029A5, 0, 11826, 6 }, // &range;
    { 0x027E9, 0, 11832, 7 }, // &rangle;
    { 0x000BB, 0, 11839, 5 }, // &raquo
    { 0x000BB, 0, 11839, 6 }, // &raquo;
    { 0x02192, 0, 6650, 5 }, // &rarr;
    { 0x02975, 0, 11845, 7 }, // &rarrap;
    { 0x021E5, 0, 11852, 6 }, // &rarrb;
    { 0x02920, 0, 11858, 8 }, // &rarrbfs;
    { 0x02933, 0, 10635, 6 }, // &rarrc;
    { 0x0291E, 0, 11866, 7 }, // &rarrfs;
    { 0x021AA, 0, 11873, 7 }, // &rarrhk;
    { 0x021AC, 0, 11880, 7 }, // &rarrlp;
    { 0x02945, 0, 11887, 7 }, // &rarrpl;
    { 0x02974, 0, 11894, 8 }, // &rarrsim;
    { 0x021A3, 0, 11902, 7 }, // &rarrtl;
    { 0x0219D, 0, 10642, 6 }, // &rarrw;
    { 0x0291A, 0, 11909, 7 }, // &ratail;
    { 0x02236, 0, 11916, 6 }, // &ratio;
    { 0x0211A, 0, 11922, 10 }, // &rationals;
    { 0x0290D, 0, 11932, 6 }, // &rbarr;
    { 0x02773, 0, 11938, 6 }, // &rbbrk;
    { 0x0007D, 0, 11944, 7 }, // &rbrace;
    { 0x0005D, 0, 11951, 7 }, // &rbrack;
    { 0x0298C, 0, 11958, 6 }, // &rbrke;
    { 0x0298E, 0, 11964, 8 }, // &rbrksld;
    { 0x02990, 0, 11972, 8 }, // &rbrkslu;
    { 0x00159, 0, 11980, 7 }, // &rcaron;
    { 0x00157, 0, 11987, 7 }, // &rcedil;
    { 0x02309, 0, 11994, 6 }, // &rceil;
    { 0x0007D, 0, 12000, 5 }, // &rcub;
    { 0x00440, 0, 1865, 4 }, // &rcy;
    { 0x02937, 0, 12005, 5 }, // &rdca;
    { 0x02969, 0, 12010, 8 }, // &rdldhar;
    { 0x0201D, 0, 12018, 6 }, // &rdquo;
    { 0x0201D, 0, 12024, 7 }, // &rdquor;
    { 0x021B3, 0, 12031, 5 }, // &rdsh;
    { 0x0211C, 0, 12036, 5 }, // &real;
    { 0x0211B, 0, 12041, 8 }, // &realine;
    { 0x0211C, 0, 12049, 9 }, // &realpart;
    { 0x0211D, 0, 12058, 6 }, // &reals;
    { 0x025AD, 0, 12064, 5 }, // &rect;
    { 0x000AE, 0, 12069, 3 }, // &reg
    { 0x000AE, 0, 12069, 4 }, // &reg;
    { 0x0297D, 0, 12073, 7 }, // &rfisht;
    { 0x0230B, 0, 12080, 7 }, // &rfloor;
    { 0x1D52F, 0, 12087, 4 }, // &rfr;
    { 0x021C1, 0, 9631, 6 }, // &rhard;
    { 0x021C0, 0, 12091, 6 }, // &rharu;
    { 0x0296C, 0, 12097, 7 }, // &rharul;
    { 0x003C1, 0, 12104, 4 }, // &rho;
    { 0x003F1, 0, 12108, 5 }, // &rhov;
    { 0x02192, 0, 2254, 11 }, // &rightarrow;
    { 0x021A3, 0, 12113, 15 }, // &rightarrowtail;
    { 0x021C1, 0, 12128, 17 }, // &rightharpoondown;
    { 0x021C0, 0, 12145, 15 }, // &rightharpoonup;
    { 0x021C4, 0, 12160, 16 }, // &rightleftarrows;
    { 0x021CC, 0, 12176, 18 }, // &rightleftharpoons;
    { 0x021C9, 0, 12194, 17 }, // &rightrightarrows;
    { 0x0219D, 0, 9147, 16 }, // &rightsquigarrow;
    { 0x022CC, 0, 12211, 16 }, // &rightthreetimes;
    { 0x002DA, 0, 87, 5 }, // &ring;
    { 0x02253, 0, 12227, 13 }, // &risingdotseq;
    { 0x021C4, 0, 12240, 6 }, // &rlarr;
    { 0x021CC, 0, 12246, 6 }, // &rlhar;
    { 0x0200F, 0, 12252, 4 }, // &rlm;
    { 0x023B1, 0, 12256, 7 }, // &rmoust;
    { 0x023B1, 0, 12263, 11 }, // &rmoustache;
    { 0x02AEE, 0, 12274, 6 }, // &rnmid;
    { 0x027ED, 0, 12280, 6 }, // &roang;
    { 0x021FE, 0, 12286, 6 }, // &roarr;
    { 0x027E7, 0, 12292, 6 }, // &robrk;
    { 0x02986, 0, 12298, 6 }, // &ropar;
    { 0x1D563, 0, 12304, 5 }, // &ropf;
    { 0x02A2E, 0, 12309, 7 }, // &roplus;
    { 0x02A35, 0, 12316, 8 }, // &rotimes;
    { 0x00029, 0, 12324, 5 }, // &rpar;
    { 0x02994, 0, 12329, 7 }, // &rpargt;
    { 0x02A12, 0, 12336, 9 }, // &rppolint;
    { 0x021C9, 0, 12345, 6 }, // &rrarr;
    { 0x0203A, 0, 12351, 7 }, // &rsaquo;
    { 0x1D4C7, 0, 12358, 5 }, // &rscr;
    { 0x021B1, 0, 12363, 4 }, // &rsh;
    { 0x0005D, 0, 12367, 5 }, // &rsqb;
    { 0x02019, 0, 12372, 6 }, // &rsquo;
    { 0x02019, 0, 12378, 7 }, // &rsquor;
    { 0x022CC, 0, 12385, 7 }, // &rthree;
    { 0x022CA, 0, 12392, 7 }, // &rtimes;
    { 0x025B9, 0, 9642, 5 }, // &rtri;
    { 0x022B5, 0, 10667, 6 }, // &rtrie;
    { 0x025B8, 0, 12399, 6 }, // &rtrif;
    { 0x029CE, 0, 12405, 9 }, // &rtriltri;
    { 0x02968, 0, 12414, 8 }, // &ruluhar;
    { 0x0211E, 0, 12422, 3 }, // &rx;
    { 0x0015B, 0, 12425, 7 }, // &sacute;
    { 0x0201A, 0, 12432, 6 }, // &sbquo;
    { 0x0227B, 0, 6719, 3 }, // &sc;
    { 0x02AB4, 0, 12438, 4 }, // &scE;
    { 0x02AB8, 0, 12442, 5 }, // &scap;
    { 0x00161, 0, 12447, 7 }, // &scaron;
    { 0x0227D, 0, 10678, 6 }, // &sccue;
    { 0x02AB0, 0, 10685, 4 }, // &sce;
    { 0x0015F, 0, 12454, 7 }, // &scedil;
    { 0x0015D, 0, 12461, 6 }, // &scirc;
    { 0x02AB6, 0, 12467, 5 }, // &scnE;
    { 0x02ABA, 0, 12472, 6 }, // &scnap;
    { 0x022E9, 0, 12478, 7 }, // &scnsim;
    { 0x02A13, 0, 12485, 9 }, // &scpolint;
    { 0x0227F, 0, 12494, 6 }, // &scsim;
    { 0x00441, 0, 7267, 4 }, // &scy;
    { 0x022C5, 0, 7411, 5 }, // &sdot;
    { 0x022A1, 0, 12500, 6 }, // &sdotb;
    { 0x02A66, 0, 12506, 6 }, // &sdote;
    { 0x021D8, 0, 12512, 6 }, // &seArr;
    { 0x02925, 0, 12518, 7 }, // &searhk;
    { 0x02198, 0, 12525, 6 }, // &searr;
    { 0x02198, 0, 12531, 8 }, // &searrow;
    { 0x000A7, 0, 1765, 4 }, // &sect
    { 0x000A7, 0, 12539, 5 }, // &sect;
    { 0x0003B, 0, 6184, 5 }, // &semi;
    { 0x02929, 0, 12544, 7 }, // &seswar;
    { 0x02216, 0, 12551, 9 }, // &setminus;
    { 0x02216, 0, 12560, 6 }, // &setmn;
    { 0x02736, 0, 12566, 5 }, // &sext;
    { 0x1D530, 0, 12571, 4 }, // &sfr;
    { 0x02322, 0, 12575, 7 }, // &sfrown;
    { 0x0266F, 0, 12582, 6 }, // &sharp;
    { 0x00449, 0, 12588, 7 }, // &shchcy;
    { 0x00448, 0, 12595, 5 }, // &shcy;
    { 0x02223, 0, 10695, 9 }, // &shortmid;
    { 0x02225, 0, 10705, 14 }, // &shortparallel;
    { 0x000AD, 0, 12600, 3 }, // &shy
    { 0x000AD, 0, 12600, 4 }, // &shy;
    { 0x003C3, 0, 12604, 6 }, // &sigma;
    { 0x003C2, 0, 12610, 7 }, // &sigmaf;
    { 0x003C2, 0, 12617, 7 }, // &sigmav;
    { 0x0223C, 0, 1300, 4 }, // &sim;
    { 0x02A6A, 0, 12624, 7 }, // &simdot;
    { 0x02243, 0, 6195, 5 }, // &sime;
    { 0x02243, 0, 5486, 6 }, // &simeq;
    { 0x02A9E, 0, 9675, 5 }, // &simg;
    { 0x02AA0, 0, 12631, 6 }, // &simgE;
    { 0x02A9D, 0, 8094, 5 }, // &siml;
    { 0x02A9F, 0, 12637, 6 }, // &simlE;
    { 0x02246, 0, 12643, 6 }, // &simne;
    { 0x02A24, 0, 12649, 8 }, // &simplus;
    { 0x02972, 0, 12657, 8 }, // &simrarr;
    { 0x02190, 0, 12665, 6 }, // &slarr;
    { 0x02216, 0, 12671, 14 }, // &smallsetminus;
    { 0x02A33, 0, 12685, 7 }, // &smashp;
    { 0x029E4, 0, 12692, 9 }, // &smeparsl;
    { 0x02223, 0, 10733, 5 }, // &smid;
    { 0x02323, 0, 12701, 6 }, // &smile;
    { 0x02AAA, 0, 12707, 4 }, // &smt;
    { 0x02AAC, 0, 12711, 5 }, // &smte;
    { 0x02AAC, 0x0FE00, 12716, 6 }, // &smtes;
    { 0x0044C, 0, 12722, 7 }, // &softcy;
    { 0x0002F, 0, 6201, 4 }, // &sol;
    { 0x029C4, 0, 6206, 5 }, // &solb;
    { 0x0233F, 0, 12729, 7 }, // &solbar;
    { 0x1D564, 0, 12736, 5 }, // &sopf;
    { 0x02660, 0, 12741, 7 }, // &spades;
    { 0x02660, 0, 12748, 10 }, // &spadesuit;
    { 0x02225, 0, 10739, 5 }, // &spar;
    { 0x02293, 0, 12758, 6 }, // &sqcap;
    { 0x02293, 0x0FE00, 12764, 7 }, // &sqcaps;
    { 0x02294, 0, 5655, 6 }, // &sqcup;
    { 0x02294, 0x0FE00, 12771, 7 }, // &sqcups;
    { 0x0228F, 0, 12778, 6 }, // &sqsub;
    { 0x02291, 0, 10745, 7 }, // &sqsube;
    { 0x0228F, 0, 12784, 9 }, // &sqsubset;
    { 0x02291, 0, 12793, 11 }, // &sqsubseteq;
    { 0x02290, 0, 12804, 6 }, // &sqsup;
    { 0x02292, 0, 10753, 7 }, // &sqsupe;
    { 0x02290, 0, 12810, 9 }, // &sqsupset;
    { 0x02292, 0, 12819, 11 }, // &sqsupseteq;
    { 0x025A1, 0, 12830, 4 }, // &squ;
    { 0x025A1, 0, 5749, 7 }, // &square;
    { 0x025AA, 0, 12834, 7 }, // &squarf;
    { 0x025AA, 0, 12841, 5 }, // &squf;
    { 0x02192, 0, 12846, 6 }, // &srarr;
    { 0x1D4C8, 0, 12852, 5 }, // &sscr;
    { 0x02216, 0, 12857, 7 }, // &ssetmn;
    { 0x02323, 0, 12864, 7 }, // &ssmile;
    { 0x022C6, 0, 12871, 7 }, // &sstarf;
    { 0x02606, 0, 5664, 5 }, // &star;
    { 0x02605, 0, 12872, 6 }, // &starf;
    { 0x003F5, 0, 12878, 16 }, // &straightepsilon;
    { 0x003D5, 0, 12894, 12 }, // &straightphi;
    { 0x000AF, 0, 12906, 6 }, // &strns;
    { 0x02282, 0, 6216, 4 }, // &sub;
    { 0x02AC5, 0, 10766, 5 }, // &subE;
    { 0x02ABD, 0, 12912, 7 }, // &subdot;
    { 0x02286, 0, 6672, 5 }, // &sube;
    { 0x02AC3, 0, 12919, 8 }, // &subedot;
    { 0x02AC1, 0, 12927, 8 }, // &submult;
    { 0x02ACB, 0, 12935, 6 }, // &subnE;
    { 0x0228A, 0, 12941, 6 }, // &subne;
    { 0x02ABF, 0, 12947, 8 }, // &subplus;
    { 0x02979, 0, 12955, 8 }, // &subrarr;
    { 0x02282, 0, 10778, 7 }, // &subset;
    { 0x02286, 0, 10786, 9 }, // &subseteq;
    { 0x02AC5, 0, 10796, 10 }, // &subseteqq;
    { 0x0228A, 0, 12963, 10 }, // &subsetneq;
    { 0x02ACB, 0, 12973, 11 }, // &subsetneqq;
    { 0x02AC7, 0, 12984, 7 }, // &subsim;
    { 0x02AD5, 0, 12991, 7 }, // &subsub;
    { 0x02AD3, 0, 12998, 7 }, // &subsup;
    { 0x0227B, 0, 6807, 5 }, // &succ;
    { 0x02AB8, 0, 13005, 11 }, // &succapprox;
    { 0x0227D, 0, 13016, 12 }, // &succcurlyeq;
    { 0x02AB0, 0, 10813, 7 }, // &succeq;
    { 0x02ABA, 0, 13028, 12 }, // &succnapprox;
    { 0x02AB6, 0, 13040, 9 }, // &succneqq;
    { 0x022E9, 0, 13049, 9 }, // &succnsim;
    { 0x0227F, 0, 13058, 8 }, // &succsim;
    { 0x02211, 0, 13066, 4 }, // &sum;
    { 0x0266A, 0, 13070, 5 }, // &sung;
    { 0x000B9, 0, 13075, 4 }, // &sup1
    { 0x000B9, 0, 13075, 5 }, // &sup1;
    { 0x000B2, 0, 13080, 4 }, // &sup2
    { 0x000B2, 0, 13080, 5 }, // &sup2;
    { 0x000B3, 0, 13085, 4 }, // &sup3
    { 0x000B3, 0, 13085, 5 }, // &sup3;
    { 0x02283, 0, 6678, 4 }, // &sup;
    { 0x02AC6, 0, 10826, 5 }, // &supE;
    { 0x02ABE, 0, 13090, 7 }, // &supdot;
    { 0x02AD8, 0, 13097, 8 }, // &supdsub;
    { 0x02287, 0, 6683, 5 }, // &supe;
    { 0x02AC4, 0, 13105, 8 }, // &supedot;
    { 0x027C9, 0, 13113, 8 }, // &suphsol;
    { 0x02AD7, 0, 13121, 8 }, // &suphsub;
    { 0x0297B, 0, 13129, 8 }, // &suplarr;
    { 0x02AC2, 0, 13137, 8 }, // &supmult;
    { 0x02ACC, 0, 13145, 6 }, // &supnE;
    { 0x0228B, 0, 13151, 6 }, // &supne;
    { 0x02AC0, 0, 13157, 8 }, // &supplus;
    { 0x02283, 0, 10838, 7 }, // &supset;
    { 0x02287, 0, 10846, 9 }, // &supseteq;
    { 0x02AC6, 0, 10856, 10 }, // &supseteqq;
    { 0x0228B, 0, 13165, 10 }, // &supsetneq;
    { 0x02ACC, 0, 13175, 11 }, // &supsetneqq;
    { 0x02AC8, 0, 13186, 7 }, // &supsim;
    { 0x02AD4, 0, 13193, 7 }, // &supsub;
    { 0x02AD6, 0, 13200, 7 }, // &supsup;
    { 0x021D9, 0, 13207, 6 }, // &swArr;
    { 0x02926, 0, 13213, 7 }, // &swarhk;
    { 0x02199, 0, 13220, 6 }, // &swarr;
    { 0x02199, 0, 13226, 8 }, // &swarrow;
    { 0x0292A, 0, 13234, 7 }, // &swnwar;
    { 0x000DF, 0, 13241, 5 }, // &szlig
    { 0x000DF, 0, 13241, 6 }, // &szlig;
    { 0x02316, 0, 13247, 7 }, // &target;
    { 0x003C4, 0, 13254, 4 }, // &tau;
    { 0x023B4, 0, 5524, 5 }, // &tbrk;
    { 0x00165, 0, 13258, 7 }, // &tcaron;
    { 0x00163, 0, 13265, 7 }, // &tcedil;
    { 0x00442, 0, 12725, 4 }, // &tcy;
    { 0x020DB, 0, 6689, 5 }, // &tdot;
    { 0x02315, 0, 13272, 7 }, // &telrec;
    { 0x1D531, 0, 13279, 4 }, // &tfr;
    { 0x02234, 0, 13283, 7 }, // &there4;
    { 0x02234, 0, 13290, 10 }, // &therefore;
    { 0x003B8, 0, 13300, 6 }, // &theta;
    { 0x003D1, 0, 13306, 9 }, // &thetasym;
    { 0x003D1, 0, 13315, 7 }, // &thetav;
    { 0x02248, 0, 13322, 12 }, // &thickapprox;
    { 0x0223C, 0, 13334, 9 }, // &thicksim;
    { 0x02009, 0, 13343, 7 }, // &thinsp;
    { 0x02248, 0, 13350, 6 }, // &thkap;
    { 0x0223C, 0, 13356, 7 }, // &thksim;
    { 0x000FE, 0, 13363, 5 }, // &thorn
    { 0x000FE, 0, 13363, 6 }, // &thorn;
    { 0x002DC, 0, 105, 6 }, // &tilde;
    { 0x000D7, 0, 3663, 5 }, // &times
    { 0x000D7, 0, 3663, 6 }, // &times;
    { 0x022A0, 0, 13369, 7 }, // &timesb;
    { 0x02A31, 0, 13376, 9 }, // &timesbar;
    { 0x02A30, 0, 13385, 7 }, // &timesd;
    { 0x0222D, 0, 7765, 5 }, // &tint;
    { 0x02928, 0, 13392, 5 }, // &toea;
    { 0x022A4, 0, 13397, 4 }, // &top;
    { 0x02336, 0, 13401, 7 }, // &topbot;
    { 0x02AF1, 0, 13408, 7 }, // &topcir;
    { 0x1D565, 0, 13415, 5 }, // &topf;
    { 0x02ADA, 0, 13420, 8 }, // &topfork;
    { 0x02929, 0, 13428, 5 }, // &tosa;
    { 0x02034, 0, 13433, 7 }, // &tprime;
    { 0x02122, 0, 13440, 6 }, // &trade;
    { 0x025B5, 0, 5761, 9 }, // &triangle;
    { 0x025BF, 0, 5672, 13 }, // &triangledown;
    { 0x025C3, 0, 5793, 13 }, // &triangleleft;
    { 0x022B4, 0, 10898, 15 }, // &trianglelefteq;
    { 0x0225C, 0, 13446, 10 }, // &triangleq;
    { 0x025B9, 0, 5811, 14 }, // &triangleright;
    { 0x022B5, 0, 10929, 16 }, // &trianglerighteq;
    { 0x025EC, 0, 13456, 7 }, // &tridot;
    { 0x0225C, 0, 9759, 5 }, // &trie;
    { 0x02A3A, 0, 13463, 9 }, // &triminus;
    { 0x02A39, 0, 13472, 8 }, // &triplus;
    { 0x029CD, 0, 13480, 6 }, // &trisb;
    { 0x02A3B, 0, 13486, 8 }, // &tritime;
    { 0x023E2, 0, 13494, 9 }, // &trpezium;
    { 0x1D4C9, 0, 13503, 5 }, // &tscr;
    { 0x00446, 0, 13508, 5 }, // &tscy;
    { 0x0045B, 0, 13513, 6 }, // &tshcy;
    { 0x00167, 0, 13519, 7 }, // &tstrok;
    { 0x0226C, 0, 13526, 6 }, // &twixt;
    { 0x0219E, 0, 13532, 17 }, // &twoheadleftarrow;
    { 0x021A0, 0, 13549, 18 }, // &twoheadrightarrow;
    { 0x021D1, 0, 13567, 5 }, // &uArr;
    { 0x02963, 0, 13572, 5 }, // &uHar;
    { 0x000FA, 0, 13577, 6 }, // &uacute
    { 0x000FA, 0, 13577, 7 }, // &uacute;
    { 0x02191, 0, 7301, 5 }, // &uarr;
    { 0x0045E, 0, 13584, 6 }, // &ubrcy;
    { 0x0016D, 0, 13590, 7 }, // &ubreve;
    { 0x000FB, 0, 13597, 5 }, // &ucirc
    { 0x000FB, 0, 13597, 6 }, // &ucirc;
    { 0x00443, 0, 13603, 4 }, // &ucy;
    { 0x021C5, 0, 13607, 6 }, // &udarr;
    { 0x00171, 0, 13613, 7 }, // &udblac;
    { 0x0296E, 0, 13620, 6 }, // &udhar;
    { 0x0297E, 0, 13626, 7 }, // &ufisht;
    { 0x1D532, 0, 13633, 4 }, // &ufr;
    { 0x000F9, 0, 13637, 6 }, // &ugrave
    { 0x000F9, 0, 13637, 7 }, // &ugrave;
    { 0x021BF, 0, 13644, 6 }, // &uharl;
    { 0x021BE, 0, 13650, 6 }, // &uharr;
    { 0x02580, 0, 13656, 6 }, // &uhblk;
    { 0x0231C, 0, 13662, 7 }, // &ulcorn;
    { 0x0231C, 0, 13669, 9 }, // &ulcorner;
    { 0x0230F, 0, 13678, 7 }, // &ulcrop;
    { 0x025F8, 0, 13685, 6 }, // &ultri;
    { 0x0016B, 0, 13691, 6 }, // &umacr;
    { 0x000A8, 0, 112, 3 }, // &uml
    { 0x000A8, 0, 112, 4 }, // &uml;
    { 0x00173, 0, 13697, 6 }, // &uogon;
    { 0x1D566, 0, 13703, 5 }, // &uopf;
    { 0x02191, 0, 13708, 8 }, // &uparrow;
    { 0x02195, 0, 13716, 12 }, // &updownarrow;
    { 0x021BF, 0, 13728, 14 }, // &upharpoonleft;
    { 0x021BE, 0, 13742, 15 }, // &upharpoonright;
    { 0x0228E, 0, 5702, 6 }, // &uplus;
    { 0x003C5, 0, 13757, 5 }, // &upsi;
    { 0x003D2, 0, 13762, 6 }, // &upsih;
    { 0x003C5, 0, 13768, 8 }, // &upsilon;
    { 0x021C8, 0, 13776, 11 }, // &upuparrows;
    { 0x0231D, 0, 13787, 7 }, // &urcorn;
    { 0x0231D, 0, 13794, 9 }, // &urcorner;
    { 0x0230E, 0, 13803, 7 }, // &urcrop;
    { 0x0016F, 0, 13810, 6 }, // &uring;
    { 0x025F9, 0, 13816, 6 }, // &urtri;
    { 0x1D4CA, 0, 13822, 5 }, // &uscr;
    { 0x022F0, 0, 13827, 6 }, // &utdot;
    { 0x00169, 0, 13833, 7 }, // &utilde;
    { 0x025B5, 0, 13840, 5 }, // &utri;
    { 0x025B4, 0, 13845, 6 }, // &utrif;
    { 0x021C8, 0, 13851, 6 }, // &uuarr;
    { 0x000FC, 0, 13857, 4 }, // &uuml
    { 0x000FC, 0, 13857, 5 }, // &uuml;
    { 0x029A7, 0, 13862, 8 }, // &uwangle;
    { 0x021D5, 0, 13870, 5 }, // &vArr;
    { 0x02AE8, 0, 13875, 5 }, // &vBar;
    { 0x02AE9, 0, 13880, 6 }, // &vBarv;
    { 0x022A8, 0, 10966, 6 }, // &vDash;
    { 0x0299C, 0, 13886, 7 }, // &vangrt;
    { 0x003F5, 0, 13893, 11 }, // &varepsilon;
    { 0x003F0, 0, 13904, 9 }, // &varkappa;
    { 0x02205, 0, 13913, 11 }, // &varnothing;
    { 0x003D5, 0, 13924, 7 }, // &varphi;
    { 0x003D6, 0, 13931, 6 }, // &varpi;
    { 0x0221D, 0, 13937, 10 }, // &varpropto;
    { 0x02195, 0, 13947, 5 }, // &varr;
    { 0x003F1, 0, 13952, 7 }, // &varrho;
    { 0x003C2, 0, 13959, 9 }, // &varsigma;
    { 0x0228A, 0x0FE00, 13968, 13 }, // &varsubsetneq;
    { 0x02ACB, 0x0FE00, 13981, 14 }, // &varsubsetneqq;
    { 0x0228B, 0x0FE00, 13995, 13 }, // &varsupsetneq;
    { 0x02ACC, 0x0FE00, 14008, 14 }, // &varsupsetneqq;
    { 0x003D1, 0, 14022, 9 }, // &vartheta;
    { 0x022B2, 0, 14031, 16 }, // &vartriangleleft;
    { 0x022B3, 0, 14047, 17 }, // &vartriangleright;
    { 0x00432, 0, 14064, 4 }, // &vcy;
    { 0x022A2, 0, 4926, 6 }, // &vdash;
    { 0x02228, 0, 5495, 4 }, // &vee;
    { 0x022BB, 0, 14068, 7 }, // &veebar;
    { 0x0225A, 0, 14075, 6 }, // &veeeq;
    { 0x022EE, 0, 14081, 7 }, // &vellip;
    { 0x0007C, 0, 14088, 7 }, // &verbar;
    { 0x0007C, 0, 14095, 5 }, // &vert;
    { 0x1D533, 0, 14100, 4 }, // &vfr;
    { 0x022B2, 0, 14104, 6 }, // &vltri;
    { 0x02282, 0x020D2, 14110, 6 }, // &vnsub;
    { 0x02283, 0x020D2, 14116, 6 }, // &vnsup;
    { 0x1D567, 0, 14122, 5 }, // &vopf;
    { 0x0221D, 0, 14127, 6 }, // &vprop;
    { 0x022B3, 0, 14133, 6 }, // &vrtri;
    { 0x1D4CB, 0, 14139, 5 }, // &vscr;
    { 0x02ACB, 0x0FE00, 14144, 7 }, // &vsubnE;
    { 0x0228A, 0x0FE00, 14151, 7 }, // &vsubne;
    { 0x02ACC, 0x0FE00, 14158, 7 }, // &vsupnE;
    { 0x0228B, 0x0FE00, 14165, 7 }, // &vsupne;
    { 0x0299A, 0, 14172, 8 }, // &vzigzag;
    { 0x00175, 0, 14180, 6 }, // &wcirc;
    { 0x02A5F, 0, 14186, 7 }, // &wedbar;
    { 0x02227, 0, 5509, 6 }, // &wedge;
    { 0x02259, 0, 14193, 7 }, // &wedgeq;
    { 0x02118, 0, 14200, 7 }, // &weierp;
    { 0x1D534, 0, 14207, 4 }, // &wfr;
    { 0x1D568, 0, 14211, 5 }, // &wopf;
    { 0x02118, 0, 14216, 3 }, // &wp;
    { 0x02240, 0, 14219, 3 }, // &wr;
    { 0x02240, 0, 14222, 7 }, // &wreath;
    { 0x1D4CC, 0, 14229, 5 }, // &wscr;
    { 0x022C2, 0, 14234, 5 }, // &xcap;
    { 0x025EF, 0, 14239, 6 }, // &xcirc;
    { 0x022C3, 0, 14245, 5 }, // &xcup;
    { 0x025BD, 0, 14250, 6 }, // &xdtri;
    { 0x1D535, 0, 14256, 4 }, // &xfr;
    { 0x027FA, 0, 14260, 6 }, // &xhArr;
    { 0x027F7, 0, 14266, 6 }, // &xharr;
    { 0x003BE, 0, 14272, 3 }, // &xi;
    { 0x027F8, 0, 14275, 6 }, // &xlArr;
    { 0x027F5, 0, 14281, 6 }, // &xlarr;
    { 0x027FC, 0, 14287, 5 }, // &xmap;
    { 0x022FB, 0, 14292, 5 }, // &xnis;
    { 0x02A00, 0, 14297, 6 }, // &xodot;
    { 0x1D569, 0, 14303, 5 }, // &xopf;
    { 0x02A01, 0, 14308, 7 }, // &xoplus;
    { 0x02A02, 0, 14315, 7 }, // &xotime;
    { 0x027F9, 0, 14322, 6 }, // &xrArr;
    { 0x027F6, 0, 14328, 6 }, // &xrarr;
    { 0x1D4CD, 0, 14334, 5 }, // &xscr;
    { 0x02A06, 0, 14339, 7 }, // &xsqcup;
    { 0x02A04, 0, 14346, 7 }, // &xuplus;
    { 0x025B3, 0, 14353, 6 }, // &xutri;
    { 0x022C1, 0, 14359, 5 }, // &xvee;
    { 0x022C0, 0, 14364, 7 }, // &xwedge;
    { 0x000FD, 0, 14371, 6 }, // &yacute
    { 0x000FD, 0, 14371, 7 }, // &yacute;
    { 0x0044F, 0, 14378, 5 }, // &yacy;
    { 0x00177, 0, 14383, 6 }, // &ycirc;
    { 0x0044B, 0, 14389, 4 }, // &ycy;
    { 0x000A5, 0, 14393, 3 }, // &yen
    { 0x000A5, 0, 14393, 4 }, // &yen;
    { 0x1D536, 0, 14397, 4 }, // &yfr;
    { 0x00457, 0, 14401, 5 }, // &yicy;
    { 0x1D56A, 0, 14406, 5 }, // &yopf;
    { 0x1D4CE, 0, 14411, 5 }, // &yscr;
    { 0x0044E, 0, 14416, 5 }, // &yucy;
    { 0x000FF, 0, 14421, 4 }, // &yuml
    { 0x000FF, 0, 14421, 5 }, // &yuml;
    { 0x0017A, 0, 14426, 7 }, // &zacute;
    { 0x0017E, 0, 14433, 7 }, // &zcaron;
    { 0x00437, 0, 7321, 4 }, // &zcy;
    { 0x0017C, 0, 14440, 5 }, // &zdot;
    { 0x02128, 0, 14445, 7 }, // &zeetrf;
    { 0x003B6, 0, 14452, 5 }, // &zeta;
    { 0x1D537, 0, 14457, 4 }, // &zfr;
    { 0x00436, 0, 14461, 5 }, // &zhcy;
    { 0x021DD, 0, 7326, 8 }, // &zigrarr;
    { 0x1D56B, 0, 14466, 5 }, // &zopf;
    { 0x1D4CF, 0, 14471, 5 }, // &zscr;
    { 0x0200D, 0, 14476, 4 }, // &zwj;
    { 0x0200C, 0, 14480, 5 }, // &zwnj;
};

const uint16_t kUppercaseOffset[] = {
0,
27,
39,
75,
129,
159,
167,
189,
201,
230,
237,
245,
305,
314,
386,
415,
434,
439,
484,
524,
547,
587,
604,
609,
613,
624,
634
};

const uint16_t kLowercaseOffset[] = {
634,
703,
819,
918,
984,
1051,
1090,
1150,
1178,
1234,
1242,
1252,
1406,
1446,
1614,
1675,
1744,
1755,
1859,
2017,
2075,
2127,
2169,
2180,
2204,
2218,
2231
};

}  // namespace

base::span<const LChar> HTMLEntityTable::EntityString(const HTMLEntityTableEntry& entry) {
  return base::span(kStaticEntityStringStorage).subspan(entry.entity_offset, entry.length);
}

LChar HTMLEntityTableEntry::LastCharacter() const {
  return HTMLEntityTable::EntityString(*this).back();
}

base::span<const HTMLEntityTableEntry> HTMLEntityTable::EntriesStartingWith(UChar c) {
  if (c >= 'A' && c <= 'Z') {
    const size_t first = kUppercaseOffset[c - 'A'];
    const size_t last = kUppercaseOffset[c - 'A' + 1];
    return AllEntries().subspan(first, last - first);
  }
  if (c >= 'a' && c <= 'z') {
    const size_t first = kLowercaseOffset[c - 'a'];
    const size_t last = kLowercaseOffset[c - 'a' + 1];
    return AllEntries().subspan(first, last - first);
  }
  return {};
}

base::span<const HTMLEntityTableEntry> HTMLEntityTable::AllEntries() {
  return base::span(kStaticEntityTable);
}

}  // namespace blink
